% (c) 2009 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(testdining,[]).
user:file_search_path(library,'.').

start(2).

transition(2,takeLeft(p1,f1),3).
transition(2,takeLeft(p2,f2),4).
transition(2,takeLeft(p3,f3),5).
transition(2,takeRight(p1,f2),6).
transition(2,takeRight(p2,f3),7).
transition(2,takeRight(p3,f1),8).
transition(3,takeLeft(p2,f2),9).
transition(3,takeLeft(p3,f3),10).
transition(3,takeRight(p1,f2),11).
transition(3,takeRight(p2,f3),12).
transition(3,dropFork(p1,f1),2).
transition(4,takeLeft(p1,f1),9).
transition(4,takeLeft(p3,f3),13).
transition(4,takeRight(p2,f3),14).
transition(4,takeRight(p3,f1),15).
transition(4,dropFork(p2,f2),2).
transition(15,takeLeft(p3,f3),16).
transition(15,takeRight(p2,f3),17).
transition(15,dropFork(p3,f1),4).
transition(15,dropFork(p2,f2),8).
transition(17,dropFork(p3,f1),14).
transition(17,dropFork(p2,f2),18).
transition(17,dropFork(p2,f3),15).
transition(5,takeLeft(p1,f1),10).
transition(5,takeLeft(p2,f2),13).
transition(5,takeRight(p1,f2),19).
transition(5,takeRight(p3,f1),20).
transition(5,dropFork(p3,f3),2).
transition(6,takeLeft(p1,f1),11).
transition(6,takeLeft(p3,f3),19).
transition(6,takeRight(p2,f3),21).
transition(6,takeRight(p3,f1),22).
transition(6,dropFork(p1,f2),2).
transition(22,takeLeft(p3,f3),23).
transition(22,takeRight(p2,f3),24).
transition(22,dropFork(p3,f1),6).
transition(22,dropFork(p1,f2),8).
transition(7,takeLeft(p1,f1),12).
transition(7,takeLeft(p2,f2),14).
transition(7,takeRight(p1,f2),21).
transition(7,takeRight(p3,f1),18).
transition(7,dropFork(p2,f3),2).
transition(24,dropFork(p3,f1),21).
transition(24,dropFork(p1,f2),18).
transition(24,dropFork(p2,f3),22).
transition(8,takeLeft(p2,f2),15).
transition(8,takeLeft(p3,f3),20).
transition(8,takeRight(p1,f2),22).
transition(8,takeRight(p2,f3),18).
transition(8,dropFork(p3,f1),2).
transition(23,dropFork(p3,f1),19).
transition(23,dropFork(p1,f2),20).
transition(23,dropFork(p3,f3),22).
transition(9,takeLeft(p3,f3),25).
transition(9,takeRight(p2,f3),26).
transition(9,dropFork(p1,f1),4).
transition(9,dropFork(p2,f2),3).
transition(26,dropFork(p1,f1),14).
transition(26,dropFork(p2,f2),12).
transition(26,dropFork(p2,f3),9).
transition(25,dropFork(p1,f1),13).
transition(25,dropFork(p2,f2),10).
transition(25,dropFork(p3,f3),9).
transition(10,takeLeft(p2,f2),25).
transition(10,takeRight(p1,f2),27).
transition(10,dropFork(p1,f1),5).
transition(10,dropFork(p3,f3),3).
transition(27,dropFork(p1,f1),19).
transition(27,dropFork(p1,f2),10).
transition(27,dropFork(p3,f3),11).
transition(11,takeLeft(p3,f3),27).
transition(11,takeRight(p2,f3),28).
transition(11,dropFork(p1,f1),6).
transition(11,dropFork(p1,f2),3).
transition(12,takeLeft(p2,f2),26).
transition(12,takeRight(p1,f2),28).
transition(12,dropFork(p1,f1),7).
transition(12,dropFork(p2,f3),3).
transition(28,dropFork(p1,f1),21).
transition(28,dropFork(p1,f2),12).
transition(28,dropFork(p2,f3),11).
transition(21,takeLeft(p1,f1),28).
transition(21,takeRight(p3,f1),24).
transition(21,dropFork(p1,f2),7).
transition(21,dropFork(p2,f3),6).
transition(13,takeLeft(p1,f1),25).
transition(13,takeRight(p3,f1),16).
transition(13,dropFork(p2,f2),5).
transition(13,dropFork(p3,f3),4).
transition(14,takeLeft(p1,f1),26).
transition(14,takeRight(p3,f1),17).
transition(14,dropFork(p2,f2),7).
transition(14,dropFork(p2,f3),4).
transition(16,dropFork(p3,f1),13).
transition(16,dropFork(p2,f2),20).
transition(16,dropFork(p3,f3),15).
transition(18,takeLeft(p2,f2),17).
transition(18,takeRight(p1,f2),24).
transition(18,dropFork(p3,f1),7).
transition(18,dropFork(p2,f3),8).
transition(19,takeLeft(p1,f1),27).
transition(19,takeRight(p3,f1),23).
transition(19,dropFork(p1,f2),5).
transition(19,dropFork(p3,f3),6).
transition(20,takeLeft(p2,f2),16).
transition(20,takeRight(p1,f2),23).
transition(20,dropFork(p3,f1),5).
transition(20,dropFork(p3,f3),8).

enabled(Op,Node) :- transition(Node,T,_),functor(T,Op,_),!.

check_aps([],_,[]).
check_aps([Op|Rest],Node,[Value|VRest]) :-
    (enabled(Op,Node) -> Value=1; Value=0),
    check_aps(Rest,Node,VRest).
check_tps([],_,[]).
check_tps([P|Rest],Op,[Value|VRest]) :-
    ( functor(Op,P,_) -> Value=1; Value=0),
    check_tps(Rest,Op,VRest).

:- use_module(ltlc).

update(_,_,_,_,_).
fairness(_States,_Transitions).
callback(Node, Aps, Out, AProps,  TProps) :-
    check_aps(AProps,Node,Aps),
    findall(trans(Next,Op,Tp),
            (transition(Node,Op,Next),check_tps(TProps,Op,Tp)),
            Out).

test :-
    ltlc_init,
    start(S),
    c_ltl_modelcheck(not(globally(implies(ap(dropFork),yesterday(once(action(takeLeft)))))),
                     [S],
                     Result,
                     testdining:callback),
    Result = model(Path),
    print_hist(Path).

print_hist([]).
print_hist([atom(N,_,Op)|Rest]) :-
    format('~d~2| ',[N]),write(Op),nl,print_hist(Rest).


user:runtime_entry(start) :- testdining:test.
