% (c) 2009 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(myheap, [myheap_init/0,
  myheap_reset/0, myheap_add_node/2, myheap_pop/1, test/0]).


/* the interface to a heap global variable stored and maintained in C */

foreign(myheap_reset,myheap_reset). % resets the heap to the empty heap; frees memory
foreign(myheap_add_node,myheap_add_node(+integer,+integer)).  % ID, Weight
foreign(myheap_pop,myheap_pop([-integer])). % pops the ID with minimum Weight


% to do: also implement a pop from end to replace the not_all_z/1 relation
% for mixed depth-first, breadth-first traversal

foreign_resource(myheap,
  [
   myheap_reset
  ,myheap_add_node
  ,myheap_pop
  ]).
  
  
  :- dynamic loaded/0.

myheap_init :- loadfr, myheap_reset.

loadfr :-
  (loaded -> true
   ; (assert(loaded), 
      assert(user:library_directory('.')), 
      %assert(user:library_directory(prob_home('.'))),
      load_foreign_resource(library(myheap)))
   ).
   

test :- myheap_init,
         myheap_add_node(22,2),
         myheap_add_node(33,3),
         myheap_add_node(11,1),
         myheap_pop(X),
         print(popped(X)),nl,
         myheap_pop(Y),
         print(popped(Y)),nl.