#include<stdio.h>
#include<stdlib.h>
#include<limits.h>

#define MAXN 200*WORDSIZE  /* Define this before including nauty.h */
#define ERROR_VALUE -20
#define DEBUG_VERSION FALSE
// #define GRAPH_COUNT_VERSION FALSE
#define TIME_NAUTY = TRUE
#define TIME_INTERFACE = TRUE 
// #define TRACE_VERSION FALSE

#include<time.h>
#include <nauty.h>   /* which includes <stdio.h> and other system files */

struct Node{ 

	unsigned int number_of_nodes; 
	int tree_node_number;
	int *cell_sizes;
	graph *label; 
	struct Node *left;
	struct Node *right;
};


/* variable */

extern int check_number_of_nodes;
extern int check_number_of_colours;
extern int check_m;

int counter; //for testing counts every call of function 

extern int global_n;
extern int global_m;
extern graph *global_g;
extern graph *global_canong;
extern int global_number_of_colours;
extern int *global_cell_sizes;
extern int *global_is_set;
extern int global_number_of_colours;
extern struct Node *store_tree; //initialize with NULL pointer (needed for insert())
//int global_tree_node_counter;

#ifdef TIME_NAUTY
extern clock_t nauty_time;
extern clock_t max_time;
extern int num_graphs_max_time; // number of graphs that nauty takes 'max_time' for
#endif

#ifdef TIME_INTERFACE
extern clock_t start_time;
extern clock_t end_time;
extern clock_t total_time;
#endif

#ifdef GRAPH_COUNT_VERSION
   extern int state_counter;
   extern int *num_of_nodes_of_stategraphs;
#endif
//extern int state_counter;
//extern int node_counter;


/*functions of the interface */
// to be added


/* functions needed to build and work with graphs */
int get_number_of_colours(int n_o_p);
graph* start_graph(int number_of_nodes);
void initGraph(graph *g, int n);
int add_edge(int origin, int dest, graph *g, int n);
int compare(graph *canon1, graph *canon2, int n);
void set_node(int node, int is_set[]);

/* functions to calculate the partition */
int init_cell(int number_of_nodes, int number_of_colours, int *cell_list);
int set_colour_of_node(int number_of_nodes, int colour, int node, int *cell_list, int *cell_sizes);
int has_colour(int node, int *cell_list, int *cell_sizes, int number_of_nodes, int number_of_colours);
void set_label(int *lab, int *ptn, int *cell_list, int number_of_nodes, int number_of_colours);

/* functions needed to build the tree*/
int compare_to_internal(graph *canon, int *cell_sizes, int n, struct Node *internalNode);
int insert_canon(graph *canon, int *cell_sizes, struct Node **treeNode, int n);
void copy_label(graph *canon, graph *label, int n);
void copy_cell_sizes();

void free_tree(struct Node **treeNode);

void init_cell_sizes(int *cell_sizes, int length);


/* functions for testing*/
void intToBin(unsigned int val, char bin[]);
void initArray(char matrix[]);
void printGraph(graph *g, int n);
void print_canon_tree(struct Node *treeNode);
void print_cell_list(int number_of_nodes, int number_of_colours, int *cell_list);
void print_cell_sizes(int *cell_sizes, int length);
