:- module(pltables_export_tools, [
							merge_attributes/3
							]).

:- use_module(probsrc(self_check)).
:- use_module(probsrc(module_information)).

:- module_info(group,pltables).
:- module_info(description,'Tools used by several of the export modules').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').

% ----
% internal: merging of attribute lists
% first list: low priority, merge in
% second list: high priority, keep
% third list: Result
% ----
:-assert_must_succeed(pltables_export_tools:merge_attributes([],[],[])).
:-assert_must_succeed(pltables_export_tools:merge_attributes([],[attr(x)],[attr(x)])).
:-assert_must_succeed(pltables_export_tools:merge_attributes([attr(x)],[attr2(y)],[attr(x),attr2(y)])).
:-assert_must_succeed(pltables_export_tools:merge_attributes([attr(y)],[attr(x)],[attr(x)])).
merge_attributes([], Res, Res).
merge_attributes([Attr | Attrs], HiPri, Res) :-
	functor(Attr, AttrName, Arity),
	functor(EmptyAttr, AttrName, Arity),
	merge_attributes(Attrs, HiPri, Res1),
	(member(EmptyAttr, HiPri) -> Res = Res1 ; Res = [Attr | Res1]).