/*
 * config.h
 *
 *  Created on: 18.12.2009
 *      Author: borgi
 */

#ifndef CONFIG_H_
#define CONFIG_H_
#include "structs.h"

//configurable sizes
#define SHMMAX 33554432 //maximum shared segment size
#define MAX_VISITED_EXPRESSIONS 	50000	//number of nodes which can be stored
#define MAX_SYMBOLTABLE_ELEMENTS	100000 //
#define SYMBOL_SIZE 	256 		//maximum number of chars


//################################################
//#			Static configuration				 #
//################################################

//Semaphore IDs to identify them in all processes
#define INDEX_ELEMENT_SEMAPHORE_ID			1
#define TRANSITIONS_SEMAPHORE_ID			2
#define VISITED_EXPRESSIONS_SEMAPHORE_ID	3
#define SYMBOLTABLE_SEMAPHORE_ID			4
#define VE_COUNTER_SEMAPHORE_ID				5
#define TRANSITION_COUNTER_SEMAPHORE_ID		6

//Shared memory segment IDs to identify them in all processes
#define TRANSITIONS_SEGMENT_ID					1
#define VISITED_EXPRESSIONS_SEGMENT_ID			2
#define SRC_INDEX_SEGMENT_ID					3
#define DST_INDEX_SEGMENT_ID					4
#define TRANSITION_ACTIONS_SEGMENT_ID			5
#define VISITED_EXPRESSION_STATES_SEGMENT_ID	6
#define INDEX_ELEMENTS_SEGMENT_ID				7
#define SYMBOLTABLE_SEGMENT_ID					8
#define COUNTER_SEGMENT_ID						9

//Size Definitions of Segments and constants used

//#define MAX_VISITED_EXPRESSIONS 	number of nodes which can be stored, from above
#define MAX_SRC_INDEX 				MAX_VISITED_EXPRESSIONS	//index structure for each node
#define MAX_DST_INDEX 				MAX_VISITED_EXPRESSIONS //index structure for each node
#define MAX_TRANSITIONS 			MAX_VISITED_EXPRESSIONS*3//MAX_VISITED_EXPRESSIONS*(MAX_VISITED_EXPRESSIONS-1)/2 //MAX is n*(n-1)/2 all nodes to all other nodes


//Definition of segment sizes.
#define TRANSITIONS_SEGMENT_SIZE				MAX_TRANSITIONS*sizeof(transition_t)
#define VISITED_EXPRESSIONS_SEGMENT_SIZE		MAX_VISITED_EXPRESSIONS*sizeof(visited_expression_t)
#define SRC_INDEX_SEGMENT_SIZE					MAX_VISITED_EXPRESSIONS*sizeof(void *)
#define DST_INDEX_SEGMENT_SIZE					MAX_VISITED_EXPRESSIONS*sizeof(void *)
#define TRANSITION_ACTIONS_SEGMENT_SIZE			SHMMAX
#define VISITED_EXPRESSION_STATES_SEGMENT_SIZE	SHMMAX
#define INDEX_ELEMENTS_SEGMENT_SIZE				SHMMAX
#define SYMBOLTABLE_SEGMENT_SIZE				sizeof(char)*MAX_SYMBOLTABLE_ELEMENTS*SYMBOL_SIZE
#define COUNTER_SEGMENT_SIZE					2*sizeof(long)

//some other constants
#define TYPE_VISITED_EXPRESSION 		1
#define TYPE_TRANSITION					2

#endif /* CONFIG_H_ */
