 /* main.c
 *
 *  Created on: 18.11.2009
 *      Author: borgi
 */

#include <stdio.h>
#include <stdlib.h>
#include <sicstus/sicstus.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <math.h>
#include <time.h>
#include "shmstorage.h"
#include "structs.h"
#include "config.h"


//#define DEBUG_ON

#ifdef DEBUG_ON
#define free(X) printf("(%s:%i) free at %p frees: %i mallocs: %i\n",__func__,__LINE__,X , ++free_counter, malloc_counter); free(X)
#define malloc(X) tmp_void = malloc(X); printf("(%s:%i) malloc at %p frees: %i mallocs: %i\n",__func__,__LINE__, tmp_void, free_counter, ++malloc_counter)
void *tmp_void;
int free_counter=0, malloc_counter=0;
#endif

/*
 * Prototypes for static functions
 * Prototypes for exported functions in shmstorage.h
 */
#ifdef DEBUG_ON
//static void add_chars(expression_t *expr, char *term_part);
#endif
static void add_to_src_index(long id, void* addr);
static void add_to_dst_index(long id, void* addr);
static int build_term_from_string(char *begin, SP_term_ref term);
static char *get_symbol_by_id(int symbol);
static SP_term_ref get_transition_action(long id);
static SP_term_ref get_visited_expression_state(long id);
static SP_term_ref get_all_visited_expressions(void);
static SP_term_ref get_all_transitions(void);
static SP_term_ref get_all_with_dst(long id);
static SP_term_ref get_all_with_src(long id);
#ifdef DEBUG_ON
//static char *get_string_representation(expression_t *expr);
//static int get_string_representation_length(expression_t *expr);
static void print_table(void);
#endif
unsigned long hash(char *str);
static void *save_transition(SP_term_ref term);
static void *save_visited_expression(SP_term_ref term);
static int store_id_to_symboltable(char *atom);
static void term_to_string(SP_term_ref term);

void *transition_counter,*ve_counter,*transitions, *visited_expressions, *src_index, *dst_index, *transition_actions, *visited_expression_states, *index_elements, *symboltable; ///< pointer to the beginning of the shared memory segments.
int ve_counter_semaphore_id, transition_counter_semaphore_id,index_elements_semaphore_id,transitions_semaphore_id,visited_expressions_semaphore_id,symboltable_semaphore_id; ///< stores the generated id from the system, to identify a semaphore. Using these as a mutex, they will never be greater 1,
int shmid_counter, shmid_transitions, shmid_visited_expressions, shmid_src_index, shmid_dst_index, shmid_transition_actions, shmid_visited_expression_states, shmid_index_elements, shmid_symboltable; ///< stores the generated id from the system, to identify a shared memory segment.
struct sembuf get_semaphore, release_semaphore; ///< structs will be filled in init() to increase and decrease semaphores.
char *tempstr, *tempstr2, *tempstrterm;
//shmap *shm_symboltable;
//int symbolcounter, nodeid;
transition_t *nodetrans = NULL;
visited_expression_t *nodeve = NULL;

/*
 * ##########################################################
 * #				static functions						#
 * ##########################################################
 */

#ifdef DEBUG_ON
//TODO comment this
/*
 *
 */
//static void add_chars(expression_t *expr, char *term_part) {
//	sprintf(tempstr, "%i", expr->symbol);
//	strcat(term_part, tempstr);
//
//	if (expr->arity > 0) {
//		int i;
//		strcat(term_part, "(");
//		for (i=0; i<expr->arity; i++) {
//			if (i>0) {
//				strcat(term_part, ",");
//			}
//			add_chars(expr->children[i], term_part);
//		}
//		strcat(term_part, ")");
//	}
//}
#endif


static void add_to_src_index(long id, void* addr) {
	semop(index_elements_semaphore_id, &get_semaphore, 1); //lock index_elements space
	index_element_t *ind = malloc(sizeof(index_element_t));
	ind->next = NULL;
	ind->transition = addr;
	memcpy((void*)((int)index_elements + (((int *)src_index)[0])), ind, sizeof(index_element_t));
	free(ind);
	if (((int *)src_index)[id] == (int)NULL) {
		((int *)src_index)[id] = ((int *)src_index)[0];
	} else {
		index_element_t *temp;
		temp = (index_element_t *)((int)index_elements + (((int *)src_index)[id]));
		while (temp->next != NULL) {
			temp = (index_element_t *)((int)index_elements + (int)(temp->next));
		}
		temp->next = (index_element_t *)((int *)src_index)[0];
	}
	((int *)src_index)[0]=(int)(((int *)src_index)[0])+sizeof(index_element_t);
	semop(index_elements_semaphore_id, &release_semaphore, 1); //unlock index_elements space
}

static void add_to_dst_index(long id, void* addr) {
	semop(index_elements_semaphore_id, &get_semaphore, 1); //lock index_elements space
	index_element_t *ind = malloc(sizeof(index_element_t));
	ind->next = NULL;
	ind->transition = addr;
	memcpy((void*)((int)index_elements + (((int *)src_index)[0])), ind, sizeof(index_element_t));
	free(ind);
	if (((int *)dst_index)[id] == (int)NULL) {
		((int *)dst_index)[id] = ((int *)src_index)[0];
	} else {
		index_element_t *temp;
		temp = (index_element_t *)((int)index_elements + (((int *)dst_index)[id]));
		while (temp->next != NULL) {
			temp = (index_element_t *)((int)index_elements + (int)(temp->next));
		}
		temp->next = (index_element_t *)((int *)src_index)[0];
	}
	((int *)src_index)[0]=(int)(((int *)src_index)[0])+sizeof(index_element_t);
	semop(index_elements_semaphore_id, &release_semaphore, 1); //unlock index_elements space

}


//TODO comment this
/*
 *
 */
static int build_term_from_string(char *begin, SP_term_ref term) {
//	printf("term: %s\n", begin);
	int symbol = atoi(begin); //get first id
	char *str = begin;
	char *p;
	long val;
	//add children now or end.
	begin = strchr(begin,'_');
	if (begin != NULL) { //children detected
		int arity=atoi(begin+sizeof(char));
		begin = strchr(begin, '(');
		SP_put_functor(term, SP_atom_from_string(get_symbol_by_id(symbol)), arity);
		int i;
		for (i=0; i< arity; i++) {
			switch (begin[0]) {
			case '(':
				i--;
				break;
			case ')':
				i--;
				break;
			case ',':
				i--;
				break;
			default:
			{
				symbol = atoi(begin);
				SP_term_ref argument = SP_new_term_ref();;
				SP_get_arg(i+1, term, argument);
				SP_term_ref term2 = SP_new_term_ref();
				char *tmpsym = get_symbol_by_id(symbol);
				if (begin[(((int)log10(symbol))+1)*sizeof(char)] == '_')  { //add length of symbol -1
					int arity2 = atoi(begin+(((int)(log10(symbol)+2))*sizeof(char)));
					SP_put_functor(term2, SP_atom_from_string(tmpsym), arity2);
					begin += build_term_from_string(begin, term2)-1;
					SP_unify(argument, term2);
				} else {
					p = tmpsym;
					val = strtol(tmpsym, &p, 10);
					if (p == tmpsym) {
						SP_put_atom(term2, SP_atom_from_string(tmpsym));
//						printf("atom %s\n", tmpsym);
					} else {
						SP_put_integer(term2, val);
//						printf("integer %li %i\n", val, errno);
					}
					SP_unify(argument, term2);
					begin+=((int)log10(symbol))*sizeof(char); //add length of symbol -1
				}
				break;
			}
			}
			begin = begin + sizeof(char); //add 1 char
		}
	} else {
		char *tmpsym = get_symbol_by_id(symbol);
		p = tmpsym;
		val = strtol(tmpsym, &p, 10);
		if (p == tmpsym) {
			SP_put_atom(term, SP_atom_from_string(tmpsym));
//			printf("atom %s\n", tmpsym);
		} else {
			SP_put_integer(term, val);
//			printf("integer %li\n", val);
		}
	}
	return (int)begin-(int)str;
}

////TODO comment this
///*
// *
// */
//static int build_term_from_string(char *begin, SP_term_ref term) {
//
//	char *str = begin;
//	begin = strchr(begin,'_');
//	if (begin != NULL) { //children detected
//		memcpy(tempstr, str, (int)begin-(int)str);
//		memcpy((void*)((int)tempstr+((int)begin-(int)str)), "\0", 1);
//		int arity=atoi(begin+sizeof(char));
//		begin = strchr(begin, '(');
//		SP_put_functor(term, SP_atom_from_string(tempstr), arity);
//		int i;
//		for (i=0; i< arity; i++) {
//			switch (begin[0]) {
//			case '(':
//				i--;
//				break;
//			case ')':
//				i--;
//				break;
//			case ',':
//				i--;
//				break;
//			default:
//			{
//				int pos=strcspn(begin, "()_,");
//				SP_term_ref argument = SP_new_term_ref();;
//				SP_get_arg(i+1, term, argument);
//				SP_term_ref term2 = SP_new_term_ref();
//				memcpy(tempstr, begin, pos);
//				memcpy(tempstr+pos, "\0", 1);
//				if (begin[pos*sizeof(char)] == '_')  { //add length of symbol -1
//					int arity2 = atoi((void *)(((int)begin+pos+1)*sizeof(char)));
//					SP_put_functor(term2, SP_atom_from_string(tempstr), arity2);
//					begin += build_term_from_string(begin, term2)-1;
//					SP_unify(argument, term2);
//				} else {
//					SP_put_atom(term2, SP_atom_from_string(tempstr));
//					SP_unify(argument, term2);
//					begin+=pos*sizeof(char); //add length of symbol -1
//				}
//				break;
//			}
//			}
//			begin = begin + sizeof(char); //add 1 char
//		}
//			} else {
//				SP_put_atom(term, SP_atom_from_string(str));
//			}
//	return (int)begin-(int)str;
//}

//TODO comment this
/*
 *
 */
static char *get_symbol_by_id(int symbol) {
	if (symbol != 0) {
		sprintf(tempstr,"%s",(char *)symboltable+SYMBOL_SIZE*(symbol)); //writing name to atom
	}
	return tempstr;
}


//TODO comment this
/*
 *
 */
static SP_term_ref get_transition_action(long id) {
	SP_term_ref term = SP_new_term_ref();
	transition_t *node = malloc(sizeof(transition_t));
	memcpy(node, (void *)((int)transitions+sizeof(transition_t)*id), sizeof(transition_t));
	build_term_from_string((char *)((int)transition_actions+(int)(node->action)), term);
	free(node);

	return term;
}


//TODO comment this
/*
 *
 */
static SP_term_ref get_visited_expression_state(long id) {
	SP_term_ref term = SP_new_term_ref();
	visited_expression_t *node = malloc(sizeof(visited_expression_t));
	memcpy(node, (void *)((int)visited_expressions+sizeof(visited_expression_t)*id), sizeof(visited_expression_t));
//	printf("get %s\n", (char *)((int)visited_expression_states+(int)(node->state)));
	build_term_from_string((char *)((int)visited_expression_states+(int)(node->state)), term);
	free(node);
	return term;
}

//TODO comment this
/*
 *
 */
static visited_expression_t *get_visited_expression(long id) {
	return (visited_expression_t *)((int)visited_expressions+sizeof(visited_expression_t)*id);
}

//TODO comment this
/*
 *
 */
static transition_t *get_transition(long id) {
	return (transition_t *)((int)transitions+sizeof(transition_t)*id);
}

//TODO comment this
/*
 *
 */
static SP_term_ref get_all_visited_expressions() {
//	printf("get all visited expressions!\n");
	SP_term_ref list = SP_new_term_ref();
	int i;
	semop(visited_expressions_semaphore_id, &get_semaphore, 1); //lock visited_expressions space
	visited_expression_t *config = (visited_expression_t *)visited_expressions;
	SP_term_ref term, term2, argument;
	argument = 0;
	for (i=1; i < config->owner-1; i++) {
		term = SP_new_term_ref();
		build_term_from_string((char *)((int)visited_expression_states + (int)(((visited_expression_t *)((int)visited_expressions + (sizeof(visited_expression_t)*i)))->state)), term);
//		printf("adding string (ve): %s\n",tempstr);
		term2 = SP_new_term_ref();
		SP_put_functor(term2, SP_atom_from_string("visited_expression"), 4);
		SP_get_arg(2, term2, argument);
		SP_unify(argument, term);

		SP_get_arg(1, term2, argument);
		term = SP_new_term_ref();
		if (((visited_expression_t *)((int)visited_expressions+(sizeof(visited_expression_t)*i)))->id == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((visited_expression_t *)((int)visited_expressions+(sizeof(visited_expression_t)*i)))->id );
//			printf("adding id %li\n", ((visited_expression_t *)((int)visited_expressions+(sizeof(visited_expression_t)*i)))->id);
		}
		SP_unify(argument, term);


		SP_get_arg(3, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((visited_expression_t *)((int)visited_expressions+(sizeof(visited_expression_t)*i)))->owner );
		SP_unify(argument, term);

		SP_get_arg(4, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((visited_expression_t *)((int)visited_expressions+(sizeof(visited_expression_t)*i)))->flags );
		SP_unify(argument, term);

		SP_cons_list(list, term2, list);
	}

	semop(visited_expressions_semaphore_id, &release_semaphore, 1); //unlock visited_expressions space
	return list;
}

//TODO comment this
/*
 *
 */
static SP_term_ref get_all_transitions(void) {
//	printf("get all transitions!\n");
	SP_term_ref list = SP_new_term_ref();
	int i;
	semop(transitions_semaphore_id, &get_semaphore, 1); //lock transitions space
	transition_t *config = (transition_t *)transitions; //special config structure, points to next free entry.
	SP_term_ref term, term2, argument;
	argument = 0;
	for (i=1; i < config->owner; i++) {
		term = SP_new_term_ref();
		build_term_from_string((char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (sizeof(transition_t)*i)))->action)), term);
		term2 = SP_new_term_ref();
		SP_put_functor(term2, SP_atom_from_string("transition"), 6);
		SP_get_arg(2, term2, argument);
		SP_unify(argument, term);

		SP_get_arg(1, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->src == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->src );
		}
		SP_unify(argument, term);

		SP_get_arg(3, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->id );
		SP_unify(argument, term);

		SP_get_arg(4, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->dst == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->dst );
		}
		SP_unify(argument, term);

		SP_get_arg(5, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->owner );
		SP_unify(argument, term);

		SP_get_arg(6, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(sizeof(transition_t)*i)))->flags );
		SP_unify(argument, term);

		SP_cons_list(list, term2, list);

	}

	semop(transitions_semaphore_id, &release_semaphore, 1); //unlock transitions space
//	printf("done!\n");
	return list;
}

//TODO comment this
/*
 *
 */
static SP_term_ref get_all_with_dst(long id) {
//	printf("get all with dst %li!\n", id);
	SP_term_ref list = SP_new_term_ref();
	if (((int *)dst_index)[id] != (int)NULL) {
		SP_term_ref term, term2, argument;
		index_element_t *temp;
		argument = 0;
		temp = (index_element_t *)((int)index_elements + (((int *)dst_index)[id]));
		semop(transitions_semaphore_id, &get_semaphore, 1); //lock transitions space
		while (temp->next != NULL) {
			term = SP_new_term_ref();
			build_term_from_string((char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)), term);
			term2 = SP_new_term_ref();
			SP_put_functor(term2, SP_atom_from_string("transition"), 6);
			SP_get_arg(2, term2, argument);
			SP_unify(argument, term);

			SP_get_arg(1, term2, argument);
			term = SP_new_term_ref();
			if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->src == 1) {
				SP_put_atom(term, SP_atom_from_string("root"));
			} else {
				SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->src );
			}
			SP_unify(argument, term);

			SP_get_arg(3, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->id );
			SP_unify(argument, term);

			SP_get_arg(4, term2, argument);
			term = SP_new_term_ref();
			if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->dst == 1) {
				SP_put_atom(term, SP_atom_from_string("root"));
			} else {
				SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->dst );
			}
			SP_unify(argument, term);

			SP_get_arg(5, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->owner );
			SP_unify(argument, term);

			SP_get_arg(6, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->flags );
			SP_unify(argument, term);

			SP_cons_list(list, term2, list);
			temp = (index_element_t *)((int)index_elements + (int)(temp->next));
		}
		term = SP_new_term_ref();
		build_term_from_string((char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)), term);
		term2 = SP_new_term_ref();
		SP_put_functor(term2, SP_atom_from_string("transition"), 6);
		SP_get_arg(2, term2, argument);
		SP_unify(argument, term);

		SP_get_arg(1, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->src == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->src );
		}
		SP_unify(argument, term);

		SP_get_arg(3, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->id );
		SP_unify(argument, term);

		SP_get_arg(4, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->dst == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->dst );
		}
		SP_unify(argument, term);

		SP_get_arg(5, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->owner );
		SP_unify(argument, term);

		SP_get_arg(6, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->flags );
		SP_unify(argument, term);
		semop(transitions_semaphore_id, &release_semaphore, 1); //unlock transitions space

		SP_cons_list(list, term2, list);
	}
//	printf("done!\n");
	return list;
}

//TODO comment this
/*
 *
 */
static SP_term_ref get_all_with_src(long id) {
//	printf("get all with src %li!\n", id);
	SP_term_ref list = SP_new_term_ref();
	if (((int *)src_index)[id] != (int)NULL) {
		SP_term_ref term, term2, argument;
		argument = 0;
		index_element_t *temp;
		semop(transitions_semaphore_id, &get_semaphore, 1); //lock transitions space
		temp = (index_element_t *)((int)index_elements + (((int *)src_index)[id]));
		while (temp->next != NULL) {
			term = SP_new_term_ref();
//			printf("get %s\n", (char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)));
			build_term_from_string((char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)), term);
//			printf("adding string (src): %s\n",(char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)));
			term2 = SP_new_term_ref();
			SP_put_functor(term2, SP_atom_from_string("transition"), 6);
			SP_get_arg(2, term2, argument);
			SP_unify(argument, term);

			SP_get_arg(1, term2, argument);
			term = SP_new_term_ref();
			if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->src == 1) {
				SP_put_atom(term, SP_atom_from_string("root"));
			} else {
				SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->src );
			}
			SP_unify(argument, term);

			SP_get_arg(3, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->id );
			SP_unify(argument, term);

			SP_get_arg(4, term2, argument);
			term = SP_new_term_ref();
			if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->dst == 1) {
				SP_put_atom(term, SP_atom_from_string("root"));
			} else {
				SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->dst );
			}
			SP_unify(argument, term);

			SP_get_arg(5, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->owner );
			SP_unify(argument, term);

			SP_get_arg(6, term2, argument);
			term = SP_new_term_ref();
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->flags );
			SP_unify(argument, term);


			SP_cons_list(list, term2, list);

			temp = (index_element_t *)((int)index_elements + (int)(temp->next));
		}
		term = SP_new_term_ref();
		build_term_from_string((char *)((int)transition_actions + (int)(((transition_t *)((int)transitions + (int)(temp->transition)))->action)), term);
		term2 = SP_new_term_ref();
		SP_put_functor(term2, SP_atom_from_string("transition"), 6);
		SP_get_arg(2, term2, argument);
		SP_unify(argument, term);

		SP_get_arg(1, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->src == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->src );
		}
		SP_unify(argument, term);

		SP_get_arg(3, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->id );
		SP_unify(argument, term);

		SP_get_arg(4, term2, argument);
		term = SP_new_term_ref();
		if ( ((transition_t *)((int)transitions+(int)(temp->transition)))->dst == 1) {
			SP_put_atom(term, SP_atom_from_string("root"));
		} else {
			SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->dst );
		}
		SP_unify(argument, term);

		SP_get_arg(5, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->owner );
		SP_unify(argument, term);

		SP_get_arg(6, term2, argument);
		term = SP_new_term_ref();
		SP_put_integer(term, ((transition_t *)((int)transitions+(int)(temp->transition)))->flags );
		SP_unify(argument, term);
		semop(transitions_semaphore_id, &release_semaphore, 1); //unlock transitions space

		SP_cons_list(list, term2, list);
	}
	return list;
}

#ifdef DEBUG_ON
//TODO comment this
/*
 *
 */
//static char *get_string_representation(expression_t *expr) {
//	int length = get_string_representation_length(expr)+1;
//	char *term_part = malloc(length);
//	term_part[0]='\0';
//	add_chars(expr, term_part);
//	return term_part;
//}

//TODO comment this
/*
 *
 */
//static int get_string_representation_length(expression_t *expr) {
//	int i, sub_length;
//	sub_length = 0;
//	if (expr->arity > 0) {
//		for (i=0; i<expr->arity; i++) {
//			sub_length += get_string_representation_length(expr->children[i]);
//		}
//		sub_length += 2 + expr->arity - 1;
//	}
//	return sub_length + ((int)log10(expr->symbol))+1;
//}


//TODO comment this
/*
 *
 */
static void print_table() {
	semop(symboltable_semaphore_id, &get_semaphore, 1);
	int elements = *(int *)symboltable;
	int i;

	for (i = 1; i <= elements; i++) {
		printf("%i symbol: |%s|\n", i, (char *)symboltable+SYMBOL_SIZE*(i+1));
	}
	semop(symboltable_semaphore_id, &release_semaphore, 1);
}
#endif




static void *save_transition(SP_term_ref term) {
	void *address;
	term_to_string(term);
//	printf("%s\n",tempstrterm);
	semop(transitions_semaphore_id, &get_semaphore, 1); //lock transitions space
	transition_t *config = (transition_t *)transitions; //special config structure, points to next free entry.
	if(config->owner >= MAX_TRANSITIONS) {
		printf("MAX_TRANSITIONS reached, no more space left\n");
		exit(1);
	} else {
		int length = strlen(tempstrterm)+1;
		if (((int)transition_actions + (int)(config->action) + length) > ((int)transition_actions + TRANSITION_ACTIONS_SEGMENT_SIZE)) {
			printf("TRANSITION_ACTIONS_SEGMENT_SIZE reached, no more space left\n");
			exit(1);
		} else {
			memcpy((char *)((int)transition_actions + (int)(config->action)), tempstrterm, length);
			address = config->action;
			config->action = (void *)((int)(config->action) + length);
			config->owner = config->owner+1;
		}
	}
	semop(transitions_semaphore_id, &release_semaphore, 1); //unlock transitions space
	return address;
}

static void *save_visited_expression(SP_term_ref term) {
	void *address;
	term_to_string(term);
//	printf("in %s\n", tempstrterm);
	semop(visited_expressions_semaphore_id, &get_semaphore, 1); //lock visited_expressions space
	visited_expression_t *config = (visited_expression_t *)visited_expressions; //special config structure, points to next free entry.
	if(config->owner >= MAX_VISITED_EXPRESSIONS) {
		printf("MAX_VISITED_EXPRESSIONS reached, no more space left\n");
		exit(1);
	} else {
		int length = strlen(tempstrterm)+1;
		if (((int)visited_expression_states + (int)(config->state) + length) > ((int)visited_expression_states + VISITED_EXPRESSION_STATES_SEGMENT_SIZE)) {
			printf("VISITED_EXPRESSION_STATES_SEGMENT_SIZE reached, no more space left\n");
			exit(1);
		} else {
			memcpy((char *)((int)visited_expression_states + (int)(config->state)), tempstrterm, length);
			address = config->state;
			config->state = (void *)((int)(config->state) + length);
			config->owner = config->owner+1;
		}
	}
	semop(visited_expressions_semaphore_id, &release_semaphore, 1); //unlock visited_expressions space
	return address;
}


unsigned long hash(char *str) {
    unsigned long hash = 5381;
    int c;
    while ((c = *str++))
        hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
    return hash+1;
}


/*
 * returns id of symbol, inserts it if new.
 */
static int store_id_to_symboltable(char *atom) {
	semop(symboltable_semaphore_id, &get_semaphore, 1); //lock symboltable for other processes

	int elements = *(int *)symboltable; //first entry holds number of inserted elements
	int i;
//	index = (int)shmap_get_value(symboltable, atom, 1);
//	printf("hashmap return is %i\n", index);
//	if (index )
	for (i = 1; i <= elements; i++) {
		//compare for every entry, if found return the id
		if (strncmp(atom, (char *)symboltable+SYMBOL_SIZE*(i+1), SYMBOL_SIZE) == 0) {
			semop(symboltable_semaphore_id, &release_semaphore, 1); //release lock
			return i+1;
		}
	}
	//if symbol not found, insert it, if symboltable is not full
	if (MAX_SYMBOLTABLE_ELEMENTS < (i+1)) {
		printf("symboltable full\n"); //if symboltable is full the process terminates
		exit(1);
	} else {
		memcpy((void *)((int)symboltable+sizeof(char)*(i+1)*SYMBOL_SIZE), atom, strlen(atom)+1); //copy symbol to corresponding space
		if (-1 == elements) {
			*(int *)symboltable = 1;
		} else {
			*(int *)symboltable=elements+1; //increase counter for table
		}
	}
	semop(symboltable_semaphore_id, &release_semaphore, 1); // release lock
	return i+1;
}


///*
// * returns id of symbol, inserts it if new.
// */
//static int store_id_to_symboltable(char *atom) {
//	semop(symboltable_semaphore_id, &get_semaphore, 1); //lock symboltable for other processes
//
//	int elements = *(int *)symboltable; //first entry holds number of inserted elements
//	if (elements+1 > MAX_SYMBOLTABLE_ELEMENTS) {
//		printf("symboltable full\n"); //if symboltable is full the process terminates
//		exit(1);
//	} else {
//		unsigned int i = hash(atom);
//		int j = 0;
//		while ((strncmp(atom, (char *)symboltable+SYMBOL_SIZE*((i+j)%MAX_SYMBOLTABLE_ELEMENTS), SYMBOL_SIZE) != 0) && (strlen((char *)(symboltable+SYMBOL_SIZE*((i+j)%MAX_SYMBOLTABLE_ELEMENTS))) > 0)) {
//			j++;
//			sleep(1);
//		}
//		if (strlen((char *)(symboltable+SYMBOL_SIZE*((i+j)%MAX_SYMBOLTABLE_ELEMENTS))) == 0) {
////			printf("inserting new symbol %s with id %i\n", atom, (i+j)%MAX_SYMBOLTABLE_ELEMENTS);
//			memcpy((void *)((int)symboltable+sizeof(char)*((i+j)%MAX_SYMBOLTABLE_ELEMENTS)*SYMBOL_SIZE), atom, strlen(atom)+1); //copy symbol to corresponding space
//			if (-1 == elements) {
//				*(int *)symboltable = 1;
//			} else {
//				*(int *)symboltable=elements+1; //increase counter for table
//			}
//		}
//		semop(symboltable_semaphore_id, &release_semaphore, 1); //release lock
//		return (i+j)%MAX_SYMBOLTABLE_ELEMENTS;
//
//	}
//
//	//	index = (int)shmap_get_value(symboltable, atom, 1);
////	printf("hashmap return is %i\n", index);
////	if (index )
////	for (i = 1; i <= elements; i++) {
////		//compare for every entry, if found return the id
////		if (strncmp(atom, (char *)symboltable+SYMBOL_SIZE*(i+1), SYMBOL_SIZE) == 0) {
////			semop(symboltable_semaphore_id, &release_semaphore, 1); //release lock
////			return i;
////		}
////	}
////	//if symbol not found, insert it, if symboltable is not full
////	if (MAX_SYMBOLTABLE_ELEMENTS < (i+1)) {
////		printf("symboltable full\n"); //if symboltable is full the process terminates
////		exit(1);
////	} else {
////		memcpy((void *)((int)symboltable+sizeof(char)*(i+1)*SYMBOL_SIZE), atom, strlen(atom)+1); //copy symbol to corresponding space
////		if (-1 == elements) {
////			*(int *)symboltable = 1;
////		} else {
////			*(int *)symboltable=elements+1; //increase counter for table
////		}
////	}
////	semop(symboltable_semaphore_id, &release_semaphore, 1); // release lock
////	return i;
//}



/*
 * builds tree of a given prolog term, saving its contents into expression
 * this function is called recursive
 */
static void term_to_string(SP_term_ref term) {
	switch(SP_term_type(term)) { //depending which type of term is given, different action is performed
		//types float and variable are not expected, nothing will be done, except for exiting programm.
		case SP_TYPE_FLOAT:{
			printf("Type of Term is float, not allowed!\n");
			exit(1);
			break;
		}
		case SP_TYPE_VARIABLE:{
			printf("Type of Term is variable, not allowed!\n");
			exit(1);
			break;
		}
		//type integer is a leaf in tree, no children, recursion breaks
		case SP_TYPE_INTEGER:{
			long integer_arg = 0;
			SP_get_integer(term, &integer_arg); //extracting integer value from term
			sprintf(tempstr,"%li",integer_arg); //writing integer in string.
		//	printf("%s\n",tempstr);
			sprintf(tempstr, "%i", store_id_to_symboltable(tempstr));
			strcat(tempstrterm, tempstr); //saving id, from symboltable
			break;
		}
		//type atom is a leaf in tree, no children, recursion breaks
		case SP_TYPE_ATOM:
		{
			int arity;
			SP_atom functor;
			SP_get_functor(term, &functor, &arity); //extracting functor and getting number of children, expected is 0
			sprintf(tempstr,"%s",SP_string_from_atom(functor)); //writing atom to string
		//	printf("%s\n",tempstr);
			sprintf(tempstr, "%i", store_id_to_symboltable(tempstr));
			strcat(tempstrterm, tempstr); //saving id, from symboltable
			break;
		}
		//type compound is a inner node, recursion is started here
		case SP_TYPE_COMPOUND:
		{
			int arity, i;
			SP_term_ref argument;
			SP_atom functor;
			SP_get_functor(term, &functor, &arity); //extract functor and number of children
			sprintf(tempstr,"%s",SP_string_from_atom(functor)); //writing name to atom
//			sprintf(tempstr,"%s_%i(",SP_string_from_atom(functor), arity); //writing name to atom
		//	printf("%s\n",tempstr);
			sprintf(tempstr, "%i_%i(", store_id_to_symboltable(tempstr), arity);
			strcat(tempstrterm, tempstr);
			for (i=0; i < arity; i++) { //for every children do
				argument = SP_new_term_ref(); //create a new term
				SP_get_arg(i+1, term, argument); //get the argument at position i+1
				term_to_string(argument); //recursive call to analyse every children
				if (i<arity-1) {
					strcat(tempstrterm, ",");
				}
			}
			strcat(tempstrterm, ")");
			break;
		}
	}
}

/*
 * ##########################################################
 * #				exported functions						#
 * ##########################################################
 */


/*
 * add a term to shared memory, stores it under id.
 */
void shmstorage_add_term(SP_term_ref term) {
	int ret;
	int arity;
	long id,owner,flags;
	void *address;
	tempstrterm[0] = '\0';
	SP_atom functor;
	SP_term_ref argument = SP_new_term_ref(); //create a new term
	SP_get_functor(term, &functor, &arity); //extract functor and number of children
switch(arity) {
		case 4: //visited_expression
			if (strcmp(SP_string_from_atom(functor), "visited_expression") == 0) {
//				printf("adding ve with\n");
				nodeve->id = 0;
				nodeve->owner = 0;
				nodeve->flags = 0;
				nodeve->state = NULL;
				//				node = malloc(sizeof(visited_expression_t));
				SP_get_arg(1, term, argument);
				ret = SP_get_integer(argument, &id);
				if (ret == 0) { id = 1; }
				SP_get_arg(2, term, argument);
				address = save_visited_expression(argument);
				SP_get_arg(3, term, argument);
				SP_get_integer(argument, &owner);
				SP_get_arg(4, term, argument);
				SP_get_integer(argument, &flags);
//				printf("add ve id: %li\n", id);
				nodeve->flags = flags;
				nodeve->id = id;
				nodeve->owner = owner;
				nodeve->state = address;
				memcpy((void *)((int)visited_expressions+sizeof(visited_expression_t)*id), nodeve, sizeof(visited_expression_t));
			} else {
				printf("undefined term\n");
			}
			break;
		case 6: //transition
			if (strcmp(SP_string_from_atom(functor), "transition") == 0) {
				nodetrans->id=0;
				nodetrans->src=0;
				nodetrans->dst=0;
				nodetrans->owner=0;
				nodetrans->flags=0;
				nodetrans->action=NULL;
				long src, dst;
//				printf("add transition\n");
				SP_get_arg(1, term, argument);
				ret = SP_get_integer(argument, &src);
				if (ret == 0) { src = 1; }
				SP_get_arg(2, term, argument);
				address = save_transition(argument);
				SP_get_arg(3, term, argument);
				SP_get_integer(argument, &id);
				SP_get_arg(4, term, argument);
				ret = SP_get_integer(argument, &dst);
				if (ret == 0) { dst = 1; }
				SP_get_arg(5, term, argument);
				SP_get_integer(argument, &owner);
				SP_get_arg(6, term, argument);
				SP_get_integer(argument, &flags);
				nodetrans->action = address;
				nodetrans->dst =dst;
				nodetrans->flags = flags;
				nodetrans->owner = owner;
				nodetrans->src = src;
				nodetrans->id = id;
				memcpy((void *)((int)transitions+sizeof(transition_t)*id), nodetrans, sizeof(transition_t));
				add_to_src_index(src, (void *)(sizeof(transition_t)*id));
				add_to_dst_index(dst, (void *)(sizeof(transition_t)*id));
			} else {
				printf("undefined term\n");
			}
			break;
		default:
			printf("undefined term \n");
			exit(1);
	}


}


/*
 * inits the enviroment, allocates space for storage, hashtable, symboltable and semaphores
 * using IDs from config.h, if the corresponding segement is already allocated, it will be attached.
 */
void shmstorage_attach() {
	//states to set and unset the semaphore.
	get_semaphore.sem_num = 0;
	get_semaphore.sem_flg = SEM_UNDO;
	get_semaphore.sem_op  = -1;

	release_semaphore.sem_num = 0;
	release_semaphore.sem_flg = SEM_UNDO;
	release_semaphore.sem_op  = +1;

	//create/get id semaphores
	index_elements_semaphore_id = semget(INDEX_ELEMENT_SEMAPHORE_ID, 1, IPC_CREAT | 0666);
	transitions_semaphore_id = semget(TRANSITIONS_SEMAPHORE_ID, 1, IPC_CREAT | 0666);
	visited_expressions_semaphore_id = semget(VISITED_EXPRESSIONS_SEMAPHORE_ID, 1, IPC_CREAT | 0666);
	symboltable_semaphore_id = semget(SYMBOLTABLE_SEMAPHORE_ID, 1, IPC_CREAT | 0666);
	ve_counter_semaphore_id = semget(VE_COUNTER_SEMAPHORE_ID, 1, IPC_CREAT | 0666);
	transition_counter_semaphore_id = semget(TRANSITION_COUNTER_SEMAPHORE_ID, 1, IPC_CREAT | 0666);

	//initialise temporary chars
	tempstr = malloc(SYMBOL_SIZE);
	tempstr2 = malloc(SYMBOL_SIZE);
	tempstrterm = malloc(SYMBOL_SIZE);
	nodeve = malloc(sizeof(visited_expression_t));
	nodetrans = malloc(sizeof(transition_t));

	//create/get shared memory segment
	if ((shmid_transitions = shmget(TRANSITIONS_SEGMENT_ID, TRANSITIONS_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((transitions = shmat(shmid_transitions, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_visited_expressions = shmget(VISITED_EXPRESSIONS_SEGMENT_ID, VISITED_EXPRESSIONS_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((visited_expressions = shmat(shmid_visited_expressions, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_src_index = shmget(SRC_INDEX_SEGMENT_ID, SRC_INDEX_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((src_index = shmat(shmid_src_index, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_dst_index = shmget(DST_INDEX_SEGMENT_ID, DST_INDEX_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((dst_index = shmat(shmid_dst_index, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_transition_actions = shmget(TRANSITION_ACTIONS_SEGMENT_ID, TRANSITION_ACTIONS_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((transition_actions = shmat(shmid_transition_actions, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_visited_expression_states = shmget(VISITED_EXPRESSION_STATES_SEGMENT_ID, VISITED_EXPRESSION_STATES_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((visited_expression_states = shmat(shmid_visited_expression_states, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

	//create/get shared memory segment
	if ((shmid_index_elements = shmget(INDEX_ELEMENTS_SEGMENT_ID, INDEX_ELEMENTS_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((index_elements = shmat(shmid_index_elements, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

    //create/get shared memory segment
	if ((shmid_symboltable = shmget(SYMBOLTABLE_SEGMENT_ID, SYMBOLTABLE_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((symboltable = shmat(shmid_symboltable, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }
	//create/get shared memory segment
	if ((shmid_counter = shmget(COUNTER_SEGMENT_ID, COUNTER_SEGMENT_SIZE, IPC_CREAT | 0666)) < 0) {
    	perror("shmget");
    	exit(1);
    }
	//attach shared memory segment
    if ((ve_counter = shmat(shmid_transitions, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }
    transition_counter = (void *)((long)ve_counter+sizeof(long));



}


/*
 * sets the semaphores and inits the structures.
 * function is only called by the first process to bootstrap the system.
 */
void shmstorage_bootstrap() {
	shmstorage_attach(); //do the usual initial stuff which every process has to do first.
	int i;
	//initialize all arrays with empty structs, first entry is always a counter variable and is set to initial value
	((int *)src_index)[0] = 1; //offset for memory
	for (i = 1; i < MAX_SRC_INDEX; i++) {
		((int *)src_index)[i] = (int)NULL;
	}
	for (i = 1; i < MAX_DST_INDEX; i++) {
		((int *)dst_index)[i] = (int)NULL;
	}
	transition_t *temptrans = malloc(sizeof(transition_t));
	temptrans->action = (void *)0; //offset for memory
	temptrans->id = -1;
	temptrans->dst = -1;
	temptrans->src = -1;
	temptrans->flags = -1;
	temptrans->owner = 1; //indicates first free element
	memcpy(transitions, temptrans, sizeof(transition_t));
	temptrans->action = NULL;
	temptrans->id = -1;
	temptrans->dst = -1;
	temptrans->src = -1;
	temptrans->flags = -1;
	temptrans->owner = -1;
    for (i=1; i < MAX_TRANSITIONS; i++) { //copy the empty struct to every entry
    	memcpy((void *)((int)transitions+i*sizeof(transition_t)), (void *)temptrans, sizeof(transition_t));
    }
    free(temptrans);
	visited_expression_t *tempvisited_expression = malloc(sizeof(visited_expression_t));
	tempvisited_expression->flags = -1;
	tempvisited_expression->id = -1;
	tempvisited_expression->owner = 1; //indicates first free element
	tempvisited_expression->state = (void *)0; //offset for memory
	memcpy(visited_expressions, tempvisited_expression, sizeof(visited_expression_t));
	tempvisited_expression->flags= -1;
	tempvisited_expression->flags = -1;
	tempvisited_expression->owner = -1;
	tempvisited_expression->state = NULL;
	for (i=1; i < MAX_VISITED_EXPRESSIONS; i++) { //copy the empty struct to every entry
    	memcpy((void *)((int)visited_expressions+i*sizeof(visited_expression_t)), (void *)tempvisited_expression, sizeof(visited_expression_t));
    }
	free(tempvisited_expression);

	//increase semaphores initial, otherwise nobody could work, all would stop, waiting for another process to increase semaphore first
	semop(index_elements_semaphore_id, &release_semaphore, 1);
	semop(transitions_semaphore_id, &release_semaphore, 1);
	semop(visited_expressions_semaphore_id, &release_semaphore, 1);
	semop(symboltable_semaphore_id, &release_semaphore, 1);
	semop(ve_counter_semaphore_id, &release_semaphore, 1);
	semop(transition_counter_semaphore_id, &release_semaphore, 1);

	*(long *)ve_counter = 2;
	*(long *)transition_counter = 2;



}


/*
 * constructs term from shared memory
 */
void shmstorage_get_term(SP_term_ref term) {
	//print_table();
	int arity,ret;
	long id;
	void *node;
	node = NULL;
	SP_atom functor;

	SP_term_ref argument = SP_new_term_ref(); //create a new term
	SP_get_functor(term, &functor, &arity); //extract functor and number of children
	if (strcmp(SP_string_from_atom(functor), "visited_expression") == 0) {
		SP_get_arg(1, term, argument);
		ret = SP_get_integer(argument, &id);
		if (ret == 0) { id = 1; }
//		printf("get visited expression %li \n", id);
		SP_get_arg(2, term, argument);
		SP_term_ref term2 = get_visited_expression_state(id);
		SP_unify(argument, term2);
		visited_expression_t *ve = get_visited_expression(id);
		SP_get_arg(3, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, ve->owner);
		SP_unify(argument, term2);
		SP_get_arg(4, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, ve->flags);
		SP_unify(argument, term2);
//		printf("done\n");
		//		SP_term_ref term3 = SP_new_term_ref();
//		get_all_with_dst(id, term3);
//		SP_unify(argument, term3);
	} else if (strcmp(SP_string_from_atom(functor), "transition") == 0) {
		SP_get_arg(3, term, argument);
		ret = SP_get_integer(argument, &id);
		if (ret == 0) { id = 1; }
//		printf("get transition %li \n", id);
		SP_get_arg(2, term, argument);
		SP_term_ref term2 = get_transition_action(id);
		SP_unify(argument, term2);
		transition_t *t = get_transition(id);
		SP_get_arg(1, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, t->src);
		SP_unify(argument, term2);
		SP_get_arg(4, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, t->dst);
		SP_unify(argument, term2);
		SP_get_arg(5, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, t->owner);
		SP_unify(argument, term2);
		SP_get_arg(6, term, argument);
		term2 = SP_new_term_ref();
		SP_put_integer(term2, t->flags);
		SP_unify(argument, term2);

	} else if (strcmp(SP_string_from_atom(functor), "src") == 0) {
		SP_get_arg(1, term, argument);
		ret = SP_get_integer(argument, &id);
		if (ret == 0) { id = 1; }
//		printf("get all transitions with source %li\n", id);
		SP_get_arg(2, term, argument);
		SP_term_ref term2 = get_all_with_src(id);
		SP_unify(argument, term2);
	} else if (strcmp(SP_string_from_atom(functor), "dst") == 0) {
		SP_get_arg(1, term, argument);
		ret = SP_get_integer(argument, &id);
		if (ret == 0) { id = 1; }
//		printf("get all transitions with destination %li\n", id);
		SP_get_arg(2, term, argument);
		SP_term_ref term2 = get_all_with_dst(id);
		SP_unify(argument, term2);
	} else if (strcmp(SP_string_from_atom(functor), "all") == 0) {
		SP_get_arg(1, term, argument);
//		printf("get all transitions\n");
		SP_term_ref term2 = get_all_transitions();
		SP_unify(argument, term2);
	} else if (strcmp(SP_string_from_atom(functor), "allve") == 0) {
		SP_get_arg(1, term, argument);
//		printf("get all visited expressions\n");
		SP_term_ref term2 = get_all_visited_expressions();
		SP_unify(argument, term2);

	} else {
		printf("undefined term \n");
	}
}

//TODO comment this
/*
 *
 */
void shmstorage_get_transition_counter(long *counter) {
	semop(transition_counter_semaphore_id, &get_semaphore, 1); //lock index_elements space
	*counter = *(long *)transition_counter;
//	printf("transition counter: %li\n", *(long *)transition_counter);
	*(long *)transition_counter = *(long *)transition_counter + 1;
	semop(transition_counter_semaphore_id, &release_semaphore, 1); //lock index_elements space

}

//TODO comment this
/*
 *
 */
void shmstorage_get_counter(long *counter) {
	semop(ve_counter_semaphore_id, &get_semaphore, 1); //lock index_elements space
	*counter = *(long *)ve_counter;
//	printf("ve counter: %li\n", *(long *)ve_counter);
	*(long *)ve_counter = *(long *)ve_counter + 1;
	semop(ve_counter_semaphore_id, &release_semaphore, 1); //lock index_elements space
}

//TODO comment this
/*
 *
 */
void shmstorage_reset_counter(long counter) {
	semop(ve_counter_semaphore_id, &get_semaphore, 1); //lock index_elements space
	if (counter == 0) {counter = 2;}
	else if (counter == 1) {counter = 3;}

	*(long *)ve_counter = counter;
	semop(ve_counter_semaphore_id, &release_semaphore, 1); //lock index_elements space
}


/*
 * release all attached segments and semaphores.
 */
void shmstorage_shutdown() {
	//first detach shared memory segments, free them afterwards, if possible, otherwise the atempt will be ignored by system
	shmdt(transitions);
	shmctl(shmid_transitions, IPC_RMID, 0);
	shmdt(visited_expressions);
	shmctl(shmid_visited_expressions, IPC_RMID, 0);
	shmdt(src_index);
	shmctl(shmid_src_index, IPC_RMID, 0);
	shmdt(dst_index);
	shmctl(shmid_dst_index, IPC_RMID, 0);
	shmdt(transition_actions);
	shmctl(shmid_transition_actions, IPC_RMID, 0);
	shmdt(visited_expression_states);
	shmctl(shmid_visited_expression_states, IPC_RMID, 0);
	shmdt(index_elements);
	shmctl(shmid_index_elements, IPC_RMID, 0);
	shmdt(symboltable);
	shmctl(shmid_symboltable, IPC_RMID, 0);
	shmdt(ve_counter);
	shmctl(shmid_counter, IPC_RMID, 0);

	//the first process who calls the function destroys the semaphores, no process is allowed to leave a running computation
	semctl(index_elements_semaphore_id, 1, IPC_RMID, 0);
	semctl(transitions_semaphore_id, 1, IPC_RMID, 0);
	semctl(visited_expressions_semaphore_id, 1, IPC_RMID, 0);
	semctl(symboltable_semaphore_id, 1, IPC_RMID, 0);
	semctl(ve_counter_semaphore_id, 1, IPC_RMID, 0);
	semctl(transition_counter_semaphore_id, 1, IPC_RMID, 0);

	//free temporary chars
	free(tempstr);
	free(tempstr2);
	free(tempstrterm);
	free(nodeve);
	free(nodetrans);

}
