:- module(shmstorage, [shmstorage_init/0,shmstorage_attach/0, shmstorage_bootstrap/0, shmstorage_shutdown/0,shmstorage_add_term/1,shmstorage_get_term/1,shmstorage_get_transition_counter/1,shmstorage_get_counter/1,shmstorage_reset_counter/1,shmstorage_get_transition_id/1,shmstorage_get_transition_src/2,shmstorage_get_transition_dst/2,shmstorage_get_transition_all/1, shmstorage_get_ve_id/1, shmstorage_get_ve_all/1]).


foreign_resource(shmstorage, [shmstorage_attach, shmstorage_bootstrap, shmstorage_shutdown,shmstorage_add_term,shmstorage_get_term,shmstorage_get_transition_counter,shmstorage_get_counter,shmstorage_reset_counter]).

foreign(shmstorage_add_term, shmstorage_add_term(+term)).
foreign(shmstorage_attach, shmstorage_attach).
foreign(shmstorage_bootstrap, shmstorage_bootstrap).
foreign(shmstorage_get_term, shmstorage_get_term(+term)).
foreign(shmstorage_shutdown, shmstorage_shutdown).
foreign(shmstorage_get_transition_counter,shmstorage_get_transition_counter(-integer)).
foreign(shmstorage_get_counter,shmstorage_get_counter(-integer)).
foreign(shmstorage_reset_counter,shmstorage_reset_counter(+integer)).

shmstorage_get_transition_id(X) :- shmstorage_get_term(X).
shmstorage_get_transition_src(X,L) :- shmstorage_get_term(src(X,L)). 
shmstorage_get_transition_dst(X,L) :- shmstorage_get_term(dst(X,L)).
shmstorage_get_transition_all(L) :- shmstorage_get_term(all(L)). 

shmstorage_get_ve_id(X) :- shmstorage_get_term(X).
shmstorage_get_ve_all(L) :- shmstorage_get_term(allve(L)).

:- dynamic shmstorage_loaded/0.


shmstorage_init :- (shmstorage_loaded -> true
 ; (assert(shmstorage_loaded), 
    load_foreign_resource(library(shmstorage))),
    shmstorage_bootstrap
   ).

   test :- shmstorage_init, 
   	shmstorage_get_transition_all(X), print(X).