#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>

#define HASHSIZE 524288
#define ENTRY 21

static char a[HASHSIZE][ENTRY];
#ifdef DEBUG
static int collisions[10];
#endif

int checked_state_count = 0;

int get_checked_states_count() {
    return checked_state_count;
}

void print_key(char key[21]) {
    int o; for(o=0;o<21;o++) printf("%d ",key[o]);
}

int ith_index_of(char key[20], int i) {
    int index = ((key[0]*256*256 + 256 * key[1] + (key[2] & 224))/32);
    int jump = ((key[3]+256*key[4]) | 1);
    if (jump<0) jump = -jump;
    int x = (index + i * jump) % HASHSIZE; 
    if (x < 0) x = -x;
    return x;
}

int occupied(char key[21],int index) {
    if (memcmp(a[index],"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",20)==0) return 0;
    if (memcmp(a[index],key,20)==0) return 0;
    return 1;
}

int index_of(char key[20], int log_collision) {
    int i=0,p=0;
    while(1) {
        p=ith_index_of(key,i++);
        if (!occupied(key, p)) break;
        assert(i < HASHSIZE / 2);
    }
    #ifdef DEBUG
    if (log_collision) {
        if (i > 10) i = 10;
        collisions[i - 1]++;
    }
    #endif
    return p;
}

int contains(char key[21]) {
    int p = index_of(key, 0);
    //	print_key(key);printf("\n");
    //	print_key(a[p]);printf("\n");
    //	sleep(1);
    if (memcmp(a[p],"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",20)==0)
        return 0;
    if (memcmp(a[p],key,20)==0)
        return 1;
    return 0;
}

int contains_processed(char key[21]) {
    int p = index_of(key, 0);
    //	printf("pos: %i ",p);
    int result = 0;
    if (memcmp(a[p],"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",20)==0)
        result = 0;
    if (memcmp(a[p],key,20)==0 && a[p][20] == 1)
        result = 1;
    //	printf("r: %d\n",result);
    return result;
}

void put_local(char key[20]) {
    int p = index_of(key, 1);
    memcpy (a[p], key, 20);
    //a[p][20] = 0;
}

void put(char key[21]) { // yes, 21 is correct
    int p = index_of(key+1, 0);
    int cmp = memcmp(a[p],key+1,20);
    if (cmp == 0 && a[p][20] == 1)
        return;
    if (key[0] == 1)
        checked_state_count++;
    memcpy (a[p], key+1, 20);
    a[p][20] = key[0];
}

int count_elements() {
    int c =0 ;
    int i;
    for(i=0;i<HASHSIZE;i++) {
        if (memcmp(a[i],"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",20)!=0)
            c++;
    }

    printf("S: %i\n",c);
    return c;
}


void init_hashmap() {
    int i;
    for(i=0;i<HASHSIZE;i++) {
        memcpy (a[i], "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0", 21);
    }
}

int teardown() {
    // do nothing
    // just implementing the same interface as hashtrie
    return -1;
}

#ifdef DEBUG
void print_collisions() {
    printf("\nCollisions:\n");
    int i;
    for (i = 0; i < 10; i++) {
        printf(i == 0 ? "%d collisions: %d\n" : "Level %d collisions: %d\n", i, collisions[i]);
    }
}
#endif

/*
 * int main(void) {
 *	init();
 *	char *text="HJ48dsj^3_3s2}d3is71";
 *	char *text2="HJ49dsj^3_3s2}d3is71";
 *	put(text);
 *	put(text2);
 *	printf("%i\n",contains(text));	
 *	printf("%i\n",contains(text2));	
 *	while(1) {}
 *    return 3;
 }
 */
