#ifndef HASHTRIE_H_INCLUDED
#define HASHTRIE_H_INCLUDED
#include "keylist.h"

typedef struct Leaf {
    uint32_t checked;
    keyList *list;
} tLeaf;


struct Node {
    char type;
    union {
	struct Node **pointers;
	tLeaf *leaf_data;
    } ;
};

typedef struct Node tNode;

int teardown();
void print_key(char *key);
int contains(char key[21]);
int contains_processed(char key[21]);
void put_local(char key[20]);
void put(char key[21]);
int count_elements();
void init_hashmap();
int get_checked_states_count();
int calculate_pos(char *key, int depth);
char *iterate();
#ifdef VERBOSE
void setId(char *id2);
#endif

#endif
