#ifndef HEAP_H_INCLUDED
#define HEAP_H_INCLUDED
// WARNING: Requires C99 compatible compiler
  typedef struct Cell {
      char *term;
      char *digest;
      int term_length;
      int id;
      struct Cell* next; 
      int val;
  } tCell;
  typedef tCell* type;
  
  struct heap
  {
      unsigned int size; // Size of the allocated memory (in number of items)
      unsigned int count; // Count of the elements in the heap
      type *data; // Array with the elements
  };

  typedef struct heap wQueue;
   
  wQueue *init_queue();
  tCell *dequeue(wQueue *q);
  void enqueue(wQueue *q, char *term, int len, char digest[20], int thresh, int id);
  void enqueue_cell(wQueue *q, tCell *t);
  int is_empty(wQueue *q);
  int q_size(wQueue *q);
  void teardown_queue(wQueue **q);


  void heap_init(struct heap *h);
  void heap_push(struct heap *h, type value);
  void heap_pop(struct heap *h);
    
    // Returns the biggest element in the heap
#define heap_front(h) (*(h)->data)
     
     // Frees the allocated memory
#define heap_term(h) (free((h)->data))
      
  void heapify(type data[], unsigned int count);
#endif
