#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
//#include <math.h>
//#include "hashtrie.h"
#include "keylist.h"

#define KEYLENGTH 20
/*
typedef struct List {
    char *digest;
    struct keyList *next;
} keyList;
*/

int peek_position(keyList *l, int depth);
keyList *add_to_list(keyList *origin, keyList *l, int depth, int digest_pos, char *digest);

int list_contains(keyList *l, char *digest) {
    if (l == NULL)
        return 0;

    if (0 == memcmp(l->digest, digest, 20)) {
        return 1;
    }
    return list_contains(l->next, digest);
}

int free_position(keyList *list, int pos) {
    while (list != NULL) {
        if (list->pos < pos) {
            list = list->next;
        } else if (list->pos == pos) {
            return 0;
        } else {
            return 1;
        }
    }
    return 1;
}


keyList *insert(keyList *l, int depth, int digest_pos, char *digest) {
    assert(l != NULL);
    if (list_contains(l, digest)) {
        return l;
    }

    if (l->pos > digest_pos) {
        keyList *new = create_cell(digest, digest_pos);
        new->next = l;
        return new;
    } else if (l->pos == digest_pos) {
        // transforming is responsibility of the hashtrie
        assert(0);
    }

    keyList *p = l;
    keyList *q = l;
    while (p->next != NULL) {
        p = p->next;
        if (p->pos > digest_pos) {
            keyList *new = create_cell(digest, digest_pos);
            q->next = new;
            new->next = p;
            return l;
        } else if (p->pos == digest_pos) {
            // transforming is responsibility of the hashtrie
            assert(0);
        }
        q = q->next;
    }
    p = p->next;
    assert(p == NULL);
    assert(q != NULL);
    assert(q->next == NULL);
    keyList *new = create_cell(digest, digest_pos);
    q->next = new;
    return l;

}


keyList *create_cell(char *digest, int pos) {
    keyList *new = (keyList*) malloc(sizeof(keyList));
    assert(new);
    char *newdigest = (char*) malloc(KEYLENGTH);
    memcpy(newdigest, digest, 20);
    new->digest = newdigest;
    new->next = NULL;
    new->pos = pos;
    return new;
}


inline int peek_position(keyList *l, int depth) {
    int pos = l->pos;
    return pos;
}

keyList *teardown_cell(keyList *l) {
    keyList *tmp = l->next;
    free(l->digest);
    free(l);
    return tmp;
}

