:- module(master, [start_master/5, hash_matches/2]).

:- use_module(library(fastrw),[ fast_buf_read/2,fast_buf_write/3 ]).
:- use_module('../../src/module_information.pl').
:- module_info(group,experimental).
:- module_info(description,'This is the interface to C code for distributed model checking.').
:- module_info(revision,'$Rev: 9609 $').
:- module_info(lastchanged,'$LastChangedDate: 2011-11-18 10:43:02 +0100 (Fr, 18 Nov 2011) $').

foreign_resource('master', [wrapped_main, set_model, set_fwp, gen_hash, set_assertion_mode]).
%foreign(main, c, main(+address(char),+integer,+address(char),+integer)).
foreign(wrapped_main, c, wrapped_main(+integer,+integer,+integer,+string)).
foreign(set_fwp, c, set_fwp(+address(char),+integer)).
foreign(set_model, c, set_model(+address(char),+integer)).
foreign(gen_hash, c, gen_hash(+address(char),+integer,-codes)).
foreign(set_assertion_mode, c, set_assertion_mode).


%get_initialisation(Term) :- 
%  consult('/Users/bendisposto/Puzzle.eventb'),
%  package(Term),
%  (Term = load_event_b_project(_A,_B,_C,_D) -> true ; print(err(Term)),nl).

get_first_workpackage(assertions(_,_,_),assertion) :- set_assertion_mode.
get_first_workpackage(_,state(root)).

:- dynamic is_initialised/0.

init_zmq_master :- is_initialised,!.
init_zmq_master :- 
%    load_foreign_resource(master),
    load_foreign_resource(library(master)),
    assert(is_initialised).

hash_matches(State,Hash) :- 
   init_zmq_master,
   fast_buf_write(State,_Len1,_Addr1),
   gen_hash(_Addr1,_Len1,Hash).

start_master(Term,N,Time,MaxStates,StatFile) :- 
    init_zmq_master,
    get_first_workpackage(Term,WP), 
    fast_buf_write(Term,_Len1,_Addr1), 
    print(size_model(_Len1)),nl, 
    set_model(_Addr1, _Len1),
    fast_buf_write(WP,_Len2,_Addr2), 
    set_fwp(_Addr2, _Len2),
    wrapped_main(Time,N,MaxStates,StatFile).

find_hash(H,ID,B) :-
   state_space:visited_expression(ID,B),
   hash_matches(state(B),H).
