#ifndef QUEUE_H_INCLUDED
#define QUEUE_H_INCLUDED
typedef struct Cell {
    char *term;
    char *digest;
    int term_length;
    int id;
    struct Cell* next; 
    int val;
} tCell;

typedef struct Queue {
    tCell *first;
    tCell *last;
    int c;
} wQueue;

wQueue *init_queue();

void print_term(tCell *t);
void enqueue(wQueue *q, char *term, int len, char digest[20], int thresh, int id);
void enqueue_cell(wQueue *q, tCell *t);
void enqueue_fifo(wQueue *q, char *term, int len, char digest[20], int id);
void enqueue_lifo(wQueue *q, char *term, int len, char digest[20], int id);
tCell *dequeue(wQueue *q);
int is_empty(wQueue *q);
int q_size(wQueue *q);
void print_queue(wQueue *q);
void teardown_queue(wQueue **q);

#ifdef DEBUG
void enqueue_debug(wQueue *q, char *term, int len, char digest[20]);
void clear_debug(wQueue *q);
int check_debugq(wQueue *q, char digest[20], char *term, int len);
#endif

#endif
