#!/bin/bash

# create JUnit reports when calculating coverage
# running all tests might differ from the test suite used by make test
# to detect, check for errors again

mkdir -p testresults
rm -f testresults/*.xml
echo "<testsuite><testcase name=\"Hudson configuration\" classname=\"Configuration.Hudson\" time=\"0\"></testcase></testsuite>" > testresults/hudson.xml
export PROB_JUNIT_DIR="testresults"
export PROB_JUNIT=" -junit $PROB_JUNIT_DIR"

basepath="./coverage_reports"

rm -r $basepath

mkdir -p ${basepath}/html/$1
mkdir -p ${basepath}/tex/$1

if [ "$1" != "descriptions" ]; then
  mkdir -p ${basepath}/xml/$1
  mkdir -p ${basepath}/color/$1
  mkdir -p ${basepath}/emma/
fi

export DONTSTOP=true
export IGNORE_TIMEOUTS=true

now=$(date "+%Y-%m-%d")

sicstus -l src/prob_cov.pl --goal "generate_report($1,$now), halt ; halt".