% (c) 2009-2013 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(units_conversions, [
                         conversion_factor/3,
                         conversion_add/3
                       ]).

:- use_module(library(clpfd)).

:- use_module(probsrc(module_information)).
:- module_info(group,plugin_units).
:- module_info(description,'Units Plugin: This module lists conversion factors for different units.').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').

% conversion by multiplication
% special cases
conversion_factor([X,s,1],60,[X,mins,1]).
conversion_factor([X,mins,1],60,[X,h,1]).
conversion_factor([X,h,1],24,[X,d,1]).

% raylway special case: half-meters
conversion_factor([X,hm,1],2,[X,m,1]).

% general cases
conversion_factor([Factor,Unit,Power],10,[Factor2,Unit,Power]) :-
    Factor2 #= Factor + 1.

% conversion by addition - currently only one special cases
conversion_add([0,degC,1],273,[0,'K',1]).
