% b_arithmetic_expressions.pl
% returns for arithmetic expressions a symbolic value that can be called in CLP(FD)

b_compute_arith_expression(b(Expr,Type,Info),LS,S,R,WF) :-  !,
    ((ground(Type), Type  == integer) -> true
     ; add_error(b_compute_arith_expression,'Expression has illegal type: ',b(Expr,Type,Info))),
     b_compute_arith_expression2(Expr,Info,LS,S,R,WF).

b_compute_arith_expression(Expr,LS,S,R,WF) :-
  add_error(b_compute_arith_expression,'Expression not properly wrapped: ',Expr),
  b_compute_arith_expression2(Expr,unknown,LS,S,R,WF).
  
  
b_compute_arith_expression2(unary_minus(Arg1),_I,LocalState,State,Value,WF) :- !,  
        b_compute_arith_expression(Arg1,LocalState,State,SV1,WF),  
        Value = '-'(SV1).
b_compute_arith_expression2(add(Arg1,Arg2),_I,LocalState,State,Value,WF) :- !,  
        b_compute_arith_expression(Arg1,LocalState,State,SV1,WF),   
        b_compute_arith_expression(Arg2,LocalState,State,SV2,WF), 
        Value = '+'(SV1,SV2).
b_compute_arith_expression2(minus(Arg1,Arg2),_I,LocalState,State,Value,WF) :- !,  
        b_compute_arith_expression(Arg1,LocalState,State,SV1,WF),   
        b_compute_arith_expression(Arg2,LocalState,State,SV2,WF), 
        Value = '-'(SV1,SV2).
b_compute_arith_expression2(multiplication(Arg1,Arg2),_I,LocalState,State,Value,WF) :- !,  
        b_compute_arith_expression(Arg1,LocalState,State,SV1,WF),   
        b_compute_arith_expression(Arg2,LocalState,State,SV2,WF), 
        Value = '*'(SV1,SV2).
b_compute_arith_expression2(Expr,Info,LocalState,State,Value,WF) :-
        b_compute_expression2(Expr,integer,Info,LocalState,State,int(Value),WF).
      %  kernel_objects:basic_type2(integer,int(Value)).
        
        