:- module(parser_integration_test,[parser_benchmark/0,load_all_files/0]).

:- use_module(probsrc(tools)).

:- use_module(probsrc(module_information)).
:- module_info(group,repl).
:- module_info(description,'Integration tests for the B-Parsers (Java/Prolog').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').


:- use_module(probsrc(parsercall)).
:- use_module(bparser(sablecc_engine)).
:- use_module(bparser(check_ast)).
:- use_module(bparser(parser_call)).
:- use_module(library(lists)).
:- use_module(library(file_systems)).

parser_benchmark:-
	bagof(X,parser_test_file(X),FileList),
	maplist(load_file,FileList),
%	maplist(lex_file,FileList),
	statistics.


init_cd:-current_directory(_,'/home/fontaine/SVN/prob/trunk/prolog').


load_all_files:-
	bagof(X,parser_test_file(X),List),
	maplist(load_file,List).

lex_file(FileName):-
	print(FileName),nl,
	read_string_from_file(FileName,Content),
	lexString(state_BParser_NORMAL_0,Content,_LexerTokens).
	
load_file(FileName):-
	print(FileName),nl,
	catch(loadMachineHierarchy(FileName,complete_machine(_Main,_Machines,_Filenames,_Pragmas)),
	      parse_errors(Errors),
	      (add_all_perrors(Errors,[],parse_error),fail)).
%        check_parse_unit(FileName,Machines).


parser_test_file('examples/B/FeatureChecks/DEFINITIONS/SETPREF.mch').
parser_test_file('examples/B/FeatureChecks/DEFINITIONS/DefinitionScopeOk.mch').
parser_test_file('examples/B/FeatureChecks/ForAll_VariousVersions.mch').
parser_test_file('examples/B/FeatureChecks/NotMemberCheck.mch').
parser_test_file('examples/B/FeatureChecks/TestPrimedBecomeSuch.mch').
parser_test_file('examples/B/FeatureChecks/EmptyString.mch').
parser_test_file('examples/B/Simple/UpCounter_NonDet.mch').
parser_test_file('examples/B/Daniel/rel_fnc.mch').
parser_test_file('examples/B/PerformanceTests/WhileLoopBench.mch').
parser_test_file('examples/B/FeatureChecks/IFTHENELSE.mch').
parser_test_file('examples/B/Puzzles/Farmer.mch').
parser_test_file('examples/B/PerformanceTests/LargeSets/LargeExplicitSet.mch').
parser_test_file('examples/B/Benchmarks/CarlaTravelAgencyErr.mch').
parser_test_file('examples/B/SchneiderBook/Chapter12/TownsRRR.ref').
parser_test_file('examples/B/NewSyntax/SET_Game_Rec.mch').
parser_test_file('examples/B/ExpressionViewer/TotFunAnalyseTest.mch').
parser_test_file('examples/B/Puzzles/WhoKilledAgatha.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1.mch').
parser_test_file('examples/B/FeatureChecks/LET_multiple_variables.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1_prettyprinted.mch').
parser_test_file('examples/B/Demo/scheduler.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteClosures4.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteParityFunction.mch').
parser_test_file('examples/B/PerformanceTests/InfinitePartialSqrtFunction.mch').
parser_test_file('examples/B/ExternalFunctions/UsesLibraryMath.mch').
parser_test_file('examples/B/ExternalFunctions/PrologFun.mch').
parser_test_file('examples/B/ExternalFunctions/PrintExternal.mch').
parser_test_file('examples/B/ExternalFunctions/LibraryStrings.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteLanguageConcatenation.mch').
parser_test_file('examples/B/Kodkod/CrewAllocationConstantsLarge.mch').
parser_test_file('examples/B/TestCaseGeneration/SimpleCounter.mch').
parser_test_file('examples/B/ExternalFunctions/SortSet.mch').
parser_test_file('examples/B/RecursiveFunctions/RecursiveSeqLenFunction.mch').
parser_test_file('examples/B/RecursiveFunctions/Factorial.mch').
parser_test_file('examples/B/RecursiveFunctions/RecursiveSigmaCHOOSEv1.mch').
parser_test_file('examples/B/RecursiveFunctions/Tests/NestedDef.mch').
parser_test_file('examples/B/RecursiveFunctions/Tests/RecursiveIntegerEquation.mch').
parser_test_file('examples/B/RecursiveFunctions/Tests/RecursiveEnumEquation.mch').
parser_test_file('examples/CSPB/Dining/Dining.mch').
parser_test_file('examples/CSPB/Dining/Dining.mch').
parser_test_file('examples/B/Daniel/TestM.mch').
parser_test_file('examples/CSPB/Tickets/Treharne1/Test_corrected.mch').
parser_test_file('examples/B/SymmetryReduction/Fraikin/Library.mch').
parser_test_file('examples/B/Daniel/CommonSubLetBug.mch').
parser_test_file('examples/B/LTL/DerrickSmith/Abstract.mch').
parser_test_file('examples/B/LTL/Mikrowelle.mch').
parser_test_file('examples/CSPB/Dining/Dining.mch').
parser_test_file('examples/CSPB/Dining/Dining.mch').
parser_test_file('examples/B/LTL/DerrickSmith/Abstract.mch').
parser_test_file('examples/B/LTL/DerrickSmith/Abstract.mch').
parser_test_file('examples/TLA/GraphIso/GraphIso_tla.mch').
parser_test_file('examples/TLA/Login/Login_Deadlock_tla.mch').
parser_test_file('examples/B/Pragmas/SymbolicPragmas.mch').
parser_test_file('examples/B/Benchmarks/CarlaTravelAgencyErr.mch').
parser_test_file('examples/B/Benchmarks/RouteIsSeq.mch').
parser_test_file('examples/B/Benchmarks/Sets2.mch').
parser_test_file('examples/B/Benchmarks/Doors.mch').
parser_test_file('examples/B/Benchmarks/DSP0.mch').
parser_test_file('examples/B/Benchmarks/DSP0_complicated_initialisation.mch').
parser_test_file('examples/B/Benchmarks/CSM.mch').
parser_test_file('examples/B/Benchmarks/scheduler.mch').
parser_test_file('examples/B/Benchmarks/phonebook7.mch').
parser_test_file('examples/B/Benchmarks/tictac.mch').
parser_test_file('examples/B/Benchmarks/Teletext_bench.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1.mch').
parser_test_file('examples/B/BZTT/TestBZTT_Data.mch').
parser_test_file('examples/B/Daniel/Kodkod/Power2Nr.mch').
parser_test_file('examples/B/Daniel/Kodkod/Power2Nr.mch').
parser_test_file('examples/B/Daniel/Kodkod/StarTopologySingleSol.mch').
parser_test_file('examples/B/PerformanceTests/conc_seq_test.mch').
parser_test_file('examples/B/PerformanceTests/LargeSets/PartialFunCheck.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAll_NATURAL.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAllExpansion.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAllExpansian_Cartesian.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAllExpansion_Cartesian2.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAllExpansion_Cartesian2.mch').
parser_test_file('examples/B/PerformanceTests/ForAll/ForAllExpansion_Cartesian3.mch').
parser_test_file('examples/B/PerformanceTests/LargeSets/SeqCheck.mch').
parser_test_file('examples/B/PerformanceTests/SetLogInefficiencies.mch').
parser_test_file('examples/B/PerformanceTests/SetLogInefficiencies2.mch').
parser_test_file('examples/B/PerformanceTests/SetLogInefficiencies3.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteClosures.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteClosures2.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteAbsSqrt.mch').
parser_test_file('examples/B/PerformanceTests/InfCardChecks.mch').
parser_test_file('examples/B/PerformanceTests/ID_Checks.mch').
parser_test_file('examples/B/PerformanceTests/DirectProductPerformance.mch').
parser_test_file('examples/B/Mathematical/Sieve.mch').
parser_test_file('examples/B/Mathematical/BinomialCoefficients.mch').
parser_test_file('examples/B/Mathematical/SieveAlternate.mch').
parser_test_file('examples/B/Mathematical/GraphIso/CheckGraphIsomorphism.mch').
parser_test_file('examples/B/Mathematical/GraphIso/CheckLargeGraphIsomorphismAsConstants.mch').
parser_test_file('examples/B/Mathematical/Theories/FiniteSequences1.mch').
parser_test_file('examples/B/Mathematical/Theories/FiniteSequences2.mch').
parser_test_file('examples/B/PerformanceTests/SATLIB/flat200-90.mch').
parser_test_file('examples/B/PerformanceTests/SATLIB/sudoku.mch').
parser_test_file('examples/B/PerformanceTests/ConstraintPropagation/MaxPropagation.mch').
parser_test_file('examples/B/PerformanceTests/ConstraintPropagation/MaxPropagation2.mch').
parser_test_file('examples/B/PerformanceTests/ConstraintPropagation/SetMembershipInference.mch').
parser_test_file('examples/B/PerformanceTests/ConstraintPropagation/SetMembershipReification.mch').
parser_test_file('examples/B/Demo/SortByPermutation_v2.mch').
parser_test_file('examples/B/IPD/colouring/GraphColouringNAT2.mch').
parser_test_file('examples/B/BZTT/PO_Scheduler.mch').
parser_test_file('examples/B/PerformanceTests/SMTLIB/IDL_SimpleUnsat.mch').
parser_test_file('examples/B/PerformanceTests/SMTLIB/int_completeness1.mch').
parser_test_file('examples/B/PerformanceTests/SMTLIB/int_completeness1_event.mch').
parser_test_file('examples/B/PerformanceTests/SMTLIB/SquareEquivalenceProblem.mch').
parser_test_file('examples/B/PerformanceTests/clpfd_constraint_checks/IntegerComprSets.mch').
parser_test_file('examples/B/PerformanceTests/SeqEnumWithLargeMAXINT.mch').
parser_test_file('examples/B/PerformanceTests/ConstraintPropagation/SequenceSolving.mch').
parser_test_file('examples/B/PerformanceTests/SAT_Tests/SubsetReificationTest.mch').
parser_test_file('examples/B/Demo/monitor2.mch').
parser_test_file('examples/B/Demo/Symetric.mch').
parser_test_file('examples/B/Demo/scheduler.mch').
parser_test_file('examples/B/SymmetryReduction/scheduler1.ref').
parser_test_file('examples/B/SymmetryReduction/PairRelation.mch').
parser_test_file('examples/B/SymmetryReduction/SetRelation.mch').
parser_test_file('examples/B/SymmetryReduction/RussianPostalPuzzle.mch').
parser_test_file('examples/B/SymmetryReduction/TicTacToe_SimplerSym.mch').
parser_test_file('examples/B/SymmetryReduction/USB_4Endpoints.mch').
parser_test_file('examples/B/Puzzles/Hanoi6Sym.mch').
parser_test_file('examples/B/SymmetryReduction/Contrived/PartiallyEnumeratedSet.mch').
parser_test_file('examples/B/Demo/monitor2.mch').
parser_test_file('examples/B/Demo/DiningCryptographers.mch').
parser_test_file('examples/B/SymmetryReduction/Fraikin/Library_FullSym.mch').
parser_test_file('examples/B/SymmetryReduction/PhilRing.mch').
parser_test_file('examples/EventBPrologPackages/Records/SampleThreeRecordsTranslated.mch').
parser_test_file('examples/EventBPrologPackages/Records/INTEGER_Record.mch').
parser_test_file('examples/B/EventB_AtelierB/Lift.sys').
parser_test_file('examples/B/Tickets/305/Environment.mch').
parser_test_file('examples/B/Tickets/308/Basic_Controller.mch').
parser_test_file('examples/B/Benchmarks/CarlaTravelAgencyErr.mch').
parser_test_file('examples/B/PerformanceTests/dfcheck_houseset.mch').
parser_test_file('examples/B/PerformanceTests/BreadthFirstTest.mch').
parser_test_file('examples/B/PerformanceTests/DepthFirstTest.mch').
parser_test_file('examples/B/SymmetryReduction/Peterson_err.mch').
parser_test_file('examples/B/Demo/RussianPostalPuzzle.mch').
parser_test_file('examples/B/Demo/TrainTorchPuzzle.mch').
parser_test_file('examples/B/Puzzles/BlocksWorldGeneric.mch').
parser_test_file('examples/B/Puzzles/Farmer.mch').
parser_test_file('examples/B/Puzzles/Hanoi.mch').
parser_test_file('examples/B/Puzzles/Hanoi6.mch').
parser_test_file('examples/B/Puzzles/Hanoi8.mch').
parser_test_file('examples/B/Puzzles/Hanoi6Sym.mch').
parser_test_file('examples/B/Puzzles/Hanoi8Sym.mch').
parser_test_file('examples/B/Puzzles/water.mch').
parser_test_file('examples/B/Puzzles/LatinSquares.mch').
parser_test_file('examples/B/Puzzles/CrewAllocationConstants.mch').
parser_test_file('examples/B/Puzzles/Queens/QueensAllSolutions.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1.mch').
parser_test_file('examples/B/ErrorMachines/CardInfOverflow.mch').
parser_test_file('examples/B/ErrorMachines/TwoOpsSameName.mch').
parser_test_file('examples/B/ErrorMachines/PreCondViolated.mch').
parser_test_file('examples/B/ErrorMachines/AssertCondViolated.mch').
parser_test_file('examples/B/ErrorMachines/WhileLoopOk.mch').
parser_test_file('examples/B/ErrorMachines/WhileLoopVariantError.mch').
parser_test_file('examples/B/ErrorMachines/WhileLoopVariantErr2.mch').
parser_test_file('examples/B/ErrorMachines/WhileLoopInvariantError.mch').
parser_test_file('examples/B/ErrorMachines/FunLaws_wderror.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/DivByZero.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/DivByZeroInsideNotExists.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/PowerOfNegativeNumber.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedInter.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedBigINTER.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedSeqOperations/FrontEmptySeq.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/MaxOfEmptySet.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/MinOfEmptySet.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedSeqOperations/LastEmptySeq.mch').
parser_test_file('examples/B/ErrorMachines/UndefinedArithmetic/DivByZeroInsideNotExists.mch').
parser_test_file('examples/B/ErrorMachines/OpCalls/Caller.mch').
parser_test_file('examples/B/ErrorMachines/TypeError1.mch').
parser_test_file('examples/B/ErrorMachines/TypeError2.mch').
parser_test_file('examples/B/ErrorMachines/TypeError3.mch').
parser_test_file('examples/B/ErrorMachines/TypeError4.mch').
parser_test_file('examples/B/ErrorMachines/CstDefError1.mch').
parser_test_file('examples/B/ErrorMachines/CstDefError2.mch').
parser_test_file('examples/B/ErrorMachines/ParameterError1.mch').
parser_test_file('examples/B/ErrorMachines/TicTacToe_ErrOp.mch').
parser_test_file('examples/B/ErrorMachines/AssignmentToParameterErr.mch').
parser_test_file('examples/B/ErrorMachines/NoTypingForPara.mch').
parser_test_file('examples/B/ErrorMachines/RecursiveDefinition.mch').
parser_test_file('examples/B/ErrorMachines/SubstitutionSeqCompAssertErrCheck.mch').
parser_test_file('examples/B/Tickets/Sven1/AbsIntern.mch').
parser_test_file('examples/B/Tickets/Sven1/AbsInternCst.mch').
parser_test_file('examples/B/Tickets/Valerio1/MAX_BIT_VECTOR_DEFINITION_v2.mch').
parser_test_file('examples/B/Tickets/Valerio1/MAX_BIT_VECTOR_DEFINITION_v2.mch').
parser_test_file('examples/B/Tickets/Valerio1/MAX_BIT_VECTOR_DEFINITION_v2.mch').
parser_test_file('examples/B/Tickets/Valerio1/MAX_BIT_VECTOR_DEFINITION_v2.mch').
parser_test_file('examples/B/Tickets/Valerio3/BV16_DEFINITION.mch').
parser_test_file('examples/B/Tickets/Valerio3/POWER2.mch').
parser_test_file('examples/B/Tickets/Valerio3/POWER2.mch').
parser_test_file('examples/B/Tickets/Valerio4/FailingInit1.mch').
parser_test_file('examples/B/Tickets/Valerio4/FailingInit2.mch').
parser_test_file('examples/B/Tickets/Valerio4/FailingInit3.mch').
parser_test_file('examples/B/Tickets/Valerio4/FailingInit4.mch').
parser_test_file('examples/B/Tickets/Valerio4/FailingInit5.mch').
parser_test_file('examples/B/Tickets/Valerio6/Z80_Simple.mch').
parser_test_file('examples/B/Tickets/Alstom1/TestBecomesElementOf.mch').
parser_test_file('examples/B/Tickets/Alstom1/TestPFBecomeSuch.mch').
parser_test_file('examples/B/Tickets/Alstom1/MAXINT_M1.mch').
parser_test_file('examples/B/Tester/TestExistsLetExtraction.mch').
parser_test_file('examples/B/Tickets/177/loop_invariant.imp').
parser_test_file('examples/B/Tickets/181/alstom_memory.mch').
parser_test_file('examples/B/Tickets/Hansen1/Bi_func.mch').
parser_test_file('examples/B/Tickets/Burdy1/TestOrApplyFun.mch').
parser_test_file('examples/B/Tickets/Plagge1/KnightKnaves2.mch').
parser_test_file('examples/B/Tickets/Mejia2/ticket_simplified.mch').
parser_test_file('examples/B/Mathematical/Voting/NoCondorcetWinnerKodkod.mch').
parser_test_file('examples/B/Tickets/Beauger1/PredProblem.mch').
parser_test_file('examples/B/Tickets/Hansen3/TestingCircDef2.mch').
parser_test_file('examples/B/Benchmarks/scheduler.mch').
parser_test_file('examples/B/PerformanceTests/InfiniteParityFunction.mch').
parser_test_file('examples/B/Benchmarks/scheduler.mch').
parser_test_file('examples/B/Benchmarks/scheduler.mch').
parser_test_file('examples/B/Tickets/DefinitionCallSwallow/PerserDefBug.mch').
parser_test_file('examples/B/Laws/EqualityLaws.mch').
parser_test_file('examples/B/Laws/ExplicitComputations.mch').
parser_test_file('examples/B/Laws/BoolLaws.mch').
parser_test_file('examples/B/Laws/ArithmeticLaws.mch').
parser_test_file('examples/B/Laws/NatRangeLaws.mch').
parser_test_file('examples/B/Laws/RelLaws.mch').
parser_test_file('examples/B/Laws/SetLaws.mch').
parser_test_file('examples/B/Laws/SetLawsNat.mch').
parser_test_file('examples/B/Laws/REPL_UNIT_TESTS0.mch').
parser_test_file('examples/B/Laws/REPL_UNIT_TESTS1.mch').
parser_test_file('examples/B/Laws/REPL_UNIT_TESTS.mch').
parser_test_file('examples/B/Daniel/rel_fnc.mch').
parser_test_file('examples/B/Laws/CardinalityLaws.mch').
parser_test_file('examples/B/Laws/FunLaws.mch').
parser_test_file('examples/B/Laws/FunLawsWithLambda.mch').
parser_test_file('examples/B/Laws/REPL_UNIT_TESTS2.mch').
parser_test_file('examples/B/Laws/SubstitutionLaws.mch').
parser_test_file('examples/B/Laws/ExplicitComputationsCLPFD.mch').
parser_test_file('examples/B/Abrial_BBook/BBook_Page80.mch').
parser_test_file('examples/B/Abrial_BBook/BBook_Page83.mch').
parser_test_file('examples/B/Abrial_BBook/MembershipProperty4_Page96.mch').
parser_test_file('examples/B/Abrial_BBook/MembershipProperty5_Page96.mch').
parser_test_file('examples/B/Abrial_BBook/MembershipProperty6_Page96.mch').
parser_test_file('examples/B/Laws/BoolLaws_SetCompr.mch').
parser_test_file('examples/B/Laws/BoolLaws_SetComprCLPFD.mch').
parser_test_file('examples/B/Laws/StringLaws.mch').
parser_test_file('examples/B/Laws/RelLaws.mch').
parser_test_file('examples/B/Demo/Lift.mch').
parser_test_file('examples/B/Benchmarks/Cruise_finite1.mch').
parser_test_file('examples/B/Demo/RussianPostalPuzzle.mch').
parser_test_file('examples/B/CBC/NoDeadlock.mch').
parser_test_file('examples/B/CBC/SimpleDeadlock1.mch').
parser_test_file('examples/B/CBC/DeadlockIntBools.mch').
parser_test_file('examples/B/CBC/ProcessIDStarvation.mch').
parser_test_file('examples/B/CBC/ProcessIDStarvation_InvErr.mch').
parser_test_file('examples/B/CBC/MinSet_Deadlock.mch').
parser_test_file('examples/B/CBC/SimpleDeadlock1.mch').
parser_test_file('examples/B/Puzzles/StableMarriages.mch').
parser_test_file('examples/B/Puzzles/StableMarriagesLarger.mch').
parser_test_file('examples/B/Puzzles/GolombRuler.mch').
parser_test_file('examples/B/Puzzles/Tischordnung.mch').
parser_test_file('examples/B/Puzzles/Wegenetz.mch').
parser_test_file('examples/B/Demo/RussianPostalPuzzle.mch').
parser_test_file('examples/B/Demo/TrainTorchPuzzle.mch').
parser_test_file('examples/B/Puzzles/BlocksWorldGeneric.mch').
parser_test_file('examples/B/Puzzles/Farmer.mch').
parser_test_file('examples/B/Puzzles/Hanoi.mch').
parser_test_file('examples/B/Puzzles/water.mch').
parser_test_file('examples/B/Puzzles/PexSolve.mch').
parser_test_file('examples/B/Puzzles/KnightsTour.mch').
parser_test_file('examples/B/Puzzles/KnightsTour_v2.mch').
parser_test_file('examples/B/Puzzles/SudokuAsConstant.mch').
parser_test_file('examples/B/Puzzles/SudokuHexAsConstant.mch').
parser_test_file('examples/B/Puzzles/SudokuAsConstantNoSolution.mch').
parser_test_file('examples/B/Puzzles/LatinSquaresBig.mch').
parser_test_file('examples/B/Puzzles/NQueens50.mch').
parser_test_file('examples/B/Puzzles/TwoQueensSevenKnights.mch').
parser_test_file('examples/B/Puzzles/SendMoreMoney.mch').
parser_test_file('examples/B/Puzzles/KissPassion.mch').
parser_test_file('examples/B/Puzzles/CopySavePasteTools.mch').
parser_test_file('examples/B/Puzzles/NoNeighboursProblem.mch').
parser_test_file('examples/B/Puzzles/SubsetSum.mch').
parser_test_file('examples/B/Puzzles/SubsetSum2.mch').
parser_test_file('examples/B/Puzzles/WhoKilledAgatha.mch').
parser_test_file('examples/B/PerformanceTests/SMTLIB/DTP_k2_n35_c175_s1.mch').
parser_test_file('examples/B/Benchmarks/scheduler.mch').
parser_test_file('examples/B/CBC/NATURAL_Add.mch').
parser_test_file('examples/B/Demo/Lift.mch').
parser_test_file('examples/B/Tutorial/DoubleCounter.mch').
parser_test_file('examples/B/Special/ConstrainedBasedChecking/mesiSet.mch').
parser_test_file('examples/B/CBC/ProcessIDStarvation_InvErr.mch').
parser_test_file('examples/B/predicate_analysis/basic.mch').
parser_test_file('examples/B/predicate_analysis/function_cards.mch').
parser_test_file('examples/B/predicate_analysis/setext_dombug.mch').
