% (c) 2009 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(slicer_csp_executable, [make_executable/2]).

:- use_module(haskell_csp).

:- use_module(error_manager,'../error_manager', [extract_line_col/5]).

:- use_module(slicer_csp_CSCFG).

make_executable(MEB,NewFilename):-
 %  tell('aux.txt'),
 %  print('\''),
 %  print(Filename),
 %  print('.sliced.csp\'.'),nl,nl,
 %  told,
 %  see('aux.txt'),
%   read(NewFilename),
%   seen,
   
   print(me(MEB,NewFilename)),nl,
   /*print(new_filename(NewFilename)),nl,*/
   findall(CN,slice_compact_node(CN,_),CNs1),
   haskell_csp:inter_set(set(CNs1),set(MEB),set(CNs)),
   haskell_csp:diff_set(set(MEB),set(CNs),set(NMEB1)),
   uncompact_list(CNs,NMEB2),
   haskell_csp:union_set(set(NMEB1),set(NMEB2),set(NMEB)),
   retractall(slice_process_id(_)),
   retractall(slice_process_info(_,_,_,_)),
   assert(slice_process_id(0)),
   findall(Parallelism,slice_parallelism(Parallelism,_,_,_),Parallelims),
   findall(Hiding,slice_hiding(Hiding,_),Hidings),
   findall(Renaming,slice_renaming(Renaming,_,_),Renamings),
   haskell_csp:union_set(set(Parallelims),set(Hidings),set(NMEB__)),
   haskell_csp:union_set(set(NMEB__),set(Renamings),set(NMEB___)),
   haskell_csp:union_set(set(NMEB),set(NMEB___),set(NMEB_)),
   print(antes_gc),nl,
   get_channels(NMEB_,Channels),
   print(despues_gc),nl,
   /*tell('cia/slice.csp'),*/
   /*tell(NewFilename),*/
   print('channel '),
   print_events(Channels),nl,nl,
   make_executable_aux(0,NMEB,'MAIN',[],0),
   told.

/*
build_new_filename([C|Cs],NCs):-
   print(entra),nl,
   (length(Cs,L),L=3 ->
    NCs='sliced.csp';
    (
     build_new_filename(Cs,NCs1), 
     NCs=[C|NCs1]
    )
   ).
*/


get_channels([],[]).
get_channels([N|Ns],Channels):-
   (
    slice_event(N,Event)->
    (Event='hiddenEvent'-> Channels1=[];Channels1=[Event]);
    (
     slice_parallelism(N,Channels1,_,_);
     (slice_hiding(N,Channels1_),Channels1=[Channels1_]);
     (slice_renaming(N,Channels1_,Channels1__),Channels1=[Channels1_,Channels1__]);
     Channels1=[]
    )
   ),
   get_channels(Ns,Channels2),
   /*print(n_ch1_ch2(N,Channels1,Channels2)),nl,*/
   haskell_csp:union_set(set(Channels1),set(Channels2),set(Channels)).
   

get_id(Id):-
   slice_process_id(Id),
   retractall(slice_process_id(_)),
   NId is Id+1,
   assertz(slice_process_id(NId)),!.

make_executable_aux(N,MEB,Process,Param,Id):-
   print(Process),
   (Process='MAIN' -> true;print(Id)),
   (Param=[] -> true;print('('),print_events(Param),print(')')),
   print(' = '),
   (
    N = -1 ->
    print('STOP'),nl;
    (
     make_executable_aux2(N,MEB,Pending,true),nl,
     make_executable_aux3(Pending,MEB)
    )
   ).
/*nl,print(n_meb_process_id_pending(N,MEB,Process,Id,Pending)),nl,*/

make_executable_aux3([],_).
make_executable_aux3([(Process,Id,Next,Param)|Ps],MEB):-
   assert(slice_process_info(Process,Id,Next,Param)),
   make_executable_aux(Next,MEB,Process,Param,Id),
   make_executable_aux3(Ps,MEB).


make_executable_aux2(_,[],[],_).
make_executable_aux2(N,MEB,Pending,NoDraw):-
   slice_node(N,_,Type),
   (Type = 6,NoDraw -> Pending=[];
   (
   findall(M,slice_edge(N,M,2),Ms1),
   sort(Ms1,Ms2),
   haskell_csp:inter_set(set(Ms2),set(MEB),set(Ms)),
   /*nl,print(n_meb_ms_ms1_type(N,MEB,Ms,Ms2,Type)),nl,*/
   (Ms=[]-> 
    ((Type=4;Type=3)->
      (
       slice_if(N,Condition)->
       (print('if '),print(Condition),print(' then STOP else STOP'));
       (print('STOP '),build_RHS(N,Ms),print('STOP '))
      );
      ((Type=10;Type=11) -> print('STOP ');true),
       build_RHS(N,Ms)
    ),
    (slice_process_call(N,Process,Param)->
     (slice_edge(N,_,3)-> PendingB=[];(get_id(Id),PendingB=[(Process,Id,-1,Param)]));
     PendingB=[]
    );
    (
     Ms=[M_]-> 
     (
      (Type=4;Type=3) -> 
      (
       slice_parallelism(N,_,M_,_);slice_choice(N,_,M_,_)->
       (
        slice_if(N,Condition)->
        (
         print('if ('),print(Condition),print(') then '),
         make_executable_aux2(M_,MEB,PendingB,true),print(' else STOP')
        );
        (
         print('( '),make_executable_aux2(M_,MEB,PendingB,true),build_RHS(N,Ms)
        )
       );
       (
        slice_if(N,Condition)->
        (
         print('if ('),print(Condition),print(') then STOP else '),
         make_executable_aux2(M_,MEB,PendingB,true)
        );
        (
         build_LHS(N,Type),print('( '),make_executable_aux2(M_,MEB,PendingB,true),print(') ')
        )
       )
      );
      (
       (
        slice_process_call(N,Process,_)->
        (build_RHS(N,Ms),get_id(Id),PendingB=[(Process,Id,M_)]);
        (
         slice_hiding(N,_) ->
         (
          print('( ('),
          make_executable_aux2(M_,MEB,PendingB,true),
          print(') '),
          build_RHS(N,Ms)
         );
         (
          slice_renaming(N,_,_) ->
          (
           print('( ('),
           make_executable_aux2(M_,MEB,PendingB,true),
           print(') '),
           build_RHS(N,Ms)
          );
          build_RHS(N,Ms),make_executable_aux2(M_,MEB,PendingB,true)
         )
        )
       )
      )
     );
     Ms=[M1,M2],print('( ('),
     make_executable_aux2(M1,MEB,Pending1,true),
     print(') '),build_RHS(N,Ms),print(' ('),
     make_executable_aux2(M2,MEB,Pending2,true),
     print(') )'),
     haskell_csp:union_set(set(Pending1),set(Pending2),set(PendingB))
    )
   ),
   (
    slice_sequential(N,SC)->
    (
     make_executable_aux2(SC,MEB,PendingSC,false),
     haskell_csp:union_set(set(PendingB),set(PendingSC),set(Pending))
    );
    Pending=PendingB
    )
   )
   ).

build_RHS(N,Ms):-
   slice_node(N,_,Type),
   print_type(N,Type),
   (Ms=[]->
    (Type=1 -> print(' -> STOP ');
     ((Type=5;Type=6) -> print('STOP ');true)
    ); 
    (Ms=[_]->
     ((Type=4;Type=3) -> print('STOP )');true)
    );
    true
   ).

build_LHS(N,Type):-
   print('STOP '),
   print_type(N,Type).











/********************************************************/



print_type(Id,Type):-
   (
    slice_event(Id,Event) ->
    (
     slice_renamed_event(Id,OriEvent)->
     print(OriEvent);
     print(Event)
    );
    (slice_process_call(Id,Process,Param) ->
     (
      print(Process),
      (
       slice_edge(Id,LoopProcess,3)->
       (slice_edge(LoopProcess,Next,2),slice_process_info(Process,IdLoop,Next,_),
        print(IdLoop));      
       (slice_process_id(IdProcess),print(IdProcess))
      ),
      (Param=[] -> print(' ');(print('('),print_events(Param),print(') ')))
     );
     (
      (
       slice_parallelism(Id,Events,_,_) ->
       (
        Events=[]-> 
        print('|||');
        print('[| {|'),print_events(Events),print('|} |] ')
       );
       (
        slice_renaming(Id,Renamed,Renamer)->
        (
         print('[[ '),print(Renamed),print(' <- '),
         print(Renamer),print(' ]]) ')
        );
        (
         slice_choice(Id,TypeChoice,_,_)->
         choice2string(TypeChoice);
         (
          nodetype2string(Type),
          (
           slice_hiding(Id,HiddenEvent) ->
           print(HiddenEvent),print(') ');
           true
          )
         )
        )
       )
      )
     )
    )
   ).

print_events([]).
print_events([E|Es]):-
   print(E),
   (Es=[] -> print_events(Es);
    (print(','), print_events(Es))
   ).

nodetype2string(1):-print('event').
nodetype2string(2):-print('process_call').
nodetype2string(3):-print('||| ').
nodetype2string(4):-print('[] ').
nodetype2string(5):-print(' -> ').
nodetype2string(6):-print('; ').
nodetype2string(7):-print('SKIP ').
nodetype2string(8):-print('STOP ').
nodetype2string(9):-print('CompactNode ').
nodetype2string(10):-print('\\ ').
nodetype2string(11):-print('[[<-]] ').


choice2string(1):-print('|~|').
choice2string(2):-print('[]').
choice2string(3):-print('if').

uncompact_list([],[]).
uncompact_list([CN|CNs],MEB):-
   uncompact(CN,MEB1),
   uncompact_list(CNs,MEB2),
   haskell_csp:union_set(set(MEB1),set(MEB2),set(MEB)).

uncompact(CN,MEB):-
   slice_compact_node(CN,List),
   slice_edge(Start,CN,2),
   uncompact_aux(List,Start,Last,MEB),
   (slice_edge(CN,Next,2)->
    (assert(slice_edge(Last,Next,2)),retract(slice_edge(CN,Next,2)));
    true
   ),
   retract(slice_edge(_,CN,2)),
   retract(slice_node(CN,_,_)).
   

uncompact_aux([],L,L,[]).
uncompact_aux([(Id,SPAN,Type)|Ns],S,F,[Id|Ids]):-
   assert(slice_node(Id,SPAN,Type)),
   assert(slice_edge(S,Id,2)),
   uncompact_aux(Ns,Id,F,Ids).
