% (c) 2009-2010 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

% term_expansion/6 hook for the debugging_calls module
% this file should only be used by the debugging_calls module

:- use_module(module_information,[module_info/3]).

:- module_info(debugging_calls_te,group,infrastructure).
:- module_info(debugging_calls_te,description,'This sub-module contains the term-expansing code of the debugging call module').
:- module_info(debugging_calls_te,revision,'$Rev$').
:- module_info(debugging_calls_te,lastchanged,'$LastChangedDate$').

:- dynamic current_context/2.
current_context(none,none).

assert_layout(File,Layout,NewPos) :-
	print('Layout:'),print(Layout),nl,
	retractall(current_context(_,_)),
	( Layout = [NewPos|_] -> true
	; otherwise -> NewPos = none),
	assert(current_context(File,NewPos)).

logte(_Term,Layout) :-
	prolog_load_context(file,File),
	current_context(Before,OldPos),
	assert_layout(File,Layout,NewPos),
	( File=Before ->
	    true
	; otherwise ->
	    print('### start: '),
	    print(File),print('/'),print(NewPos),
	    print(', was: '),
	    print(Before),print('/'),print(OldPos),nl).
	

:- multifile user:term_expansion/6.
user:term_expansion(Term1, Layout1, Ids, Term2, Layout2, [rm_debug_calls|Ids]) :-
	nonvar(Term1), nonmember(rm_debug_calls,Ids),
	(Term1 = (:- meta_predicate '~~'(X))
	 -> print(not_removing_in_meta_predicate('~~'(X))),nl,
	   fail
	 ; true),
	!,
%	logte(Term1,Layout1),
	debugging_calls:remove_debugging_calls(Layout1,Term1,Layout2,Term2).
