% (c) 2009-2013 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(version, [ version/4,
                     revision/1,
                     lastchangeddate/1,
                     revision/1]).

:- use_module(module_information,[module_info/2,get_maximal_module_info/2]).

:- module_info(group,infrastructure).
:- module_info(description,'This module contains the current version number of ProB together with automatically updated version control infos.').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').

version(1,3,6,'final').

% this file needs to be touched and committed for information below to be updated!

get_revision(R) :- catch(read_revision(R),_,module_information:get_maximal_module_info(revision,R)).
lastchangeddate(X) :-
   module_information:get_maximal_module_info(lastchanged,X).


% Tries to read the revision file generated by make.
% If it does not come from svn, the fallback revision number is used.
read_revision(R) :- open('revision', read, ID),
                    read(ID,R), close(ID), (R='exported'->throw(not_in_svn);true).

:- dynamic  revision/1.
:- get_revision(X), assert(revision(X)).

