# (c) 2009-2012 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
# Heinrich Heine Universitaet Duesseldorf
# This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

# ------------------------------------------------------------
# ProB TCL file (from btracer_tcl.pl)
# ------------------------------------------------------------
# --------
# procedure to initialise menu section
# --------
   global batch_mode
   set batch_mode 0
   if {$tcl_version<8.4} {
	    tkErrorBox "You have Tcl/Tk Version $tcl_version.\nProB may not work correctly.\nPlease install version 8.4 or newer."
   }
   # puts "Tcl Version $tcl_version"
   global version shortversion prologversion
   prolog version:version(V1,V2,V3,Suffix)
   set shortversion "$prolog_variables(V1).$prolog_variables(V2).$prolog_variables(V3)"
   set version "$shortversion-$prolog_variables(Suffix)"
   prolog prolog_flag(version,PV)
   set prologversion "$prolog_variables(PV)"
   global revision lastchangeddate
   prolog version:revision(Rev)
   set revision $prolog_variables(Rev)
   prolog version:lastchangeddate(LCD)
   set lastchangeddate $prolog_variables(LCD)
   global normal_user expert_user
   set normal_user 0
   set expert_user 0
   global show_error_if_no_transition
   set show_error_if_no_transition 1
   global strFilename strFilenameTemporary logFile currentRefSpecFile cspstrFilename curFileDisplayed UsedCspStrFilename
   set  strFilename ""
   set  strFilenameTemporary ""
   set  logFile ""
   set curFileDisplayed "NONE"
   set UsedCspStrFilename ""
   global forceRecompile
   set forceRecompile 1
   set  currentRefSpecFile ""
   set  cspstrFilename ""
   global testing_mode failed_tests detailed_errors
   set testing_mode false
   set failed_tests ""
   set detailed_errors ""
   global only_eventb_menues
   global csp_assertions_dialog_arr
   array set csp_assertions_dialog_arr {
        fontname 			"Curier"
   	fontsize 			10
   	background 			"Gray90"
   	selectcolor 			"gray60"
   	spec 				""
   	impl 				""
   	ref_model 	        	"Trace"
   	deterministic_proc   		""
   	deterministic_model		"Failure"
   	deadlock_proc 			""
   	deadlock_model 			"Failure"
   	livelock_proc 			""
   	selected_notebook_type 		"Refinement"
	assertion_check_running		false
        listbox_size			0
        current_new_assertions		{}
        all_new_assertions		{}
   }
   global eval_window_arr
   array set eval_window_arr {
        b_hist_index   0
        csp_hist_index 0
        input          ""
        input_index    "2.5"
        b_history      {}
        csp_history    {}
	proCSPInterpreter true
   }
   set only_eventb_menues [list]
   global find_menu_arr
   array set find_menu_arr {
        case         false
        word         false
        backwards    false
        wraparound   true 
        allpatterns  false
        search       ""
        replace      ""
        exact_flag   ""
        found_index  ""
        direction    "-forwards"
        search_hist  {}
        replace_hist {}
   }
   global text_editor_arr
   array set text_editor_arr {
        ctext_package   			false
        text_index      			"1.0"
        file_modified   			false
        file_last_modified			""
	current_timestamp			""
        high_line_index 			0
        reopening_file			        false
        deactivate_asking_for_reloading		false
        font_name				""
        font_size				""
        highlight_bracket			true
        highlight_line				true
        linenumbers				false
        ask_when_content_changed		false
	last_timestamped_file			""
	disable_comments_highlighting		false
	disable_highlighting			false
   }
	global ltldata
	array set ltldata {
		formula	""
		mode		""
		result	""
		ok		false
		hist		{}
	}
   namespace import ::evaluationView::*
   namespace import ctext::*
   # patch: to resolve the problem that displaying error messages hangs in Active Tcl/Tk 8.6 or 8.5.9.2
   # question: does it affect Linux/Mac ?? if [prolog tools:host_platform(darwin)]
proc bgerror {msg} {
   tk_messageBox -icon info -message $msg
}

proc procGUI_Menu {} {
    global normal_user
    set normal_user [prolog preferences:get_preference(user_not_beginner,true)]
    global expert_user
    set expert_user [prolog preferences:get_preference(user_is_an_expert_with_accessto_source_distribution,true)]
    global plugin_menu_index
    global plugin_deactivate_index
    set plugin_menu_index -1
    global plugin_preferences_menu_index
    set plugin_preferences_menu_index -1
#    frame .frmMenu
    frame .main -width 860 -height 680
    # top level menu bar
    # option add *tearoff 0
    menu .frmMenu -tearoff 0

    # -tearoff 0 was removed for Leopard 
    . config -menu .frmMenu
    if {[prolog tools:host_platform(darwin)] || [prolog tools:host_platform(windows)]} {
           bind .frmMenu <<MenuSelect>> {proc_updateMenuEntryStates}
    } else {
           bind .frmMenu <Any-Motion> {proc_updateMenuEntryStates}
    }

    foreach m {File Edit Animate Verify Analyse Plugins Preferences Debug Files Help} {
        set $m [menu .frmMenu.mnu$m -tearoff 0]
        .frmMenu add cascade -label $m -menu .frmMenu.mnu$m
    }

    # -------------------- file menu
#    menu .frmMenu.mnuFile -tearoff 0
    set AccKey [procGetAccKey]
    set AccKeyComb "Alt+$AccKey"
    .frmMenu.mnuFile add command -label "New..." -underline 0 -command procNewFile -accelerator $AccKey+N
    .frmMenu.mnuFile add command -label "Open..." -underline 0 -command procOpenFile -accelerator $AccKey+O
    .frmMenu.mnuFile add command -label "Reopen" -underline 0 -command procReOpenFile -accelerator $AccKey+R -state disabled
    .frmMenu.mnuFile add command -label "Save" -underline 0 -command procSaveFile -accelerator $AccKey+S -state disabled
    .frmMenu.mnuFile add command -label "Save and Reopen" -command procSaveAndReopenFile -state disabled
    .frmMenu.mnuFile add command -label "Save As..." -command procSaveAsFile -state disabled
    .frmMenu.mnuFile add sep
    .frmMenu.mnuFile add command -label "Save Statespace" -command procSaveState -state disabled
    .frmMenu.mnuFile add command -label "Load Saved Statespace" -command procLoadState -state disabled
    .frmMenu.mnuFile add sep
    if {$normal_user} {
		.frmMenu.mnuFile add command -label "Open in External Editor" -command procOpenFileInEditor -state disabled -accelerator $AccKey+E
		.frmMenu.mnuFile add cascade -label "Open Special" \
				-menu .frmMenu.mnuFile.mnuOpenSpecial
		.frmMenu.mnuFile add sep
    }
    .frmMenu.mnuFile add cascade -label "Recent Files" \
				-menu .frmMenu.mnuFile.mnuRecentDocuments
    .frmMenu.mnuFile add sep
    .frmMenu.mnuFile add command -label "Quit" -underline 0 -command procDoQuit -accelerator $AccKey+Q

     .frmMenu.mnuEdit add command -label "Undo" -command procundo -accelerator $AccKey+Z -state disabled
     .frmMenu.mnuEdit add command -label "Redo" -command procredo -state disabled -accelerator Shift-$AccKey+Z
    .frmMenu.mnuEdit add sep

    .frmMenu.mnuEdit add command -label "Cut" -command {procCutOrCopySlectedRangeOfText "no"} -accelerator $AccKey+X -state disabled
    .frmMenu.mnuEdit add command -label "Copy" -underline 0 -command {procCutOrCopySlectedRangeOfText "yes"} -accelerator $AccKey+C -state disabled
    .frmMenu.mnuEdit add command -label "Paste" -command {procPasteTheCopiedRangeOfText} -accelerator $AccKey+V -state disabled
    .frmMenu.mnuEdit add command -label "Delete" -command procDeleteTheSelectedRangeOfText -state disabled
    .frmMenu.mnuEdit add sep
    .frmMenu.mnuEdit add command -label "Select All" -underline 7 -command {proc_selectAll} -accelerator $AccKey+A -state disabled
    .frmMenu.mnuEdit add sep

     global find_menu_arr
     prolog preferences:get_history_elements_list(searched_patterns,true,SearchedPat)
     prolog preferences:get_history_elements_list(replaced_patterns,true,ReplacedPat)
     set find_menu_arr(search_hist) $prolog_variables(SearchedPat)
     set find_menu_arr(replace_hist) $prolog_variables(ReplacedPat)

    .frmMenu.mnuEdit add cascade -label "Search" -menu .frmMenu.mnuEdit.mnuSearch
    menu .frmMenu.mnuEdit.mnuSearch -tearoff 0
    .frmMenu.mnuEdit.mnuSearch add command -label "Find..." -command procLaunchFindMenu -accelerator $AccKey+F
    .frmMenu.mnuEdit.mnuSearch add command -label "Replace..." -command procLaunchFindAndReplaceMenu -accelerator Shift-$AccKey+F
    .frmMenu.mnuEdit.mnuSearch add command -label "Goto Line..." -command {GotoLineSelect}
    .frmMenu.mnuEdit add sep
    .frmMenu.mnuEdit add cascade -label "Unicode Options" -menu .frmMenu.mnuEdit.mnuUnicode -state disabled

    menu .frmMenu.mnuEdit.mnuUnicode -tearoff 0
    .frmMenu.mnuEdit.mnuUnicode add command -label "To Unicode Symbols" -command toUnicodeCommand
    .frmMenu.mnuEdit.mnuUnicode add command -label "Remove Unicode Symbols" -command fromUnicodeCommand
    # -------------------- Open Special menu
    menu .frmMenu.mnuFile.mnuOpenSpecial -tearoff 0
   .frmMenu.mnuFile.mnuOpenSpecial add command -label "Use CSP File to Guide B..." -command procAddCSPFile
   .frmMenu.mnuFile.mnuOpenSpecial add command -label "Use Default CSP File" -underline 7 -command procAddDefaultCSPFile -accelerator $AccKey+minus
   #.frmMenu.mnuFile.mnuOpenSpecial add command -label "Add XTL File..." -command procAddXTLFile

    # -------------------- Open Special menu
    menu .frmMenu.mnuFile.mnuRecentDocuments -tearoff 0
    procRebuildRecentDocumentsMenu

    # -------------------- Animate menu
#    menu .frmMenu.mnuAnimate -tearoff 0
    .frmMenu.mnuAnimate add command -label "Reset" -command procReset
    .frmMenu.mnuAnimate add sep
    .frmMenu.mnuAnimate add command -label "Random Animation (10)" -command procRand
    .frmMenu.mnuAnimate add command -label "Random Animation..." -command procRandAny
    .frmMenu.mnuAnimate add sep
    .frmMenu.mnuAnimate add command -label "Find State Satisfying Predicate..." \
        -command procAdvancedFind  -accelerator $AccKey+Y
    .frmMenu.mnuAnimate add cascade -label "Find" \
        -menu .frmMenu.mnuAnimate.mnuFind
    .frmMenu.mnuAnimate add sep
    .frmMenu.mnuAnimate add command -label "View Statespace" \
       -underline 11 -command procDisplayVisitedStates -accelerator $AccKey+D
     .frmMenu.mnuAnimate add cascade -label "View" \
            -menu .frmMenu.mnuAnimate.mnuDisp
    if {$normal_user} {
    .frmMenu.mnuAnimate add sep
    .frmMenu.mnuAnimate add command -label "Execute an Operation ..." -command procExecuteOperation -accelerator $AccKey+W
    .frmMenu.mnuAnimate add sep
		# .frmMenu.mnuAnimate add command -label "Show Trace to Current State..."\
				-command {procFindTrace "no"}
		.frmMenu.mnuAnimate add command -label "Show Shortest Trace to Current State"\
				-command {procFindTrace}
		#.frmMenu.mnuAnimate add command -label "Execute Trace to Current State..." -command procExecTrace
		# .frmMenu.mnuAnalyse add sep
		.frmMenu.mnuAnimate add command -label "Show Current B State"\
				-command {procShowCurrentState}
     if {$expert_user} {
    .frmMenu.mnuAnimate add command -label "Slowly Execute Trace to Current State" \
               -command {procReExecuteTraceToCurNode}
     }
    }


         #Display sub menu
    menu .frmMenu.mnuAnimate.mnuDisp -tearoff 0
    .frmMenu.mnuAnimate.mnuDisp add command -label "Shortest Trace to Current State" \
       -command {procDisplayTraceToCurrentState "yes"} -state normal
    .frmMenu.mnuAnimate.mnuDisp add command -label "History to Current State" \
       -command {procDisplayTraceToCurrentState "no"} -state normal
    .frmMenu.mnuAnimate.mnuDisp add command -label "Current State" \
       -command {procDisplayCurrentState "no"} -state normal
    if {$normal_user} {
    .frmMenu.mnuAnimate.mnuDisp add command -label "Current State as Graph" \
       -command {procDisplayCurrentState "yes"} -state normal
    .frmMenu.mnuAnimate.mnuDisp add sep
    .frmMenu.mnuAnimate.mnuDisp add command -label "Transition Diagram for Custom Expression..." \
       -command {procDisplayTransitionDiagram} -state normal
    .frmMenu.mnuAnimate.mnuDisp add sep
    .frmMenu.mnuAnimate.mnuDisp add command -label "Signature-Merge Reduced Statespace" \
       -command {procDisplayReducedSigMerge} -state normal -accelerator $AccKey+K
    .frmMenu.mnuAnimate.mnuDisp add command -label "DFA Reduced Statespace" \
       -command {procDisplayReducedDFA} -state normal
    .frmMenu.mnuAnimate.mnuDisp add command -label "Select Operations & Arguments for Reduction" \
        -command procShowArgChooser; ## Argument chooser for DFA
     if {$expert_user} {
    .frmMenu.mnuAnimate.mnuDisp add sep
    .frmMenu.mnuAnimate.mnuDisp add command -label "Subgraph leading to Invariant Violation" \
       -command {procSubgraph "invariant"} -state normal
    .frmMenu.mnuAnimate.mnuDisp add command -label "Subgraph for GOAL" \
       -command {procSubgraph "goal"} -state normal
		.frmMenu.mnuAnimate.mnuDisp add sep
		.frmMenu.mnuAnimate.mnuDisp add command -label "Current State as Custom Graph" \
		   -command {procDisplayCurrentState "custom"} -state normal
		.frmMenu.mnuAnimate.mnuDisp add sep
		.frmMenu.mnuAnimate.mnuDisp add command -label "Neigbourhood (1)" \
		   -command {procDisplayVisitedStatesUpTo 1} -state normal
		.frmMenu.mnuAnimate.mnuDisp add command -label "Neigbourhood (2)" \
		   -command {procDisplayVisitedStatesUpTo 2} -state normal
		.frmMenu.mnuAnimate.mnuDisp add command -label "Neigbourhood (3)" \
		   -command {procDisplayVisitedStatesUpTo 3} -state normal
       }
   }
       
    # -------------------- Verify menu
#    menu .frmMenu.mnuVerify -tearoff 0
    .frmMenu.mnuVerify add command -label "Model Check..." -underline 0 -command procModelCheck -accelerator $AccKey+M
   # .frmMenu.mnuVerify add cascade -label "Search Settings" \
        -menu .frmMenu.mnuVerify.mnuMCOptions
    .frmMenu.mnuVerify add sep
    .frmMenu.mnuVerify add command -label "Check LTL Formula..." \
        -underline 6 -command procLtl -accelerator $AccKey+L
    .frmMenu.mnuVerify add command -label "Check LTL Assertions" \
        -command {CheckLtlAssertions}
    .frmMenu.mnuVerify add command -label "Check CSP-M Assertions" \
        -command {CheckCspAssertions}
    .frmMenu.mnuVerify add command -label "Check CTL Formula..." \
        -command procCtl
		.frmMenu.mnuVerify add sep
	   .frmMenu.mnuVerify add command -label "Trace Refinement Check..." \
		           -command procRefinementCheck
	   .frmMenu.mnuVerify add command -label "Save State for Later Refinement Check" \
		           -command procSaveSpecStateForRefinement
    if {$normal_user} {
		.frmMenu.mnuVerify add sep
        .frmMenu.mnuVerify add cascade -label "Constraint Based Checking" \
            -menu .frmMenu.mnuVerify.mnuCBC
		.frmMenu.mnuVerify add sep
        .frmMenu.mnuVerify add cascade -label "External Tools" \
            -menu .frmMenu.mnuVerify.mnuRef
		.frmMenu.mnuVerify add sep
        .frmMenu.mnuVerify add cascade -label "Trace Checking" \
            -menu .frmMenu.mnuVerify.mnuTrace
    }

         #CBC menu
    menu .frmMenu.mnuVerify.mnuCBC -tearoff 0
	.frmMenu.mnuVerify.mnuCBC add command -label "Check Invariant Preservation for Operations" \
		-command {execInBZMode procConstraintBasedCheck}
	.frmMenu.mnuVerify.mnuCBC add command -label "Check Invariant for Specific Operation..." \
		-command {execInBZMode procOpConstraintBasedCheck}
    .frmMenu.mnuVerify.mnuCBC add sep
	.frmMenu.mnuVerify.mnuCBC add command -label "Generate a Valid State" \
		-command {execInBZMode procConstraintFindValidState}
	.frmMenu.mnuVerify.mnuCBC add command -label "Find Sequence..." \
		-command {execInBZMode procCBCFindSequence}
    .frmMenu.mnuVerify.mnuCBC add sep
	.frmMenu.mnuVerify.mnuCBC add command -label "Find Deadlock" \
		-command {execInBZMode procFindDeadlockedState}
	.frmMenu.mnuVerify.mnuCBC add command -label "Find Deadlock Satisfying Predicate..." \
		-command {execInBZMode procFindDeadlockedStateWithPred}
    .frmMenu.mnuVerify.mnuCBC add sep
	.frmMenu.mnuVerify.mnuCBC add command -label "Check Assertions on Constants" \
		-command {execInBZMode procFindStaticAssertionViolation}
    if {$expert_user} {
        .frmMenu.mnuVerify.mnuCBC add sep
	.frmMenu.mnuVerify.mnuCBC add command -label "Dependence Analysis (Table)" \
		-command {execInBZMode procDependenceAnalysis}
	.frmMenu.mnuVerify.mnuCBC add command -label "Dependence Analysis (Graph)" \
		-command {execInBZMode procDependenceAnalysis_Graph}
	.frmMenu.mnuVerify.mnuCBC add command -label "Enabling Analysis (Table)" \
		-command {execInBZMode procEnablingAnalysisShort}
	.frmMenu.mnuVerify.mnuCBC add command -label "Enabling Analysis (Precise, Table)" \
		-command {execInBZMode procEnablingAnalysisLong}
	.frmMenu.mnuVerify.mnuCBC add command -label "Enabling Analysis (Graph)" \
		-command {execInBZMode procEnablingAnalysis_Graph}

	.frmMenu.mnuVerify.mnuCBC add sep
	.frmMenu.mnuVerify.mnuCBC add command -label "Refinement Checking" \
		-command {execInBZMode procCBCRefinementCheck}
    }
    
         #Refinement Check menu
    menu .frmMenu.mnuVerify.mnuRef -tearoff 0
	 .frmMenu.mnuVerify.mnuRef add command -label "Typecheck" \
		-command procTypeCheckFile  -accelerator $AccKey+B
		if {$normal_user} {
		 .frmMenu.mnuVerify.mnuRef add command -label "Typecheck Internal Representation" \
			-command procTypeCheck_PPF_BFile
		}
		.frmMenu.mnuVerify.mnuRef add sep
	 .frmMenu.mnuVerify.mnuRef add command -label "Save State to FDR/CSP File" \
		-command procSaveStateToFDR
	 .frmMenu.mnuVerify.mnuRef add command -label "Check Statespace with FDR" \
		-underline 22 -command procCheckStatespaceWithFDR -accelerator $AccKey+U
	 .frmMenu.mnuVerify.mnuRef add command -label "Open Specification with FDR" -command procOpenFDROnSpec
     .frmMenu.mnuVerify.mnuRef add sep
                      .frmMenu.mnuVerify.mnuRef add command -label "Evaluate with the CSPM-Interpreter" \
                                          -command {if [prolog animation_mode(cspm)] {
                                                        set eval_window_arr(proCSPInterpreter) false
							procEvalConsole
                                                    } else {
                                                        tkErrorBoxNoParent "Can only be applied to CSP specifications."
                                                        } }
     .frmMenu.mnuVerify.mnuRef add sep      
	 .frmMenu.mnuVerify.mnuRef add command -label "Save State to Spin/Promela File" \
		-command procSaveStateToSPIN
	 .frmMenu.mnuVerify.mnuRef add command -label "Save State to Never Claim" \
		-command procSaveStateToNeverClaim
	 .frmMenu.mnuVerify.mnuRef add command -label "Print Event-B model as classical B" \
		-command procPrintAsEventB -state disabled
     global only_eventb_menues
    lappend only_eventb_menues [list .frmMenu.mnuVerify.mnuRef [.frmMenu.mnuVerify.mnuRef index end]]

         #Trace Check menu
    menu .frmMenu.mnuVerify.mnuTrace -tearoff 0
     .frmMenu.mnuVerify.mnuTrace add command -label "Save History to Trace File" \
        -command {procSaveTraceFile 0}
     .frmMenu.mnuVerify.mnuTrace add command -label "Check Trace from Trace File" \
        -underline 6 -command {procCheckTraceFile} -accelerator $AccKey+T
     .frmMenu.mnuVerify.mnuTrace add sep
     .frmMenu.mnuVerify.mnuTrace add command -label "Save History to other File..." \
        -command {procSaveTraceFile 1}
     .frmMenu.mnuVerify.mnuTrace add command -label "Check Trace from other File..." \
			-command procCheckOtherTraceFile
    if {$expert_user} {
     .frmMenu.mnuVerify.mnuTrace add sep
     .frmMenu.mnuVerify.mnuTrace add command -label "Generate FDR Check from History..." \
			-command {prologmnf b_trace_checking:print_trace_as_fdr_check}
     }
     .frmMenu.mnuVerify.mnuTrace add sep
     .frmMenu.mnuVerify.mnuTrace add command -label "Save History to B File..." \
        -command procSaveBTraceFile



    # -------------------- Analyse menu
#    menu .frmMenu.mnuAnalyse -tearoff 0
    .frmMenu.mnuAnalyse add cascade -label "Coverage" \
            -menu .frmMenu.mnuAnalyse.mnuCoverage
    .frmMenu.mnuAnalyse add command -label "Show Typing" -command procShowTyping
     .frmMenu.mnuAnalyse add sep
     .frmMenu.mnuAnalyse add cascade -label "Analyse Predicate" \
            -menu .frmMenu.mnuAnalyse.mnuDebugPred
     .frmMenu.mnuAnalyse add cascade -label "Analyse Graphically" \
            -menu .frmMenu.mnuAnalyse.mnuVisualise
     .frmMenu.mnuAnalyse add command -label "Open Evaluation View" \
        -command openEvaluationView -accelerator $AccKey++
    if {$normal_user} {
    .frmMenu.mnuAnalyse add command -label "Save Values..." -command procSaveValuesToFile
    .frmMenu.mnuAnalyse add command -label "Eval..." -command {procEvalConsole}
    }
     .frmMenu.mnuAnalyse add sep
     .frmMenu.mnuAnalyse add command -label "View Machine Hierarchy" \
        -underline 13 -command procViewModuleHierarchy -accelerator $AccKey+H
    if {$normal_user} {
        .frmMenu.mnuAnalyse add sep
        .frmMenu.mnuAnalyse add cascade -label "Testing" \
            -menu .frmMenu.mnuAnalyse.mnuTest
		  if {$expert_user} {
			 .frmMenu.mnuAnalyse add sep
			 .frmMenu.mnuAnalyse add command -label "Analyze Hash Collisions" -command {prologmnf analyze_hash_collisions}
			 .frmMenu.mnuAnalyse add sep
			 # .frmMenu.mnuAnalyse add command -label "Slice (experimental)" -command procSliceProgramPoint
                         .frmMenu.mnuAnalyse add cascade -label "Slicing" \
                              -menu .frmMenu.mnuAnalyse.mnuSlicer
#			 .frmMenu.mnuAnalyse add command -label "AbsInt (experimental)" -command procAbsInt
#			 .frmMenu.mnuAnalyse add command -label "Show Enable Graph (experimental)" -command procFlowEnableGraph
#			 .frmMenu.mnuAnalyse add command -label "Show Enable Graphs (experimental)" -command procFlowEnableGraphs
#			 .frmMenu.mnuAnalyse add command -label "Show Base Guide Automaton (experimental)" -command procBaseGuide			
#			 .frmMenu.mnuAnalyse add command -label "Show Event Guide Automaton (experimental)" -command procEventGuide					
             .frmMenu.mnuAnalyse add command -label "Show Predicate Analysis of Properties" -command procShowPropertiesAnalysis
		   }
    }

    # -------------------- Find menu
    menu .frmMenu.mnuAnimate.mnuFind -tearoff 0
    .frmMenu.mnuAnimate.mnuFind add command -label "Find State Enabling an Operation..." \
        -command {procFindEnabledOp}
    .frmMenu.mnuAnimate.mnuFind add command -label "Find a Non-Deterministic State" \
        -command procJumpToNonDetNode
    .frmMenu.mnuAnimate.mnuFind add command -label "Find a Branching State" \
        -command procJumpToBranchingNode
    .frmMenu.mnuAnimate.mnuFind add command -label "Find a Non-Resetable State" \
        -command procJumpToNonResetableNode
    .frmMenu.mnuAnimate.mnuFind add sep
    .frmMenu.mnuAnimate.mnuFind add command -label "Find an Open State" -underline 0 \
              -command procJumpToAnOpenNode -accelerator $AccKey+J
     if {$expert_user} {
    .frmMenu.mnuAnimate.mnuFind add command -label "Find a not fully explored State" \
              -command procJumpToAMaxReachedNode
     }
    # -------------------- Coverage menu
    menu .frmMenu.mnuAnalyse.mnuCoverage -tearoff 0
    .frmMenu.mnuAnalyse.mnuCoverage add command -label "Compute Coverage" -underline 14 -command {procComputeCoverage 0} -accelerator $AccKey+G
    .frmMenu.mnuAnalyse.mnuCoverage add command -label "Compute Coverage and Enabling" -underline 14 -command {procComputeCoverage enabling} 
    .frmMenu.mnuAnalyse.mnuCoverage add command -label "Compute Minum and Maximum Values" -underline 14 -command {procComputeCoverage minmax} 
    
    
    # -------------------- Analyse menu
    menu .frmMenu.mnuAnalyse.mnuDebugPred -tearoff 0
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Invariant" -underline 0 -command {procAnalyseInvariant} -accelerator $AccKey+I
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Properties" -command {procAnalysePred properties}
    if {$expert_user} {
        .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Debug Properties" -command {execInBZMode procDebugProperties}
    }
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Assertions" -command {procAnalyseAssertions} -accelerator $AccKey+\]
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Debug Operation PRE..." -command procDebugOperation
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Custom Predicate..." -command procAnalyseCustomPredicate
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "GOAL" -command procAnalyseDEFGOAL  -accelerator $AccKey+\[
    .frmMenu.mnuAnalyse.mnuDebugPred add command -label "Deadlock PO" -command {procAnalysePred deadlock}

    
    
    
    # -------------------- Visualise menu
    menu .frmMenu.mnuAnalyse.mnuVisualise -tearoff 0
	 .frmMenu.mnuAnalyse.mnuVisualise add command -label "Invariant" -command {procVisualiseInvariant}
	 .frmMenu.mnuAnalyse.mnuVisualise add command -label "Properties" -command {procVisualiseProperties}
	 .frmMenu.mnuAnalyse.mnuVisualise add command -label "Assertions" -command {procVisualiseAssertions}
	 .frmMenu.mnuAnalyse.mnuVisualise add command -label "Operation PRE..." -command procVisualiseOperationPre
	 .frmMenu.mnuAnalyse.mnuVisualise add command -label "Custom Predicate..." -command procVisualiseCustomPredicate
	  if {$normal_user} {
	     .frmMenu.mnuAnalyse.mnuVisualise add command -label "GOAL" -command {provVisualizeDEFGOAL}
	     .frmMenu.mnuAnalyse.mnuVisualise add command -label "Deadlock PO" -command {procVisualiseInvariantOrOpPRE "_deadlockpo_"}
	  }
	  if {$expert_user} {
	     .frmMenu.mnuAnalyse.mnuVisualise add sep
	     .frmMenu.mnuAnalyse.mnuVisualise add command -label "Expression as Table..." -command {procShowAnExpressionAsTable}
	  }

    # -------------------- ProTest menu
    menu .frmMenu.mnuAnalyse.mnuTest -tearoff 0
	   if {$normal_user} {
		.frmMenu.mnuAnalyse.mnuTest add command -label "View Testcase Determinized Graph" \
		   -command {procTestCaseGraph} -state normal
		.frmMenu.mnuAnalyse.mnuTest add command -label "Compute Testcases" \
		   -command {prologmnf compute_testcases} -state normal
	        .frmMenu.mnuAnalyse.mnuTest add sep
           .frmMenu.mnuAnalyse.mnuTest add command -label "Constraint-based test case generation..." \
            -command procCBCTestcases
	        .frmMenu.mnuAnalyse.mnuTest add sep
	        .frmMenu.mnuAnalyse.mnuTest add command -label "MC global test case generation..." \
		   -command procSAPTestcases
	        .frmMenu.mnuAnalyse.mnuTest add command -label "MC local test case generation..." \
		   -command procSAPLocal
	   }

    # -------------------- Flow menu
#  menu .frmMenu.mnuAnalyse.mnuFlow -tearoff 0
#		.frmMenu.mnuAnalyse.mnuFlow add command -label "Calculate Enable Graph" \
#		   -command {procFlowEnableGraph} -state normal 
		

    # -------------------- Slice menu
    menu .frmMenu.mnuAnalyse.mnuSlicer -tearoff 0
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "Highlight Slice"\
                   -command procSliceProgramPoint
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "Generate Executable Slice MEB" \
                   -command procSliceExecutableMEB
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "Generate Executable Slice CEB" \
                   -command procSliceExecutableCEB
		.frmMenu.mnuAnalyse.mnuSlicer add sep
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "View MEB Graph" \
                   -command {procVisualizeSliceGraph "CSCFG_slice_MEB"}
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "View CEB Graph" \
                   -command {procVisualizeSliceGraph "CSCFG_slice_CEB"}
		.frmMenu.mnuAnalyse.mnuSlicer add command -label "View Compacted Graph" \
                   -command {procVisualizeSliceGraph "CSCFG_compact"}


    # -------------------- Debug menu
#    menu .frmMenu.mnuDebug -tearoff 0
    global debugMode
    .frmMenu.mnuDebug add command -label "Report a Bug..." -command "procReportBug" 
    .frmMenu.mnuDebug add sep
    if {$normal_user} {
        .frmMenu.mnuDebug add command -label "Perform Self Check" \
        -command {procPerformSelfCheck}
    }
    if {$expert_user} {
		.frmMenu.mnuDebug add command -label "Perform Verbose Self Check" \
			-command {procPerformVerboseSelfCheck}
		.frmMenu.mnuDebug add command -label "Perform Self Check for Module..." \
			-command {procPerformSelfCheckForModule}
	}
	if {$normal_user} {
        .frmMenu.mnuDebug add command -label "Show Internal Representation" -command procShowInternalRep
		.frmMenu.mnuDebug add sep
		.frmMenu.mnuDebug add checkbutton -label "Debugging Info" \
			 -variable debugMode -offvalue 0 -onvalue 1 -command procUpdateDebuggingMode
		global typeCheckMode
		.frmMenu.mnuDebug add checkbutton -label "Runtime Type Checking" \
			 -variable typeCheckMode -offvalue 0 -onvalue 1 -command procUpdateDebuggingMode
		if {$expert_user} {
		    global traceUponError
		    .frmMenu.mnuDebug add checkbutton -label "Trace Upon Error" \
			 -variable traceUponError -offvalue 0 -onvalue 1 -command procUpdateDebuggingMode
			 .frmMenu.mnuDebug add sep
			 .frmMenu.mnuDebug add command -label "Perform Benchmark Test" \
				-command {procBenchmark}
			 .frmMenu.mnuDebug add command -label "Perform Regression Test" \
				-command {procRegressionTest}
			 .frmMenu.mnuDebug add command -label "Perform Quick Mathematical Laws Check" \
				-command {procLawCheckTest "false"}
			 .frmMenu.mnuDebug add command -label "Perform Full Mathematical Laws Check" \
				-command {procLawCheckTest "true"}
			 .frmMenu.mnuDebug add command -label "Perform CSP-M Benchmark Test" \
				-command {procCSPMBenchmark}
			 .frmMenu.mnuDebug add command -label "Perform Symmetry Benchmark" \
				-command {procSymBenchmark}
			 .frmMenu.mnuDebug add sep
			 .frmMenu.mnuDebug add command -label "Show all specialized invariants" \
				-command {procShowAllSpecializedInvariants}
			 .frmMenu.mnuDebug add command -label "Show specialized invariants..." \
				-command {procShowSpecializedInvariants}
		 }
		 .frmMenu.mnuDebug add sep
		 .frmMenu.mnuDebug add command -label "Print Prolog statistics" \
			-command {prolog (nl,debug:timer_statistics,nl,statistics,nl)}
		 if {$expert_user} {
		 .frmMenu.mnuDebug add command -label "Reset Statespace with statistics" \
			-command {prolog state_space_initialise_with_stats; procInsertHistoryOptionsState}
		 }
     }
    # -------------------- Plugins menu
    menu .frmMenu.mnuPlugins.mnuPluginsActivate -tearoff 0
    menu .frmMenu.mnuPlugins.mnuPluginsPreferences -tearoff 0

    .frmMenu.mnuPlugins add cascade -label "Activate Plugin" \
            -menu .frmMenu.mnuPlugins.mnuPluginsActivate -state disabled
    set plugin_menu_index [.frmMenu.mnuPlugins index end]	
    .frmMenu.mnuPlugins add command -label "Deactivate Plugin" -command procDeactivatePlugin -state disabled
    set plugin_deactivate_index [.frmMenu.mnuPlugins index end]
    .frmMenu.mnuPlugins add sep

    .frmMenu.mnuPlugins add cascade -label "Plugin Preferences" \
            -menu .frmMenu.mnuPlugins.mnuPluginsPreferences -state disabled
    set plugin_preferences_menu_index [.frmMenu.mnuPlugins index end]
    procCheckForPluginPreferences




    # -------------------- Preferences menu
#       menu .frmMenu.mnuPreferences -tearoff 0
    global tcl_version
    if {$tcl_version >= 8.5} {
       .frmMenu.mnuPreferences add command -label "Text Editor Preferences..." \
              -command {procSetTextEditorPreferences}
    } else {
       .frmMenu.mnuPreferences add cascade -label "Font" \
              -menu .frmMenu.mnuPreferences.mnuFont
       .frmMenu.mnuPreferences add cascade -label "Display Line Numbers" \
              -menu .frmMenu.mnuPreferences.mnuLinenumbers
       .frmMenu.mnuPreferences add cascade -label "Highlight Bracket" \
              -menu .frmMenu.mnuPreferences.mnuHighlightCurrentBracket
       .frmMenu.mnuPreferences add cascade -label "Highlight Current Line" \
              -menu .frmMenu.mnuPreferences.mnuHighlightCurrentLine
    }
    .frmMenu.mnuPreferences add cascade -label "Symmetry" \
            -menu .frmMenu.mnuPreferences.mnuSym
    .frmMenu.mnuPreferences add sep
    .frmMenu.mnuPreferences add command -label "Animation Preferences..." \
          -command {procSetPreferences "animation"} 
    .frmMenu.mnuPreferences add cascade -label "Graphical Viewer" \
            -menu .frmMenu.mnuPreferences.mnuGraphViewer
    .frmMenu.mnuPreferences add command -label "Graphical Viewer Preferences..." \
          -command {procSetPreferences "dot"} 
    .frmMenu.mnuPreferences add command -label "Syntax Highlighting Preferences..." \
          -command {procSyntaxColouringPreferences} 
    .frmMenu.mnuPreferences add command -label "CSP Preferences..." \
          -command {procSetPreferences "csp_prefs"} 
    if {$normal_user} {
    .frmMenu.mnuPreferences add command -label "Advanced Preferences..." \
          -command {procSetPreferences "advanced"} 
    }
    if {$normal_user} {
        .frmMenu.mnuPreferences add cascade -label "Enable Kodkod for Properties" \
            -menu .frmMenu.mnuPreferences.mnuKodkod
        menu .frmMenu.mnuPreferences.mnuKodkod -tearoff 0
        global kodkod_enabled
        set kodkod_enabled [prolog preferences:get_preference(try_kodkod_on_load,true)]
        .frmMenu.mnuPreferences.mnuKodkod add radiobutton -label "Enabled"  -variable kodkod_enabled -value 1 \
            -command "prologmnf preferences:set_preference(try_kodkod_on_load,true)"
        .frmMenu.mnuPreferences.mnuKodkod add radiobutton -label "Disabled"  -variable kodkod_enabled -value 0 \
            -command "prologmnf preferences:set_preference(try_kodkod_on_load,false)"
    }
    .frmMenu.mnuPreferences add sep
    .frmMenu.mnuPreferences add cascade -label "User Mode" \
            -menu .frmMenu.mnuPreferences.mnuMode
    .frmMenu.mnuPreferences add cascade -label "Configurations" \
            -menu .frmMenu.mnuPreferences.mnuConfigs
	if {$expert_user} {
	# Preferences for Plugins
    .frmMenu.mnuPreferences add sep
    .frmMenu.mnuPreferences add command -label "Hidden Preferences..." \
          -command {procSetPreferences "hidden"} 
    .frmMenu.mnuPreferences add command -label "Print Non-Default Preferences" \
          -command {prolog preferences:print_non_default_preferences}
    }

         #line numbers menu
    global text_editor_arr
    prolog preferences:get_preference(show_line_numbers,ShowLines)
    set text_editor_arr(linenumbers) $prolog_variables(ShowLines)
         #highlight current bracket
    prolog preferences:get_preference(highlight_brackets,HighlightBrackets)
    set text_editor_arr(highlight_bracket) $prolog_variables(HighlightBrackets)
         #highlight current line
    prolog preferences:get_preference(highlight_current_line,HighlightCurrentLine)
    set text_editor_arr(highlight_line) $prolog_variables(HighlightCurrentLine)
         #asking when file content changed from external program
    prolog preferences:get_preference(ask_when_content_changed,Ask)
    set text_editor_arr(ask_when_content_changed) $prolog_variables(Ask)
    if {$tcl_version < 8.5} {
         #font menu
        menu .frmMenu.mnuPreferences.mnuFont -tearoff 0
        global chosefontval
        foreach font {"Courier 9" "Courier 10" "Courier 12" "Courier 14" "Courier 16" "Courier 18" "Courier 20" "Courier 24"} {
        	.frmMenu.mnuPreferences.mnuFont add radiobutton -label "$font"  -variable chosefontval -value $font \
         	       -command "changeFont {$font}"
         }
        menu .frmMenu.mnuPreferences.mnuLinenumbers -tearoff 0
        .frmMenu.mnuPreferences.mnuLinenumbers add radiobutton -label "Enabled" -variable text_editor_arr(linenumbers) \
              -value true -command {procSetLinenumbersValueToTrue "true"}
        .frmMenu.mnuPreferences.mnuLinenumbers add radiobutton -label "Disabled" -variable text_editor_arr(linenumbers) \
              -value false -command {procSetLinenumbersValueToTrue "false"}

        menu .frmMenu.mnuPreferences.mnuHighlightCurrentBracket -tearoff 0
        .frmMenu.mnuPreferences.mnuHighlightCurrentBracket add radiobutton -label "Enabled" -variable text_editor_arr(highlight_bracket) \
              -value true -command {procSetHighlightBracketValueToTrue "true"}
        .frmMenu.mnuPreferences.mnuHighlightCurrentBracket add radiobutton -label "Disabled" -variable text_editor_arr(highlight_bracket) \
              -value false -command {procSetHighlightBracketValueToTrue "false"}

        menu .frmMenu.mnuPreferences.mnuHighlightCurrentLine -tearoff 0
        .frmMenu.mnuPreferences.mnuHighlightCurrentLine add radiobutton -label "Enabled" -variable text_editor_arr(highlight_line) \
              -value true -command {procSetHighlightCurrentLineValueToTrue "true"}
        .frmMenu.mnuPreferences.mnuHighlightCurrentLine add radiobutton -label "Disabled" -variable text_editor_arr(highlight_line) \
              -value false -command {procSetHighlightCurrentLineValueToTrue "false"}
    }
    menu .frmMenu.mnuPreferences.mnuSym -tearoff 0
    global chosensymmode
    prolog preferences:get_preference(symmetry_mode,SYMMODE)
    set chosensymmode $prolog_variables(SYMMODE)
    #puts "SymmMode $chosensymmode"
    foreach mode {"off" "hash" "flood" "nauty"} {
	.frmMenu.mnuPreferences.mnuSym add radiobutton -label "$mode"  -variable chosensymmode -value $mode \
	       -command "prolog preferences:set_preference(symmetry_mode,$mode); procReOpenFile"
    }
    .frmMenu.mnuPreferences.mnuSym add sep
    .frmMenu.mnuPreferences.mnuSym add command -label "(will reload machine)" -state disabled
     # User mode menu
     
    menu .frmMenu.mnuPreferences.mnuGraphViewer -tearoff 0
    global chosen_dot_mode
    prologmnf preferences:get_preference(dot_use_ps_viewer,PSV)
    prologmnf preferences:get_preference(dot_use_alterate_dot_viewer,PSV2)
    if {$prolog_variables(PSV)==true} {
       set chosen_dot_mode 1
    } elseif {$prolog_variables(PSV2)==false} {
       set chosen_dot_mode 2
    } else {
       set chosen_dot_mode 3
    }
	.frmMenu.mnuPreferences.mnuGraphViewer add radiobutton -label "PostScript"  -variable chosen_dot_mode -value 1 \
	       -command "prologmnf preferences:set_preference(dot_use_ps_viewer,true)"
	.frmMenu.mnuPreferences.mnuGraphViewer add radiobutton -label "Dot Viewer"  -variable chosen_dot_mode -value 2 \
	       -command "prologmnf preferences:set_preference(dot_use_ps_viewer,false); prologmnf preferences:set_preference(dot_use_alterate_dot_viewer,false)"
	.frmMenu.mnuPreferences.mnuGraphViewer add radiobutton -label "Alternate Dot Viewer"  -variable chosen_dot_mode -value 3 \
	       -command "prologmnf preferences:set_preference(dot_use_ps_viewer,false); prologmnf preferences:set_preference(dot_use_alterate_dot_viewer,true)"
    
    menu .frmMenu.mnuPreferences.mnuConfigs -tearoff 0
	.frmMenu.mnuPreferences.mnuConfigs add command -label "MININT..MAXINT (32bit)" \
	       -command "prologmnf preferences:set_preference_group(integer,int32)"
	.frmMenu.mnuPreferences.mnuConfigs add command -label "MININT..MAXINT = -1..3" \
	       -command "prologmnf preferences:set_preference_group(integer,default)"
	.frmMenu.mnuPreferences.mnuConfigs add sep
	.frmMenu.mnuPreferences.mnuConfigs add command -label "Dot Colour Scheme (Winter)" \
	       -command "prologmnf preferences:set_preference_group(dot_colors,winter)"
	.frmMenu.mnuPreferences.mnuConfigs add command -label "Dot Colour Scheme (Dreams)" \
	       -command "prologmnf preferences:set_preference_group(dot_colors,dreams)"
	.frmMenu.mnuPreferences.mnuConfigs add command -label "Dot Colour Scheme (Classic)" \
	       -command "prologmnf preferences:set_preference_group(dot_colors,classic)"
	.frmMenu.mnuPreferences.mnuConfigs add command -label "Dot Colour Scheme (Default)" \
	       -command "prologmnf preferences:set_preference_group(dot_colors,default)"
	       
    menu .frmMenu.mnuPreferences.mnuMode -tearoff 0
	.frmMenu.mnuPreferences.mnuMode add radiobutton -label "Beginner"  -variable normal_user -value 0 \
	       -command "procUpdateMenu"
	.frmMenu.mnuPreferences.mnuMode add radiobutton -label "Normal"  -variable normal_user -value 1 \
	       -command "procUpdateMenu"


    # -------------------- Help menu
#    menu .frmMenu.mnuHelp -tearoff 0
    .frmMenu.mnuHelp add command -label "About ProB" -command "procAboutProB" 
    .frmMenu.mnuHelp add command -label "Go to ProB website" -command {proc_open_url "http://www.stups.uni-duesseldorf.de/ProB/"} 
    .frmMenu.mnuHelp add command -label "Check for Updates" -command "procCheckForUpdates" 
    .frmMenu.mnuHelp add sep
    .frmMenu.mnuHelp add command -label "Summary of B Syntax" -command "procLaunchSyntaxInfo B" 
    .frmMenu.mnuHelp add command -label "Summary of CSP Syntax" -command "procLaunchSyntaxInfo CSP" 
    .frmMenu.mnuHelp add command -label "Summary of TLA+ Syntax" -command "procLaunchSyntaxInfo TLA"
    .frmMenu.mnuHelp add command -label "Summary of Supported Z" -command "procLaunchSyntaxInfo Z" 
    .frmMenu.mnuHelp add sep
    .frmMenu.mnuHelp add command -label "Verification Info" -command "procCheckingInfo" 
    .frmMenu.mnuHelp add command -label "Symmetry Reduction Info" -command "procSymmInfo" 
    .frmMenu.mnuHelp add sep
    .frmMenu.mnuHelp add command -label "Install AtelierB 4 Plugin..." -command "installAtelierBPlugin" 
    .frmMenu.mnuHelp add command -label "Download and Install TLA2B" -command "installTLA2B" 


    .frmMenu.mnuFiles add command -label "No File Opened" -state disabled
    # ----- fix the menu bar
#    pack append . .frmMenu {top fillx}

}

# raise an error message only if we are in batch mode
proc assertBatchError {ERRMSG} {
      global batch_mode
 	  if {$batch_mode} {
	       puts "\n### Batch mode error:\n$ERRMSG\n\n"
	       prolog assert_cli_error_occured(batch)
	   } 
}

proc procErrShowList {Result WinTitle msg} {
   global batch_mode
   global testing_mode strFilename failed_tests detailed_errors
  if {$batch_mode} {
     puts "### An Error Occurred\n$msg"
     prolog assert_cli_error_occured(procErrShowList)
  } elseif {$testing_mode==true} {
       append failed_tests $strFilename "; 1 Error Message ;;"
       append detailed_errors $strFilename ";  " $msg ";;" 
  } else {
       procShowList $Result $WinTitle $msg
  }
}
proc tkErrorBox {msg} {
  global batch_mode
   global testing_mode strFilename failed_tests detailed_errors
  if {$batch_mode} {
     puts "### An Error Occurred\n$msg"
     prolog assert_cli_error_occured(tkErrorBox)
  } elseif {$testing_mode==true} {
       append failed_tests $strFilename "; 1 Error Message ;;"
       append detailed_errors $strFilename ";  " $msg ";;" 
  } else {
     tk_messageBox -parent . -icon error -message $msg
  }
}
proc tkErrorBoxNoParent {msg} {
  global batch_mode
   global testing_mode strFilename failed_tests detailed_errors
  if {$batch_mode} {
     puts "### An Error Occurred\n$msg"
     prolog assert_cli_error_occured(tkErrorBoxNoParent)
  } elseif {$testing_mode==true} {
       append failed_tests $strFilename "; 1 Error Message ;;"
       append detailed_errors $strFilename ";  " $msg ";;" 
  } else {
     tk_messageBox -icon error -message $msg
  }
}
proc tkMessageBox {msg} {
  global batch_mode
  if {$batch_mode} {
     puts "$msg"
  } else {
     tk_messageBox -parent .main -message $msg
  }
}
proc tkMessageBoxNoParent {msg} {
  global batch_mode
  if {$batch_mode} {
     puts "$msg"
  } else {
     tk_messageBox -message $msg
  }
}

proc tkYesNoMessageWarningBox {Msg Title} {
  global batch_mode
  if {$batch_mode} {
     return "no"
     prolog assert_cli_error_occured(tkYesNoMessageWarningBox)
  } else {
     return [tk_messageBox -default yes\
                  -message "$Msg" -title "$Title" -type yesno -icon warning -parent .]
  }
}

proc procToUnicode {} {
    global strFilename
    set csp_ext [file extension $strFilename]
    if { $csp_ext == ".csp" || $csp_ext == ".cspm" } {
    # Enable "Unicode Options" Menu when the loaded File one of the Extensions .csp or .cspm has
          .frmMenu.mnuEdit entryconfigure 12 -state normal
    } else {
          .frmMenu.mnuEdit entryconfigure 12 -state disabled
    }
}

proc toUnicodeCommand {} {
    global strFilename
    set addUnicodeOption "--addUnicode="
    prolog "cspm_file_add_remove_unicode('$strFilename', '$strFilename', '$addUnicodeOption')"
    procReOpenFile
}

proc fromUnicodeCommand {} {
    global strFilename
    set removeUnicodeOption "--removeUnicode="
    prolog "cspm_file_add_remove_unicode('$strFilename', '$strFilename', '$removeUnicodeOption')"
    procReOpenFile
}    

proc VisualizeSelectedPredicate {} {
    set sel [selection get]
    if {$sel != ""} {
       # puts "sel = $sel"
       regsub -all -- {\n} $sel " " sel 
       # puts "sel2 = $sel"
       procVisualiseCustomPredicate_direct $sel
    }
	selection clear
}

proc EvaluateSelectedExpression {} {
	set sel [selection get]
	if {$sel != ""} {
		regsub -all -- {\n} $sel " " sel
		set EvalSelection [escapeChars $sel]
		prolog "tcltk_eval(\'$EvalSelection\',Res,EnumWarning,Solution)"
		set Result $prolog_variables(Res)
		if [prolog real_error_occurred] {
			procShowErrors
		} else {
			if {$prolog_variables(Solution) != ""} {
				ShowEvaluatedExpressionInDialogWindow "$prolog_variables(Res)\n$prolog_variables(Solution)"
			} else {
				ShowEvaluatedExpressionInDialogWindow "$prolog_variables(Res)"
			}
		}
	}
	selection clear
}
proc procShowAnExpressionAsTable {} {
    global Goal
    set Goal [Dialog_Promptww "Enter Expression to Visualize as Table(use B syntax):" 70 ""]
	if {$Goal != ""} {
		procShowExpressionAsTable $Goal
	}
}
proc procShowExpressionAsTable {Expr} {
	if {$Expr != ""} {
		prolog "tcltk_eval_as_table(\'$Expr\',Res)"
		if [prolog real_error_occurred] {
			procShowErrors
		} else {
    		procShowTable $prolog_variables(Res) "Table" "Table for $Expr" "ValueTable" ""
		}
	}
}

proc ShowEvaluatedExpressionInDialogWindow {expr} {
	destroy .evalSelection
	# destroy added for Mac TclTk
    set f .evalSelection
	if [Dialog_Create $f "Evaluated Expression" -borderwidth 10] {

        frame $f.frmSource -borderwidth .1c -relief groove
        ctext $f.frmSource.text -yscrollcommand "$f.frmSource.scrolly set" \
         -setgrid 1 -height 8 -width 50 -state normal -linemap 0
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
		
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		button $b.ok -text Done -command {wm withdraw .evalSelection}
		pack $b.ok -side right

		bind $f.frmSource <Return> {wm withdraw .evalSelection}
		bind $f.frmSource <Control-c> {wm withdraw .evalSelection}
		$f.frmSource.text delete 1.0 end
		$f.frmSource.text insert end $expr
		procDoInTimeSyntaxColouring $f.frmSource.text
		$f.frmSource.text configure -state disabled		
		focus .evalSelection
	}
}

proc GotoLineSelect {} {
   set LineNumber [Dialog_Prompt "Show Line Number:"]
   while {![string is integer $LineNumber]} {
    tkErrorBox "Invalid input. Please enter a valid number."
    set LineNumber [Dialog_Prompt "Show Line Number:"]
   } 
   if {$LineNumber != ""} { 
    GotoLine $LineNumber
   } 
}

proc GotoLine {lineNo} {
    set BG   "lightgreen"	;# default background color for text
    set FG   "lightgray"	;# default foreground color for text
	.main.frmSource.text tag remove hilite 0.0 end
	.main.frmSource.text tag add hilite $lineNo.0 $lineNo.1000
	.main.frmSource.text tag configure hilite -background $BG
	# -foreground $FG 
	.main.frmSource.text yview -pickplace [expr $lineNo-4]
}

proc procGetAccKey {} {
   if [prolog tools:host_platform(windows)] {
	     return "Control"
	} elseif [prolog tools:host_platform(darwin)] {
	     return "Command"
	} else {
	     return "Control"
	     # Meta ?
	}
}

proc procLaunchMenuCmd {Cmd} {
   # wait > 100 ms to circumvent bug in latest Tk versions on Mac (see [ tktoolkit-Bugs-3285355])
   if [prolog tools:host_platform(darwin)] { after 130 $Cmd } else { eval $Cmd }
}
proc procSetCommandKeyShortCuts {} {
   set CMD [procGetAccKey]
   if [prolog tools:host_platform(darwin)] {
      event add <<RIGHTCLICK>> <Button-2>
      event add <<RIGHTCLICK>> <Control-Button-1>
   } else {
      event add <<RIGHTCLICK>> <Button-3>
   }
   bind all <$CMD-minus> {procLaunchMenuCmd procAddDefaultCSPFile}

   bind .main.frmSource.text <$CMD-a> {procLaunchMenuCmd proc_selectAll}
   bind .main.frmSource.text <$CMD-A> {procLaunchMenuCmd proc_selectAll}
   bind all <$CMD-b> {procLaunchMenuCmd procTypeCheckFile}
   bind all <$CMD-b> {procLaunchMenuCmd procTypeCheckFile}
   bind all <$CMD-c> {procLaunchMenuCmd {procCutOrCopySlectedRangeOfText "yes"}}
   bind all <$CMD-C> {procLaunchMenuCmd {procCutOrCopySlectedRangeOfText "yes"}
                      #event generate .main.frmSource.text <<Copy>>
                      }
   bind all <$CMD-d> {procLaunchMenuCmd procDisplayVisitedStates}
   bind all <$CMD-D> {procLaunchMenuCmd procDisplayVisitedStates}
   bind all <$CMD-e> {procLaunchMenuCmd procOpenFileInEditor}
   bind all <$CMD-E> {procLaunchMenuCmd procOpenFileInEditor}
   bind all <$CMD-f> {procLaunchMenuCmd procLaunchFindMenu}
   bind all <$CMD-F> {procLaunchMenuCmd procLaunchFindMenu}
   bind all <$CMD-g> {procLaunchMenuCmd {procComputeCoverage 0}}
   bind all <$CMD-G> {procLaunchMenuCmd {procComputeCoverage 0}}
   bind all <$CMD-h> {procLaunchMenuCmd procViewModuleHierarchy}
   bind all <$CMD-H> {procLaunchMenuCmd procViewModuleHierarchy}
   bind all <$CMD-i> {procLaunchMenuCmd procAnalyseInvariant}
   bind all <$CMD-I> {procLaunchMenuCmd procAnalyseInvariant}
   bind all <$CMD-j> {procJumpToAnOpenNode}
   bind all <$CMD-J> {procJumpToAnOpenNode}
   
   bind all <$CMD-k> {procLaunchMenuCmd procDisplayReducedSigMerge}
   bind all <$CMD-K> {procLaunchMenuCmd procDisplayReducedSigMerge}
   bind all <$CMD-l> {procLaunchMenuCmd procLtl}
   bind all <$CMD-L> {procLaunchMenuCmd procLtl}
   bind all <$CMD-m> {procLaunchMenuCmd procModelCheck}
   bind all <$CMD-M> {procLaunchMenuCmd procModelCheck}
   bind all <$CMD-n> {procLaunchMenuCmd procNewFile}
   bind all <$CMD-N> {procLaunchMenuCmd procNewFile}
   bind all <$CMD-o> {procLaunchMenuCmd procOpenFile}
   bind all <$CMD-O> {procLaunchMenuCmd procOpenFile}

   bind all <Shift-$CMD-f> {procLaunchMenuCmd procLaunchFindAndReplaceMenu}
   bind all <Shift-$CMD-F> {procLaunchMenuCmd procLaunchFindAndReplaceMenu}
   bind all <$CMD-q> {procLaunchMenuCmd procDoQuit}
   bind all <$CMD-Q> {procLaunchMenuCmd procDoQuit}
   bind all <$CMD-r> {procLaunchMenuCmd procReOpenFile}
   bind all <$CMD-R> {procLaunchMenuCmd procReOpenFile}
   bind all <$CMD-s> {procLaunchMenuCmd procSaveFile}
   bind all <$CMD-S> {procLaunchMenuCmd procSaveFile}
   bind all <Shift-$CMD-s> {procLaunchMenuCmd procSaveAsFile}
   bind all <Shift-$CMD-S> {procLaunchMenuCmd procSaveAsFile}
   bind all <$CMD-t> {procLaunchMenuCmd procCheckTraceFile}
   bind all <$CMD-T> {procLaunchMenuCmd procCheckTraceFile}
   bind all <$CMD-u> {procLaunchMenuCmd procCheckStatespaceWithFDR}
   bind all <$CMD-U> {procLaunchMenuCmd procCheckStatespaceWithFDR}
   bind all <$CMD-v> {.main.frmSource.text highlight 1.0 end}
   bind all <$CMD-V> {procLaunchMenuCmd procPasteTheCopiedRangeOfText}
   bind all <$CMD-w> {procLaunchMenuCmd procExecuteOperation}
   bind all <$CMD-W> {procLaunchMenuCmd procExecuteOperation}
   bind all <$CMD-X> {procLaunchMenuCmd {procCutOrCopySlectedRangeOfText "no"}
                      #event generate .main.frmSource.text <<Cut>>
                      }
   bind all <$CMD-y> {procLaunchMenuCmd procAdvancedFind}
   bind all <$CMD-Y> {procLaunchMenuCmd procAdvancedFind}

   bind all <$CMD-z> "procundo"
   bind all <$CMD-Z> "procundo"
   bind all <Shift-$CMD-z> "procredo"
   bind all <Shift-$CMD-Z> "procredo"
   
   bind all <$CMD-bracketleft> {procLaunchMenuCmd procAnalyseDEFGOAL}
   bind all <$CMD-bracketright> {procLaunchMenuCmd procAnalyseAssertions}

   bind all <$CMD-plus> {procLaunchMenuCmd openEvaluationView}
}

proc procUpdateMenu {} {
    global normal_user
    if {$normal_user} {
      prologmnf preferences:set_preference(user_not_beginner,true)
    } else {
      prologmnf preferences:set_preference(user_not_beginner,false)
    }
    tkMessageBox "You need to restart ProB for these settings to take effect."
}

global forceQuit
set forceQuit 0

proc procQuit {} {
   global forceQuit
   global app_dir
   if {! $forceQuit} {
     procSavePrefs
     procCheckIfSaved
   }
}

proc procDoQuit {} {
   global forceQuit
   # puts "procDoQuit"
   procQuit
   set forceQuit 1
   destroy .
}

proc procDoQuitMain {win} {
   global forceQuit
   if [string equal $win ".__ctextTemp"] {
       return
   } else {
       procDoQuit
   }
}

proc procResetFilesMenu {} {
   global CSP_File_Already_Added
   .frmMenu.mnuFiles delete 0 999
   set CSP_File_Already_Added 0
}

proc procAddNewFileToFilesMenu {FileToShow Type} {
   global CSP_File_Already_Added
   if {$Type=="CSP"} {
      if {$CSP_File_Already_Added} {
       .frmMenu.mnuFiles entryconfigure last -label "$FileToShow"
       .frmMenu.mnuFiles entryconfigure last -command "procShowSpecificFile {$FileToShow} {$Type}"
       # Assumption: CSP File always last and only one CSP file
      } else {
        set CSP_File_Already_Added 1
       .frmMenu.mnuFiles add sep
       .frmMenu.mnuFiles add command -label "$FileToShow" -command "procShowSpecificFile {$FileToShow} {$Type}"
      }
   } else {
     #set lastlabel [.frmMenu.mnuFiles entrycget last -label]
     .frmMenu.mnuFiles add command -label "$FileToShow" -command "procShowSpecificFile {$FileToShow} {$Type}"
   }
}

proc procShowSpecificFile {FileToShow Type} {
  procCheckIfSaved
  procShowSourceCode $FileToShow
  if {$Type=="B"} {
     procDoSyntaxColouring .main.frmSource.text
     procEnableSourceCodeEditing
  } elseif {$Type=="CSP"} {
     procDoCSPSyntaxColouring  .main.frmSource.text
     procEnableSourceCodeEditing
  }
  procResetCodeModified false false
}

# -------

proc procRebuildRecentDocumentsMenu {} {
    # set lasti [.frmMenu.mnuFile.mnuRecentDocuments cget end]
    # puts "Rebuild: lasti $lasti"

    .frmMenu.mnuFile.mnuRecentDocuments delete 0 999

    prologmnf get_recent_documents(List)
    set ii 0
    set AccKey [procGetAccKey]
    foreach i $prolog_variables(List) {
       if {$ii < 1} {
          .frmMenu.mnuFile.mnuRecentDocuments add command -label "$i" -command "procOpenSpecificFile {$i}" -accelerator "$AccKey+$ii"
          set CMD [procGetAccKey]
          bind all <$CMD-$ii> "procLaunchMenuCmd {procOpenSpecificFile {$i}}"
          incr ii
       } else {
         .frmMenu.mnuFile.mnuRecentDocuments add command -label "$i" -command "procOpenSpecificFile {$i}"
       }
    }
    .frmMenu.mnuFile.mnuRecentDocuments add sep
    .frmMenu.mnuFile.mnuRecentDocuments add command -label "Clear Menu" \
          -command "prologmnf preferences:clear_recent_documents ; procRebuildRecentDocumentsMenu"
}

# -------

proc procEnableReopen {} {
    global strFilename
    global version normal_user
	# enable ReOpen MenuItem
	set fileTail [file tail $strFilename]
	.frmMenu.mnuFile entryconfigure 2 -state normal \
	   -label "Reopen $fileTail"

    if {$normal_user} {
      .frmMenu.mnuFile entryconfigure 10 -state normal \
	     -label "Open $fileTail in External Editor"
	 }

    if [prolog animation_mode(Mode),plugins:is_registered_plugin(Mode,Name)] {
        wm title . "$prolog_variables(Name): $version \[$fileTail\]"
    } else {
     set ext [file extension $strFilename]
     if {$ext == ".tex"} {
		   wm title . "ProZ:  $version: \[$fileTail\]"
		} elseif {$ext == ".cspm" || $ext == ".csp"} {
		   wm title . "ProCSP: $version \[$fileTail\]"
		} elseif {$ext == ".pml" || $ext == ".prom"} {
		   wm title . "ProM: $version \[$fileTail\]"
		} elseif {$ext == ".P"} {
		   wm title . "ProXTL $version: \[$fileTail\]"
		} else {
		   wm title . "ProB $version: \[$fileTail\]"
		}
    }
}
proc procEnableItemsAfterOpeningFile {} {
    global expert_user normal_user

	procEnableReopen

	.frmMenu.mnuFile entryconfigure 5 -state normal
	.frmMenu.mnuFile entryconfigure 7 -state normal
	.frmMenu.mnuFile entryconfigure 8 -state normal
	if {$normal_user} {
	 .frmMenu.mnuFile entryconfigure 10 -state normal
	}


    # enable View Statespace and View
    #.frmMenu.mnuAnimate entryconfigure 8 -state normal
    #.frmMenu.mnuAnimate entryconfigure 9 -state normal

	     
     .frmMenu.mnuEdit entryconfigure 0 -state disabled
	 .frmMenu.mnuEdit entryconfigure 1 -state disabled
    
    procUpdateMenusFromPrologInfo
}
proc procDisableItemsAfterClosingFile {} {
	.frmMenu.mnuFile entryconfigure 5 -state disabled
	.frmMenu.mnuFile entryconfigure 7 -state disabled
	.frmMenu.mnuFile entryconfigure 10 -state disabled

    
    procResetFilesMenu
}

# -------
# procedure to initialise info section
# -------
proc procGUI_Info {} {
    frame .main.frmInfo -borderwidth .1c  -relief groove
    if [prolog get_preference(use_small_window,true)] {
        if [prolog get_preference(tk_show_source_pane,true)] {
		  set pane_height 12 
	    } else {
	      set pane_height 18
	    }
		set pane_width 25
    } else {
		if [prolog get_preference(tk_show_source_pane,true)] {
		  set pane_height 15 
	    } else {
	      set pane_height 22
	    }
		set pane_width 30
    }
    # ------ History
    frame .main.frmInfo.frmHisto -relief groove
    label .main.frmInfo.frmHisto.label -text History -relief flat
    scrollbar .main.frmInfo.frmHisto.scrolly -command ".main.frmInfo.frmHisto.list yview"
    scrollbar .main.frmInfo.frmHisto.scrollx -command ".main.frmInfo.frmHisto.list xview" -orient h
    listbox .main.frmInfo.frmHisto.list -yscroll ".main.frmInfo.frmHisto.scrolly set" \
        -xscroll ".main.frmInfo.frmHisto.scrollx set" -setgrid 1 -height $pane_height -width $pane_width -bg white -selectmode extended
    pack .main.frmInfo.frmHisto.label -side top -fill x -ipady 2
    pack .main.frmInfo.frmHisto.scrolly -side right -fill y
    pack .main.frmInfo.frmHisto.scrollx -side bottom -fill x
    pack .main.frmInfo.frmHisto.list -side left -expand 1 -fill both

    bind .main.frmInfo.frmHisto.label <<RIGHTCLICK>> {procPerformHistoryContextMenu %X %Y}
    bind .main.frmInfo.frmHisto.list <<RIGHTCLICK>> {procPerformHistoryContextMenu %X %Y}

    # ------ States
    frame .main.frmInfo.frmState -relief groove
    label .main.frmInfo.frmState.label -text StateProperties -relief groove
    # set StatusFrame .main.frmInfo.frmStatus
    global StatusFrame
    set StatusFrame .main.frmInfo.frmState.status
    frame $StatusFrame -relief groove
      # label $StatusFrame.invlbl -text "INVARIANT:" -fg blue -font "Courier 9"
      global InvKO InvOK InvUnknown InvRef SwapProcs InvTimeout Timeout TimeoutEmpty Maxreach MaxreachEmpty MaxreachSym tcl_dir
      if [file exists "$tcl_dir/icons/InvUnknown.gif"] {
        image create photo InvUnknown -format gif -fil "$tcl_dir/icons/InvUnknown.gif"
        image create photo InvOK -format gif -fil "$tcl_dir/icons/InvOK.gif"
        image create photo InvKO -format gif -fil "$tcl_dir/icons/InvKO.gif"
        image create photo InvTimeout -format gif -fil "$tcl_dir/icons/InvTimeout.gif"
        image create photo InvRef -format gif -fil "$tcl_dir/icons/InvRef.gif"
        image create photo SwapProcs -format gif -fil "$tcl_dir/icons/Change.gif"
        image create photo Timeout -format gif -fil "$tcl_dir/icons/Timeout.gif"
        image create photo TimeoutEmpty -format gif -fil "$tcl_dir/icons/TimeoutEmpty.gif"
        image create photo Maxreach -format gif -fil "$tcl_dir/icons/Maxreach.gif"
        image create photo MaxreachEmpty -format gif -fil "$tcl_dir/icons/MaxreachEmpty.gif"
        image create photo MaxreachSym -format gif -fil "$tcl_dir/icons/MaxreachSym.gif"
        image create photo BackEnabled -format gif -fil "$tcl_dir/icons/BackEnabled.gif"
        # image create photo BackDisabled -format gif -fil "$tcl_dir/icons/BackDisabled.gif"
        image create photo ForwardEnabled -format gif -fil "$tcl_dir/icons/ForwardEnabled.gif"
        # image create photo ForwardDisabled -format gif -fil "$tcl_dir/icons/ForwardDisabled.gif"
        image create photo WindowSubIcon -format gif -fil "$tcl_dir/icons/prob_sub_128.gif"
      } else {
        image create photo InvUnknown
        image create photo InvOK
        image create photo InvKO
        image create photo Timeout
        image create photo TimeoutEmpty
        image create photo Maxreach
        image create photo MaxreachEmpty
        image create photo MaxreachSym
        image create photo BackEnabled
        image create photo ForwardEnabled
      }
      button $StatusFrame.inv -text OK -image InvUnknown -relief flat -command {procStatusFrameClick}
      #button $StatusFrame.maxreached -image MaxreachEmpty\
          -command {tkMessageBox "Possibly not all enabled operations were computed. Increase Max Number of Initialisations/Operations in the Animation Preferences and re-load the machine."}
      # label $StatusFrame.lbl2 -text "STATUS:" -font "Courier 9"
      label $StatusFrame.lbl2 -text "State Properties"
      bind $StatusFrame.lbl2 <<RIGHTCLICK>> {procPerformStatePropertyContextMenu %X %Y}
      button $StatusFrame.timeout -image TimeoutEmpty\
           -command {procTimeOutButton}
      pack   $StatusFrame.inv -side left
      #pack $StatusFrame.maxreached -side left
      pack $StatusFrame.lbl2 -side left -padx 15 -fill x
      pack $StatusFrame.timeout -side right  -padx 15
    scrollbar .main.frmInfo.frmState.scrolly -command ".main.frmInfo.frmState.list yview"
    scrollbar .main.frmInfo.frmState.scrollx -command ".main.frmInfo.frmState.list xview" -orient h
    listbox .main.frmInfo.frmState.list -yscroll ".main.frmInfo.frmState.scrolly set" \
        -xscroll ".main.frmInfo.frmState.scrollx set" -setgrid 1 -height $pane_height -width $pane_width -bg white -selectmode extended
    bind .main.frmInfo.frmState.list <Button1-ButtonRelease> procShowStateDetail
    # pack .main.frmInfo.frmState.label -side top -fill x
    pack $StatusFrame -side top -fill x
    pack .main.frmInfo.frmState.scrolly -side right -fill y
    pack .main.frmInfo.frmState.scrollx -side bottom -fill x
    pack .main.frmInfo.frmState.list -side left -expand 1 -fill both
    bind .main.frmInfo.frmState.list <Double-1> {procPerformStateList}
    bind .main.frmInfo.frmState.list <<RIGHTCLICK>>  {procPerformStatePropertyContextMenu %X %Y}

    # ------ Available options
    frame .main.frmInfo.frmPerform -relief groove
    global OpStatusFrame
    set OpStatusFrame .main.frmInfo.frmPerform.status
    frame $OpStatusFrame -relief groove
    label $OpStatusFrame.label -text "Enabled Operations"
    # -relief groove
      button $OpStatusFrame.maxreached -image MaxreachEmpty\
          -command {procMaxreachedButtonAction}
      button $OpStatusFrame.backtrack -image BackEnabled -command procPerformBacktrack
      button $OpStatusFrame.forward -image ForwardEnabled -command procPerformForward
      label $OpStatusFrame.empty -text {}
      pack $OpStatusFrame.maxreached -side left
      pack $OpStatusFrame.label -side left -padx 15 -fill x
      pack $OpStatusFrame.empty -side right -padx 5
      pack $OpStatusFrame.forward -side right
      pack $OpStatusFrame.backtrack -side right
    
    scrollbar .main.frmInfo.frmPerform.scrolly -command ".main.frmInfo.frmPerform.list yview"
    scrollbar .main.frmInfo.frmPerform.scrollx -command ".main.frmInfo.frmPerform.list xview" -orient h
    listbox .main.frmInfo.frmPerform.list -yscroll ".main.frmInfo.frmPerform.scrolly set" \
         -xscroll ".main.frmInfo.frmPerform.scrollx set" -setgrid 1 -height $pane_height -width $pane_width -bg white
    bind .main.frmInfo.frmPerform.list <ButtonRelease> {procPerformOptionSingleClick}
    bind .main.frmInfo.frmPerform.list <Double-1> {procPerformOption}
    bind .main.frmInfo.frmPerform.list <Return> {procPerformOption}
    pack $OpStatusFrame -side top -fill x
    pack .main.frmInfo.frmPerform.scrolly -side right -fill y
    pack .main.frmInfo.frmPerform.scrollx -side bottom -fill x
    pack .main.frmInfo.frmPerform.list -side left -expand 1 -fill both

    bind $OpStatusFrame.label <<RIGHTCLICK>> {procPerformOpContextMenu_woidx %X %Y}
    bind .main.frmInfo.frmPerform.list <<RIGHTCLICK>> {procPerformContextMenu %X %Y}
    
    # ------- pack all top frames
    pack .main.frmInfo.frmState .main.frmInfo.frmPerform .main.frmInfo.frmHisto -side left -expand yes -fill both
}

proc proc_updateMenuEntryStates {} {
    if {[.main.frmSource.text cget -state] == "disabled"} {
	set stateCut disabled; set stateCopy normal
	set statePaste disabled; set stateDelete disabled
	set stateundo disabled; set stateredo disabled
    } else {
	set stateCut [procSelectLabelStateOfTheTextContextMenu]
	set stateCopy [procSelectLabelStateOfTheTextContextMenu]
        set statePaste [procSelectLabelStateOfTheTextContextMenuPaste]
        set stateDelete [proc_textEditorExistsAndIsEnabled]
        set stateundo [procSelectLabelStateOfUndo]
        set stateredo [procSelectLabelStateOfRedo]
    }
    .frmMenu.mnuEdit entryconfigure 0 -state $stateundo
    .frmMenu.mnuEdit entryconfigure 1 -state $stateredo
    .frmMenu.mnuEdit entryconfigure 3 -state $stateCut
    .frmMenu.mnuEdit entryconfigure 4 -state $stateCopy
    .frmMenu.mnuEdit entryconfigure 5 -state $statePaste
    .frmMenu.mnuEdit entryconfigure 6 -state $stateDelete
    .frmMenu.mnuEdit entryconfigure 8 -state $stateDelete
}

proc proc_textEditorExistsAndIsEnabled {} {
    set editor .main.frmSource.text
    if {[winfo exists $editor]  && [$editor cget -state] == "normal"} {
        return normal
    }
    return disable
}

proc procCreateOperationsPopupMenu {hasTrace} {
    destroy .operationspopup
    menu .operationspopup -tearoff 0
    if {$hasTrace} {
        set state normal
    } else {
        set state disabled
    }
    .operationspopup add command -label "Reset" -command procReset -state normal
    .operationspopup add command -label "Random Animation (10)" -command procRand -state normal
    .operationspopup add sep
    .operationspopup add command -label "Show Event Trace" -command procShowEventTrace -state $state
   if [prolog animation_mode(b)] {
    .operationspopup add sep
    .operationspopup add command -label "Execute an Operation ..." -command procExecuteOperation -state normal
    .operationspopup add sep
    .operationspopup add command -label "Debug Operation PRE..." -command procDebugOperation -state normal
    .operationspopup add sep
    .operationspopup add command -label "Visualize Operation PRE..." -command procVisualiseOperationPre -state normal
    .operationspopup add command -label "Visualize Deadlock PO..." -command {procVisualiseInvariantOrOpPRE "_deadlockpo_"} -state normal
  }
}

proc procPerformLineColumnsContextMenu {X Y} {
    destroy .lincolpopup
    menu .lincolpopup -tearoff 0
    .lincolpopup add command -label "Goto Line..." -command {GotoLineSelect} 
    .lincolpopup add sep
    global text_editor_arr
    if {$text_editor_arr(linenumbers)==true} {
        .lincolpopup add command -label "Hide Line Numbers" -command {procSetLinenumbersValueToTrue "false"} 
    } else {
        .lincolpopup add command -label "Show Line Numbers" -command {procSetLinenumbersValueToTrue "true"}  
    }
    if {$text_editor_arr(highlight_line)==true} {
        .lincolpopup add command -label "Disable Highlighting Current Line" -command {procSetHighlightCurrentLineValueToTrue "false"} 
    } else {
        .lincolpopup add command -label "Highlight Current Line" -command {procSetHighlightCurrentLineValueToTrue "true"}  
    }
    .lincolpopup add command -label "Text Editor Preferences..." -command {procSetTextEditorPreferences}  
    tk_popup .lincolpopup $X $Y
}
proc procPerformHistoryContextMenu {X Y} {
    destroy .historypopup
    menu .historypopup -tearoff 0
    .historypopup add command -label "Reset" -command procReset -state normal
    .historypopup add command -label "View History" -command {procDisplayTraceToCurrentState "no"} -state normal
    .historypopup add sep
    .historypopup add command -label "Save History to Trace File" -command procSaveTraceFile
    .historypopup add sep
    .historypopup add command -label "Check Trace from Trace File" -command {procCheckTraceFile}
    tk_popup .historypopup $X $Y
}
proc procPerformStatePropertyContextMenu {X Y} {
    destroy .statepopup
    menu .statepopup -tearoff 0
    .statepopup add command -label "Eval..." -command {procEvalConsole}
    if [prolog animation_mode(b)] {
    .statepopup add command -label "Open Evaluation View" -command openEvaluationView 
    .statepopup add command -label "Analyse Properties" -command {procAnalysePred properties} 
    .statepopup add command -label "Analyse Assertions" -command procAnalyseAssertions
    .statepopup add sep
    .statepopup add command -label "View Current State as Graph" -command {procDisplayCurrentState "yes"}
    }
    tk_popup .statepopup $X $Y
}

proc procPerformContextMenu {X Y} {
 # Context Menu for Enabled Operations pane
    set listy [winfo rooty .main.frmInfo.frmPerform.list]
    set ycoord [expr $Y - $listy]
    set index [.main.frmInfo.frmPerform.list nearest $ycoord]
    .main.frmInfo.frmPerform.list selection clear 0 end
    .main.frmInfo.frmPerform.list selection set $index
    .main.frmInfo.frmPerform.list activate $index
    set hasTrace [prolog tcltk_has_eventtrace($index)]
    procCreateOperationsPopupMenu $hasTrace
    tk_popup .operationspopup $X $Y
}
proc procPerformOpContextMenu_woidx {X Y} {
    procCreateOperationsPopupMenu 0
    tk_popup .operationspopup $X $Y
}

proc procShowEventTrace {} {
    set sel [.main.frmInfo.frmPerform.list curselection]
    if [expr [llength $sel] == 1] {
        puts "selection: $sel"
        if [prolog tcltk_show_eventtrace($sel,Result)] {
            set Result $prolog_variables(Result)
            procShowText $Result "Event Trace"
        } else {
            tkErrorBox "Internal Error: Could not display event trace."
        }
    } 
}

proc procShowStateDetail {} {
    set sel [.main.frmInfo.frmState.list curselection]
    if [expr [llength $sel] == 1] {
		if [prolog tcltk_get_detailed_state_error($sel,ErrorMsg,Line,Col,EL,EC)] {
		    set line $prolog_variables(Line)
		    if {$line >= 0} {
		        procHighlightErrorSpan .main.frmSource.text $line $prolog_variables(Col) $prolog_variables(EL) $prolog_variables(EC)
		    }
			if [prolog can_generate_dot_from_last_state_error] {
			      procShowText4 $prolog_variables(ErrorMsg) "Detailed transition error" "Visualize" procVisualiseSpanPredicate
			} else {
			      procShowText $prolog_variables(ErrorMsg) "Detailed transition error"
			}
		}
    } 
}

proc procTimeOutButton {} {
    prologmnf "preferences:get_preference(time_out,CurTO)"
	set Result $prolog_variables(CurTO)
	prologmnf "eclipse_interface:op_timeout_occurred(OpList)"
	set List $prolog_variables(OpList)
    set ans [tkYesNoMessageWarningBox "A timeout ($Result ms) has occurred while computing enabled operations ($List).\nRecompute this state without a timeout?" "Timeout!"]
    if { $ans == "yes" } {
		prologmnf tcltk_mark_current_node_to_be_recomputed_wo_timeout
		global show_error_if_no_transition
		set show_error_if_no_transition 1
		set sst "Time for recomputing: [time {procInsertHistoryOptionsState}]"
	    prolog "tools:print_message('$sst')"
	}
}

proc procCheckForPluginPreferences {} {
    global plugin_preferences_menu_index
    if [prolog plugins:plugin_has_preferences] {
        prolog plugins:plugins_with_preferences(Plugins)
        set plugins $prolog_variables(Plugins)
        foreach p $plugins {
            set pluginid [lindex $p 0]
            set pluginname [lindex $p 1]
            .frmMenu.mnuPlugins.mnuPluginsPreferences add command -label "$pluginname" \
                -command "procSetPreferences plugin($pluginid)" 
        }
        set new_state normal
    } else {
        set new_state disabled
    }
    .frmMenu.mnuPlugins entryconfigure $plugin_preferences_menu_index -state $new_state
}

proc procCheckForPlugins {} {
    global plugin_menu_index
    if {$plugin_menu_index >= 0} {
        .frmMenu.mnuPlugins.mnuPluginsActivate delete 0 end    
        if [prolog plugins:plugin_is_available_for_mode] {
            prolog plugins:available_plugins_for_mode(Plugins)
            set plugins $prolog_variables(Plugins)
            foreach p $plugins {
                set pluginid [lindex $p 0]
                set pluginname [lindex $p 1]
                .frmMenu.mnuPlugins.mnuPluginsActivate add command -label "$pluginname" \
                    -command "procActivatePlugin $pluginid"
            }
            set new_state normal
        } else {
            set new_state disabled
        }
        .frmMenu.mnuPlugins entryconfigure $plugin_menu_index -state $new_state
    }
}

proc procActivatePlugin {id} {
    global plugin_deactivate_index
    prolog plugins:start_plugin_for_current_mode($id)
    procInsertHistoryOptionsState
    procShowErrors
    .frmMenu.mnuPlugins entryconfigure $plugin_deactivate_index -state normal
    procInitPluginOutputMenu
}

proc procInitPluginOutputMenu {} {
    global plugin_menu_index
    global plugin_preferences_menu_index

    .frmMenu.mnuPlugins delete [expr $plugin_preferences_menu_index + 1] end  

    if [prolog plugins:plugin_has_output(tcltk)] {
        .frmMenu.mnuPlugins add sep

        prolog plugins:plugin_get_output(Outputs,tcltk)
        set plugins $prolog_variables(Outputs)
        foreach p $plugins {
            set name [lindex $p 0]
            set output [lindex $p 1]
            .frmMenu.mnuPlugins add command -label "$name" \
                -command [list procShowPluginOutput $name]
        }
    }
}

proc procShowPluginOutput {name_in} {
    prolog plugins:plugin_get_output(Outputs,tcltk)
    
    set plugins $prolog_variables(Outputs)
    foreach p $plugins {
        set name [lindex $p 0]
        set output [lindex $p 1]

        if {$name == $name_in} {
            procShowText $output $name
            break
        }
    }
}

proc procDeactivatePlugin {} {
    global plugin_preferences_menu_index
    global plugin_deactivate_index
    prolog plugins:stop_plugin
    .frmMenu.mnuPlugins delete [expr $plugin_preferences_menu_index + 1] end  
    .frmMenu.mnuPlugins entryconfigure $plugin_deactivate_index -state disabled
    procReOpenFile
}


proc procSetLinenumbersValueToTrue {enable} {
    global text_editor_arr
    set text_editor_arr(linenumbers) $enable
    if {$enable == "true"} {
         prolog preferences:set_preference(show_line_numbers,true)
        .main.frmSource.text configure -linemap 1 -linemapbg grey90
    } else {
         prolog preferences:set_preference(show_line_numbers,false)
        .main.frmSource.text configure -linemap 0
    }        
}

proc procSetHighlightBracketValueToTrue {enable} {
     global text_editor_arr
     set text_editor_arr(highlight_bracket) $enable
     if {$enable == "true"} {
         prolog preferences:set_preference(highlight_brackets,true)
    } else {
         prolog preferences:set_preference(highlight_brackets,false)
    }
}

proc procSetHighlightCurrentLineValueToTrue {enable} {
    global text_editor_arr
         set text_editor_arr(highlight_line) $enable
    if {$enable == "true"} {
         prolog preferences:set_preference(highlight_current_line,true)
    } else {
         prolog preferences:set_preference(highlight_current_line,false)
         catch {.main.frmSource.text tag delete highlightCurrentLine}
    }         
}

proc procSetAskWhenFileContentChangedValueToTrue {enable} {
	global text_editor_arr
	set text_editor_arr(ask_when_content_changed) $enable
	if {$enable == "true"} {
		prolog preferences:set_preference(ask_when_content_changed,true)
	} else {
		prolog preferences:set_preference(ask_when_content_changed,false)
	}         
}

proc procSetlinecolumnsValue {} {
        global text_editor_arr find_menu_arr
        procUpdateIndicesAfterLoadingAFile
        set twin .main.frmSource.text
        bind $twin <Button-1> {.main.frmSource.text tag remove patternTag 1.0 end
                               if {$find_menu_arr(allpatterns)} {procHighlightAllPatterns $find_menu_arr(search) $find_menu_arr(exact_flag)}
                               after idle {procUpdatelinecolumns "click"}}
        bind $twin <<RIGHTCLICK>> {popupContextTextMenu %X %Y;break}
        bind $twin <Shift-Up> {after idle {procUpdatelinecolumns "up" "shift"}}
        bind $twin <Shift-Down> {after idle {procUpdatelinecolumns "down" "shift"}}
        bind $twin <Key-Up> {after idle {procUpdatelinecolumns "up"}}
        bind $twin <Key-Down> {after idle {procUpdatelinecolumns "down"}}
        bind $twin <Key-Left> {after idle {procUpdatelinecolumns "move"}}
        bind $twin <Key-Right> {after idle {procUpdatelinecolumns "move"}}
        bind $twin <Return> {after idle {procUpdatelinecolumns "move"}}
        bind $twin <BackSpace> {after idle {procUpdatelinecolumns "move"}}
        bind $twin <Key> {after idle {procUpdatelinecolumns "insert" %K}}
        bind $twin <<Selection>> {after idle {if {$text_editor_arr(highlight_line)} {procHighlightSelectionInAlreadyHighlightedLine}}}
}

proc procUpdateIndicesAfterLoadingAFile {} {
        global currentLinePositionInText currentColumnPositionInText currentMaxColumnPosition
        set position [.main.frmSource.text index end]
        regexp {([0-9]+).([0-9]+)} $position all line column
        incr line -1
        set currentLinePositionInText $line
        set column [string length [.main.frmSource.text get $line.0 $line.end ]]
        set currentColumnPositionInText $column
        set currentMaxColumnPosition $column
        incr column
        .main.frmSource.statusframe.linecolumns configure -text "Ln $line, Col $column"\
			-width [string length [string map {" " ""} "Ln $line, Col $column+"]]
}

proc popupContextTextMenu {X Y} {
            CreatePopupMenuForText [.main.frmSource.text cget -state]
            tk_popup .operationsTextpopup $X $Y
}

proc CreatePopupMenuForText {st} {
	destroy .operationsTextpopup
        menu .operationsTextpopup -tearoff 0
	if {$st != "normal"} {
	        set stateCut disabled;set stateCopy normal;set statePaste disabled
		set stateDelete disabled;set stateundo disabled;set stateredo disabled
	} else {
	        set stateCut [procSelectLabelStateOfTheTextContextMenu]
	        set stateCopy [procSelectLabelStateOfTheTextContextMenu]
	        set statePaste [procSelectLabelStateOfTheTextContextMenuPaste]
		set stateDelete normal
       		set stateundo [procSelectLabelStateOfUndo]
        	set stateredo [procSelectLabelStateOfRedo]
	}
        if [prolog animation_mode(b)] {
        .operationsTextpopup add command -label "Visualize Selected Predicate" -command {VisualizeSelectedPredicate} -state normal
	#.operationsTextpopup add command -label "Show Selected Expression As Table" -command {ShowSelectedExpressionAsTable} -state normal
	.operationsTextpopup add command -label "Evaluate Selected Expression" -command {EvaluateSelectedExpression} -state normal
	.operationsTextpopup add sep
        }
        .operationsTextpopup add command -label "Undo" -command {procundo; proc_highlightCurrentLineIfNecessary} -state $stateundo
        .operationsTextpopup add command -label "Redo" -command {procredo; proc_highlightCurrentLineIfNecessary} -state $stateredo
        .operationsTextpopup add sep
        .operationsTextpopup add command -label "Cut" -command {procCutOrCopySlectedRangeOfText "no"; proc_breakCommandExecution} -state $stateCut
        .operationsTextpopup add command -label "Copy" -command {procCutOrCopySlectedRangeOfText "yes"; proc_breakCommandExecution} -state $stateCopy
        .operationsTextpopup add command -label "Paste" -command {procPasteTheCopiedRangeOfText; proc_breakCommandExecution} -state $statePaste 
        .operationsTextpopup add command -label "Delete" -command {procDeleteTheSelectedRangeOfText; proc_breakCommandExecution} -state $stateDelete
        .operationsTextpopup add sep
        .operationsTextpopup add command -label "Select All" -command {proc_selectAll true; break} -state normal
        .operationsTextpopup add sep
        .operationsTextpopup add command -label "Find..." -command {procLaunchFindMenu} -state normal
        .operationsTextpopup add command -label "Replace..." -command procLaunchFindAndReplaceMenu -state normal
        .operationsTextpopup add command -label "Goto Line..." -command {GotoLineSelect} -state normal
        .operationsTextpopup add sep
	global text_editor_arr
	if {$text_editor_arr(linenumbers)==true} {
		.operationsTextpopup add command -label "Hide Line Numbers" -command {procSetLinenumbersValueToTrue "false"} 
	} else {
		.operationsTextpopup add command -label "Show Line Numbers" -command {procSetLinenumbersValueToTrue "true"}  
	}
	if {$text_editor_arr(highlight_bracket)==true} {
		.operationsTextpopup add command -label "Disable Bracket Highlighting" -command {procSetHighlightBracketValueToTrue "false"} 
	} else {
		.operationsTextpopup add command -label "Enable Bracket Highlighting" -command {procSetHighlightBracketValueToTrue "true"}  
	}
	if {$text_editor_arr(highlight_line)==true} {
		.operationsTextpopup add command -label "Disable Highlighting Current Line" -command {procSetHighlightCurrentLineValueToTrue "false"} 
	} else {
		.operationsTextpopup add command -label "Highlight Current Line" -command {procSetHighlightCurrentLineValueToTrue "true"}  
	}
        .operationsTextpopup add command -label "Text Editor Preferences..." -command {procSetTextEditorPreferences}  
}

proc procSelectLabelStateOfTheTextContextMenu {} {
    set twin .main.frmSource.text
    if [winfo exists $twin] {
       if {[.main.frmSource.text tag range sel] == "" || [.main.frmSource.text cget -state] == "disabled"} {
           return disabled
       } else {
           return normal
       }
    } else {
       return disabled
    }
}

proc procSelectLabelStateOfTheTextContextMenuPaste {} {
    set twin .main.frmSource.text
    if [winfo exists $twin] {
        if {[.main.frmSource.text cget -state] == "normal"} {
            if [catch {expr {[selection get -selection CLIPBOARD] == ""}}] {
                return disabled
            } elseif {[selection get -selection CLIPBOARD] == ""} {
                return disabled
            } else {
                return normal
            }
        } else {
            return disabled
        }
    } else {
        return disabled
    }
}

proc procSelectLabelStateOfUndo {} {
    set modified [.main.frmSource.text edit modified]
    if { [catch {.main.frmSource.text edit undo} ] } {
         proc_setFileNotModified
         return disabled
    } else {
         catch {.main.frmSource.text edit redo}
         # Text was modified because of performing undo and then redo
         # by determining the state of the undo menu item.
         # We have to set thus the text widget to not modified, otherwise on every 
         # click on the menu bar the "Source file not saved" dialog will be popped up.
         .main.frmSource.text edit modified $modified
         return normal
    }
}

proc procSelectLabelStateOfRedo {} {
    set modified [.main.frmSource.text edit modified]
    if {[catch {.main.frmSource.text edit redo}]} {
         return disabled
    } else {
         catch {.main.frmSource.text edit undo}
         .main.frmSource.text edit modified $modified
         return normal
    }
}

proc procCutOrCopySlectedRangeOfText {is_copy} {
    global text_editor_arr
    set startIndex [lindex [.main.frmSource.text tag range sel] 0]
    set endIndex [lindex [.main.frmSource.text tag range sel] 1]
    if {![catch {set selectedString [.main.frmSource.text get $startIndex $endIndex]}]} {
        clipboard clear        
        clipboard append $selectedString
	if {$is_copy != "yes"} {
	        .main.frmSource.text delete $startIndex $endIndex
	} else {
            catch {.main.frmSource.text add tag sel $startIndex $endIndex}
        }
        set text_editor_arr(text_index) $startIndex
        proc_highlightCurrentLineIfNecessary
    }
}

proc procPasteTheCopiedRangeOfText {} {
    global text_editor_arr
    set lastSeenIndex $text_editor_arr(text_index)
    set content [selection get -selection CLIPBOARD]
    .main.frmSource.text insert insert $content
    set lines [split $content "\n"]
    set line_num [expr {[llength $lines] -1}]
    set chars [expr {[string length [lindex $lines end]] +1}]
    set text_editor_arr(text_index) [.main.frmSource.text index "$text_editor_arr(text_index) + $line_num lines + $chars chars"]
    .main.frmSource.text see $text_editor_arr(text_index)
    procHighlightTextSpecial .main.frmSource.text $lastSeenIndex $text_editor_arr(text_index)
    proc_highlightCurrentLineIfNecessary
    proc_highlightMultilineCommentBlocks
}

proc procDeleteTheSelectedRangeOfText {} {
    set editor .main.frmSource.text 
    if {[$editor cget -state] == "normal"} {
        set selectionArray [$editor tag range sel]
        if {$selectionArray != ""} {
            set startIndex [lindex $selectionArray 0]
            set endIndex [lindex $selectionArray 1]
            $editor delete $startIndex $endIndex
            regexp {([0-9]+)\.[0-9]+} $startIndex match lineFirst
            regexp {([0-9]+)\.[0-9]+} $endIndex match lineLast
            procHighlightTextSpecial $editor $lineFirst.0 $lineLast.end
            tk::TextSetCursor $editor $startIndex ; # setting the text cursor to the first index of the deleted token 
        }
        proc_highlightCurrentLineIfNecessary
        proc_highlightMultilineCommentBlocks
    }
}

proc proc_selectAll {{loop false}} {
    .main.frmSource.text tag add sel 1.0 end
    if {$loop} {
       if [prolog tools:host_platform(darwin)] {
           return -code break
       } else {
           return -code return
       }
    }
}

proc proc_breakCommandExecution {{end false}} {
    if {!$end} {
        # do nothing
    } else {
       after idle {
           tk::TextSetCursor .main.frmSource.text end
       }
    }
    if [prolog tools:host_platform(darwin)] {
        return -code break
    } else {
        return -code return
    }
}

proc proc_highlightCurrentLineIfNecessary {} {
    global text_editor_arr
    if {$text_editor_arr(highlight_line)} {
         regexp {([0-9]+)\.[0-9]+} [.main.frmSource.text index insert] match line
         procHighlightCurrentLine $line
    }
}

# -------
# procedure to initialise source code section
# -------
proc procGUI_Source {} {
    global tcl_version text_editor_arr
    prolog "get_preference(font_name,FontName)"
    set text_editor_arr(font_name) $prolog_variables(FontName)
    prolog "get_preference(font_size_only,FontSize)"
    set text_editor_arr(font_size) $prolog_variables(FontSize)
    if [prolog get_preference(tk_show_source_pane,true)] {
		if [prolog get_preference(use_small_window,true)] {
			set source_height 17
		} else {
			set source_height 23
		}
		# ------- code source frames
		frame .main.frmSource -borderwidth .1c -relief groove
		scrollbar .main.frmSource.scrolly -command ".main.frmSource.text yview"
		scrollbar .main.frmSource.scrollx -command ".main.frmSource.text xview" -orient h
                set TextFont [string map {" " ""} $text_editor_arr(font_name)]
                if {$text_editor_arr(linenumbers)} {
                     set linemapVar 1
                } else {
                     set linemapVar 0
                }
                ctext .main.frmSource.text -bg white -yscrollcommand ".main.frmSource.scrolly set" \
                       -xscrollcommand ".main.frmSource.scrollx set" -setgrid 1 -height $source_height\
                       -linemap $linemapVar -state disabled -font "$TextFont $text_editor_arr(font_size)"
		frame .main.frmSource.statusframe -bg #EDECEB
		label .main.frmSource.statusframe.messagestatus -relief flat -justify center\
			-width [expr {[.main.frmSource cget -width]-45}] -bg #EDECEB
		label .main.frmSource.statusframe.linecolumns -relief flat -justify left -text "Ln 1, Col 1"\
                          -width [string length [string map {" " ""} "Ln 1, Col 1+"]] -bg #EDECEB
		label .main.frmSource.statusframe.modelstatus -relief flat -justify center -text ""\
                          -width 25 -bg #EDECEB
		#text .main.frmSource.text -yscroll ".main.frmSource.scrolly set" -xscroll ".main.frmSource.scrollx set" \
                #          -setgrid 1 -height $source_height -state disabled
                .main.frmSource.text edit modified 0
                proc_setFileNotModified
                pack .main.frmSource.statusframe.messagestatus -expand 1 -side left -fill both
                pack .main.frmSource.statusframe.linecolumns -expand 0 -side left -fill both
                pack .main.frmSource.statusframe.modelstatus -expand 0 -side left -fill both
		pack .main.frmSource.statusframe -expand 0 -side bottom -fill both
		pack .main.frmSource.scrolly -side right -fill y
		pack .main.frmSource.scrollx -side bottom -fill x
		pack .main.frmSource.text -expand 1 -fill both
                procSetlinecolumnsValue
		bind .main.frmSource.statusframe.linecolumns <<RIGHTCLICK>> {procPerformLineColumnsContextMenu %X %Y}
    } else {
		set source_height 0
		frame .main.frmSource -borderwidth .1c -relief groove
		text .main.frmSource.text -height $source_height -state disabled
		# pack .main.frmSource.text -expand 1 -fill both
    }

    #set font to monospaced font (windows defaults to times else)
    prologmnf "get_preference(font_size,PrefFont)"
    set chosenfont $prolog_variables(PrefFont)
    changeFont $chosenfont

    #  proxy all insert calls to the filter frame to keep modified state saved
    rename .main.frmSource.text ..main.frmSource.text
    proc .main.frmSource.text args {
        if [regexp {^(ins|del).*} [lindex $args 0]] { procSetCodeModified }
	    uplevel ..main.frmSource.text $args
    }
    focus -force .main.frmSource.text
    .main.frmSource.text configure -undo 1
    bind .main.frmSource.text <<Modified>>  procupdateState
    bind . <Destroy> [list procDoQuitMain %W]
}

proc procPackageRequireIsMissing {missing_widget missing_package} {
    set answer [tk_messageBox -message "The widget $missing_widget from $missing_package is missing.\n\
                                        Please install $missing_package if possible.\n\
                                        Do you want to run ProB now without the new text editor features?"\
                  -title "Package is missing." -type yesno -default yes -icon error -parent .]
    if {$answer == "no"} {
        exit
    }
}

proc procUpdatelinecolumns {click args} {
      global strFilename text_editor_arr
      set editor .main.frmSource.text
      set noInsertKeys [list "??" "Next" "Prior" "Home" "End" "KP_Enter"]
      set ix [lsearch -exact $noInsertKeys [lindex $args 0]]
      set line 1; set column 0
      if [winfo exists .main.frmSource.statusframe.linecolumns] {
         if {$click == "click"} {
             regexp {([0-9]+).([0-9]+)} [$editor index current] all line column
	     if {[$editor index $line.end] == "$line.$column"} {
		# this action prevents from not moving the cursor to the begin column of the next line
		# when the end of a line has been clicked
		tk::TextSetCursor $editor $line.$column
	     }
         } elseif {$click == "down"} {
                 regexp {([0-9]+).([0-9]+)} $text_editor_arr(text_index) all line column
                 set lineend [$editor index $line.end]
                 if [$editor compare $line.end == [$editor index "end -1 chars"]] {
                     if {[llength $args] >0 && [lindex $args 0] == "shift"} {
                         if [catch {set start [$editor index sel.first]}] {
                             set start $text_editor_arr(text_index)
                         }
                         tk::TextSetCursor $editor end
                         .main.frmSource.text tag add sel $start [$editor index "end -1 chars"]
                      } else {
                         tk::TextSetCursor $editor end
                      }
                      regexp {([0-9]+).([0-9]+)} [$editor index "end -1 chars"] all line column
                 } else {
                     regexp {([0-9]+).([0-9]+)} [$editor index insert] all line column
                 }
         } elseif {$click == "up"} {
                 if [$editor compare $text_editor_arr(text_index) < 2.0] {
                     if {[llength $args] >0 && [lindex $args 0] == "shift"} {
                         if [catch {set end [$editor index sel.last]}] {
                             set end $text_editor_arr(text_index)
                          }
                          tk::TextSetCursor $editor 1.0
                          .main.frmSource.text tag add sel 1.0 $end
                     } else {
                          tk::TextSetCursor $editor 1.0
                     }
                     set line 1; set column 0
                 } else {
                     regexp {([0-9]+).([0-9]+)} [$editor index insert] all line column
                 }
         } elseif {$click == "move" || $click == "insert"} {
                 regexp {([0-9]+).([0-9]+)} [$editor index insert] all line column
         } else {
             error "Option unknown $click by procedure procUpdatelinecolumns."
         }
         if {($strFilename != "") && [file exists $strFilename]} {
             if {([file mtime $strFilename] != $text_editor_arr(file_last_modified)) && !($text_editor_arr(deactivate_asking_for_reloading))} {
		if {!$text_editor_arr(ask_when_content_changed) && ![$editor edit modified]} {
			set fid [open $strFilename r]
			set strInFile [read $fid]
			close $fid
			procRefreshContentInTextEditor $editor $strInFile false
			procresetundo
			set text_editor_arr(file_last_modified) [file mtime $strFilename]
			.main.frmSource.statusframe.modelstatus configure -text "File content was changed." -bg orange
		} else {
			# File was last modified by another program
			set ans [tk_messageBox -default yes -message "The file $strFilename changed on disk.\nDo you want\
                       to reload the file content into the text editor?" -title "Warning" -type yesno -icon warning -parent .]
			if {$ans == "yes"} {
				set fid [open $strFilename r]
				set strInFile [read $fid]
				close $fid
				procRefreshContentInTextEditor $editor $strInFile false
				procresetundo
				set text_editor_arr(file_last_modified) [file mtime $strFilename]
				tk_messageBox -parent . -icon warning -message "File content in text editor changed!\
					\nYou have to reload the current model to apply changes."
			} else {
				set text_editor_arr(deactivate_asking_for_reloading) true
			}
		}
             }
         }
         if {$text_editor_arr(highlight_line)} {
              if {$ix < 0} {
                  procHighlightCurrentLine $line
              } else {
                     # do not update current line highlighting
              }
         }
         set text_editor_arr(text_index) "$line.$column"
         set twin .main.frmSource.text
         proc_setFileModifiedMarker
         $twin tag delete matchBracket
         if {$text_editor_arr(highlight_bracket)} {
             $twin tag delete matchBracket
             set symbol [$twin get $text_editor_arr(text_index)]
             if [procIsBracketSymbol $symbol] {
                 procCallHighlightMatchedPairSymbolProcedure $symbol $text_editor_arr(text_index)
             } else {
                 set symbol [$twin get "$text_editor_arr(text_index) -1 chars"]
                 procCallHighlightMatchedPairSymbolProcedure $symbol [$twin index "$text_editor_arr(text_index) -1 chars"]
            }
         }
             proc_highlightMultilineCommentBlocks ; # need to prove efficiency of this procedure
         incr column
         .main.frmSource.statusframe.linecolumns configure -text "Ln $line, Col $column" \
                           -width [string length [string map {" " ""} "Ln $line, Col $column+"]]
      }
}

proc procCallHighlightMatchedPairSymbolProcedure {symbol index} {
      switch -- $symbol {
        "\{" {procHighlightMatchedPairSymbol $index "-forwards" "\\\{" "\\\}" end}
        "\}" {procHighlightMatchedPairSymbol $index "-backwards" "\\\}" "\\\{" 1.0}
        "\[" {procHighlightMatchedPairSymbol $index "-forwards" "\\\[" "\\\]" end}
        "\]" {procHighlightMatchedPairSymbol $index "-backwards" "\\\]" "\\\[" 1.0}
        "\(" {procHighlightMatchedPairSymbol $index "-forwards" "\\(" "\\)" end}
        "\)" {procHighlightMatchedPairSymbol $index "-backwards" "\\)" "\\(" 1.0}
      }                 
}

proc procIsBracketSymbol {symbol} {
     if {[lsearch -exact [list "\{" "\}" "\[" "\]" "\(" "\)"] $symbol] > -1} {
          return true
     } else {
          return false
     }
}

# add * infornt of the file name when the file were modified
proc proc_setFileModifiedMarker {} {
    global strFilename version text_editor_arr
    if {[.main.frmSource.text edit modified] && !$text_editor_arr(file_modified) && 
        $strFilename != ""} {
        set fileTail [file tail $strFilename]
        set ext [file extension $strFilename]
        set text_editor_arr(file_modified) 1
        if {$ext == ".tex"} {
	     wm title . "ProZ:  $version: \[\*$fileTail\]"
	} elseif {$ext == ".cspm" || $ext == ".csp"} {
	     wm title . "ProCSP: $version \[\*$fileTail\]"
	} elseif {$ext == ".pml" || $ext == ".prom"} {
	     wm title . "ProM: $version \[\*$fileTail\]"
	} elseif {$ext == ".P"} {
	     wm title . "ProXTL $version: \[\*$fileTail\]"
	} else {
	     wm title . "ProB $version: \[\*$fileTail\]"
	}
    }
}

proc proc_setFileNotModified {} {
    global strFilename version text_editor_arr
    if {![.main.frmSource.text edit modified] && $strFilename != ""} {
        set fileTail [file tail $strFilename]
        set ext [file extension $strFilename]
        set text_editor_arr(file_modified) 0
        if {$ext == ".tex"} {
	     wm title . "ProZ:  $version: \[$fileTail\]"
	} elseif {$ext == ".cspm" || $ext == ".csp"} {
	     wm title . "ProCSP: $version \[$fileTail\]"
	} elseif {$ext == ".pml" || $ext == ".prom"} {
	     wm title . "ProM: $version \[$fileTail\]"
	} elseif {$ext == ".P"} {
	     wm title . "ProXTL $version: \[$fileTail\]"
	} else {
	     wm title . "ProB $version: \[$fileTail\]"
	}
    }
}

proc procupdateState {args} {
      
      # Check the modified state and update the label
      if { [.main.frmSource.text edit modified] } {
	     .frmMenu.mnuEdit entryconfigure 0 -state normal
	     .frmMenu.mnuEdit entryconfigure 1 -state normal
      } else {
	     .frmMenu.mnuEdit entryconfigure 0 -state disabled
	     .frmMenu.mnuEdit entryconfigure 1 -state disabled
             proc_setFileNotModified
      }
}

proc procundo {} {
      # edit undo throws an exception when there is nothing to
      # undo. So catch it.
      global undosperformed
      if { [catch {.main.frmSource.text edit undo}] } {
         bell
      } else {
          procHighlightTextSpecial .main.frmSource.text 1.0 end
          incr undosperformed
          .frmMenu.mnuEdit entryconfigure 1 -state normal
      }
}

proc procredo {} {
      # edit redo throws an exception when there is nothing to
      # undo. So catch it.
      if { [catch {.main.frmSource.text edit redo}] } {
         bell
      } else {
        procHighlightTextSpecial .main.frmSource.text 1.0 end        
        global undosperformed
        if {$undosperformed >0} {
            set undosperformed [expr $undosperformed-1]
        }
        if {$undosperformed==0} {
           .frmMenu.mnuEdit entryconfigure 1 -state disabled
        }
      }
}
   
proc procresetundo {} {
     global undosperformed
     set undosperformed 0
     .frmMenu.mnuEdit entryconfigure 0 -state disabled
     .frmMenu.mnuEdit entryconfigure 1 -state disabled
     # Reset the modified state
     .main.frmSource.text edit modified 0
     proc_setFileNotModified
     # Clear the undo stack
     .main.frmSource.text edit reset
     .main.frmSource.text configure -undo 1
}

proc changeFont {chosenfont} {
    global chosefontval
    # puts "Changing Font: $chosefontval $chosenfont"
    set chosefontval $chosenfont

   #.main.frmSource.text configure -font $chosenfont
    prologmnf "get_preference(use_font_size_for_columns,UseForCols)"
    set useforcolumns $prolog_variables(UseForCols)
   if {$useforcolumns == "true"} { 
      .main.frmInfo.frmHisto.label configure -font $chosenfont
      .main.frmInfo.frmHisto.list configure -font $chosenfont
      .main.frmInfo.frmPerform.label configure -font $chosenfont
      .main.frmInfo.frmPerform.list configure -font $chosenfont
      .main.frmInfo.frmState.label configure -font $chosenfont
      .main.frmInfo.frmState.list configure -font $chosenfont
   }
    prolog "set_preference(font_size,'$chosenfont')"
}

proc procLaunchFindMenu {} {
    global find_menu_arr
    set find_menu_arr(found_index) ""
    eval global find
    set find .findMenu
    if [winfo exists .findMenu] {
        raise .findMenu
    } else {
        if [winfo exists .replaceMenu] {
            destroy .replaceMenu
        }
        if [Dialog_Create $find "Find" -borderwidth 10] {
            wm resizable $find 0 0
            wm transient $find .
            set find_menu_arr(search) ""
            frame $find.searchFrame -relief flat
            label $find.searchFrame.searchLabel -text "Search for: "
            ttk::combobox $find.searchFrame.search -textvariable find_menu_arr(search) -state editable -values $find_menu_arr(search_hist)
            frame $find.check -relief flat
            ttk::checkbutton $find.check.matchCase -text "Match Case" -variable find_menu_arr(case) -onvalue true -offvalue false
            ttk::checkbutton $find.check.matchWord -text "Match entire word only" -variable find_menu_arr(word) -onvalue true -offvalue false
            ttk::checkbutton $find.check.searchBackwards -text "Search backwards" -variable find_menu_arr(backwards) -onvalue true -offvalue false
            ttk::checkbutton $find.check.wrapAround -text "Wrap around" -variable find_menu_arr(wraparound) -onvalue true -offvalue false
            frame $find.buttons -relief flat
            button $find.buttons.find -text Find -command {procSearchPatternInText .findMenu} -activebackground lightblue -width 6
            button $find.buttons.close -text Close -command {destroy .findMenu} -activebackground lightblue -width 6
            pack $find.searchFrame $find.check $find.buttons -side top -pady 5
            pack $find.searchFrame.searchLabel $find.searchFrame.search -side left
            pack $find.check.matchCase $find.check.matchWord $find.check.searchBackwards $find.check.wrapAround -side top -pady 1 -fill x
            pack $find.buttons.close $find.buttons.find -side right -padx 25
            bind .findMenu <Return> {$find.buttons.find invoke}
            bind .findMenu <Escape> {destroy .findMenu}
            focus -force $find.searchFrame.search
        }
    }
}

proc procLaunchFindAndReplaceMenu {} {
    global find_menu_arr
    eval global repl
    set repl .replaceMenu
    if [winfo exists .replaceMenu] {
        raise .replaceMenu
    } else {
        if [winfo exists .findMenu] {
            destroy .findMenu
        }
        if [Dialog_Create $repl "Replace" -borderwidth 10] {
            wm resizable $repl 0 0
            wm transient $repl .
            set find_menu_arr(search) ""
            set find_menu_arr(replace) ""
            frame $repl.searchFrame -relief flat
            label $repl.searchFrame.searchLabel -text "Search for: "
            ttk::combobox $repl.searchFrame.search -textvariable find_menu_arr(search) -state editable -values $find_menu_arr(search_hist)
            frame $repl.replaceFrame -relief flat
            label $repl.replaceFrame.replaceLabel -text "Replace with: "            
            ttk::combobox $repl.replaceFrame.replace -textvariable find_menu_arr(replace) -state editable -values $find_menu_arr(replace_hist)
            frame $repl.check -relief flat
            ttk::checkbutton $repl.check.matchCase -text "Match Case" -variable find_menu_arr(case) -onvalue true -offvalue false
            ttk::checkbutton $repl.check.matchWord -text "Match entire word only" -variable find_menu_arr(word) -onvalue true -offvalue false
            ttk::checkbutton $repl.check.searchBackwards -text "Search backwards" -variable find_menu_arr(backwards) -onvalue true -offvalue false
            ttk::checkbutton $repl.check.wrapAround -text "Wrap around" -variable find_menu_arr(wraparound) -onvalue true -offvalue false
            frame $repl.buttons -relief flat
            button $repl.buttons.find -text Find -command {procSearchPatternInText .replaceMenu} -activebackground lightblue
            button $repl.buttons.replace -text Replace -command {procReplacePattern .replaceMenu} -activebackground lightblue -state disabled
            button $repl.buttons.replaceAll -text "Replace All" -command {procReplaceAllFoundedPatterns .replaceMenu} -activebackground lightblue
            button $repl.buttons.close -text Close -command {destroy .replaceMenu} -activebackground lightblue
            pack $repl.searchFrame $repl.replaceFrame $repl.check $repl.buttons -side top -pady 5
            pack $repl.searchFrame.searchLabel $repl.searchFrame.search -side left -padx 8
            pack $repl.replaceFrame.replaceLabel $repl.replaceFrame.replace -side left
            pack $repl.check.matchCase $repl.check.matchWord $repl.check.searchBackwards $repl.check.wrapAround -side top -pady 1 -fill x
            pack $repl.buttons.close $repl.buttons.replaceAll $repl.buttons.replace $repl.buttons.find -side right -padx 3
            bind .replaceMenu <Return> {procSearchPatternInText .replaceMenu}
            bind .replaceMenu <Escape> {destroy .replaceMenu}
            focus -force $repl.searchFrame.search
        }
    }

}

proc procSearchPatternInText {win} {
     global find_menu_arr text_editor_arr
     set index [procGetFoundedStringIndex $win]
     if {$index != ""} {
        set text_editor_arr(text_index) $index
        set find_menu_arr(found_index) $index
        set NextTextIndex [procReturnEndTextIndex $text_editor_arr(text_index) $find_menu_arr(search)]
        procHighlightAllPatterns $find_menu_arr(search) $find_menu_arr(exact_flag)
        procHighlightPattern $text_editor_arr(text_index) $NextTextIndex
        set text_editor_arr(text_index) $NextTextIndex
        procAppendElementToFindWindowSearchHistory $find_menu_arr(search) $win.searchFrame.search "search"
        if [winfo exists $win.buttons.replace] {
            $win.buttons.replace configure -state normal
        }
    } else {
        .main.frmSource.text tag remove patternTag 1.0 end
        procHighlightAllPatterns $find_menu_arr(search) $find_menu_arr(exact_flag)
        set find_menu_arr(found_index) ""
    }
}

proc procHighlightAllPatterns {pattern flag} {
    global find_menu_arr
        if {$find_menu_arr(word)} {
            procHighlightAllMatchedEntireWordsInText $pattern $flag
        } else {
            procHighlightAllPatternsInText $pattern $flag
        }
}

proc procGetFoundedStringIndex {win} {
     global text_editor_arr find_menu_arr
     set find_menu_arr(search) [$win.searchFrame.search get]
     if {$find_menu_arr(search) != ""} {
         procDefineSearchingFlags
         if {!$find_menu_arr(wraparound)} {
             if {$find_menu_arr(direction) == "-backwards"} {
                 set endIndex 1.0
             } else {
                 set endIndex end
             }
         } else {
             set endIndex ""
         }   
         set foundedIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text\
                                                                            $find_menu_arr(search) $find_menu_arr(direction) $text_editor_arr(text_index) $endIndex]
         if [procCheckIndicesAccordingToSearchDirection $text_editor_arr(text_index) $foundedIndex $find_menu_arr(search) $find_menu_arr(direction)] {
             # if we search backwards then we have to change the index parameter
             set text_editor_arr(text_index) [procReturnStartTextIndex $text_editor_arr(text_index) $find_menu_arr(search)]
             set foundedIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text\
                                                                            $find_menu_arr(search) $find_menu_arr(direction) $text_editor_arr(text_index) $endIndex]
          }
          return $foundedIndex
     } else {
          return ""
     } 
}

proc procGetPatternIndexDependingOnTheMatchEntireWordOption {twin pattern direction start {end ""}} {
     global find_menu_arr
     if {$end == ""} {
         set endIndexArg {}
     } else {
         set endIndexArg [list $end]
     }
     if {$find_menu_arr(word)} {
         set cmd [concat [list procGetEntireWordMatchIndexOnly $twin $pattern $start $direction] $endIndexArg]
         return [eval $cmd]
     } else {
         set cmd [concat [list $twin search $direction $find_menu_arr(exact_flag) $pattern $start] $endIndexArg]
         return [eval $cmd]
     }
}

proc procGetEntireWordMatchIndexOnly {twin pattern start direction {end "end"}} {
     global find_menu_arr
     while 1 {
          set index [$twin search $direction -count length -regexp -- {([^\s\(\{\[\}\]\)\.\t\n\r;\"'\|,]+)} $start $end]
          if {$index == "" || $pattern == ""} {
              break
          }
          set wordEnd [$twin index "$index + $length chars"]
          set word [$twin get $index $wordEnd]
          if {$pattern == $word} {
              break
          } elseif {$find_menu_arr(exact_flag) == "-nocase"} {
              if {[string tolower $word] == [string tolower $pattern]} {
                  break
              }
          }
          if {$direction == "-backwards"} {
              set start $index
          } else {
              set start $wordEnd
          }
     }
     return $index
}


proc procHighlightAllMatchedEntireWordsInText {pattern flag} {
      global find_menu_arr
      set twin .main.frmSource.text
      if {$pattern != ""} {
          $twin tag remove allPatterns 1.0 end
          set start 1.0
          set highlightedPatterns 0
          while 1 {
              set index [$twin search -count length -regexp -- {([^\s\(\{\[\}\]\)\.\t\n\r;\"'\|,]+)} $start end]
              if {$index == ""} {
                  break
              }
              set wordEnd [$twin index "$index + $length chars"]
              set word [$twin get $index $wordEnd]
              if {$pattern == $word} {
                  $twin tag add allPatterns $index $wordEnd
                  incr highlightedPatterns
              } elseif {$flag == "-nocase"} {
                  if {[string tolower $pattern] == [string tolower $word]} {
                      $twin tag add allPatterns $index $wordEnd
                      incr highlightedPatterns              
                  }
              }
              set start $wordEnd
          }
          if {$highlightedPatterns > 0} {
              set find_menu_arr(allpatterns) true
          }
          $twin tag configure allPatterns -background #FFFF00
      }
}

proc procDefineSearchingFlags {} {
     global find_menu_arr
     if {$find_menu_arr(case)} {
         set find_menu_arr(exact_flag) "-exact"
     } else {
         set find_menu_arr(exact_flag) "-nocase"
     }
     if {$find_menu_arr(backwards)} {
        set find_menu_arr(direction) "-backwards"
     } else {
        set find_menu_arr(direction) "-forwards"
     }
}

proc procReplacePattern {win} {
    global find_menu_arr
    if {$find_menu_arr(found_index) != ""} {
        set newPattern [$win.replaceFrame.replace get]
        set endIndex [procReturnEndTextIndex $find_menu_arr(found_index) $find_menu_arr(search)]
        .main.frmSource.text delete $find_menu_arr(found_index) $endIndex
        .main.frmSource.text insert $find_menu_arr(found_index) $newPattern
        procAppendElementToFindWindowSearchHistory $find_menu_arr(search) $win.searchFrame.search "search"
        procAppendElementToFindWindowSearchHistory $newPattern $win.replaceFrame.replace "replace"
        procHighlightTextSpecial .main.frmSource.text $find_menu_arr(found_index) end
        procSearchPatternInText $win
    } else {
        $win.buttons.replace configure -state disabled
    }
}

proc procReplaceAllFoundedPatterns {win} {
    procDefineSearchingFlags
    set pattern [$win.searchFrame.search get]
    set newPattern [$win.replaceFrame.replace get]
    if {[expr {$pattern != ""}] && [expr {$newPattern != ""}]} {
        procAppendElementToFindWindowSearchHistory $pattern $win.searchFrame.search "search"
        procAppendElementToFindWindowSearchHistory $newPattern $win.replaceFrame.replace "replace"
        set veryFirstIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" 1.0 end]
        if {$veryFirstIndex != ""} {
            set endIndex [procReturnEndTextIndex $veryFirstIndex $pattern]
            set newEndIndex [procReturnEndTextIndex $veryFirstIndex $newPattern]
            .main.frmSource.text delete $veryFirstIndex $endIndex
            .main.frmSource.text insert $veryFirstIndex $newPattern
            set nextIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" $newEndIndex end]
            while {$nextIndex != ""} {
                 set nextEndIndex [procReturnEndTextIndex $nextIndex $pattern]
                 set newEndIndex [procReturnEndTextIndex $nextIndex $newPattern]
                 .main.frmSource.text delete $nextIndex $nextEndIndex
                 .main.frmSource.text insert $nextIndex $newPattern
                 set nextIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" $newEndIndex end]
            }
            procHighlightTextSpecial .main.frmSource.text $veryFirstIndex end
        }
    }
}

proc procAppendElementToFindWindowSearchHistory {element win whichHistory} {
    global find_menu_arr
    if {$element != ""} {
        if {$whichHistory == "search"} {
            prolog preferences:add_element_to_history(searched_patterns,'$element',9)
        } else {
            prolog preferences:add_element_to_history(replaced_patterns,'$element',9)
        }
        set tmpList [list $element]
    } else {
        set tmpList {}
    }
    if {$whichHistory == "search"} {
        set historyList $find_menu_arr(search_hist)
    } else {
        set historyList $find_menu_arr(replace_hist)
    }
    foreach i $historyList {
        if {$element != $i} {
            lappend tmpList $i
        }
    }
    if {$whichHistory == "search"} {
        set find_menu_arr(search_hist) $tmpList
    } else {
        set find_menu_arr(replace_hist) $tmpList
    }
    $win configure -values [lrange $tmpList 0 8]
}

proc procHighlightPattern {startIndex endIndex} {
      .main.frmSource.text tag remove patternTag 1.0 end
      .main.frmSource.text tag remove allPatterns $startIndex $endIndex
      .main.frmSource.text tag add patternTag $startIndex $endIndex
      .main.frmSource.text tag configure patternTag -foreground white
      .main.frmSource.text tag configure patternTag -background #86ABD9
      regexp {([0-9]+)\.[0-9]+} $startIndex match line
      .main.frmSource.text see "$line.0"
}

proc procHighlightAllPatternsInText {pattern flag} {
      global find_menu_arr
      if {$pattern != ""} {
          .main.frmSource.text tag remove allPatterns 1.0 end
          set veryFirstIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" 1.0]
          if {$veryFirstIndex != ""} {
              set find_menu_arr(allpatterns) true
              set endIndex [procReturnEndTextIndex $veryFirstIndex $pattern]
              set nextIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" $endIndex]
              .main.frmSource.text tag add allPatterns $veryFirstIndex $endIndex
              .main.frmSource.text tag configure allPatterns -background #FFFF00
              while {$nextIndex != $veryFirstIndex} {
                 set nextEndIndex [procReturnEndTextIndex $nextIndex $pattern]
                 .main.frmSource.text tag add allPatterns $nextIndex $nextEndIndex
                 set nextIndex [procGetPatternIndexDependingOnTheMatchEntireWordOption .main.frmSource.text \
                                                                $pattern "-forwards" $nextEndIndex]
              }
          }
      }
}

proc procHighlightSelectionInAlreadyHighlightedLine {} {
     global text_editor_arr
     regexp {([0-9]+)\.[0-9]+} [.main.frmSource.text index insert] all line
     procHighlightCurrentLine $line
         if [procIsCurrentHighlightedLineIndexInSelectionRange $text_editor_arr(high_line_index)] {
             set startIndex [lindex [split [.main.frmSource.text tag range sel]] 0]
             set endIndex [lindex [split [.main.frmSource.text tag range sel]] 1]
             .main.frmSource.text tag remove highlightCurrentLine $startIndex $endIndex
          } else {
             # do nothing
          }
}

proc procIsCurrentHighlightedLineIndexInSelectionRange {line} {
     if [regexp {([0-9]+).[0-9]+\ ([0-9]+).[0-9]+} [.main.frmSource.text tag range sel] all linestart lineend] {
          if {[expr {$line >= $linestart}] && [expr {$line <= $lineend}]} {
                return 1
          } else {
                return 0
          }
     } else {
         return 0
     }
}

proc procHighlightCurrentLine {line} {
     global text_editor_arr
     set twin .main.frmSource.text
     set ltags [list hlite patternTag allPatterns executedTag executedauxTag executedControlFlowTag \
                   errcoltag sliceTag errtag sliceTagCEB sel]
     if [$twin compare $line.end != [$twin index end]] {
         $twin tag delete highlightCurrentLine
         set nextline [expr {$line +1}]
         $twin tag add highlightCurrentLine $line.0 $nextline.0
         $twin tag configure highlightCurrentLine -background grey90
         set text_editor_arr(high_line_index) $line
         foreach i $ltags {
              catch {$twin tag raise $i}
         }
     }
}

proc lelement {element list} {
     foreach i $list {
        if {$i == $element} {return true} else {return false}
     }
}

proc procHighlightMatchedPairSymbol {index direction bracket symbol end} {
     global text_editor_arr
     set twin .main.frmSource.text
     set searchRE "[set bracket]|[set symbol]"
     set count 1
     set lastFound ""
     if {$direction == "-forwards"} {
         set index [$twin index "$index + 1 chars"]
     }
     while 1 {
         set found [$twin search $direction -regexp $searchRE $index $end]

         if {$found == ""} {
              return
         }
         if {$lastFound != "" && [$twin compare $found == $lastFound]} {
              return ; # in case the search is wrapping back after no matching symbol found
         }

         set lastFound $found
         set char [$twin get $found]
         set index $found
         if {$direction == "-forwards"} {
             # avoid endless loop by forwards search through the text
             set index [$twin index "$index + 1 chars"]
         }

         if {[string equal $char [subst $symbol]]} {
              incr count -1
              if {$count == 0} {
                  $twin tag add matchBracket $found
                  if {$text_editor_arr(highlight_line)} {
                      $twin tag configure matchBracket -background DarkGrey -foreground white
                  } else {
                      $twin tag configure matchBracket -background grey -foreground white
                  }
                  break 
              }
         } elseif {[string equal $char [subst $bracket]]} {
              incr count
         }
     }
}

proc procIsSymbolPaired {str s1 s2} {
	set count 0; set i 0; set len [string length $str]
	while {$i < $len} {
		set ch [string index $str $i]
		if [string equal "$ch" "$s1"] {
			incr count
		} elseif [string equal "$ch" "$s2"] {
			incr count -1
		}		
		incr i
	}
	return !$count
}

proc proc_highlightMultilineCommentBlocks {} {
     set searchRE [proc_getMultilineSearchRE]
     regexp {(.*)\|(.*)} $searchRE match start end
     set twin .main.frmSource.text
     set foundStart [$twin search -forwards -- $start 0.0 end]
     if {$foundStart != "" && [$twin cget -state] != "disabled"} {
         $twin tag delete multiline_comment
         while 1 {
             set foundEnd [$twin search -forwards -- $end $foundStart end]
             if {$foundEnd == ""} {
                 proc_highlightCurrentCommentBlock $foundStart end
                 return
             } else {
                 proc_highlightCurrentCommentBlock $foundStart [$twin index "$foundEnd +2 chars"]
             }
             set foundStart [$twin search -forwards -- $start $foundEnd end]
             if {$foundStart == ""} {
                 return
             }
         }
     } elseif {[$twin cget -state] != "disabled"} {
         $twin tag delete multiline_comment
     }
}

proc proc_highlightCurrentCommentBlock {start end} {
     set twin .main.frmSource.text
     $twin tag add multiline_comment $start $end
     prolog preferences:get_preference(sh_comments,Colour)
     set col $prolog_variables(Colour)
     $twin tag configure multiline_comment -foreground $col
}

proc proc_getMultilineSearchRE {} {
     global strFilename
     set file_ext [file extension $strFilename]
     set commentStartExpression "\/\*"
     set commentEndExpression "\*\/"
     if { $file_ext == ".csp" || $file_ext == ".cspm" } {
          set commentStartExpression "\{\-"
          set commentEndExpression "\-\}"
     } elseif {$file_ext == ".tla"} {
          set commentStartExpression "(\*"
          set commentEndExpression "\*)"
     }
     return "[set commentStartExpression]|[set commentEndExpression]"
}

proc procReturnEndTextIndex {index pattern} {
    regexp {([0-9]+)\.([0-9]+)} $index match line col
    set endcol [expr {$col + [string length $pattern]}]
    return $line.$endcol
}

proc procReturnStartTextIndex {index pattern} {
    regexp {([0-9]+)\.([0-9]+)} $index match line col
    set startcol [expr {$col - [string length $pattern]}]
    if {$startcol < 0} {
        set startcol 0
    }
    return $line.$startcol
}

proc procCheckIndicesAccordingToSearchDirection {index findex pattern direction} {
    if {[regexp {([0-9]+)\.([0-9]+)} $index match line col] && [regexp {([0-9]+)\.([0-9]+)} $findex match2 line2 col2]} {
        if {$direction == "-backwards"} {
            if {$col2 == [expr {$col - [string length $pattern]}]} {
                return 1
            } else {
                return 0
            }
        } else {
            return 0
        }
     } else {
        return 0
     }
}

# -------
# procedure to initialise main GUI
# -------

proc procInitPreferences {} {
    global mcPerformBreadthFirst mcFindDeadlocks mcFindInvViolations
    global mcSearchForNewErrors mcFindGOAL mcPartialOrderReduction
    set mcPerformBreadthFirst 0
    set mcFindDeadlocks 1
    set mcFindInvViolations 1
    set mcSearchForNewErrors 1
    set mcFindGOAL 0
    set mcFindAssViolations 0
    set mcPartialOrderReduction 0

    global mc_prompt
    set mc_prompt(result) "100000"

    global ltldata
    set ltldata(result) "1000"
    set ltldata(mode) "init"

    global ctldata
    set ctldata(result) "1000"
    set ctldata(mode) "starthere"
}

proc procGUI_WindowIcon {} {
    global tcl_dir tcl_version
   if {$tcl_version>=8.5} {
    if [file exists "$tcl_dir/icons/prob_128.gif"] {
	  image create photo WindowIcon -format gif -fil "$tcl_dir/icons/prob_128.gif"
	  wm iconphoto . WindowIcon
    }
    }
}

# procedures for using the place geometry manager
proc Pane_Create {f1 f2 args} {

   # Map optional arguments into array values
   set t(-orient) vertical
   set t(-percent) 0.5
   set t(-in) [winfo parent $f1]
   array set t $args

   # Keep state in an array associated with the master frame
   set master $t(-in)
   upvar #0 Pane$master pane
   array set pane [array get t]
   # Create the grip and set placement attributes that
   # will not change. A thin divider line is achieved by
   # making the two frames one pixel smaller in the
   # adjustable dimension and making the main frame black.
   set pane(1) $f1
   set pane(2) $f2
   set cursor $t(-cursor)
   set pane(grip) [frame $master.grip -background snow3 \
      -width 10 -height 10 -bd 1 -relief raised \
      -cursor $cursor]
   if {[string match vert* $pane(-orient)]} {
      set pane(D) Y;# Adjust boundary in Y direction
      place $pane(1) -in $master -x 0 -rely 0.0 -anchor nw \
         -relwidth 1.0 -height -1
      place $pane(2) -in $master -x 0 -rely 1.0 -anchor sw \
         -relwidth 1.0 -height -1
      place $pane(grip) -in $master -anchor c -relx 0.8
   } else {
      set pane(D) X ;# Adjust boundary in X direction
      place $pane(1) -in $master -relx 0.0 -y 0 -anchor nw \
         -relheight 1.0 -width -1
      place $pane(2) -in $master -relx 1.0 -y 0 -anchor ne \
         -relheight 1.0 -width -1
      place $pane(grip) -in $master -anchor c -rely 0.8
   }
   $master configure -background grey60
   # Set up bindings for resize, <Configure>, and
   # for dragging the grip.
   bind $master <Configure> [list PaneGeometry $master]
   bind $pane(grip) <ButtonPress-1> \
      [list PaneDrag $master %$pane(D)]
   bind $pane(grip) <B1-Motion> \
      [list PaneDrag $master %$pane(D)]
   bind $pane(grip) <ButtonRelease-1> \
      [list PaneStop $master]
   # Do the initial layout
   PaneGeometry $master
}

proc PaneDrag {master D} {
   upvar #0 Pane$master pane
   if [info exists pane(lastD)] {
      set delta [expr double($pane(lastD) - $D) \
                             / $pane(size)]
      set pane(-percent) [expr $pane(-percent) - $delta]
      if {$pane(-percent) < 0.0} {
         set pane(-percent) 0.2
      } elseif {$pane(-percent) > 1.0} {
         set pane(-percent) 0.8
      }
      PaneGeometry $master
   }
   set pane(lastD) $D
}
proc PaneStop {master} {
   upvar #0 Pane$master pane
   catch {unset pane(lastD)}
}

proc PaneGeometry {master} {
   upvar #0 Pane$master pane
   if {$pane(D) == "X"} {
       place $pane(1) -relwidth $pane(-percent)
       place $pane(2) -relwidth [expr 1.0 - $pane(-percent)]
       place $pane(grip) -relx $pane(-percent)
       set pane(size) [winfo width $master]
   } else {
       place $pane(1) -relheight $pane(-percent)
       place $pane(2) -relheight [expr 1.0 - $pane(-percent)]
       place $pane(grip) -rely $pane(-percent)
       set pane(size) [winfo height $master]
   }
}

proc procInitGUI {} {
    global version
    wm title . "ProB $version"
    wm iconname . "ProB"
#g    frame .frmMenu

    procGUI_WindowIcon
    procGUI_Menu
    procGUI_Info
    procGUI_Source
    procSetCommandKeyShortCuts
    pack .main.frmSource -expand true -fill both
    pack .main.frmInfo -expand true -fill both
    pack .main -expand true -fill both
    pack propagate .main off
    Pane_Create .main.frmSource .main.frmInfo -percent 0.6 -orient vertical -in .main \
           -showhandle 0 -cursor double_arrow

    # ------- arrange all top frames
    #pack .main.frmInfo .main.frmSource -side bottom -expand yes -pady 1 -fill both

#    pack .main.frmInfo -side bottom -expand no -pady 1 -fill both
    
#    pack .main.frmSource -side bottom -expand yes -pady 1 -fill both


   # wm geometry . 80x50

    procAboutProBInSourceFrame
}


proc procGetEnviron {ENV} {
   procGetEnviron2 $ENV ""
}
proc procGetEnviron2 {ENV DEFAULT} {
   # we could use global env instead
    if [prolog system:environ($ENV,Dir)] {
      return $prolog_variables(Dir)
    } else {
      tkErrorBox "Environment variable $ENV not set.\nUsing '$DEFAULT'."
      return "$DEFAULT"
    }
}

proc procLawCheckTest {full} {
    global strFilename version
    global bench_MC_maxnodes
    set NewProBExDir [procGetEnviron2 'PROB_EX_DIR' "~/svn_root/NewProB/examples/"] 
    set bench_MC_maxnodes_bak $bench_MC_maxnodes
    if {$full==true} {
       set bench_MC_maxnodes 10000
    } else {
       set bench_MC_maxnodes 1000
    }

    procStartTesting lawcheck

    set strFilename "$NewProBExDir/B/Benchmarks/BoolLaws.mch"
    procGenericLoadFile
    procSingleBenchmarkFullOpts 0 1 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolWithArithLaws.mch"
    procGenericLoadFile
    procSingleBenchmarkFullOpts 0 1 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolLaws_SetCompr.mch"
    procGenericLoadFile
    procSingleBenchmarkFullOpts 0 1 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolLaws_SetComprCLPFD.mch"
    procGenericLoadFile
    procSingleBenchmarkFullOpts 0 1 1 1
    
    set strFilename "$NewProBExDir/B/Laws/ExplicitComputations.mch"
    procGenericLoadFile
    procSingleBenchmarkFullOpts 1 1 1 1
    procCheckDebugProperties
    
    set strFilename "$NewProBExDir/B/Laws/SubstitutionLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Laws/StringLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Laws/INTEGERSET_Laws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/NatRangeLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/RelLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    
    set strFilename "$NewProBExDir/B/Laws/ArithmeticLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetSetLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetRelLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SeqLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/FunLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetLawsNat.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/SetLawsNatural.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/FunLawsWithLambda.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/EventBPrologPackages/Laws/SetLaws.eventb"
    procLoadEventBPackage
    procSingleBenchmark 0 1 1
    
    set strFilename "$NewProBExDir/EventBPrologPackages/Laws/LawsEventBSpecific.eventb"
    procLoadEventBPackage
    procSingleBenchmark 0 1 1
    
    set strFilename "$NewProBExDir/B/NewSyntax/RecSetLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    
    procEndTesting

    set bench_MC_maxnodes $bench_MC_maxnodes_bak
}



proc procRegressionTest {} {
    global strFilename
    procStartTesting regression
    
    global bench_MC_maxnodes
    set bench_MC_maxnodes_bak $bench_MC_maxnodes
    set bench_MC_maxnodes 100

    set NewProBExDir [procGetEnviron2 'PROB_EX_DIR' "~/svn_root/NewProB/examples/"]  
    set NewProBPrivateExDir [procGetEnviron2 'PROB_PEX_DIR' "~/svn_root/probprivate/examples/"] 
    
    
    set strFilename "$NewProBExDir/B/Benchmarks/Chapter_10/Safes.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/ErrorMachines/MultiAssignInit_bug.mch"
    procGenericLoadFile
    procSingleBenchmarkWoErrCheck 1 0 0 0
    procExpectErrors 1

    # set strFilename "$NewProBExDir/B/ErrorMachines/CstDefError1.mch"
    # procGenericLoadFile
    # procExpectErrors 2

    set strFilename "$NewProBExDir/B/FeatureChecks/INCLUDES_USES_SEES/M2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    # procCheckInvStatus 1 # "Trace has been changed"
    
    set strFilename "$NewProBExDir/B/FeatureChecks/StrangeNames/initialise_machine.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/FeatureChecks/DEFINITIONS/DEFAA12.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/FeatureChecks/DEFINITIONS/DefDouble.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/FeatureChecks/DEFINITIONS/TestMacroPrio.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/FeatureChecks/SetOperators/TestInterNatural.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/FeatureChecks/SetOperators/TestDifficultSetDifference.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/FeatureChecks/SetOperators/TestPartition.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/FeatureChecks/SetOperators/TestPartition2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/FeatureChecks/SetOperators/TestPartition3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Tester/PartialEnumeratedSet.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/PartialEnumeratedSet2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SELECT_CASE.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SELECT_ELSE_CHECK.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/TestAssoc.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SetComprehension.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Tester/NastySetComprehensions.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/Ticktest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/TwoDimensionalArray.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/ThreeDimensionalArray.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/ForAllSet.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SquareRoot.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SquareRootBigger.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tester/SquareRootFunction.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    
    set strFilename "$NewProBExDir/B/Tickets/227/file_system.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Tickets/Fraikin1/BecomeSuchThat_tmp.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Tickets/Boland1/Microwave.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    # set strFilename "$NewProBExDir/EventBTrans/SteveWright_VM/RegMach4.mch"
    # procGenericLoadFile
    # procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestSubset.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestSubset2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestStrictSubset.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestDisjoint.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestDisjunction.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestImplicationArith.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TestEquivArith.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/LargeAndSmallSets.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/ForallConstraints.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/ImageTestSimple.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/RangeRelTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/DomRelTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/ConstraintPropagation/TimeModelling.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/DisEqualityCheck.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/DisEqualityLarge.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SetLogInefficiencies.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests4.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests5.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerateFunctionTests6.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/TestFD_Domain_Narrowing.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/Symbolic/TestIDPropagation.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    

    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/SimpleArith.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/ArithDisjunctionComplicated1.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/ArithDisjunctionComplicated2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/SATLIB/uf20-903.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SATLIB/uf20-903_MYBOOL.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/DeferredSetsLarge.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/OverridePerfTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/RestrictionTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/LargeSequences.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SubsetChecks.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/LargeSets/PartialFunCheck.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/LargeSets/SeqCheck.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/CardTotFunExpansionTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/CardTotFunExpansionTests2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/PerformanceTests/ComplementMaximalSet.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 6 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/DomRangeClosures.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Demo/countdown.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Demo/BirthdayPuzzle.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Demo/TrainTorchPuzzle.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/SimpleConstants.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/EventB/SimpleRodinTypeCheckTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/EventB/SimpleSETasQVAR.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/BoolLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolWithArithLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolLaws_SetCompr.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    set strFilename "$NewProBExDir/B/Laws/BoolLaws_SetComprCLPFD.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    
    set strFilename "$NewProBExDir/B/Laws/StringLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    
    set strFilename "$NewProBExDir/B/Laws/RelLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SeqLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SeqTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Benchmarks/SeqTest2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Laws/FunLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/SetLawsNat.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/SetLawsNatural.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/FunLawsWithLambda.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Laws/INTEGERSET_Laws.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Benchmarks/spec.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    puts "SKIPPING TEST: Functions.mch - TO DO: enable again"
    # set strFilename "$NewProBExDir/B/Benchmarks/Functions.mch"
    # procGenericLoadFile
    # procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/CartesianNat.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Tester/SimpleSetComprTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    
    set strFilename "$NewProBPrivateExDir/B/Other/Stephane/ideal_behavr_conf_mdl.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    
    set strFilename "$NewProBPrivateExDir/B/Other/Passos/Clean.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Other/Valerio/SigmaProblem.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1


    set strFilename "$NewProBExDir/B/NewSyntax/FunMultipleArgs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/ExistentialTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/Pairs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/Team.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PrjTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/AllInjFunsTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Tester/TotalFunTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/TotalFunTest2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/TotalFunTest3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/TotalFunTest4.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunTest2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunTest3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunTest4.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/EnumerationChooseTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/ParallelProduct.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/LargeSets.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/LargeRelationSetTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerationSpeed.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerationSpeed2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/EnumerationSpeed3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/PerfManyVarsCsts200.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/TotalFunEqualityTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/TotalBijInverse.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/PartialFunInverse.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/TwoBinFunctions.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/PerformanceTests/TwoBinFunctionsSET.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/Alternate.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/PerformanceTests/PartitionIntoComponentsTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/TestLastSeqRev.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunNATURAL.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunCartesianNATURAL.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/PartialFunOverRel.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/IterateTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Demo/SortByPermutation.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Demo/SortByPermutation5.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Demo/SortByPermutationPF.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/ParityFunction.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/SurjEnumCst.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/PerformanceTests/Sort.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Compilers/LLParsingStagedEfficient.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Compilers/LLParsing.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Puzzles/FibonacciMorphism.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Puzzles/BlocksWorld.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Puzzles/BlocksWorldGeneric.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Puzzles/RushHour.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/STUPS2_KURS/FileSystem.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/FeatureChecks/InclusionChecks/Double3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Tester/CaseStmt.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Tester/SubstSetInTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/SymmetryReduction/RelationRelation.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    
    set strFilename "$NewProBExDir/B/FeatureChecks/INCLUDES_USES_SEES/ParameterChecks/M1.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/RenameParameterTests/Customer.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Other/Evans/LetWithAndProblem.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBPrivateExDir/B/Siemens/TestConcreteVariables.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBPrivateExDir/B/Siemens/TestConcreteConstants.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBPrivateExDir/B/Siemens/TestString.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBPrivateExDir/B/Siemens/Test/GroundPropTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/TwoCounters.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/FourCounters.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/ExtCounter.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/ExtPromCounter.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/TwoExtCounters.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/FourExtCounters.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/STUPS2_KURS/SudokuSETS9.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Simple/TwoPurses.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Simple/dijkstra.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Mathematical/Sieve.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Mathematical/SieveAlternate.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Mathematical/Sieve_WithMin.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Mathematical/GraphColouring.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Mathematical/GraphIso/CheckGraphIsomorphism.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Mathematical/TLA/TLA_Graph.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/TLA/GraphIso.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/TLA/GraphIsoEnum.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Mathematical/LeaderElectionRing.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/Mathematical/PostCorrespondence.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Puzzles/NQueens.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Puzzles/NQueens50.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/PerformanceTests/CardPropagation/CardProp.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/RenameParameterTests/MyTwoDatas.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBPrivateExDir/B/Satpathy/SystemOnChip/Router.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Puzzles/MagicSquare3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Puzzles/MagicSquareSimple.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Puzzles/TwoQueensSevenKnights.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/B/Puzzles/SudokuAsConstant.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/B/Puzzles/SudokuAsConstantVeryHard.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Other/Schneider/AHBDecoderStateV1.1.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Abrial/Earley/earley_4_v2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    # has invariant violation
    
    set strFilename "$NewProBExDir/B/Special/PO_ModelChecking/earley_3_original.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Abrial/Earley/earley_3_v6.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Tester/NatRangeParsingTest.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBPrivateExDir/B/Rodin/Enbacka/MacTimes.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Other/Srivastava/Simple_Unicast_Broadcast1.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Rodin/USB_ClearSy/USB_1.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Rodin/USB_ClearSy/USB_3.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/ClearSy/spec_Cruise/Cruise1.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/ClearSy/JCRE/opcodes_i.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/ClearSy/control/M1_i.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/ClearSy/control/M1.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/L4MicroKernel/L4API/API.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Benchmarks/Chapter13/AllocateR.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Benchmarks/Chapter13/Booksr.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/Benchmarks/Chapter13/Booksrr.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/B/Abrial/Queue/m1.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/B/Abrial/Press/m13.ref"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/Canal_Communication_V3/Canal_Communication_V3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/Canal_Communication_V3/Canal_Communication_V3_R2.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/MachineChocolat/cr2.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/Parking/parking_r2.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/DEMONEY/CycleDeVieAppletRaffineEnDEMONEY/OpenPlatform_WithActions_r1.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Stouls/These/DEMONEY/TransEc_EtatCanal_SecuEc/ModeleGS_R1.ref"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    
    
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/PortR.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Implementations/Mul/MulSimpleImp_ProB.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Implementations/Mul/MulSimpleImp100_ProB.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Implementations/MaxDevelopment/IncludeVector0.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Implementations/MaxDevelopment/IncludeScalar0.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Implementations/MaxDevelopment/MaxImp.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Implementations/ConcreteVars/MI.imp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Implementations/Power/AExpBImpl.imp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Implementations/Division/DivisionImplOk.imp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBPrivateExDir/B/Siemens/AdaptedBModelPropCheck/utlb_srv_constantes_i.imp"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Implementations/MaxDevelopment/MaxImpVector.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/ClearSy/turbomeca/pld_i.imp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/Towns.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/TownsR.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/TownsRR.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter12/TownsRRR.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1


    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter16/Fifo.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter16/RobustFifo.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter16/PositionCounter.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter16/Archive.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter17/Sortarray.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter17/Array.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter17/Priorityqueue.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/B/SchneiderBook/Chapter17/Heaparray.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Cansell/FORMATS07_contention_model_ProB/cont3.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Cansell/decode.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Cansell/tarNI3E/m4.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Cansell/tarNI3E/m6.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBPrivateExDir/B/Cansell/tarNI3E/m9.ref"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/DivBy0_bool.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/emi.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/exemple7_occuper_zone.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/B/Alstom/exemple7.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/B/Alstom/exemple12/exemple12.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/B/Alstom/DataValidationProject/Tickets/Burdy3/Rule_DB_General_0006.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0


    set strFilename "$NewProBExDir/Z/Daniel/watergate.tex"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/Z/Woodcock/InnerMember.tex"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/Z/Daniel/Praxis/network2.tex"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

   # set strFilename "$NewProBPrivateExDir/B/Siemens/TestDEFINITIONS.mch"
   # procGenericLoadFile
   # procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/NewSyntax/RecTest.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/NewSyntax/RecTest2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/JensBendisposto/Schleuse/Schleusen_Records.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/NewSyntax/SET_Game_Rec.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/NewSyntax/RecSetLaws.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/EventBPrologPackages/Test1.0/Testid_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/EventBPrologPackages/Test1.0/Testprj_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/EventBPrologPackages/Test1.0/TestPartition_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/EventBPrologPackages/AnimB_Tests/test1_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/EventBPrologPackages/MLift_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/EventBPrologPackages/sieve.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/EventBPrologPackages/ProofDirected/model/mc1_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1    
    set strFilename "$NewProBExDir/EventBPrologPackages/ProofDirected/model/mc1_mch_v2.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/EventBPrologPackages/TrafficLight/tlm_0.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/EventBPrologPackages/TrafficLight/tlm_1.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/EventBPrologPackages/TrafficLight/tlm_3.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/EventBPrologPackages/so_cr_end_states_eventb/mchoreography.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/RodinModels/Huffman/HuffmanM_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/RodinModels/SAP/TUCC_Example/v3/m_wodel123_partner_behaviour.eventb"
    procLoadEventBPackage
    procAddDefaultCSPFile
    procSingleBenchmark 1 0 0
    
    #set strFilename "$NewProBPrivateExDir/RodinModels/Deploy/Bosch/CruiseControl/CrsCtl_m4.eventb"
    #procLoadEventBPackage
    #procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/RodinModels/Deploy/Bosch/CruiseControl/CrsCtl_m2.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/RodinModels/Bosch/CrCtl_0.5.0_v3/Usec3_simplified_mch.eventb"
    procLoadEventBPackage
    procSingleBenchmark 1 0 0
    
    
    set strFilename "$NewProBExDir/CSP/mydemos/microwave.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    
    set strFilename "$NewProBExDir/CSPB/Turner/SetTest.mch"
    procGenericLoadFile
    procAddDefaultCSPFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSPB/Dining/Dining.mch"
    procGenericLoadFile
    procAddDefaultCSPFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/CSPB/trafficLight/myMachine.mch"
    procGenericLoadFile
    procAddDefaultCSPFile 
    procSingleBenchmark 1 0 0
    
    
   # set strFilename "$NewProBExDir/CSPB/McEwan/BoolTest.csp"
   # procGenericLoadFile
   # procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/CSPB/McEwan/BoolTest.mch"
    procGenericLoadFile
    procAddDefaultCSPFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/B/Demo/Simpson/Simpson_Four_Slot_CSP.mch"
    procGenericLoadFile
    procAddDefaultCSPFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/B/Tickets/315/ANN_Neuron.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBPrivateExDir/RodinModels/PaulSimon/ca_m03_mch.eventb"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBPrivateExDir/RodinModels/PaulSimon/ca_m01_mch.eventb"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/SAP/ABAP_Constants/zmu.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Siemens/AdaptedBModelPropCheck/acs_as_env_cfg_ipart.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/cbtc_mes_as_env_inv_easitf_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 127 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/cbtc_mes_as_env_inv_etors_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 142 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/cbtc_mes_as_env_inv_stors_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 148 1 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_mes_as_env_inv_etors_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 125 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_etors_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 188 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_etors_dist_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 184 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_mesitf_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 182 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_pasitf_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 177 1 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_se_dj_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 176 2 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_ss_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 192 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_stors_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 192 0 0
    set strFilename "$NewProBPrivateExDir/B/Siemens/Canarsie_PAR1_PAL/par1_pans_as_env_inv_tcs_bs.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 191 8 0
    
    
    set strFilename "$NewProBPrivateExDir/B/Siemens/BAC9_ZC/pas_as_env_inv_ld.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    procAnalysePredCheck assertions 27 0 0
    
    
    set strFilename "$NewProBExDir/B/PerformanceTests/InfiniteClosures.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/InfiniteClosures2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/InfiniteClosures3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/IntervalSMTProblem.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/IntervalSMTProblem2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/B/PerformanceTests/SAT_Tests/ReificationCompTests.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/axl3/axl3.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/ixl/lausanne.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/cbtc/actions_cbtc.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/signal/tms_signal_0001.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/ssp/tms_ssp_0004.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBPrivateExDir/B/Alstom/gfpd/tms_signal_0001.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
	
    procZTest
    
    procEndTesting
    set bench_MC_maxnodes $bench_MC_maxnodes_bak
}


proc procCSPMBenchmark {} {
    global strFilename forceRecompile
    global version
    set backforceRecompile $forceRecompile
    set forceRecompile 0
    global bench_MC_maxnodes
    set bench_MC_maxnodes_bak $bench_MC_maxnodes
    set bench_MC_maxnodes 20000
    
    set NewProBExDir [procGetEnviron2 'PROB_EX_DIR' "~/svn_root/NewProB/examples/"]   
    set NewProBPrivateExDir [procGetEnviron2 'PROB_PEX_DIR' "~/svn_root/NewProBPrivate/examples/"] 
    
    procStartTesting csp_regression
    
    set strFilename "$NewProBExDir/CSP/mydemos/Edd/UnionBoolTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/slicing/UnionCheck.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/slicing/UnionCheck.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/microwave.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/simple/exception_operator.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleGenGen.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleSeqComp.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleInterruptTimeout.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    # procCheckStatespaceWithFDR  fails due to non-omega semantics of FDR
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleInterruptTimeout2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/evans/InterruptExample_NonRec.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/evans/UnderscoreInput.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/simple/check_set_compr_pat.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/Buffer.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/Buffer_hide.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleRenaming.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/LambdaSimple.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/LambdaComplex.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleRenaming2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleIfThenElse.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/ComplicatedSync.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/ComplicatedSync.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/ComplicatedSync2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/mydemos/ComplicatedChannelGuards.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleAlphaPar.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleLinkedParallel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleCompLinkedPar.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleLinkedParallel2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/ComplicatedLinkedParallel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/curry_test.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/ListPat.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/ContrivedLambda.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/QuestionMarkTuple.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RecordDotTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RecordDotTest2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RenameRecordPattern.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RenameRecordPattern2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RecursiveDatatype.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/CSP/mydemos/ReplicatedInterleave.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/ReplicatedInterleaveSetDef.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/mydemos/subtype_ex.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/subtype_nametype_ex.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/nametype_test.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/nametype_test2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/TestDotPat.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/StrangeAgents.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/NastyNonDet.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/evans/NastyLambda.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/CSP/evans/KeyNET_protocol.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    set strFilename "$NewProBExDir/CSP/evans/KeyNETv2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/CSP/evans/LetWithEmptySet.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/LetMultipleEquations.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/CSPOZ/CurriedNATupleFun.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/CSPOZ/CurriedNATupleFunNested.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/CSPOZ/Kleine_probtest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine_Head.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/misusing-lists.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/interrupt-bug.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    
    set strFilename "$NewProBExDir/CSP/other/Kleine_Head_complex.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/bag.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/timeout_test.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine_print.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/KleineScheduler.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/RenamingRecordTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/philosophers.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/coz-example.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Kleine/stcc-timeout-ext.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/ComplicatedProjectionLet.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/ComplicatedDotProjectionLet.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/Casper/SimpleRecordReadFromChannel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
        
    set strFilename "$NewProBExDir/CSP/Stolz/mangle.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/other/Ivo/replicates.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/other/Ivo/replicates2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/LetFunctionPassedOut.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/dot_tests/SimpleDotTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/GenericBuffer1.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/FibGen.cspm"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/PairSimple.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/PairMedium.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/PatMatchPair.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/Marc/HigherOrder.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/Marc/HanoiSimple.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 0
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/LetTestsChannel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/LetMultipleFuns.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/LetTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/EnumerationTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetCompTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetCompAdvanced.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetCompWithLambda.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SeqCompTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SequenceComprTests2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleCompRenaming.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SeqTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SeqRangeTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/ReplicatedAlphParallel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/ReplicatedSequential.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/BigUnionInterTests.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleTransparent.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleInterleaveSkipTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleInterleaveSkipTest2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleCHAOS.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleSubsets.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimplePatMatch.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetCompComplicated.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SetCompComplicated2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/BigUnionInterChannelTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleReplicated.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleRepAlphParallel.csp"
    procGenericLoadFile
    procSingleBenchmark 0 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/SimpleReplicatedLinkedParallel.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/ReplicatedSharing.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/NameWithApostrophe.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/FDRFeatureTests/RepHalfIntegerDivisionTest.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/peterson.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/demo/Peterson_v2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/prize.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/buses.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/bankv4.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/basin_olderog_bank.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/mydemos/demo/basin_olderog_bank_nolambda.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    
    set strFilename "$NewProBExDir/CSP/mydemos/demo/JavaCSP/SequentialRouter.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    set strFilename "$NewProBExDir/CSP/mydemos/demo/JavaCSP/CorrectRouter.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/hanoi.fix.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/hanoi.fixv2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/ICFEM/scheduler.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/sieve_fdr.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/fontaine/funbench/funBench.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/fontaine/RecDataTypeFunctions.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBExDir/CSP/mydemos/demo/roscoe_chapter4_bs.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSP/mydemos/demo/roscoe_chapter4.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/abp_chapter5_roscoe.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/roscoe_section2-1.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/roscoe_section2-2.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/dudcounter_roscoe_chapter8.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/GenPrime.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/ICFEM/scheduler0_1.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/CompareWithFDR/ICFEM/scheduler0_6.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
 
    set strFilename "$NewProBExDir/CSP/mydemos/demo/crossing.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    procCheckStatespaceWithFDR
    
    set strFilename "$NewProBPrivateExDir/CSP/Winter/miniAlvey.csp"
    procGenericLoadFile
    procSingleBenchmark 1 0 0
    
    set strFilename "$NewProBExDir/CSP/mydemos/demo/mbuff.csp"
    procGenericLoadFile
    procSingleBenchmark 1 1 1
    # procCheckStatespaceWithFDR

    procEndTesting
    
    set forceRecompile $backforceRecompile
    set bench_MC_maxnodes $bench_MC_maxnodes_bak
    puts "******************************"
    puts "Finished CSP-M Regression Test"
    puts "******************************"
}


proc procZTest {} {
    prologmnf proz:startzconversiontests
    procShowErrors			   
}


proc procBenchmark {} {
    global strFilename forceRecompile
    global version
    set backforceRecompile $forceRecompile
    set forceRecompile 0
    
    set NewProBExDir [procGetEnviron2 'PROB_EX_DIR' "~/svn_root/NewProB/examples/"]  

    procStartTesting b_bench

    set strFilename "$NewProBExDir/B/Benchmarks/CarlaTravelAgencyErr.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/RouteIsSeq.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/Sets2.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/Doors.mch"
    procGenericLoadFile
    procSingleBenchmark 1 0 0

    set strFilename "$NewProBExDir/B/Benchmarks/DSP0.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 0

    set strFilename "$NewProBExDir/B/Benchmarks/DSP0_complicated_initialisation.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 0

    set strFilename "$NewProBExDir/B/Benchmarks/DSP0_complicated_property.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 0

    set strFilename "$NewProBExDir/B/Benchmarks/CSM.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/scheduler.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/phonebook7.mch"
    procGenericLoadFile
    procSingleBenchmark 1 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/tictac.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 0

    set strFilename "$NewProBExDir/B/Benchmarks/Teletext_bench.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    set strFilename "$NewProBExDir/B/Benchmarks/Cruise_finite1.mch"
    procGenericLoadFile
    procSingleBenchmark 0 1 1

    procEndTesting

    set forceRecompile $backforceRecompile
}

proc procSymBenchmark {} {
   global strFilename
   if {$strFilename != ""} {
     set UP [Dialog_Prompt "Enter Max Size of deferred sets:"]
     if {$UP != ""} {
       procSymBenchmark2 1 $UP
     }
   } else {
       tkErrorBox "Open a B Machine first."
   }
}

proc procSymBenchmark2 {lowbound upbound} {
    global strFilename forceRecompile
    global logFile bench_MC_maxnodes
    set cpy $bench_MC_maxnodes
    set bench_MC_maxnodes 100000
    global version
    set backforceRecompile $forceRecompile
    set forceRecompile 0
    
    procStartTesting sym_bench
    
    for {set i $lowbound} {$i <= $upbound} {incr i} {
       puts $logFile "Size of unspecified deferred sets: $i"
       puts "Size of unspecified deferred sets: $i"
       prologmnf preferences:set_preference(globalsets_fdrange,$i)
       procGenericLoadFile
       procSingleBenchmark 0 1 1
       prologmnf tcltk_compute_coverage(Res)
       puts "$prolog_variables(Res)"
       puts $logFile "-----------"
    }
    procEndTesting
    
    set forceRecompile $backforceRecompile
    set bench_MC_maxnodes cpy
}

global bench_MC_maxnodes
set bench_MC_maxnodes 100

proc procSingleBenchmarkWoErrCheck {traceCheck modelCheck findInvViol findAssViol} {
    global strFilename
    global logFile
    global bench_MC_maxnodes
    puts $logFile ""
    puts $logFile "% Benchmarking: $strFilename"
    procAddTestingEntry "\nTreating $strFilename"
    
	global mcFindDeadlocks mcFindInvViolations mcSearchForNewErrors mcPartialOrderReduction
	if {$modelCheck} {
     puts "% Model checking benchmark system"
     set mctime [time {prolog tcltk_model_check($bench_MC_maxnodes,ErrRes,0,$findInvViol,0,$findAssViol,0,0,360000,PrologTime)} 1]
     puts $logFile "% Model Checking Time: $mctime"
     set mctimems [lindex [split $mctime] 0]
     set CURDATEH [clock format [clock seconds] -format "%Y%m%d%H"]
     puts $logFile "mc('$strFilename',$CURDATEH,$mctimems)."
     puts "MC Time: $mctimems microsecs, Prolog: $prolog_variables(PrologTime) millisecs"
     procAddTestingEntry "Model checking time: $mctimems microsecs, Prolog: $prolog_variables(PrologTime) millisecs"
     #set Result $prolog_variables(ErrRes)
     if {$findInvViol && [prolog tcltk_goto_an_invariant_violation]} {
          procInsertHistoryOptionsState
          tkErrorBox "Invariant violation found in $strFilename!"
     }
     puts "Computing coverage"
     prologmnf tcltk_compute_coverage(Res)
     # obtain a list of conjuncts with their status
	 set Result $prolog_variables(Res)
	 puts $logFile "/* $Result */"
	}
	if {$traceCheck} {
     puts "% Trace checking benchmark system"
     puts $logFile "% Trace Checking Time: [time {procCheckTraceFile2 0 1} 1]"
     procAddTestingEntry "Trace Checking finished"
	}
}

proc procSingleBenchmark {traceCheck modelCheck findInvViol} {
   procSingleBenchmarkFullOpts $traceCheck $modelCheck $findInvViol 0
}
proc procSingleBenchmarkFullOpts {traceCheck modelCheck findInvViol findAssViol} {
   if [prolog spec_file_has_been_successfully_loaded] {
    procSingleBenchmarkWoErrCheck $traceCheck $modelCheck $findInvViol $findAssViol
    procInsertHistoryOptionsState
    procShowErrors
  } else {
    puts "### No specification file has been successfully loaded"
    puts "### Skipping Test"
  }
}

proc procCheckInvStatus {iNVVIOLATED} {
   if [prolog tcltk_get_status($iNVVIOLATED,_,_)] {
     puts "Invariant violated = $iNVVIOLATED"
   } else {
     tkErrorBox "Invariant status ($iNVVIOLATED) not as expected !"
   }
}
proc procPerformSelfCheck {} {
  global curFileTypeOpened
  if {$curFileTypeOpened != "None"} {
      tkErrorBox "The Self-Check can only be performed before opening a machine.\nRestart ProB and do the self-check after startup."
  } else {
      if [prolog perform_self_check] {
        tkMessageBox "Self-Check was successful."
      } else {
        procShowErrors
      }
  }
}

proc procPerformVerboseSelfCheck {} {
  global curFileTypeOpened
  if {$curFileTypeOpened != "None"} {
      tkErrorBox "The Self-Check can only be performed before opening a machine.\nRestart ProB and do the self-check after startup."
  } else {
      if [prolog perform_verbose_self_check] {
        tkMessageBox "Self-Check was successful."
      } else {
        procShowErrors
      }
  }
}

proc procPerformSelfCheckForModule {} {
  global curFileTypeOpened
  if {$curFileTypeOpened != "None"} {
      tkErrorBox "The Self-Check can only be performed before opening a machine.\nRestart ProB and do the self-check after startup."
  } else {
      prolog get_module_list(ML)
      set ModuleName [procChooseElementFromList $prolog_variables(ML) "Module" "no" "" "var" "true"]
      puts "ModuleName $ModuleName"
      if [prolog perform_self_check('$ModuleName')] {
        tkMessageBox "Self-Check was successful."
      } else {
        procShowErrors
      }
  }
}


# -------
# procedure to open a file, and then execute it on prolog
# -------

proc procNewFile {} {
    global strFilename
    procCheckIfSaved
    set types {
    	{"B Machine Files"		{.mch}	}
    	{"B Refinements"		{.ref}	}
    	{"B Implementations"	{.imp}	}
    	{"Event-B System Files"		{.sys}	}
    	{"All B Files"	{.mch .ref .imp .sys}	}
    	{"CSP Files"		{.csp}	}
    	{"TLA Files"		{.tla}	}
	    {"All files"		*}
    }
    # show the dialog box
    set oldstrFilename $strFilename
    proc_getSaveFile $types
    if {$strFilename != ""} {
        # Now create an empty Machine File
        set MachName [file rootname [file tail $strFilename]]
        set ext [file extension $strFilename]
		set fileid [open "$strFilename" w]
		if {$ext == ".cspm" || $ext == ".csp"} {
		  puts $fileid "-- $MachName\nMAIN = SKIP\n"
		} elseif {$ext == ".tex"} {
		  puts $fileid "\\documentclass[a4paper]{article}\n\\usepackage{fuzz}\n\\begin{document}\n\\end{document}\n"
		} elseif {$ext == ".P"} {
		  puts $fileid "start(a).\ntrans(lock,a,b).\ntrans(unlock,b,a).\nprop(X,X).\nprop(c,unsafe).\n"
		} elseif {$ext == ".tla"} {
		  puts $fileid "----- MODULE $MachName -----\nEXTENDS Naturals\nCONSTANTS lim\nASSUME lim=10\nVARIABLES x\nInit == x = 1\nInc == x < lim /\\ x' = x+1\nDec == x >0 /\\ x'=x-1\nNext == Inc \\/ Dec\n=======================\n"
		} else {
          puts $fileid "MACHINE $MachName\nSETS\n ID={aa,bb}\nCONSTANTS iv\nPROPERTIES\n iv:ID\nVARIABLES xx\nINVARIANT\n xx:ID\nINITIALISATION xx:=iv\nOPERATIONS\n  Set(yy) = PRE yy:ID THEN xx:= yy END\nEND\n"
        }
        close $fileid
        procGenericLoadFile
    } else {
        set strFilename $oldstrFilename
    }
}

proc proc_getSaveFile { types } {
    global strFilename
    # show the dialog box
   if [prolog animation_mode(cspm)] {
      set untitled "Untitled.csp"
      set XT "csp"
   } elseif [prolog animation_mode(xtl)] {
      set untitled "Untitled.P"
      set XT "P"
   } else {
      set untitled "Untitled.mch"
      set XT "mch"
   }
    set strFilename [proc_getSaveFilename $types $untitled $XT]
    if {$strFilename != ""} {
	# remember the directory for next time
	setMachinesPath [file dirname $strFilename]
    }

}

proc proc_getSaveFilename { types untitled XT} {
    set machinesPath [getMachinesPath]
    if {$machinesPath != "" && [file isdirectory $machinesPath]} {
         return [tk_getSaveFile -filetypes $types -initialdir $machinesPath -initialfile "$untitled" -parent . -defaultextension "$XT"]
    } else {
         return [tk_getSaveFile -filetypes $types -initialfile "$untitled" -parent .  -defaultextension "$XT"]
    }
}

# -------
# procedure to open a file, and then execute it on prolog
# -------
proc procOpenSpecificFile {theFileName} {
    global strFilename
    set strFilename $theFileName
    procCheckIfSaved
    procGenericLoadFile
}
proc procOpenFile {} {
    global strFilename curFileTypeOpened
    procCheckIfSaved
    set btypes {
			{"All B and CSP Files"	{.mch .ref .imp .sys .csp .eventb .v}	}
			{"B Machine Files"		{.mch}	}
			{"B Refinements"		{.ref}	}
			{"B Implementations"	{.imp}	}
    	                {"Event-B System Files"		{.sys}	}
                        {"TLA Files"            {.tla}}
    }
    set otherTypes {
        {"Other Formalisms (CSP,Z,XTL)"	{.csp .tex .P .cspm .pml .prom .eventb .smv .tla}	}
    }
    if {$curFileTypeOpened == "B" || $curFileTypeOpened == "CSP" ||$curFileTypeOpened == "None" || $curFileTypeOpened == "EVENTB"} {
        set types [concat $btypes $otherTypes]
    } else {
        set types [concat $otherTypes $btypes]
    }
    # append extensions for plugins
    prolog plugins:plugin_file_extensions(Ext)
    set types [concat $types $prolog_variables(Ext)]
    # append all files
    lappend types {"All files" *}
    # show the dialog box
    set oldstrFilename $strFilename
    proc_getOpenFile $types
    if {$strFilename != ""} {
        after idle {procGenericLoadFile}
    } else {
        set strFilename $oldstrFilename
    }
}

proc procConfigureEventBMenues {state} {
    global only_eventb_menues
    foreach menuentry $only_eventb_menues {
        set menu [lindex $menuentry 0]
        set index [lindex $menuentry 1]
        $menu entryconfigure $index -state $state
    }
}

proc procGenericLoadFile {} {
    global strFilename find_menu_arr tcl_version text_editor_arr

    set reactivatePlugin false
    if [prolog plugins:active_plugin(ActivePlugin)] {
	set reactivatePlugin true
    }

    if [file exists $strFilename] {
        .main.frmSource.text configure -undo 0
        prolog preferences:add_recent_document('$strFilename')
        procRebuildRecentDocumentsMenu
        procToUnicode
        proc_updateMenuEntryStates
        procConfigureEventBMenues disabled
        set find_menu_arr(allpatterns) false
		set ext [file extension $strFilename]
                if {[winfo exists .checkCspAsser] && ($ext != ".csp" || $ext != ".cspm")} {
                       # clear Csp Assertions section
                       .checkCspAsser.frmSource.text delete 0 end
                       .checkCspAsser.frmSource.text insert end "No Assertions in this File found."
		       set f .checkCspAsser.refMenu
                       if {$tcl_version >= 8.5} {
                            foreach w [list $f.refinement.col1.spec1 $f.refinement.col3.spec2 $f.determinism.col1.spec \
                                $f.livelock.col2.spec $f.deadlock.col1.spec] {
                                 $w configure -values {}
                                 $w set ""
                            }
                            update
		       } else {
                            foreach w [list $f.col1.fr.spec $f.col3.fr.impl] {
				    if [winfo exists $w] {$w delete 0 end}
			    }
			    foreach e [list $f.col1.entry $f.col2.entry $f.col3.entry] {
				    if [winfo exists $e] {$e delete 0 end}
			   } 	    
			   update
		   }
                }
                set text_editor_arr(text_index) 1.0
                set text_editor_arr(reopening_file) false
                set text_editor_arr(disable_highlighting) false
		set text_editor_arr(file_last_modified) [file mtime $strFilename]
		prolog "unset_tcltk_cspm_mode"
		if {$ext == ".tex"} {
		   procLoadZFile
		} elseif {$ext == ".cspm" || $ext == ".csp"} {
		   procLoadCSPMFile
		} elseif {$ext == ".pml" || $ext == ".prom"} {
		   procLoadPromelaFile
		} elseif {$ext == ".smv"} {
		   # procLoadSmvFile
		   tkErrorBox "Loading of SMV files is curently not supported."
		} elseif {$ext == ".P"} {
		   procLoadXTLFile
		} elseif {$ext == ".eventb"} {
		   procLoadEventBPackage
           procConfigureEventBMenues normal
		} elseif {$ext == ".tla"} {
           procLoadTLAFile
        } elseif [prolog plugins:is_plugin_file_extension('[escapeChars $ext]',Id)] {
            procLoadPluginFile $prolog_variables(Id)
        } else {
           procLoadBFile
		}
        procUpdateIndicesAfterLoadingAFile
        
        if {$reactivatePlugin} {
            prolog plugins:available_plugins_for_mode(PluginsForMode)
	    if {[lsearch $prolog_variables(PluginsForMode) $prolog_variables(ActivePlugin)*] != -1} {
                procActivatePlugin $prolog_variables(ActivePlugin)
            } else {
                procDeactivatePlugin
	    }
        }
    } else {
	    tkErrorBox "File does not exist: $strFilename.\nCannot open it."
    }
}


proc procLoadEventBPackage {} {
  global strFilename curFileTypeOpened
  if {$strFilename != ""} {
        prologmnf tcltk_clear_machine
        procResetOptions "Opening..." DarkGray
        set curFileTypeOpened "EVENTB"
        if [prolog tcltk_load_packaged_eventb_file('$strFilename')] {
            procShowErrors
			procInitLoadedBMachine
		   if [prolog bmachine:b_show_machine_representation(Res,true)] {
				procShowSourceCodeFromCodes .main.frmSource.text $prolog_variables(Res)
				procDoSyntaxColouring .main.frmSource.text
		   } else {
				procShowSourceCode $strFilename
				procDoEventBSyntaxColouring .main.frmSource.text
				tkErrorBox "Internal Error: Could not display internal representation for EventB model."
		   }
        } else {
           procShowErrors
	   procClearOptionsStateHistory
           procShowSourceCode $strFilename
	   procDoEventBSyntaxColouring .main.frmSource.text
        }
		procResetCodeModified false false
		procResetFilesMenu
		global expert_user
		if {$expert_user} {
		  .main.frmSource.text configure -state normal
		} else {
		  .main.frmSource.text configure -state disabled
		}
        procCheckForPlugins
  } 
}


proc proc_getOpenFile { types } {
    global strFilename 
    # show the dialog box
    set machinesPath [getMachinesPath]
    if {$machinesPath != "" && [file isdirectory $machinesPath]} {
         set strFilename [tk_getOpenFile -filetypes $types -initialdir $machinesPath -parent . ]
    } else {
         set strFilename [tk_getOpenFile -filetypes $types -parent . ]
    }
    if {$strFilename != ""} {
	#remember the directory for next time
	setMachinesPath [file dirname $strFilename]
    }

}


proc procTreatCommandLineArgs {} {
   global strFilename batch_mode
   if [prolog tcltk_get_command_line_option(batch_mode)] {
      puts "Going into batch mode"
      set batch_mode 1
   } else {
      set batch_mode 0
   }
   if [prolog tcltk_get_command_line_option(run_selfcheck)] {
      procPerformSelfCheck
   }
   if [prolog tcltk_get_command_line_option(run_benchmarks)] {
      puts "Running Benchmarks"
      procBenchmark
   }
   if [prolog tcltk_get_command_line_option(run_regression_tests)] {
      puts "Running Regression Tests"
      procRegressionTest
   }
   if [prolog tcltk_get_command_line_option(run_full_law_tests)] {
      procLawCheckTest "true"
   }
   if [prolog tcltk_get_command_line_option(run_quick_law_tests)] {
      procLawCheckTest "false"
   }
   if [prolog tcltk_get_command_line_option(run_cspm_tests)] {
      procCSPMBenchmark
   }
   if [prolog tcltk_get_command_line_option(tcltk_open_last_file)] {
      prologmnf get_recent_documents(List)
	  set strFilename [lindex $prolog_variables(List) 0]
      if {$strFilename != ""} {
         procDisableItemsAfterClosingFile
         procGenericLoadFile
      }
   }
   if [prolog tcltk_get_command_line_file_to_open(X)] {
	  set strFilename $prolog_variables(X)
      if {$strFilename != ""} {
         procDisableItemsAfterClosingFile
         procGenericLoadFile
      }
   }
   if [prolog tcltk_get_command_line_tcltk_commands(Cmds)] {
      set nrargs [llength $prolog_variables(Cmds)]
      for {set i 0} {$i < $nrargs} {incr i 1} {
		set Command [lindex $prolog_variables(Cmds) $i]
		puts "Executing ProB Command Line $i/$nrargs: $Command"
		$Command
	  }
   }
}


proc procLoadXTLFile {} {
    procCheckIfSaved
    global strFilename curFileTypeOpened cspstrFilename text_editor_arr
    if {$strFilename != ""} {
        set curFileTypeOpened "XTL"
        set cspstrFilename ""
        global version
        prolog tcltk_open_xtl_file('$strFilename')
            # the file exists, so load it.
        procShowSourceCode $strFilename
        if {!$text_editor_arr(ctext_package)} {
            procDoInTimeXTLSyntaxColouring .main.frmSource.text
        } else {
            procDoXTLSyntaxColouring .main.frmSource.text
        }
        procFinishLoading
    }
}
proc procAddXTLFile {} {
    global strFilename
    set types {
    	{"XTL Trans/Prop Files"		{.P}	}
	    {"All files"		*}
    }
    # show the dialog box
    proc_getOpenFile $types
    if {$strFilename != ""} {
        prolog tcltk_add_xtl_file('$strFilename')
            # the file exists, so load it.
        procShowSourceCode $strFilename
	    prologmnf tcltk_initialise
        procInsertHistoryOptionsState
	    procEnableItemsAfterOpeningFile
    }
}

proc CallFuzz {FUZZ FUZZLIB FuzzName} {
   puts "call $FUZZ -p $FUZZLIB >$FuzzName"
    global strFilename curFileTypeOpened cspstrFilename
	    if {[catch {exec  "$FUZZ" -d -l -p "$FUZZLIB" $strFilename >$FuzzName} errid]} {
           # a .fuzz file will be created even if the specification contains an error
           # We have to delete it. If not, it will be used next time without calling fuzz.
           file delete $FuzzName
           HighlightLineErr $errid ":"
           tkErrorBox "Error while executing fuzz.\nError: $errid"
           return 0
        } else {
           return 1
        }
}
proc HighlightLineErr {errid AfterNr} {
   set idx [string first " line " $errid]
   if {$idx != -1} {
	 set start [expr $idx+6]
	 set end [string first "$AfterNr" $errid $start]
	 if {$end != -1} {
	     set end [expr $end-1]
		 set linenr [string range $errid $start $end]
		 # puts "Found line: $linenr ($start - $end)"
		 procHighlightLine $linenr
		 .main.frmSource.text see "$linenr.0"
		 return 1
	 } 
   }
   return 0
}

proc HighlightBCompErr {errid} {
   set idx [string first ":" $errid]
   if {$idx != -1} {
	 set start [expr $idx+1]
	 set end [string first ":" $errid $start]
	 if {$end != -1} {
	     set end [expr $end-1]
		 set linenr [string range $errid $start $end]
		 # puts "Found line: $linenr ($start - $end)"
		 procHighlightLine $linenr
		 .main.frmSource.text see "$linenr.0"
		 return 1
	 } 
   }
   return 0
}
proc CallFuzzNoLib {FUZZ FuzzName} {
   puts "call $FUZZ >$FuzzName"
    global strFilename curFileTypeOpened cspstrFilename
	    if {[catch {exec  "$FUZZ" -d -l $strFilename >$FuzzName} errid]} {
           HighlightLineErr $errid ":"
           tkErrorBox "Error while executing fuzz ($FUZZ).\nError: $errid"
           return 0
        } else {
           return 1
        }
}

proc procLoadZFile {} {
    global strFilename curFileTypeOpened cspstrFilename text_editor_arr
    if {$strFilename != ""} {
            set curFileTypeOpened "Z"
            set cspstrFilename ""
            # puts "Opening Z file $strFilename"
            set rootName [file rootname $strFilename]
            set FuzzName {}
            append FuzzName $rootName ".fuzz"
            if [file exists $FuzzName] {
               file stat $strFilename mchStats
               file stat $FuzzName xmlStats
               if {$xmlStats(mtime) < $mchStats(mtime)} {
                 # recompilation needed
                 set recompileRequired 1
               } else {
                 # normally recompilation needed
                 if {$xmlStats(size)<1} {
                    # file was empty
                    set recompileRequired 1
                 } else {
                    set recompileRequired 0
                 }
               }
            } else {
              set recompileRequired 1
            }
            procShowSourceCode $strFilename
            procResetCodeModified false $text_editor_arr(reopening_file)

            if {$recompileRequired} {
              if [file exists $FuzzName] { file delete $FuzzName }
              global lib_dir
              if [file exists "$lib_dir/fuzzlib"] {
                   if {[prolog tools:host_platform(windows)]} {
                      set ok [CallFuzz "$lib_dir/fuzz.exe" "$lib_dir/fuzzlib" $FuzzName]
                   } else {
                      set ok [CallFuzz "$lib_dir/fuzz" "$lib_dir/fuzzlib" $FuzzName]
                   } 
              } elseif [prolog preferences:get_preference(path_to_fuzz,PFuzzCmd)] {
	             set Cmd $prolog_variables(PFuzzCmd)
	             if {[prolog tools:host_platform(windows)]} {
	                  set fuzz_dir [file dirname $Cmd]
                      set ok [CallFuzz $Cmd $fuzz_dir/fuzzlib $FuzzName]
                 } else {
                      set ok [CallFuzzNoLib $Cmd $FuzzName]
                 }
	          } else {
                      set ok [CallFuzzNoLib "fuzz" $FuzzName]
              }
            } else {
              set ok 1
            }
            
            if {!$text_editor_arr(ctext_package)} {
                procDoInTimeZedSyntaxColouring .main.frmSource.text
            } else {
                procDoZedSyntaxColouring .main.frmSource.text
            }

            if {$ok && [file exists $FuzzName]} {
                # the file exists, so load it.
                set success [prolog tcltk_open_z_file('$FuzzName')]
                procJumpToTheLastSeenTextIndex
                procShowErrors
                if $success {
                    procInitLoadedBMachine
		    procSetCurrentTimeStampForModel
                } else {
                    tkErrorBox "Loading fuzz file failed"
                }
            } elseif {$ok} {
                tkErrorBox "An error occurred while parsing $strFilename. Be sure to have fuzz 2000 installed."
            }
        procResetFilesMenu
        procEnableSourceCodeEditing
        procCheckForPlugins
    }
}

proc procLoadSmvFile {} {
    global strFilename curFileTypeOpened lib_dir cspstrFilename text_editor_arr
    if {$strFilename != ""} {
        set curFileTypeOpened "SMV"
        set cspstrFilename ""
        set smvstrFilename {}
        append smvstrFilename $strFilename ".pl"
        if [file exists $smvstrFilename] { file delete $smvstrFilename }
        set MacJava6 "/System/Library/Frameworks/JavaVM.framework/Versions/1.6/Commands/java"
        if [file exists $MacJava6] {set MyJava $MacJava6} else {set MyJava "java"}
        exec $MyJava -jar $lib_dir/smv2pterm.jar $strFilename $smvstrFilename
	    
        procShowSourceCode $strFilename
        if [prolog tcltk_open_smv_file('$smvstrFilename')] {
            # the file exists, so load it.
            procJumpToTheLastSeenTextIndex
        } else {
          procErrorBoxWithErrorMessages "Parsing of SMV file failed!"
        }
        if {!$text_editor_arr(ctext_package)} {
            procDoInTimeSmvSyntaxColouring  .main.frmSource.text
        } else {
            procDoSmvSyntaxColouring .main.frmSource.text
        }
	    procFinishLoading
    }
}

proc runJavaJarOnFile {JAR FILE} {
    set MacJava6 "/System/Library/Frameworks/JavaVM.framework/Versions/1.6/Commands/java"
    if [file exists $MacJava6] {set MyJava $MacJava6} else {set MyJava "java"}
    if [prolog get_preference(use_large_jvm_for_parser,true)] {
       # puts "using large JVM for $JAR and $FILE"
       exec $MyJava -Xms300m -Xmx1500m -Xss10m -jar $JAR $FILE
       # puts "finished parsing $FILE"
    } else {
       exec $MyJava -jar $JAR $FILE
    }
}
proc procLoadTLAFile {} {
   global strFilename curFileTypeOpened lib_dir cspstrFilename text_editor_arr
   if {$strFilename != ""} {
        set curFileTypeOpened "TLA"
        set cspstrFilename ""
        # puts "File to parse: $strFilename"
        if {[catch {runJavaJarOnFile $lib_dir/TLA2B.jar $strFilename} result]} {
            procShowSourceCode $strFilename
            procLaunchTLASyntaxColouring .main.frmSource.text
            procShowErrorAndHighlightTextTLA "$result"
            procResetCodeModified false $text_editor_arr(reopening_file)
            procClearOptionsStateHistory
        } else {
            set TLAFilename [file rootname $strFilename]
            set generatedMchFile "$TLAFilename\_tla\.mch"
            procShowSourceCode $strFilename
            procResetCodeModified false $text_editor_arr(reopening_file)
            procLaunchTLASyntaxColouring .main.frmSource.text
            if [file exists $generatedMchFile] {
               puts $generatedMchFile
               if [prolog tcltk_open_b_file_for_minor_mode('$generatedMchFile','tla')] {
                   procJumpToTheLastSeenTextIndex
		   procShowErrors
		   procInitLoadedBMachine
		   procSetCurrentTimeStampForModel
	       } else {
	               # Syntax Error or other problem with main machine
	           procShowErrors
	           procClearOptionsStateHistory
	       }
            } else {
               tkErrorBox "B translation file $generatedMchFile does not exist.\nCheck that you have the correct version of TLA2B installed."
               procShowErrors
               procClearOptionsStateHistory
            }
       }
       procEnableSourceCodeEditing
   }
}

proc procShowErrorAndHighlightTextTLA {result} {
   global lib_dir
   set lines [split $result \n]
   set outputedError {}
   set positionSeen 0
   foreach i $lines {
        if {[expr {[string first "Encountered" $i] != -1}] && [expr {$positionSeen == 0}]} {
             set tokens [split $i]
             if {[regexp {([0-9]+).*} [lindex $tokens [expr {[lsearch -exact $tokens line] +1}]] match line] &&\
                 [regexp {([0-9]+).*} [lindex $tokens [expr {[lsearch -exact $tokens column] +1}]] match column]} {
                 procHighlightLineIn .main.frmSource.text $line
                 set column [incr column -1]
                 procUnderlineColumn $line $column
                 incr opsitionSeen
             }
        } elseif {[regexp {\s*line ([0-9]+), col ([0-9]+) to line ([0-9]+), col ([0-9]+).*} \
                  $i match startline startcolumn endline endcolumn] && [expr {$positionSeen == 0}]} {
                 procHighlightLineIn .main.frmSource.text $startline
                 set startcolumn [incr startcolumn -1]
                 procUnderlineColumnFromTo $startline $startcolumn $endline $endcolumn
                 incr opsitionSeen
        }
        lappend outputedError $i 
   }
   if [file exists $lib_dir/TLA2B.jar] {
     procShowList3 $outputedError "TLA2B Error Messages" "The following errors occurred:" \
    0 0 "Reinstall TLA2B" installTLA2B "TLA2B_Output.txt"
   } else {
     set MSG "\n\nEnsure that you have installed TLA2B.jar into ProB's lib directory!\nMore information can be found in the Help menu."
     set MSG2 "\nYou can also use the 'Install TLA2B' button below."
     procShowList3 $outputedError "TLA2B Error Messages" "The following errors occurred:$MSG\n$MSG2" \
    0 0 "Install TLA2B" installTLA2B "TLA2B_Output.txt"
   }
}

proc installTLA2B {} {
     global lib_dir
     set TLA2B_url "http://nightly.cobra.cs.uni-duesseldorf.de/tla"
     
	if [prolog tools:host_platform(windows)] {
		tkMessageBox "I will try and open $TLA2B_url.\nPlease download and unzip tla2b.zip.\nThen move TLA2B.jar to $lib_dir."
        proc_open_url $TLA2B_url
	} else {
		 set DOWNLOAD1 "curl $TLA2B_url/tla/tla2b.zip -o $lib_dir/tla2b.zip"
		 set DOWNLOAD2 "unzip -qo $lib_dir/tla2b.zip -d $lib_dir/"
		 set URL "http://nightly.cobra.cs.uni-duesseldorf.de/tla/tla2b.zip"
		 puts "exec $DOWNLOAD1"
		 if {[catch {exec "curl" "$URL" -o "$lib_dir/tla2b.zip" 2> /dev/null} errid ]} {
			   tkErrorBox "Error while executing '$DOWNLOAD1'.\nError:\n$errid"
		 } else {
			 puts "exec $DOWNLOAD2"
			 if {[catch {exec "unzip" -qo "$lib_dir/tla2b.zip" -d "$lib_dir/"} errid ]} {
				   tkErrorBox "Error while executing '$DOWNLOAD2'.\nError:\n$errid"
			 } else {
				   exec "mv" "$lib_dir/tla2b/TLA2B.jar" "$lib_dir"
				   tkMessageBox "Downloaded TLA2B.jar form '$URL' and installed it to $lib_dir.\nYou should now be able to load TLA+ specifications."
			 }
		 }
     }
}

proc procLaunchTLASyntaxColouring {twin} {
    global text_editor_arr
    if {!$text_editor_arr(ctext_package)} {
        procDoInTimeTLASyntaxColouring $twin
    } else {
        procDoTLASyntaxColouring $twin
    }

}

proc procLoadPluginFile {id} {
    global strFilename curFileTypeOpened cspstrFilename
    if {$strFilename != ""} {
        set curFileTypeOpened $id
        set cspstrFilename ""
        set pfilename [escapeChars $strFilename]
        procShowSourceCode $strFilename
        if [prolog plugins:load_plugin_file('$id','$pfilename')] {
            # ok
        } else {
            procErrorBoxWithErrorMessages "Parsing of $id failed!"
        }
        procDoPluginSyntaxColouring $id .main.frmSource.text
        procFinishLoading
    }
}

proc procLoadPromelaFile {} {
    global strFilename curFileTypeOpened lib_dir app_dir cspstrFilename text_editor_arr
    if {$strFilename != ""} {
        set curFileTypeOpened "Promela"
        set cspstrFilename ""
        set promelastrFilename {}
        append promelastrFilename $strFilename ".pl"
        if [file exists $promelastrFilename] { file delete $promelastrFilename }
        set MacJava6 "/System/Library/Frameworks/JavaVM.framework/Versions/1.6/Commands/java"
        if [file exists $MacJava6] {set MyJava $MacJava6} else {set MyJava "java"}
        # puts "exec $MyJava -jar $lib_dir/Promela.jar $strFilename $app_dir"
        exec $MyJava -jar $lib_dir/Promela.jar $strFilename $app_dir
	    
	    if [file exists $promelastrFilename] {
			procShowSourceCode $strFilename
			if [prolog tcltk_open_promela_file('$promelastrFilename')] {
				# the file exists, so load it.
                procJumpToTheLastSeenTextIndex
			} else {
			  	procErrorBoxWithErrorMessages "Loading of parsed Promela file failed!"
			}
                if {!$text_editor_arr(ctext_package)} {
    			    procDoInTimePromelaSyntaxColouring  .main.frmSource.text
                } else {
                    procDoPromelaSyntaxColouring .main.frmSource.text
                }
			procFinishLoading
	    } else {
		   tkErrorBox "Parsing of Promela file failed!\nNote: the parser requires Java6 or newer."
	       procShowErrors
	    }
    }
}

proc procLoadCSPMFile {} {
    global strFilename strFilenameTemporary curFileTypeOpened checkCspAsser text_editor_arr
    if {$strFilename != ""} {
        set curFileTypeOpened "CSP"
        set cspstrFilename ""
        if [file exists $strFilename] {
            askToSaveNewAssertionsFromCheckCspWin "no" .
            file delete $strFilenameTemporary
        }    
        procShowSourceCode $strFilename
        if [prolog tcltk_open_cspm_file('$strFilename')] {
            # the file exists, so load it.
            procJumpToTheLastSeenTextIndex
        } else {
          procErrorBoxWithErrorMessages "Parsing of CSP-M file failed!"
        }
        if {!$text_editor_arr(ctext_package)} {
            if [winfo exists .eval] {
                 procDoInTimeCSPSyntaxColouring .eval.frmSource.text
            }
            procDoInTimeCSPSyntaxColouring .main.frmSource.text
        } else {
            procDoCSPSyntaxColouring .main.frmSource.text
        }
	#procShowCSPMSyntaxErrors
	procFinishLoading
	prolog "set_tcltk_cspm_mode"
        if [winfo exists .checkCspAsser] {
              global UsedCspStrFilename
              set UsedCspStrFilename $strFilename
              procUpdateCheckCspAssertionsWindow .checkCspAsser true
        }
    }
}


proc procErrorBoxWithErrorMessages {Message} {
   if [prolog real_error_occurred] {
          procShowErrors2 "" "$Message" "$Message\nThe following errors occurred:"
   } else {
          tkErrorBox "$Message"
   }
}

proc procSetCurrentTimeStampForModel {} {
	# setting timestamp for the currently loaded model needed for updating the status label
	# in case that the current file content changed then the currently loaded model
	# is not anymore consistent with the file content of the script
	global text_editor_arr strFilename
	set text_editor_arr(current_timestamp) [file mtime $strFilename]
	set text_editor_arr(last_timestamped_file) $strFilename
}

proc procFinishLoading {} {
    global show_error_if_no_transition text_editor_arr
    set show_error_if_no_transition 1
	procResetCodeModified false $text_editor_arr(reopening_file)
	procResetFilesMenu
	procShowErrors
	# Show errors that occur during loading
	prologmnf tcltk_initialise
	procInsertHistoryOptionsState
	procEnableItemsAfterOpeningFile
	procEnableSourceCodeEditing
	procShowErrors
	procCheckForPlugins
	procSetCurrentTimeStampForModel
}


proc procAddDefaultCSPFile {} {
    global cspstrFilename strFilename curFileTypeOpened
    if {$curFileTypeOpened!= "B" && $curFileTypeOpened!= "Z" && $curFileTypeOpened!= "EVENTB"} {
          tkErrorBox "You can only use a CSP Process to guide B or Z Machines.\nOpen a B Machine or Z Spec first."
    } else {
	procCheckIfSaved
	set cspstrFilename {}
	append cspstrFilename [file rootname $strFilename] ".csp"
	procAddCSPFileToBFile
    }
}
proc procAddCSPFile {} {
    global cspstrFilename curFileTypeOpened
    if {$curFileTypeOpened!= "B" && $curFileTypeOpened!= "Z"} {
          tkErrorBox "You can only use a CSP Process to guide B or Z Machines.\nOpen a B Machine or Z Spec first."
    } else {
        procCheckIfSaved
		set types {
			{"CSP Files"		{.csp .cspm}	}
			{"All files"		*}
		}
		# show the dialog box
		proc_getOpenCSPFile $types
		if {$cspstrFilename != ""} {
			procAddCSPFileToBFile
		}
    }
}
proc procAddCSPFileToBFile {} {
    global strFilename cspstrFilename curFileTypeOpened
    if {$cspstrFilename != "" && [file exists $cspstrFilename]} {
	wm title . "ProCSB: \[[file tail $strFilename]+[file tail $cspstrFilename]\]"
	procAddNewFileToFilesMenu $cspstrFilename "CSP-M"
	if [prolog tcltk_add_csp_file('$cspstrFilename')] {
		# the file exists, so load it.
	} else {
		procErrorBoxWithErrorMessages "Parsing of CSP-M file failed!"
	}
	procShowErrors
	prologmnf tcltk_initialise
	procInsertHistoryOptionsState
    } else {
          tkErrorBox "CSP-M file does not exist:'$cspstrFilename'"
    }
}
proc proc_getOpenCSPFile { types } {
    global cspstrFilename
    # show the dialog box
    set machinesPath [getMachinesPath]
    if {$machinesPath != "" && [file isdirectory $machinesPath]} {
         set cspstrFilename [tk_getOpenFile -filetypes $types -initialdir $machinesPath -parent . ]
    } else {
         set cspstrFilename [tk_getOpenFile -filetypes $types -parent . ]
    }
    if {$cspstrFilename != ""} {
	#remember the directory for next time
	setMachinesPath [file dirname $cspstrFilename]
    }

}

proc procLoadBFile {} {
    global strFilename curFileTypeOpened currentRefSpecFile cspstrFilename version text_editor_arr
    if [file exists $strFilename] {
       set curFileTypeOpened "B"
       set currentRefSpecFile ""
       set cspstrFilename ""
       procEnableReopen
       global version

	   prologmnf tcltk_clear_machine
	   # puts "cleared machine"
	   procShowSourceCode $strFilename
	   # puts "showed SourceCode"
       if {!$text_editor_arr(ctext_package)} {
            procDoInTimeSyntaxColouring .main.frmSource.text
            if [winfo exists .eval] {
                    procDoInTimeSyntaxColouring .eval.frmSource.text
            }
       } else {
            procDoSyntaxColouring .main.frmSource.text
       }
       # puts "Finished colouring..."
	   procResetCodeModified false $text_editor_arr(reopening_file)
	   procResetFilesMenu
       # puts "procEnableSourceCodeEditing"
	   procEnableSourceCodeEditing
       # puts "procResetHistory"
	   procResetHistory
       # puts "procResetState"
	   procResetState "" LightGray
	   procResetOptions "Opening..." DarkGray
	   if [prolog tcltk_open_b_file('$strFilename')] {
		   set rootName [file rootname $strFilename]
		   procAddNewFileToFilesMenu $strFilename "B"
                   procJumpToTheLastSeenTextIndex
		   procShowErrors
		   procInitLoadedBMachine
		   procSetCurrentTimeStampForModel
	   } else {
	       # Syntax Error or other problem with main machine
	       procShowErrors
	       procClearOptionsStateHistory
	   }
       procCheckForPlugins
    } else {
	tkErrorBox "File $strFilename does not exist."
    }
}

proc procInitLoadedBMachine {} {
	global show_error_if_no_transition
	set show_error_if_no_transition 1
	prologmnf tcltk_initialise
	procShowErrors
	procInsertHistoryOptionsState
	procEnableItemsAfterOpeningFile
	resetEvaluationView
}


proc procRemoveHighlightExecutedOperation {} {
      .main.frmSource.text tag remove executedTag 1.0 end
      .main.frmSource.text tag remove executedauxTag 1.0 end
      .main.frmSource.text tag remove executedControlFlowTag 1.0 end
	  .main.frmSource.text tag configure executedTag -foreground darkgreen
	  .main.frmSource.text tag configure executedTag -background lightblue
	  .main.frmSource.text tag configure executedauxTag -foreground gray40
	  .main.frmSource.text tag configure executedauxTag -background gold
	  .main.frmSource.text tag configure executedControlFlowTag -foreground black
	  .main.frmSource.text tag configure executedControlFlowTag -background chartreuse3
}
proc procHighlightExecutedOperation {line col endline endcol} {
      if {[.main.frmSource.text compare "$endline.$endcol" >= end]} {
          puts "Highlight location $endline.$endcol out of bounds"
          # happens when wrong file is shown, we need location info to be file aware
      } else {
          # puts "Highlight line:$line, col:$col, endline:$endline, endcol:$endcol."
		  set loffset 0
		  set lChr [.main.frmSource.text get "$line.$col+$loffset chars"]
		  set roffset 1
		  set rChr [.main.frmSource.text get "$endline.$endcol - $roffset chars"]
		  # erase leading and trailing whitespace
		  while {$lChr != "" && [string is space $lChr]} {
			 incr loffset
			 set lChr [.main.frmSource.text get "$line.$col + $loffset chars"]
		  }
		  set start "$line.$col + $loffset chars"
		  while {$rChr != "" && [string is space $rChr]} {
			 incr roffset
			 set rChr [.main.frmSource.text get "$endline.$endcol - $roffset chars"]
		  }
		  set roffset [expr $roffset-1]
		  set endl "$endline.$endcol - $roffset chars"
		   # puts "NewleftChar = '$lChr' $start -> $endl '$rChr'"
		  if {($lChr == "\[") && ($endline > $line || $endcol>$col+2)} {
			# is text describing shared channels 
			.main.frmSource.text tag add executedauxTag $start $endl
		  } elseif {$endline==$line && $col==$endcol-1 && ($lChr=="\[" || $lChr=="\]" || $lChr=="\|")} {
			# is a single control flow character from external, internal choice or interleave
			.main.frmSource.text tag add executedControlFlowTag $start $endl
		  } else {
			.main.frmSource.text tag add executedTag $start $endl
		  }
		  .main.frmSource.text see "$line.0"
      }
}

proc procRemoveHighlightSlice {} {
      .main.frmSource.text tag remove errcoltag 1.0 end
      .main.frmSource.text tag remove errtag 1.0 end
      .main.frmSource.text tag remove sliceTag 1.0 end
}

proc procRemoveHighlightSliceCEB {} {
      foreach tag {errcoltag errtag sliceTagCEB} {
           eval ".main.frmSource.text tag remove $tag 1.0 end"
      }
}

proc procHighlightSlice {line col endline endcol} {
	  .main.frmSource.text tag add sliceTag $line.$col $endline.$endcol
	  .main.frmSource.text tag configure sliceTag -foreground darkgreen
	  .main.frmSource.text tag configure sliceTag -background lightblue
      .main.frmSource.text see "$line.0"
}

proc procHighlightSliceCEB {line col endline endcol} {
	  .main.frmSource.text tag add sliceTagCEB $line.$col $endline.$endcol
          .main.frmSource.text tag configure sliceTagCEB -underline true
      .main.frmSource.text see "$line.0"
}

proc procHighlightLine {errlinenr} {
	  procHighlightLineIn .main.frmSource.text $errlinenr
}
proc procHighlightLineIn {w errlinenr} {
	  $w tag add errtag $errlinenr.0 $errlinenr.end
	  $w tag configure errtag -foreground darkred
	  $w tag configure errtag -background yellow
}

proc procUnderlineColumn {errlinenr errcolnr} {
	  .main.frmSource.text tag add errcoltag $errlinenr.[expr $errcolnr-1] $errlinenr.$errcolnr
	  .main.frmSource.text tag configure errcoltag -underline true
	  .main.frmSource.text tag configure errcoltag -foreground darkblue
	  .main.frmSource.text tag configure errcoltag -background yellow
}

proc procDeleteErrorTagsInSourceFile {} {
     foreach tag {errtag errcoltag allPatterns hilite sliceTag \
                 sliceTagCEB executedTag executedauxTag executedControlFlowTag} {
          eval ".main.frmSource.text tag delete $tag"
     }
}

proc procUnderlineColumnFromTo {errlinenr errcolnr endline endcol} {
   procUnderlineColumnFromToIn .main.frmSource.text $errlinenr $errcolnr $endline $endcol
}
proc procUnderlineColumnFromToIn {w errlinenr errcolnr endline endcol} {
	  $w tag add errcoltag $errlinenr.$errcolnr $endline.$endcol
	  $w tag configure errcoltag -underline true
	  $w tag configure errcoltag -foreground darkblue
	  $w tag configure errcoltag -background yellow
}


proc procSyntaxColouringPreferences {} {
   procSetPreferences "syntax_highlighting"
   # Missing: check if changes were made !!
   procDoSyntaxColouring .main.frmSource.text
}

proc procDoSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  # set lasti [$textWidget index end]
  # puts "last $lasti"
  if {[$textWidget compare "0.0 + 50000 chars" < end]} {
     prolog "tools:print_message('More than 50,000 chars')"
  }
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
      # puts "marking comments"
	  procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment

      # puts "marking syntax_type"
	  set pattern {[0-9]*\s*\.\.\s*[0-9]*|(-->)|(-->>?)|(>->>?)|(\+->>?)|(>\+>>?)|<->|(?=\m)(POW(1?)|(scope_\w*)|(SET_PREF_\w*)|(FORCE_SYMMETRY_\w*)|FIN(1?)|perm|i?seq1?|BOOL|struct|STRING|INT(EGER)?|NAT(URAL)?1?)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_type
	  # puts "marking syntax_logical"
	  set pattern {&|(?=\m)(not|or|TRUE|FALSE|bool|GOAL|ANIMATION_IMG\w*|ANIMATION_STR\w*|ANIMATION_FUNCTION_DEFAULT|ANIMATION_FUNCTION|HEURISTIC_FUNCTION|ASSERT_LTL\w*)(?=\M)|<?=>|!|#}
	  procMarkRegExpression $textWidget $pattern syntax_logical
	  
	  # puts "marking syntax_assignment"
	  set pattern {<--|:=|==?(?!>)|\|\||::}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	  # puts "marking syntax_operator 1"
	  # note: maplet |-> is not matched to avoid performance problem with large relations in properties,...
	  set pattern {\|->|>=|<=(?!>)|%|\*\*|~|/?<<?:|/(:|=)|<\+|><|^|<-(?!-|>)|<<?\||\|>>?|{}|{|}|\[|\]|\|\[\]|<>|^|(/\|?\\)|(\\\|?/)|\'|(?=\m)(SIGMA|PI|MININT|MAXINT|pred|succ|id|INTER|UNION|card|dom|ran|max|min|union|inter|size|mod|fnc|rel|rev|conc|front|tail|first|last|rec|closure1|closure|iterate|prj(1|2))(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_operator
	  # puts "marking syntax_keyword"
	  set pattern {MACHINE(\s*\w\w*)?|END\s*\Z|(?=\m)(OPERATIONS|EVENTS|ASSERTIONS|INITIALI(S|Z)ATION|SEES|PROMOTES|USES|INCLUDES|IMPORTS|REFINES|EXTENDS|REFINEMENT|CSP_CONTROLLER|SYSTEM|MODEL|IMPLEMENTATION|INVARIANT|CONCRETE_VARIABLES|ABSTRACT_VARIABLES|VARIABLES|PROPERTIES|CONSTANTS|ABSTRACT_CONSTANTS|CONCRETE_CONSTANTS|CONSTRAINTS|SETS|DEFINITIONS)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_keyword
	  # puts "marking syntax_control_keyword"
	  set pattern {(?=\m)(skip|LET|BE|VAR|IN|ANY|WHILE|DO|VARIANT|ELSIF|IF|THEN|ELSE|EITHER|CASE|SELECT|ASSERT|WHEN|PRE|BEGIN|END|CHOICE|WHERE|OR|OF)(?=\M)|;}
	  procMarkRegExpression $textWidget $pattern syntax_control_keyword
	  
	  #puts "marking syntax_unsupported"
	  set pattern {invariant_violated|\#\#\#\#|(?=\m)(both_true_false|wd_error(_false|_true)?|timeout(_false|_true)?|left|right|infix|arity|subtree|son|father|rank|mirror|sizet|postfix|prefix|sons|top|const|btree|tree)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_unsupported
  }
}


proc procDoEventBSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {

	  procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment

	  set pattern {(?=\m)(event_b_model|event_b_context|sees|variables|invariant|refines|theorems|events|extends|constants|axioms|sets|deferred_set|event)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {(?=\m)(integer|natural1_set|natural_set|couple)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_type
	  
	  set pattern {(?=\m)(subset|member|not_member|set_subtraction|set_extension|range|domain|card|add|multiplication|div|interval|boolean_true|boolean_false)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_operator
	  
	  set pattern {(?=\m)(conjunct|less_equal|greater|equal|not_equal|greater_equal|less)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_logical
	  
	  set pattern {(?=\m)(assign|becomes_element_of)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	  
	  set pattern {(?=\m)(none|identifier)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_comment
  }
}

proc procDoXTLSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {

	  procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment

	  set pattern {(?=\m)(start|trans|prop)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {(?=\m)(true|fail|atomic|nonvar|var|functor|op|is|ground|member|append|length)(?=\M)|=}
	  procMarkRegExpression $textWidget $pattern syntax_type
	  
	  set pattern {:-|!|-->|;|\.}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	  
	  set pattern {%(.*)}
	  procMarkRegExpression $textWidget $pattern syntax_comment
  }
}

proc procDoPluginSyntaxColouring {id textWidget} {
    procUpdateSyntaxColours $textWidget
    if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
        if [prolog plugins:tcl_plugin_syntax_colouring($id,Rules)] {
            set rules $prolog_variables(Rules)
            foreach r $rules {
                 set type [lindex $r 0]
                if {$type == "pair"} {
                    set begin [lindex $r 1]
                    set end [lindex $r 2]
                    set colouring [lindex $r 3]
                    procMarkRegExpressionPair $textWidget $begin $end $colouring
                } elseif {$type == "expression"} {
                    set pattern [lindex $r 1]
                    set colouring [lindex $r 2]
                    procMarkRegExpression $textWidget $pattern $colouring
                }
            }
        }
    }
}

proc procDoZedSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {

	  procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment

	  set pattern {\\(\\|noindent|(sub)?section|begin{document}|end{document}|usepackage{(fuzz|z-eves)}|documentclass)}
	  procMarkRegExpression $textWidget $pattern syntax_comment

	  set pattern {(\\(begin{schema}|end{schema}|begin{(zed|axdef)}|end{(zed|axdef)}))|\\(?=\m)(where|Delta)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {\\{|\\}|\\(notin|in|cup|cap|subseteq|setminus|emptyset|leq|geq|div|mod|dom|ran|mapsto|\#)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_operator

	  set pattern {\\(power|nat(_1)?|num)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_type

	  set pattern {\\(land|lor|implies|iff|lnot|forall|exists)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_logical

	  set pattern {:=|=}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	  
	  # set pattern {\\(begin{axdef}|end{axdef})}
	  # procMarkRegExpression $textWidget $pattern syntax_unsupported
  }
}

proc procDoInTimeCSPSyntaxColouring {textWidget args} {
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {

          ctext::clearHighlightClasses $textWidget

          prolog preferences:get_preference(sh_top_level_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_keyword $col {if then else let within}
          ctext::addHighlightClassForRegexp $textWidget syntax_keyword $col {(\{|\}|\{\||\|\}|\[|\]|\[\||\|\]|\\|@@|<-(>)?)}

          prolog preferences:get_preference(sh_operators,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_operator $col {channel datatype subtype nametype MAIN Events}
          prolog preferences:get_preference(sh_type_colour,Colour)

	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget syntax_type_words $col {(?=\m)(STOP|SKIP|CHAOS)(?=\M)}
          ctext::addHighlightClassForRegexp $textWidget syntax_type $col {(\[\]|\|~\||\|\|\||/\\|\[>|\!|\?|->|@)}

          prolog preferences:get_preference(sh_logical_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget syntax_logical $col {(?=\m)(true|false|length|null|head|tail|concat|set|Set|seq|Seq|elem|empty|card|member|union|diff|inter|Union|Inter|not|and|or|Int|Bool)(?=\M)}
          ctext::addHighlightClassForRegexp $textWidget syntax_logical1 $col {(\*|\+|-|\%|>|\|\||<|(=|!|<|>)=|=<|&&)}

          prolog preferences:get_preference(sh_assignments_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_assignment $col {assert transparent diamond print}

          prolog preferences:get_preference(sh_unsupported_background,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_unsupported SlateBlue1 {external Proc}
          ctext::addHighlightClassForRegexp $textWidget syntax_set #f83cff {([0-9]*\s*\.\.\s*[0-9]*)}

          ctext::addHighlightClassForRegexp $textWidget assertion_operators #1e90ff {\[[FDTR]+=}
          ctext::addHighlightClassForRegexp $textWidget assertion_operators1 #1e90ff {\[[FD]+\]}

          prolog preferences:get_preference(sh_comments,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget syntax_comments $col {--[^\n\r]*}
          ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {\{-(.|[\n\r]*)*-\}}
          if [regexp {[0-9]+\.[0-9]+} [lindex $args 0] match] {
              procHighlightTextSpecial $textWidget $match end
          } else {
              procHighlightTextSpecial $textWidget 1.0 end
          }
   }
}

proc procDoInTimeSyntaxColouring {textWidget} {
   if [prolog preferences:get_preference(do_syntax_highlighting,true)] {

          ctext::clearHighlightClasses $textWidget

          prolog preferences:get_preference(sh_type_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget syntax_type $col {([0-9]*\s*\.\.\s*[0-9]*|-->|-->(>)?|>->(>)?|\+->(>)?|>\+>(>)?|<->|\
                         scope_\w*|SET_PREF_\w*|FORCE_SYMMETRY_\w*)|((FIN(1?)|perm|i?seq1?|BOOL|struct|STRING|INT(EGER)?|NAT(URAL)?1?)(?=\M))}
          #ctext::addHighlightClass $textWidget syntax_type_words $col {POW POW1 FIN FIN1 perm seq iseq seq1 iseq1 BOOL STRING INT INTEGER NAT NAT1 NATURAL NATURAL1}

          prolog preferences:get_preference(sh_logical_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_logical $col {not or TRUE FALSE bool GOAL ANIMATION_FUNCTION_DEFAULT ANIMATION_FUNCTION\
                         HEURISTIC_FUNCTION}
          ctext::addHighlightClassForRegexp $textWidget syntax_logical1 $col {(TRUE|FALSE|&|ANIMATION_IMG\w*|ANIMATION_STR\w*|ASSERT_LTL\w*|(<)?=>|!|\#)}

          prolog preferences:get_preference(sh_operators,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_operator1 $col {SIGMA PI MININT MAXINT pred succ|id INTER UNION card dom ran max\
                         min union inter size mod fnc rel rev conc front tail first last rec closure1 closure iterate prj1 prj2 <=>}
          ctext::addHighlightClassForRegexp $textWidget syntax_operator $col {(\\|\|->|>=|<=(>)?|%|\*\*|~|(//)?<(<)?:|/(:|=)|<\+|\^|<-(>)?|<(<)?\||\
                         \|>(>)?|\{|\}|\[\]|\|\[\]|<>|/(\|)?\\|\\(\|)?/)}

          prolog preferences:get_preference(sh_assignments_colour,Colour)
	  set col $prolog_variables(Colour)
	  ctext::addHighlightClassForRegexp $textWidget syntax_assignment $col {(<--|:=|=(=)?(>)?|\|\||::)}

          prolog preferences:get_preference(sh_top_level_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_keyword $col {OPERATIONS EVENTS ASSERTIONS INITIALIZATION INITIALISATION SEES PROMOTES\
                        USES INCLUDES IMPORTS REFINES EXTENDS REFINEMENT CSP_CONTROLLER SYSTEM MODEL IMPLEMENTATION INVARIANT\
                        CONCRETE_VARIABLES ABSTRACT_VARIABLES VARIABLES PROPERTIES CONSTANTS ABSTRACT_CONSTANTS CONCRETE_CONSTANTS\
                        CONSTRAINTS SETS DEFINITIONS}
          ctext::addHighlightClassForRegexp $textWidget syntax_keyword_Machine $col {(MACHINE(\s*\w\w*)?|END\s*\Z)}

          prolog preferences:get_preference(sh_control_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_control_keyword $col {skip LET BE VAR IN ANY WHILE DO VARIANT ELSIF IF THEN ELSE\
                        EITHER CASE SELECT ASSERT WHEN PRE BEGIN END CHOICE WHERE OR OF}
          ###\' throws exception for this char

          prolog preferences:get_preference(sh_unsupported_background,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_unsupported1 black {invariant_violated both_true_false left right infix arity subtree \
                         son father rank mirror sizet postfix prefix sons top const btree tree}
          ctext::addHighlightClassForRegexp $textWidget syntax_unsupported black {(wd_error(_false|_true)?|timeout(_false|_true)?|\#\#\#\#)}
          $textWidget tag configure syntax_unsupported -background $col
          $textWidget tag configure syntax_unsupported1 -background $col

          prolog preferences:get_preference(sh_comments,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {/\*(.|[\n\r]*)*\*/}
          procHighlightTextSpecial $textWidget 1.0 end
   }
}

proc procHighlightTextSpecial {editor start end} {
	  global text_editor_arr
          regexp {([0-9]+)\.[0-9]+} [$editor index "$start"] match firstline
          regexp {([0-9]+)\.[0-9]+} [$editor index "$end"] match lastline
          set currentline $firstline
	  if {!$text_editor_arr(disable_highlighting)} {
	          while {$currentline <= $lastline} {
       		       if {[string length [$editor get $currentline.0 $currentline.end]] > 500} {
        	           $editor highlight $currentline.0 $currentline.500
        	      } else {
        	           $editor highlight $currentline.0 $currentline.end      
        	      }
        	      incr currentline
        	  }
	  }
}

proc procDoInTimeZedSyntaxColouring {textWidget} {
   if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
        ctext::clearHighlightClasses $textWidget

        prolog preferences:get_preference(sh_operators,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_operators $col {(\\(notin|in|cup|cap|subseteq|setminus|emptyset|leq|geq|div|mod|dom|ran|mapsto|\#))}

        prolog preferences:get_preference(sh_comments,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_comment $col {\\(noindent|documentclass)}
        ctext::addHighlightClassForRegexp $textWidget syntax_comment1 $col {(\\((begin|end)\{(document)\}|(sub)?section|(usepackage)\{(fuzz|z-eves)\}|\\))}    

        prolog preferences:get_preference(sh_top_level_keywords,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_keywords $col {(\\(where|Delta))}
        ctext::addHighlightClassForRegexp $textWidget syntax_keywords1 $col {(\\(begin|end)\{(schema|zed|axdef)\})}

        prolog preferences:get_preference(sh_type_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_type $col {(\\(power|nat(_1)?|num))}

        prolog preferences:get_preference(sh_logical_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_logical $col {(\\(land|lor|implies|iff|lnot|forall|exists))}

        prolog preferences:get_preference(sh_assignments_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_assignment $col {((:)?=)}

        prolog preferences:get_preference(sh_comments,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget multiline_comment $col {/\*(.|[\n\r]*)*?\*/}

        procHighlightTextSpecial $textWidget 1.0 end
   }  
}

proc procDoInTimeXTLSyntaxColouring {textWidget} {
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
        ctext::clearHighlightClasses $textWidget

        prolog preferences:get_preference(sh_type_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_type $col {true fail atomic nonvar var functor op is ground member append length}

        prolog preferences:get_preference(sh_top_level_keywords,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_keywords $col {start trans prop}

        prolog preferences:get_preference(sh_assignments_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_assignment $col {(:-|!|-->|;|\.)}

        prolog preferences:get_preference(sh_comments,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_comment1 $col {%[^\n\r]*}
        ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {/\*(.|[\n\r]*)*\*/}

        procHighlightTextSpecial $textWidget 1.0 end
  }
}

proc procDoInTimeSmvSyntaxColouring {textWidget} {
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
        ctext::clearHighlightClasses $textWidget

        prolog preferences:get_preference(sh_type_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_type $col {boolean}

        prolog preferences:get_preference(sh_top_level_keywords,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_keywords $col {MODULE VAR SPEC INPUT OUTPUT ASSIGN module}
	  
        prolog preferences:get_preference(sh_assignments_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_assignment $col {case esac next init}

	  
        prolog preferences:get_preference(sh_logical_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_logical $col {full nfull true empty nempty}
        ctext::addHighlightClassForRegexp $textWidget syntax_logical1 $col {(\!|&|\^|\?|\~)}

        prolog preferences:get_preference(sh_comments,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_comment1 $col {--[^\n\r]*}
        ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {/\*(.|[\n\r]*)*\*/}

        procHighlightTextSpecial $textWidget 1.0 end
  }
}

proc procDoInTimePromelaSyntaxColouring {textWidget} {
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
        ctext::clearHighlightClasses $textWidget

        prolog preferences:get_preference(sh_operators,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_operator $col {atomic d_step run printf}
        ctext::addHighlightClassForRegexp $textWidget syntax_operator1 $col {(\?|!|->|;|-(-)?|\+(\+)?|\*|::|\]|\[)}

        prolog preferences:get_preference(sh_type_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_type $col {mtype chan active proctype of byte init bool int typedef}
        ctext::addHighlightClassForRegexp $textWidget syntax_type1 $col {(\{|\}|\#define)}

        prolog preferences:get_preference(sh_top_level_keywords,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_keywords $col {if fi else goto skip do od for rof break unless provided}

        prolog preferences:get_preference(sh_assignments_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_assignment $col {assert timeout}
        ctext::addHighlightClassForRegexp $textWidget syntax_assignment1 $col {(::|--)}

        prolog preferences:get_preference(sh_logical_colour,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_logical $col {full nfull true empty nempty}
        ctext::addHighlightClassForRegexp $textWidget syntax_logical1 $col {(==|\!=|>|<|<=|>=|=<|&&|\|\|)}

        prolog preferences:get_preference(sh_comments,Colour)
	set col $prolog_variables(Colour)
        ctext::addHighlightClassForRegexp $textWidget syntax_comment1 $col {%[^\n\r]*}
        ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {/\*(.|[\n\r]*)*\*/}

        prolog preferences:get_preference(sh_unsupported_background,Colour)
        set col $prolog_variables(Colour)
        ctext::addHighlightClass $textWidget syntax_unsupported black {extern inline}
        $textWidget tag configure syntax_unsupported -background $col

        procHighlightTextSpecial $textWidget 1.0 end
  }
}

proc procDoInTimeEventBSyntaxColouring {textWidget} {
   if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
          ctext::clearHighlightClasses $textWidget

          prolog preferences:get_preference(sh_top_level_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_keywords $col {event_b_model event_b_context sees variables invariant refines \
                          theorems events extends constants axioms sets deferred_set event}

          prolog preferences:get_preference(sh_type_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_type $col {integer natural1_set natural_set couple}

          prolog preferences:get_preference(sh_operators,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_operators $col {subset member not_member set_subtraction set_extension range \
                          domain card add multiplication div interval boolean_true boolean_false}

          prolog preferences:get_preference(sh_logical_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_logical $col {conjunct less_equal greater equal not_equal greater_equal less}

          prolog preferences:get_preference(sh_assignments_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_assignment $col {assign becomes_element_of}

          prolog preferences:get_preference(sh_comments,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_comment $col {none identifier}

        procHighlightTextSpecial $textWidget 1.0 end
   }
}

proc procDoInTimeTLASyntaxColouring {textWidget} {
   if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
          ctext::clearHighlightClasses $textWidget

          prolog preferences:get_preference(sh_operators,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_operator1 $col {Head SubSeq Append Len Seq Tail IsFiniteSet Cardinality Int Nat}
          ctext::addHighlightClassForRegexp $textWidget syntax_operator $col {(\+|=|-|\*|\^|/|\.\.|\\(o|circ|div|leq)|%|(<|>|/)?=)}

         prolog preferences:get_preference(sh_logical_colour,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_logical $col {TRUE FALSE}
          ctext::addHighlightClassForRegexp $textWidget syntax_logical1 $col {((<)?=>|!|(<|-)>|\[\]|\|->|\\|/\\|\\/|~\|\.|\"
                         |\\(land|lor|lnot|neg|equiv|E|A|in|notin|cap|intersect|cup|subseteq|subset))}

          prolog preferences:get_preference(sh_top_level_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_keyword $col {MODULE CONSTANTS CONSTANT ASSUME ASSUMPTION VARIABLE \
                         VARIABLES AXIOM THEOREM EXTENDS INSTANCE LOCAL}
          ctext::addHighlightClassForRegexp $textWidget syntax_keyword_Machine $col {(==)}

          prolog preferences:get_preference(sh_control_keywords,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClass $textWidget syntax_control_keyword $col {IF THEN ELSE UNION CHOOSE LET IN UNCHANGED SUBSET\
                         CASE DOMAIN  EXCEPT ENABLED SF_ WF_ WITH OTHER BOOLEAN STRING}

          prolog preferences:get_preference(sh_comments,Colour)
	  set col $prolog_variables(Colour)
          ctext::addHighlightClassForRegexp $textWidget multiline_comment $col {\(\*(.|[\n\r]*)*\*\)}
          ctext::addHighlightClassForRegexp $textWidget syntax_comment1 $col {\\\*[^\n\r]*}

        procHighlightTextSpecial $textWidget 1.0 end
   }
}

proc procDoTLASyntaxColouring {textWidget} {
   procUpdateSyntaxColours $textWidget
   if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
          procMarkRegExpressionPair $textWidget {\(\*} {\*\)} syntax_comment

	  set pattern {((?=\m)(Head|SubSeq|Append|Len|Seq|Tail|IsFiniteSet|Cardinality|Int|Nat)(?=\M))\
                                                     |\+|\*|\^|\.\.|\\(o|circ|div|leq)|%}
	  procMarkRegExpression $textWidget $pattern syntax_operator

	  set pattern {((<)?=>|!|(<|-)>|\[\]|\|->|\\|/\\|\\/|~\|\.|\"
                         |\\(land|lor|lnot|neg|equiv|E|A|in|notin|cap|intersec|cup|subseteq|subset)|TRUE|FALSE)}
	  procMarkRegExpression $textWidget $pattern syntax_logical

	  set pattern {((?=\m)(MODULE|CONSTANTS|CONSTANT|ASSUME|ASSUMPTION|VARIABLE|VARIABLES|AXIOM|THEOREM|EXTENDS|INSTANCE|LOCAL)(?=\M))|==}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {((?=\m)(IF|THEN|ELSE|UNION|CHOOSE|LET|IN|UNCHANGED|SUBSET|CASE|DOMAIN|EXCEPT|ENABLED|SF_|WF_|WITH|OTHER|BOOLEAN|STRING)(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_control_keyword
   }
}


proc procDoCSPSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
	  procMarkRegExpressionPair $textWidget {\{-} {-\}} syntax_comment

	  set pattern {;;|((?=\m)(agent|MAIN|channel|datatype|subtype|nametype|machine|Events)(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_operator

	  set pattern {(!|\?|->|\[\]|\|~\||\|\|\||;|STOP|SKIP|CHAOS|/\\|\[>|@)}
	  procMarkRegExpression $textWidget $pattern syntax_type

	  set pattern {((?=\m)(if|then|else|@@|let|within)(?=\M))|\{|\}|<-|<->|\[\||\|\]|\[|\]|\\}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {((?=\m)(true|false|length|null|head|tail|concat|set|Set|Seq|elem|empty|card|member|union|diff|inter|Union|Inter|not|and|or|mod)(?=\M))|\*|\+|/|==|\!=|>|<|<=|>=|=<|&&|\|\|}
	  procMarkRegExpression $textWidget $pattern syntax_logical

	  set pattern {(?=\m)(assert|transparent|diamond)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_assignment

	  set pattern {--(.*)}
	  procMarkRegExpression $textWidget $pattern syntax_comment

	  set pattern {(?=\m)(external|extensions|productions|Proc)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_unsupported
  }
}

proc procDoSmvSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
      
      procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment
      
	  set pattern {(?=\m)(boolean)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_type
	  
	  set pattern {((?=\m)(MODULE|VAR|SPEC|INPUT|OUTPUT|ASSIGN|module)(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_keyword
	  
	  set pattern {(?=\m)(case|esac|next|init)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	  
	  set pattern {((?=\m)(full|nfull|true|empty|nempty)(?=\M))\!|&|\^|\?|\~}
	  procMarkRegExpression $textWidget $pattern syntax_logical
	  
	  set pattern {--(.*)}
	  procMarkRegExpression $textWidget $pattern syntax_comment
  }
}

proc procDoPromelaSyntaxColouring {textWidget} {
  procUpdateSyntaxColours $textWidget
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
      
      procMarkRegExpressionPair $textWidget {/\*} {\*/} syntax_comment

	  set pattern {\?|!|->|;|-(-)?|\+(\+)?|\*|::|\]|\[|((?=\m)(atomic|d_step|run|printf)(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_operator
      
	  set pattern {(?=\m)(mtype|chan|active|proctype|of|byte|init|bool|int|typedef)(?=\M)|#define|\{|\}}
	  procMarkRegExpression $textWidget $pattern syntax_type

	  set pattern {((?=\m)(if|fi|else|goto|skip|do|od|for|rof|break|unless|provided)(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_keyword

	  set pattern {(?=\m)(assert|timeout)(?=\M)|::|--|(=(?=\M))}
	  procMarkRegExpression $textWidget $pattern syntax_assignment
	
	  set pattern {((?=\m)(full|nfull|true|empty|nempty)(?=\M))|==|\!=|>|<|<=|>=|=<|&&|\|\|}
	  procMarkRegExpression $textWidget $pattern syntax_logical

	  set pattern {%(.*)}
	  procMarkRegExpression $textWidget $pattern syntax_comment
      # puts "Phase 6"

	  set pattern {(?=\m)(extern|inline)(?=\M)}
	  procMarkRegExpression $textWidget $pattern syntax_unsupported
  }
}

proc procDoSyntaxColouringForAnalyseInvariant {textWidget} {
  procDoSyntaxColouring $textWidget

  set pattern {(?=\m)(false|unknown|both_true_and_false|undefined)(?=\M)}
  procMarkRegExpression $textWidget $pattern syntax_unsupported

}

proc procUpdateSyntaxColours {textWidget} {
  if [prolog preferences:get_preference(do_syntax_highlighting,true)] {
      prolog preferences:get_preference(sh_type_colour,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_type -foreground $col
      prolog preferences:get_preference(sh_logical_colour,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_logical -foreground $col
      prolog preferences:get_preference(sh_assignments_colour,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_assignment -foreground $col
      prolog preferences:get_preference(sh_operators,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_operator -foreground $col
      prolog preferences:get_preference(sh_top_level_keywords,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_keyword -foreground $col
      prolog preferences:get_preference(sh_control_keywords,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_control_keyword -foreground $col
      prolog preferences:get_preference(sh_comments,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_comment -foreground $col
      prolog preferences:get_preference(sh_unsupported_background,Colour)
	  set col $prolog_variables(Colour)
	  $textWidget tag configure syntax_unsupported -background $col
  } else {
	  $textWidget tag configure syntax_type -foreground black
	  $textWidget tag configure syntax_logical -foreground black
	  $textWidget tag configure syntax_assignment -foreground black
	  $textWidget tag configure syntax_operator -foreground black
	  $textWidget tag configure syntax_keyword -foreground black
	  $textWidget tag configure syntax_control_keyword -foreground black
	  $textWidget tag configure syntax_comment -foreground black
	  $textWidget tag configure syntax_unsupported -background white
  }

}

proc procMarkRegExpression {textWidget regpattern tag_to_mark} {
  global nrChars
  set nrMatches 0
  set nrChars 0
  set startClock [clock clicks -milliseconds]
  # puts "search ExpressionPair $regpattern"
  set start [$textWidget search -count nrChars -regexp -- $regpattern 1.0 end]
  # puts "searched $start count $nrChars"
  # search does not seem to do multiline matches !!!?
  # if we have more than 1000 matches: stop; performance will be bad
  while {($start != "") && ([clock clicks -milliseconds]-$startClock<1000)} {
    # puts "start:$start nrChars:$nrChars"
    $textWidget tag add $tag_to_mark $start "$start +$nrChars chars"
    incr nrChars
    if {[$textWidget compare "$start +$nrChars chars" < end]} {
      set start [$textWidget search -count nrChars -regexp -- $regpattern "$start +$nrChars chars" end]
    } else { set start "" }
  }
  if {$start!=""} {
     prolog "tools:print_message('Too much syntax colouring; bailing out')"
  }
}


proc procMarkRegExpressionPair {textWidget begregpattern endregpattern tag_to_mark} {
  global nrChars nrChars2
  set nrChars2 0
  set nrChars 0
  # puts "search ExpressionPair $begregpattern"
  set begstart [$textWidget search -count nrChars -regexp -- $begregpattern 1.0 end]
  # puts "searched $begstart count $nrChars"
  # search does not seem to do multiline matches !!!?
  while {$begstart != ""} {
    incr nrChars
    if {[$textWidget compare "$begstart +$nrChars chars" < end]} {
      set endstart [$textWidget search -count nrChars2 -regexp -- $endregpattern "$begstart +$nrChars chars" end]
      if {$endstart != ""} {
       # we found a pair
        $textWidget tag add $tag_to_mark $begstart "$endstart +$nrChars2 chars"
        if {[$textWidget compare "$endstart +$nrChars2 chars" < end]} {
           set begstart [$textWidget search -count nrChars -regexp -- $begregpattern "$endstart +$nrChars2 chars" end]
        } else {set begstart ""}
      } else {
        puts "Unclosed comment !"
        $textWidget tag add $tag_to_mark $begstart end
        set begstart ""
      }
    } else {
      set begstart ""
    }
  }
}

proc execInBZMode {Cmd} {
   if [prolog b_or_z_mode] {
	   $Cmd
   } else {
       tkErrorBoxNoParent "This command is only possible for B, Z or TLA+ specifications ($Cmd)."
   }
}
# --------------------------------
# SAVING TO FILE
# --------------------------------

proc procSaveValuesToFile {} {
   global strFilename curFileTypeOpened 
   if [prolog b_or_z_mode] {
		set types {
			{"Text Files"	{.txt}	}
			{"All files"		*}
		}
		set machinesPath [getMachinesPath]
	    set rn [file rootname [file tail $strFilename]]
		set valFile [tk_getSaveFile -filetypes $types -initialdir $machinesPath \
		    -initialfile "${rn}_values" -parent . -defaultextension ".txt"]
		if {$valFile != ""} { 
	        prolog "b_show_history:write_values_to_file('$valFile')"
	    }
   } else {
       tkErrorBoxNoParent "Values can only be saved for B specifications."
   }
}

proc procSaveAsFile {} {
    global strFilename curFileDisplayed
    if {$curFileDisplayed != $strFilename} {
	      tkErrorBox "Can only save main file $strFilename."
    } else {
		##procCheckIfSaved
		set types {
			{"B Machine Files"		{.mch}	}
			{"B Refinements"		{.ref}	}
			{"B Implementations"	{.imp}	}
    	    {"Event-B System Files"		{.sys}	}
			{"All B Files"	{.mch .ref .imp .sys}	}
                        {"TLA Files" {.tla}      }
			{"All files"		*}
		}
		# show the dialog box
		set oldstrFilename $strFilename
		proc_getSaveFile $types
		if {$strFilename != ""} {
            set wasModified [.main.frmSource.text edit modified]
            prolog preferences:add_recent_document('$strFilename')
			set curFileDisplayed $strFilename
			procSaveFile
			procEnableItemsAfterOpeningFile
            procRebuildRecentDocumentsMenu
			if {$wasModified} {
			   procReOpenFile
			}
		} else {
			set strFilename $oldstrFilename
		}
    }
}
proc procSaveFile {} {
     # not yet fully tested !
    global strFilename curFileTypeOpened text_editor_arr
    if {$curFileTypeOpened == "EVENTB"} {
       tkErrorBox "EventB Packaged can not be saved & edited from within ProB."
    } elseif {$strFilename != ""} {
		global curFileDisplayed
		if {$curFileDisplayed != $strFilename} {
		  # puts "Saving $curFileDisplayed (main file: $strFilename)"
		}
                if {$text_editor_arr(deactivate_asking_for_reloading)} {
                    set ans [tk_messageBox -default yes -message "The file $strFilename has been modified since reading it.\
                             \nIf you save it, all external changes will be lost. Save it anyway?" -title "Warning"\
                             -type yesno -icon warning -parent .]
                    if {$ans == "yes"} {
                        procSaveTextContentIntoFile $curFileDisplayed
                        set text_editor_arr(deactivate_asking_for_reloading) false
                    }
                } else {
                    procSaveTextContentIntoFile $curFileDisplayed
                }
    } else {
       tkErrorBox "No file open. Cannot save."
    }
}

proc procSaveTextContentIntoFile {file} {
	global text_editor_arr
	set modified [.main.frmSource.text edit modified]
	set text [.main.frmSource.text get 1.0 "end - 1 chars"]
	#output to file here instead
	set fid [open $file w]
	puts -nonewline  $fid $text
	# seems to add extra blank lines at the end ?!
	close $fid
	procResetCodeModified true true
	if {$text_editor_arr(current_timestamp) != "" && $modified &&
            $text_editor_arr(last_timestamped_file) == $file && $text_editor_arr(current_timestamp) != [file mtime $file]} {
		.main.frmSource.statusframe.modelstatus configure -text "File content was changed." -bg Gray80
	}
}

proc procResetCodeModified {saving reopen} {
    global strFilename text_editor_arr
    .frmMenu.mnuFile entryconfigure 3 -state disabled
    .frmMenu.mnuFile entryconfigure 4 -state disabled
    .main.frmSource.text edit modified 0
    if {$saving} {
      proc_setFileNotModified
    } elseif {!$reopen} {
      procresetundo
    }
    if {$strFilename != "" && [file exists $strFilename]} {
        set text_editor_arr(file_last_modified) [file mtime $strFilename]
    }
}

proc procSetCodeModified {} {
    .frmMenu.mnuFile entryconfigure 3 -state normal
    .frmMenu.mnuFile entryconfigure 4 -state normal
    .main.frmSource.text edit modified 1
}
proc procCheckIfSaved {} {
    global curFileDisplayed curFileTypeOpened
    set bModified [.main.frmSource.text edit modified]
    if { $bModified && $curFileTypeOpened != "EVENTB"} {
	   set ans [tk_messageBox -default yes -message "Source File $curFileDisplayed is not saved.  Save changes to disk?" \
	            -title "Warning" -type yesno -icon warning]
	   if { $ans == "yes" } {
	     procSaveFile
	   }
    }
}
proc procSaveAndReopenFile {} {
  procSaveFile
  procReOpenFile
}

# ---------------------------------------------- reload
proc procReOpenFile {} {
    global strFilename curFileTypeOpened find_menu_arr tcl_version text_editor_arr

    set reactivatePlugin false
    if [prolog plugins:active_plugin(ActivePlugin)] {
	set reactivatePlugin true
    }

    set ext [file extension $strFilename]
    if {$strFilename != ""} {
        procCheckIfSaved
        set find_menu_arr(allpatterns) false
		if [file exists $strFilename] {
                        set text_editor_arr(reopening_file) true
			#.main.frmSource.text configure -undo 0
			if {$curFileTypeOpened == "B"} {
			   procLoadBFile
			} elseif {$curFileTypeOpened == "Z"} {
			   procLoadZFile
			} elseif {$curFileTypeOpened == "XTL"} {
			   procLoadXTLFile
			} elseif {$curFileTypeOpened == "CSP"} {
			   procLoadCSPMFile
			} elseif {$curFileTypeOpened == "Promela"} {
			   procLoadPromelaFile
			} elseif {$curFileTypeOpened == "EVENTB"} {
			   procLoadEventBPackage
                        } elseif {$curFileTypeOpened == "TLA"} {
                           procLoadTLAFile
            		} elseif [prolog plugins:is_registered_plugin($curFileTypeOpened)] {
       			   procLoadPluginFile $curFileTypeOpened
			} else {
			   tkErrorBox "Unknown file type: $curFileTypeOpened"
			}
			if {$reactivatePlugin} {
			   procActivatePlugin $prolog_variables(ActivePlugin)
			}
		} else {
		  tkErrorBox "File $strFilename no longer exists or has been moved."
		}
    } else {
      tkErrorBox "No file to open"
    }
}

# ---------------------------------------------

proc procJumpToTheLastSeenTextIndex {} {
    global text_editor_arr tcl_version
    if {$tcl_version >= 8.5} {
        tk::TextSetCursor .main.frmSource.text $text_editor_arr(text_index)
    }
    if {[regexp {([0-9]+)\.[0-9]+} $text_editor_arr(text_index) all line] && $text_editor_arr(highlight_line)} {
         procHighlightCurrentLine $line
    }
    .main.frmSource.text see $text_editor_arr(text_index)
}

# -------
# procedure to reset the animation
# -------
proc procReset {} {
	    prologmnf  tcltk_reset
        procInsertHistoryOptionsState
}

# ----------------------------------
# procedure to do a random animation
# ----------------------------------
proc procRand {} {
    for {set i 1} {$i < 11} {incr i} {
     if [prolog tcltk_random_perform] {
       procInsertHistoryOptionsState
     } else {set i 11}   }
}
# ----------------------------------
proc procRandAny {} {
	global prompt Depth count done
	destroy .search
	set f .search
	if [Dialog_Create $f "Random Execution:" -borderwidth 10] {
		message $f.msg -text "Enter maximum nr of operations: " -aspect 1000
		entry $f.entry -textvariable prompt(result)
		set b [frame $f.buttons]
		pack $f.msg $f.entry $f.buttons -side top -fill x
		pack $f.entry -pady 5
		button $b.ok -text Check -command {set prompt(ok) 1}
		button $b.cancel -text Cancel \
			-command {set prompt(ok) 0}
		pack $b.ok -side left
		pack $b.cancel -side right

		label $f.msg2 -text "Waiting"
		pack $f.msg2 -side bottom -fill x

		bind $f.entry <Return> {set prompt(ok) 1 ; break}
		bind $f.entry <Control-c> {set prompt(ok) 0 ; break}
	} else {
	    set b $f.buttons
	    wm title $f "Searching:"
	    $f.msg configure -text "Enter maximum nr of operations: " -aspect 1000
	}
    $f.msg2 configure -text ""
    set done 0
    set prompt(ok) 0
    $b.ok configure -text Run
    $b.ok configure -state normal

	Dialog_Wait_Prepare $f prompt(ok) $f.entry

    while {$done != 1} {
	  $b.ok configure -state normal
	  set prompt(ok) 0

	  tkwait variable prompt(ok)

	 if {$prompt(ok)} {
		set Depth $prompt(result)
		set prompt(ok) 1
		$f.msg2 configure -text "Random... "
		set count 0
		set done 0
		$b.ok configure -state disabled

		random_step
		if {!($done)} {
		  tkwait variable done
		}
	  } else {
	    set done 1
	  }
	}
	Dialog_Wait_Finish $f
	Dialog_Dismiss $f
}

proc random_step {} {
	global prompt
	global count Depth done

    if {($prompt(ok)) && ($count < $Depth)} {
      .search.msg2 configure -text "Random... $count / $Depth"
      set count [expr $count+1]
      # puts $count

         if [prolog tcltk_random_perform] {
              procInsertHistoryOptionsState
           if [prolog tcltk_current_state_invariant_violated] {
              tkErrorBox "Invariant Violation found!"
              set done 1
           } else {
              after 1 random_step
           }
          } else {
          set count $Depth
          if [prolog {tcltk_get_status(INVVIOLATED,MAXREACHED,1)}] {
             tkErrorBox "Possible Deadlock found (timeout occurred)."
          } else {
             tkErrorBox "Deadlock found!"
          }
          set done 1
          }

    } else {
      if {!($done)} {
         set done 2
         if {$prompt(ok)} {
         .search.msg2 configure -text "$count operations executed"
         } else {
         .search.msg2 configure -text "User cancelled after $count"
         }
      }
      return
    }
}

# -------
# procedure to search for invalid states


# -------
# procedure to display a trace to current node
# -------

proc procExecTrace {} {
   prologmnf tcltk_execute_trace_to_current_node

   procInsertHistoryOptionsState
}

proc procFindTrace {} {
    global ok
    destroy .trace
    set f .trace
	if [Dialog_Create $f "Find Trace" -borderwidth 10] {
		message $f.msg -text "Trace to current node:" -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.text xview" -orient h
        text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
         -setgrid 1 -height 18 -state disabled
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.msg $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		button $b.ok -text Done -command {set ok 1}
		pack $b.ok -side right

		bind $f.frmSource <Return> {set ok 1 ; break}
		bind $f.frmSource <Control-c> {set ok 1 ; break}
	}

    prologmnf tcltk_find_shortest_trace_to_current_node(Res)

    # obtain a list of operations to execute to reach current node

	set Result $prolog_variables(Res)
    # puts "Result $Result"

    $f.frmSource.text configure -state normal
    $f.frmSource.text delete 0.0 end

    foreach i $Result {
       # puts "i $i"
       $f.frmSource.text insert end $i
       $f.frmSource.text insert end "\n"
    }

    # $f.frmSource.text configure -state disabled

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
}

# ---------------------------------------------------------------
# PREFERENCES
# ---------------------------------------------------------------


proc procSavePrefs {} {
  global app_dir
  if [file writable "$app_dir/ProB_Preferences.pl"] {
   prolog preferences:save_preferences('$app_dir/ProB_Preferences.pl')
  } else {
   # save in local directory
   prolog preferences:save_preferences('~/ProB_Preferences.pl')
  }
}

proc procLoadPreferences {} {
  global app_dir
  if [prolog tcltk_load_commandline_prefs_file] {
     # user specified prefs file
  } elseif [file writable "$app_dir/ProB_Preferences.pl"] {
     prolog preferences:load_preferences('$app_dir/ProB_Preferences.pl')
  } elseif [prolog file_systems:file_exists('~/ProB_Preferences.pl')] {
     prolog preferences:load_preferences('~/ProB_Preferences.pl')
  } else {
     prolog preferences:load_preferences('$app_dir/ProB_Preferences.pl')
  }
  procShowErrors
}

proc procSetPreferences {prefcategory} {
    global curprefcategory
    set curprefcategory $prefcategory
	prologmnf preferences:backup_preferences
    global ok
    destroy .trace
    set f .trace
	if [Dialog_Create $f "View/Edit Preferences" -borderwidth 10] {
		message $f.msg -text "List of Preferences" -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        listbox $f.frmSource.text -yscroll "$f.frmSource.scrolly set" \
         -setgrid 1 -height 10 -width 60 -bg white
        bind $f.frmSource.text <ButtonRelease-1> {procPerformPrefOption}
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
	    set c [frame $f.checks]
		pack $f.msg $f.frmSource $f.checks $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		global lastiOption boolPrefVal
		set lastiOption 0
		set boolPrefVal 0
		radiobutton $c.bool -text True -variable boolPrefVal  -value 1 -state disabled
		radiobutton $c.bool2 -text False -variable boolPrefVal  -value 0 -state disabled
		message $c.valmsg -text "Value: " -aspect 1000
		global textPrefVal
		set textPrefVal 0
		entry $c.val -textvariable textPrefVal -width 40 -state disabled
		button $c.pick -text Pick -command {procPickValue} -state disabled
		pack $c.valmsg $c.val $c.bool $c.bool2 $c.pick -side left
		button $b.ok -text Finished -command {set ok 1; procPerformSetPrefOption}
		button $b.cancel -text Cancel -command {set ok 2}
		button $b.resetall -text "Reset all to defaults" -command {procResetPrefToDefaults}
		pack $b.ok $b.cancel $b.resetall -side right

		bind $f.frmSource <Return> {set ok 1 ; procPerformSetPrefOption; break}
		bind $f.frmSource <Control-c> {set ok 1 ; break}
	}

    prologmnf get_preferences_list($prefcategory,Res)
	set Result [split [string trimright $prolog_variables(Res) {;}] \;]
    foreach i $Result {
       $f.frmSource.text insert end $i
    }

    # $f.frmSource.text configure -state normal

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
	if {$ok==1} {
	  global app_dir
	  procSavePrefs
	} else {
	  prologmnf preferences:revert_preferences
	}
	# procInsertHistoryOptionsState
}
proc procResetPrefToDefaults {} {
    global curprefcategory
    procPerformSetPrefOption
    prologmnf reset_to_defaults($curprefcategory)
    procPerformGetPrefOption
}
proc procPerformPrefOption {} {
    global curprefcategory
    procPerformSetPrefOption
    procPerformGetPrefOption
}
proc procPickValue {} {
    global curprefcategory
    global lastiOption textPrefVal boolPrefVal
    if {$lastiOption > 0} {
        prologmnf get_ith_preference_type($curprefcategory,$lastiOption,Type)
        prologmnf get_ith_preference_value($curprefcategory,$lastiOption,Val)
        set curtype $prolog_variables(Type)
        set curval $prolog_variables(Val)
        # puts "curtype $curtype"
        if {$curtype == "rgb_color"} {
            set colres [tk_chooseColor -initialcolor $curval -parent .trace]
            if {$colres != ""} {
              # puts "color: $colres"
              set textPrefVal $colres
            }
        } elseif {$curtype == "path"} {
            set pathres [tk_getOpenFile -parent .trace]
            if {$pathres != ""} {
              # puts "color: $colres"
              set textPrefVal $pathres
            }
        } else {
          tkErrorBox "You cannot pick for this type"
        }
    }
}
proc procPerformGetPrefOption {} {
    global curprefcategory
    global lastiOption
    set iOption [.trace.frmSource.text curselection]
    if {$iOption != ""} {
        incr iOption
        prologmnf get_ith_preference_value($curprefcategory,$iOption,Val)
        set lastiOption $iOption
        global textPrefVal
        global boolPrefVal
        set textPrefVal $prolog_variables(Val)
        if [prolog get_ith_preference_type($curprefcategory,$iOption,bool)] {
           if {$textPrefVal=="true"} {set boolPrefVal 1} else {set boolPrefVal 0}
            # set boolPrefVal [expr $textPrefVal=="true"]
           .trace.checks.val configure -state disabled
           .trace.checks.bool configure -state normal
           .trace.checks.bool2 configure -state normal
           .trace.checks.pick configure -state disabled

        } else {
            set boolPrefVal 2
           .trace.checks.val configure -state normal
           .trace.checks.bool configure -state disabled
           .trace.checks.bool2 configure -state disabled
            if [prolog get_ith_preference_type($curprefcategory,$iOption,rgb_color)] {
               .trace.checks.pick configure -state normal
            } elseif [prolog get_ith_preference_type($curprefcategory,$iOption,path)] {
               .trace.checks.pick configure -state normal
            } else {
               .trace.checks.pick configure -state disabled
           }
        }
    }
}
proc procPerformSetPrefOption {} {
    global curprefcategory
    global lastiOption textPrefVal boolPrefVal
    if {$lastiOption>0} {
        prologmnf get_ith_preference_type($curprefcategory,$lastiOption,PType)
        set preftype $prolog_variables(PType)
        if {$preftype=="bool"} {
           if {$boolPrefVal == 1} {
              prologmnf set_ith_preference_value($curprefcategory,$lastiOption,true)
            } else {
              prologmnf set_ith_preference_value($curprefcategory,$lastiOption,false)
            }
        } elseif {$preftype=="string" || $preftype=="rgb_color" || $preftype=="path"} {
           prolog set_ith_preference_value($curprefcategory,$lastiOption,'$textPrefVal')
        } else {
           if {![prolog set_ith_preference_value($curprefcategory,$lastiOption,$textPrefVal)]} {
               tkErrorBoxNoParent "Could not set $curprefcategory preference to $textPrefVal"
           }
        }
   }
}

proc procSetTextEditorPreferences {} {
   global text_editor_arr
   destroy .textEditorPref
   eval global epref
   set epref .textEditorPref
   if [Dialog_Create $epref "Text Editor Preferences" -borderwidth 10] {
       wm resizable $epref 0 0
       wm transient $epref .main.frmSource
       frame $epref.body -borderwidth 3 -relief raised
       set eb $epref.body
       frame $eb.font
       # Sorted list with all system relevant fonts
       set allfonts [lsort -dictionary -unique [font families]]
       message $eb.fontmsg -text "Font" -font {-family times -size 14 -weight bold} -aspect 1000 -justify left
       label $eb.lfont -text "Editor font: "
       label $eb.lsize -text "Editor size: "
       ttk::combobox $eb.fonts -textvariable text_editor_arr(font_name) -width 20 -state readonly -value $allfonts
       ttk::combobox $eb.size -textvariable text_editor_arr(font_size) -state normal -width 4 -value {8 9 10 12 14 16 18 20 22 24 36 72}
       scale $eb.scale -from 8 -to 36 -orient horizontal -length 120 -variable text_editor_arr(font_size) -tickinterval 6 -showvalue false
       message $eb.title1 -text "Line Numbers" -font {-family times -size 14 -weight bold} -aspect 1000 -justify left 
       message $eb.title2 -text "Current Line" -font {-family times -size 14 -weight bold} -aspect 1000 -justify left 
       message $eb.title3 -text "Bracket Matching" -font {-family times -size 14 -weight bold} -aspect 1000 -justify left
       message $eb.title4 -text "File Content Changed" -font {-family times -size 14 -weight bold} -aspect 1000 -justify left
       if {$text_editor_arr(ctext_package)} {
           set st disabled
       } else {
           set st normal
       }
       ttk::checkbutton $eb.check1 -text "Display Line Numbers                " -variable text_editor_arr(linenumbers) \
             -onvalue true -offvalue false \
                         -command {procSetLinenumbersValueToTrue $text_editor_arr(linenumbers)} -state $st
       ttk::checkbutton $eb.check2 -text "Highlight Current Line               " -variable text_editor_arr(highlight_line)\
             -onvalue true -offvalue false \
                         -command {procSetHighlightCurrentLineValueToTrue $text_editor_arr(highlight_line)}
       ttk::checkbutton $eb.check3 -text "Highlight Bracket                       " -variable text_editor_arr(highlight_bracket)\
             -onvalue true -offvalue false \
                         -command {procSetHighlightBracketValueToTrue $text_editor_arr(highlight_bracket)}
       ttk::checkbutton $eb.check4 -text "Ask When File Content Changed" -variable text_editor_arr(ask_when_content_changed)\
             -onvalue true -offvalue false \
                         -command {procSetAskWhenFileContentChangedValueToTrue $text_editor_arr(ask_when_content_changed)}
       frame $epref.buttons -relief flat
       frame $epref.buttons.right
       button $epref.buttons.reset -text "Reset all to defaults" -command "procResetToDefaultTextEditorPreferences" -activebackground lightblue
       button $epref.buttons.right.close -text "Close" -command {destroy .textEditorPref} -activebackground lightblue
       button $epref.buttons.right.apply -text "Apply" -command "procApplyTextEditorPreferences" -activebackground lightblue

       grid $eb.fontmsg -row 0 -column 0 -sticky nw -pady 5
       grid $eb.lfont -row 1 -column 0 -sticky e
       grid $eb.fonts -row 1 -column 1 -columnspan 2 -sticky sew
       grid $eb.lsize -row 2 -column 0 -sticky ne -pady 3
       grid $eb.size -row 2 -column 1 -sticky new -pady 3
       grid $eb.scale -row 2 -column 2 -sticky sew -pady 6
       foreach t {title1 title2 title3 title4} c {check1 check2 check3 check4} i {3 5 7 9} j {4 6 8 10} {
           grid $eb.$t -row $i -column 0 -sticky nw -pady 5
               grid $eb.$c -row $j -column 0 -columnspan 3 -sticky nw -pady 3 -padx 35
       }
       pack $epref.buttons.right.close $epref.buttons.right.apply -side right -padx 5
       pack $epref.buttons.reset $epref.buttons.right -side left -padx 20
       pack $eb -ipady 10 -ipadx 10 -side top -pady 15
       pack $epref.buttons -side top
   }
}

proc getCurrentFont {} {
   global text_editor_arr
   set FontName [string map {" " ""} $text_editor_arr(font_name)]
   return "$FontName $text_editor_arr(font_size)"
}
proc procApplyTextEditorPreferences {} {
   global text_editor_arr
   set FontName [string map {" " ""} $text_editor_arr(font_name)]
   if [catch {.main.frmSource.text configure -font "$FontName $text_editor_arr(font_size)"}] {
       puts "Error by setting the new font \'$text_editor_arr(font_name) $text_editor_arr(font_size)\'."
   } else {
       prolog "set_preference(font_name,'$text_editor_arr(font_name)')"
       prolog "set_preference(font_size_only,$text_editor_arr(font_size))"
   }
}

proc procResetToDefaultTextEditorPreferences {} {
   global text_editor_arr
   set text_editor_arr(font_name) "Courier"; set text_editor_arr(font_size) 12
   set text_editor_arr(linenumbers) false; set text_editor_arr(highlight_line) true; set text_editor_arr(highlight_bracket) true
   set text_editor_arr(ask_when_content_changed) false
   prolog "set_preference(font_name,'$text_editor_arr(font_name)')"
   prolog "set_preference(font_size_only,$text_editor_arr(font_size))"
   prolog "set_preference(show_line_numbers,false)"
   prolog "set_preference(highlight_brackets,true)"
   prolog "set_preference(highlight_current_line,true)"
   prolog "set_preference(ask_when_content_changed,false)"
   .main.frmSource.text configure -font "$text_editor_arr(font_name) $text_editor_arr(font_size)"
}

# -------
# procedure to display coverage of operation information
# -------

proc procComputeCoverage0 {} {
  procComputeCoverage 0
}
proc procComputeCoverage {type} {
    if {$type == "enabling"} {
        prologmnf tcltk_compute_coverage_and_enabling(Res)
        set Text "transitions (with enabling info)"
    } elseif {$type == "minmax"} {
        prologmnf tcltk_compute_min_max(Res)
        set Text "constants and variables (minumum and maximum values)"
    } else {
        prologmnf tcltk_compute_coverage(Res)
        set Text "transitions"
    }
    # obtain a list of conjuncts with their status

	set Result $prolog_variables(Res)
	global batch_mode
	if {$batch_mode} {
	   puts "Coverage Statistics:\n$Result"
	} else {
	  # procDisplayCoverage $Result $Text
		procShowList2 $Result "Analysing Coverage" "Coverage for $Text:" 1 0 "Coverage.txt"
	}
}

# -------
# procedure to analyse the invariant in the current state
# -------
proc procDebugOperation {} {
   global OpName
   set OpName [procChooseOperationOrINITIALISATION]
   if {$OpName != ""} {
	  procDebugProperties1 $OpName 0
   }
}

proc procChooseOperationOrINITIALISATION {} {
   if {[prolog current_state_corresponds_to_initialised_b_machine]} {
      if {[prolog tcltk_unique_top_level_operation(Name)]} {
         return $prolog_variables(Name)
      } else {
         return [procChooseOperation]
      }
   } elseif {[prolog current_state_corresponds_to_setup_constants_b_machine]} {
      # return {@INITIALISATION}
      return [procChooseElementFromList {@INITIALISATION} "Operations" "no" "" "var" "true"]
   } else {
      # return {@PROPERTIES}
      return [procChooseElementFromList {@PROPERTIES} "Operations" "no" "" "var" "true"]
   }
}

proc procVisualiseOperationPre {} {
   global OpName strFilename
    if {$strFilename != ""} {
	   # set OpName [Dialog_Prompt "Enter operation name"]
	   set OpName [procChooseOperationOrINITIALISATION]
	   if {$OpName != ""} {
		   procVisualiseInvariantOrOpPRE $OpName
		   procShowErrors
	   }
    } else {
       tkErrorBox "No File open. Cannot visualise operation enabling condition."
    }
}


proc procChooseOperation {} {
    return [procChooseOperation2 "no" "" "var" "true"]
}
proc procChooseOperation2 {ChkBox ChkBoxMsg ChkBoxVar FilterPred} {
    prologmnf findall(Name,b_top_level_operation(Name),LN)
    
    return [procChooseElementFromList $prolog_variables(LN) "Operations" $ChkBox $ChkBoxMsg $ChkBoxVar $FilterPred]
}
proc procChooseElementFromList {List ElName ChkBox ChkBoxMsg ChkBoxVar FilterPred} {
    global ok
    destroy .trace
    set f .trace
    prologmnf findall(Name,b_top_level_operation(Name),LN)
    
	if [Dialog_Create $f "Choose $ElName" -borderwidth 10] {
		message $f.msg -text "List of $ElName" -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        listbox $f.frmSource.text -yscroll "$f.frmSource.scrolly set" \
         -setgrid 1 -height 9 -width 40 -bg white
        bind $f.frmSource.text <Double-1> {set ok 1}
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.msg $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		
		if {$ChkBox == "yes"} {
		  global $ChkBoxVar
		  checkbutton $f.mychckbox -text "$ChkBoxMsg" -variable $ChkBoxVar \
		    -offvalue 0 -onvalue 1
		  pack $f.mychckbox -side top
		}
		button $b.ok -text Select -command {set ok 1}
		button $b.cancel -text Cancel -command {set ok 2}
		pack $b.ok $b.cancel -side right

		bind $f.frmSource <Return> {set ok 1 ; break}
		bind $f.frmSource <Control-c> {set ok 2 ; break}
	}

	foreach i $List {
	   if {$FilterPred=="true" || [prolog "'$FilterPred'($i)"]} {
		 $f.frmSource.text insert end $i
	   } else {
		 $f.frmSource.text insert end "($i : not covered)"
	   }
	}

    # $f.frmSource.text configure -state normal

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
	set sel [.trace.frmSource.text curselection]
	if {$ok==1} {
	  set res [lindex $List $sel]
	  # puts "Selection $sel : $res"
	  return $res
	} else {
	  return ""
	}
}


proc procExecuteOperation {} {
   global OpName
   # set OpName [Dialog_Prompt "Enter operation name"]
   
   if {[prolog b_machine_has_constants_or_properties] && [prolog current_expression(root,_)]} {
       set OpName {$setup_constants}
   } else {
       set OpName [procChooseOperationOrINITIALISATION]
   }
   if {$OpName != ""} {
        puts "Getting op paras"
		prolog b_get_machine_operation_parameter_names('$OpName',LP)
        puts "$prolog_variables(LP)"
		procExecuteSpecificOperation $prolog_variables(LP)
   }
}

proc procExecuteSpecificOperation {Parameters} {		
        global OpName
        global ok
		destroy .execOp
		set f .execOp
		if [Dialog_Create $f "Enter Parameters for $OpName" -borderwidth 10] {
			message $f.msg -text "Parameters for $OpName" -aspect 1000
			# ------- code source frames
			frame $f.frmVals -borderwidth .1c -relief groove
	
			set b [frame $f.buttons]
			pack $f.msg $f.frmVals $b -side top -fill x
			
			button $b.ok -text Execute -command {set ok 1}
			button $b.cancel -text Cancel -command {set ok 2}
			pack $b.ok $b.cancel -side right
			
			foreach i $Parameters {
			     global exopvars
				 message $f.frmVals.valmsg$i -text "$i:" -aspect 1000
				 entry $f.frmVals.val$i -textvariable exopvars(textVal$i) -width 40 -state normal
				 pack $f.frmVals.valmsg$i $f.frmVals.val$i -side top
			}
			global precondval
			message $f.frmVals.premsg -text "Additional PRE:" -aspect 1000
			entry $f.frmVals.preval -textvariable precondval -width 60 -state normal
			pack $f.frmVals.premsg $f.frmVals.preval -side top
	
			bind $f.frmVals <Return> {set ok 1 ; break}
			bind $f.frmVals <Control-c> {set ok 2 ; break}
		}
	
	
		# $f.frmVals.text configure -state normal
	
		set ok 0
		Dialog_Wait $f ok $f.frmVals
		Dialog_Dismiss $f
		if {$ok==1} {
		  # puts "Executing $OpName"
		  if {$precondval != ""} {
		      set PreCond $precondval
		  } else {
		      set PreCond "(TRUE=TRUE)"
		  }
		  foreach i $Parameters {
			     set val $exopvars(textVal$i)
			     # puts "Parameter $i = $val"
			     if {$val != ""} {
			        if {$PreCond == "(TRUE=TRUE)"} {
			           set PreCond "($i = $val)"
			        } else {
			           append PreCond "& ($i = $val)"
			        }
			     }
		  }
		  puts "PreCond2 $PreCond"
		  
		 if [prolog tcltk_add_user_executed_operation('$OpName','$PreCond')] {
			procShowErrors
			procInsertHistoryOptionsState
		 } else {
		    procShowErrors
			tkErrorBox "Could not execute operation $OpName\nExtra Pre-Condition: $PreCond."
		 }
		}
}

proc prologmnf {Query} {
   # checks that a prolog query does not fail (mnf)
   set PQ "prolog $Query"
   # puts "exec prolog $Query"
   if [uplevel 1 $PQ] {
      # puts "done prolog $Query"
      return 1
   } else {
      tkErrorBox "Prolog Query unexpectedly failed: $Query"
      return 0
   }
}


proc procCheckDebugProperties {} {
      global batch_mode
      set saved_mode $batch_mode
      set batch_mode 1
      procDebugProperties
      set batch_mode $saved_mode
}
proc procDebugProperties {} {
   procDebugProperties1 "@PROPERTIES" 0
}
proc procDebugInitialisation {} {
   procDebugProperties1 "@INITIALISATION" 0
}
proc procDebugProperties1 {OpName UnsatCore} {
    puts "procDebugProperties $OpName"
    set ExtraBtn "Minimize..."
    set UnsatCoreFile "Debug"
    if {$UnsatCore} {
       global expert_user
	   if {$expert_user} {
	      set ans [tk_messageBox -default no \
	            -message "Precise minimisation of unsatisfiable predicates (may take a long time)?" \
	            -title "Minmise Unsatisfiable Predicates" -type yesnocancel -icon question -parent .]
	   } else {
	      set ans "yes"
	   }
	   if { $ans == "yes" } {
	      set Unsat "full"
          set UnsatCoreFile "UnsatCore"
          # set ExtraBtn ""
	   } elseif { $ans == "no" } {
	      set Unsat "fast"
          set UnsatCoreFile "FastUnsatCore"
	   } else {
	      return
	   }
    } else {
       set Unsat "false"
    }
    if [prolog tcltk_debug_properties_or_op('$OpName',$Unsat,Res,Satisfiable)] {
        if {$prolog_variables(Satisfiable)==false} {
           assertBatchError "Property Unsatisfiable"
        } else {
           set ExtraBtn "none"
        }
		set Result [split [string trimright $prolog_variables(Res) {;}] \;]
		procShowErrors
		if {$OpName == "@PROPERTIES"} {
		   set Msg1 "Constraints and Properties"
		   set Msg2 "the CONSTRAINTS and PROPERTIES clauses"
		} else {
		   set Msg1 "$OpName Enabling Condition"
		   set Msg2 "the Operation $OpName"
		}
		set Cmd "procDebugProperties1 $OpName 1"
		procShowList3 $Result "Debugging $Msg1" "Debugging $Msg2:" 1 0 $ExtraBtn $Cmd "$UnsatCoreFile.txt"
    }
}

proc procCheckNumber {Msg Expected Real} {
	if {$Real != $Expected && $Expected>=0} {
	   tkErrorBox "Unexpected Number of $Msg.\nExpected: $Expected\nGot: $Real"
	}
}

proc procAnalysePred {TYPE} {
   procAnalysePredCheck $TYPE -1 -1 -1
}

proc procAnalysePredCheck {TYPE ExpTot ExpFal ExpUnk} {
    prolog tcltk_analyse_option($TYPE,Desc)
    if [prologmnf tcltk_analyse($TYPE,Res,Total,False,Unknown)] {
		set Result [split [string trimright $prolog_variables(Res) {;}] \;]
		# puts "Showing results"
		procShowErrors
		set Tot $prolog_variables(Total)
		procCheckNumber "conjuncts" $ExpTot $Tot
		set Fal $prolog_variables(False)
		procCheckNumber "false conjuncts" $ExpFal $Fal
		set Unk $prolog_variables(Unknown)
		procCheckNumber "unknown conjuncts" $ExpUnk $Unk
		procShowList2 "$Result ------ SUMMARY ------ Analysed:$Tot False:$Fal Unknown:$Unk" "Analysing $prolog_variables(Desc)" "(Non-Typing) Conjuncts of $prolog_variables(Desc):" 1 0 "PredicateAnalysis.txt"
    }
}
proc procAnalyseInvariant {} {
    procAnalysePred invariant
}
proc procAnalyseProperties {} {
    procAnalysePred properties
}
proc procAnalyseAssertions {} {
    procAnalysePred assertions
}

proc procAnalyseDEFGOAL {} {
  if [prolog b_reset_machine_goal_from_DEFINITIONS] {
     procAnalyseGOAL
  } else {
       tkErrorBox "Could not obtain GOAL predicate from DEFINITIONS."
  }
}
proc procAnalyseGOAL {} {
    if [prologmnf tcltk_analyse_goal(Res)] {
        procShowErrors
		# obtain a list of conjuncts with their status
		set Result [split [string trimright $prolog_variables(Res) {;}] \;]
		procShowList2 $Result "Analysing GOAL" "Conjunct of the GOAL:" 1 0 "Goal_Analysis.txt"
    }
}



proc procShowTyping {} {
    if [prologmnf tcltk_show_typing_of_variables_and_constants(Res)] {
        procShowErrors
		set Result [split [string trimright $prolog_variables(Res) {;}] \;]
		procShowList2 $Result "Analysing Typing" "Typing of Constants and Variables:" 1 0 "Typing.txt"
    }
}

proc procShowCurrentState {} {
  if [prolog tcltk_show_current_state(TB)] {
     puts "current: $prolog_variables(TB)"
	set Result [split $prolog_variables(TB) \n]
     procShowList "$Result" "Current B State" "Current B State"
  } else {
         tkErrorBox "Please set up constants first"
  }
}

proc procShowList {Result WindowTitleMsg1 Msg2} {
    procShowList2 $Result $WindowTitleMsg1 $Msg2 0 0 "ProB_Output.txt"
}

proc procShowList2 {Result WindowTitleMsg1 Msg2 SyntaxHighlight BugReportButton DefaultSaveName} {
  procShowList3 $Result $WindowTitleMsg1 $Msg2 $SyntaxHighlight $BugReportButton none none $DefaultSaveName
}
proc procShowList3 {Result WindowTitleMsg1 Msg2 SyntaxHighlight BugReportButton ExtraButtonName ExtraCmd DefaultSaveName} {
  global batch_mode testing_mode
  if {$batch_mode || $testing_mode==true} {
     puts "$WindowTitleMsg1\n$Msg2\n\n$Result"
  } else {
     global strFilename
	 set rn [file rootname [file tail $strFilename]]
	 set us "_"
     procShowList4 $Result $WindowTitleMsg1 $Msg2 $SyntaxHighlight $BugReportButton $ExtraButtonName $ExtraCmd "$rn$us$DefaultSaveName"
  }
}
proc procShowList4 {Result WindowTitleMsg1 Msg2 SyntaxHighlight BugReportButton ExtraButtonName ExtraCmd DefaultSaveName} {
    global ok
	destroy .invariant
	# destroy added for Mac TclTk
    set f .invariant
	if [Dialog_Create $f $WindowTitleMsg1 -borderwidth 10] {
		message $f.msg -text $Msg2 -aspect 1000
		global tcl_dir
        # image create photo checkKO -format gif -fil "$tcl_dir/icons/CheckOK.gif"
        # label $f.okko -text OKKO -image checkKO
        
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.text xview" -orient h
        text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
         -setgrid 1 -height 18 -state disabled
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.msg $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		if {$BugReportButton} {
		  button $b.bug -text "Report as Bug..." -command {set ok 2}
		  pack $b.bug -side left
		}
		if {$ExtraButtonName!="none"} {
		  button $b.extra -text "$ExtraButtonName" -command {set ok 4}
		  pack $b.extra -side left
		}
		button $b.save -text "Save..." -command {set ok 3}
		pack $b.save -side left
		button $b.ok -text Done -command {set ok 1}
		pack $b.ok -side right

		bind $f.frmSource <Return> {set ok 1 ; break}
		bind $f.frmSource <Control-c> {set ok 1 ; break}
		bind $f.frmSource <Escape> {set ok 1 ; break}
	}

    $f.frmSource.text configure -state normal
    $f.frmSource.text delete 0.0 end
    foreach i $Result {
       $f.frmSource.text insert end $i
       $f.frmSource.text insert end "\n"
    }
    if {$SyntaxHighlight} {
       procDoSyntaxColouringForAnalyseInvariant $f.frmSource.text
    }
    # puts "Finished Syntaxhighlighting"
    HighlightSyntaxErrors $f.frmSource.text
    
    # $f.frmSource.text configure -state disabled
    # keep normal instead of disabled: this allows users to select and copy the list

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
	if {$BugReportButton && $ok==2} {
	   procReportDBug "Errors:$Result"
	} elseif {$ok==3} {
	    set types {
	        {"Text File" {.txt} }
			{"All files"		*}
		}
	    set DEBUGFILE [tk_getSaveFile -filetypes $types -initialfile $DefaultSaveName -parent . -defaultextension "txt"]
		if {$DEBUGFILE != ""} { 
		   # puts "Opening File: $DEBUGFILE"
		   set channel [open "$DEBUGFILE" "w+"]
			foreach i $Result {
			   puts $channel $i
			}
		   close $channel
       }
	} elseif {$ok==4} {
	   eval $ExtraCmd
	   procShowErrors
	}
}

proc procEval {} {
    set f .eval
    global eval_window_arr text_editor_arr
    if [Dialog_Create $f "Eval" -borderwidth 10] {
        entry $f.entry -textvariable eval_window_arr(input) -width 80
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.text xview" -orient h
        if {!$text_editor_arr(ctext_package)} {
             ctext $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
               -setgrid 1 -height 18 -state disabled -linemap 0
        } else {
             text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
               -setgrid 1 -height 18 -state disabled
        }
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
        pack $f.frmSource.text -expand 1 -fill both
        set b [frame $f.buttons]
        pack $f.frmSource $f.buttons -side top -fill x
        pack $f.frmSource -pady 5 -expand 1 -fill both
        pack $f.entry -side bottom
        button $b.eval -text Eval -command {procEvalInput; procUpdateHistoryListAndHistoryIndex; set eval_window_arr(input) ""}
        button $b.ok -text Finished -command {destroy .eval; set eval_window_arr(input) ""; procSetHistoryToLastEvaluatedString}
        pack $b.ok $b.eval -side right
        bind $f.entry <Return> {procEvalInput;procUpdateHistoryListAndHistoryIndex;set eval_window_arr(input) "";break}
        bind $f.entry <Up> {if [prolog animation_mode(cspm)] {
                              procRecallHistoryEval -1 $eval_window_arr(csp_history) true
                            } else { 
                              procRecallHistoryEval -1 $eval_window_arr(b_history) false}}
        bind $f.entry <Down> {if [prolog animation_mode(cspm)] {
                              procRecallHistoryEval 1 $eval_window_arr(csp_history) true
                            } else { 
                              procRecallHistoryEval 1 $eval_window_arr(b_history) false}}
        bind $f.entry <Control-c> {destroy .eval ; break; set eval_window_arr(input) ""; procSetHistoryToLastEvaluatedString}
        bind $f <Destroy> {set eval_window_arr(input) "1+1"; procSetHistoryToLastEvaluatedString}
        bind $f <<RIGHTCLICK>> {after idle {break}}
	}
        catch {tkwait visibility .eval}
        if [prolog get_all_errors(Res)] {
        }
}

proc procEvalConsole {} {
    global eval_window_arr text_editor_arr
    destroy .eval
    set e .eval
    prolog preferences:get_history_elements_list(eval_history_elements,false,Hist)
    prolog preferences:get_history_elements_list(eval_csp_history_elements,false,CSPHist)
    set eval_window_arr(b_history) $prolog_variables(Hist)
    set eval_window_arr(csp_history) $prolog_variables(CSPHist)
    set eval_window_arr(b_hist_index) [llength $eval_window_arr(b_history)]
    set eval_window_arr(csp_hist_index) [llength $eval_window_arr(csp_history)]
    if {!$text_editor_arr(ctext_package)} {
        if [Dialog_Create $e "Eval - 80x18" -borderwidth 10] {
            #wm transient $e .
            set seconds [clock seconds]
            set eval_window_arr(input) ""
            frame $e.frmSource -borderwidth .1c -width 80
            prolog "get_preference(font_name,FontName)"
            set text_editor_arr(font_name) $prolog_variables(FontName)
            prolog "get_preference(font_size_only,FontSize)"
            set TextFont [string map {" " ""} $text_editor_arr(font_name)]
            ctext $e.frmSource.text -yscrollcommand "$e.frmSource.scrolly set"\
               -setgrid 1 -height 18 -state normal -linemap 0  -font "$TextFont $text_editor_arr(font_size)"
            scrollbar $e.frmSource.scrolly -command "$e.frmSource.text yview"
            if [prolog animation_mode(cspm)] {
                procDoInTimeCSPSyntaxColouring $e.frmSource.text
            } else {
                procDoInTimeSyntaxColouring $e.frmSource.text
            }
            set eval_window_arr(input_index) 2.5
            set t $e.frmSource.text
            $t insert 1.0 "Logged on [clock format $seconds]\n"
            $t insert 2.0 ">>>> "
            pack $e.frmSource.scrolly -side right -fill y
            pack $e.frmSource.text -expand 1 -fill both
            pack $e.frmSource -pady 5 -expand 1 -fill both
            focus -force .eval.frmSource.text
            bind $t <Configure> {procChangeEvalWidnowsTitle .eval .eval.frmSource.text}
            bind $t <Return> {procEvalInputConsole .eval.frmSource.text; procUpdateHistoryListAndHistoryIndex}
            bind $t <Up> {if [prolog animation_mode(cspm)] {
                              procRecallHistoryOfEvalConsole -1 $eval_window_arr(csp_history)
                          } else { 
                              procRecallHistoryOfEvalConsole -1 $eval_window_arr(b_history)}}
            bind $t <Down> {if [prolog animation_mode(cspm)] {
                              procRecallHistoryOfEvalConsole 1 $eval_window_arr(csp_history)
                            } else { 
                              procRecallHistoryOfEvalConsole 1 $eval_window_arr(b_history)}}
            bind $t <Left> {procMoveCursorLeft "no"}
            bind $t <Right> {procMoveCursorRight}
            bind $t <Button-1> {after idle {tk::TextSetCursor .eval.frmSource.text $eval_window_arr(input_index)}}
            bind $t <BackSpace> {procMoveCursorLeft "yes"}
            bind $t <Tab> {break}
	        bind $t <Shift-Control-c> {tk_textCopy .eval.frmSource.text}
	        bind $t <Shift-Control-C> {tk_textCopy .eval.frmSource.text}
            set CMD [procGetAccKey]
            bind $t <$CMD-BackSpace> {procClearWindow .eval.frmSource.text; break}
            bind $t <$CMD-k> {procClearWindow .eval.frmSource.text; break}
            bind $t <Control-c> {after idle {tk::TextSetCursor .eval.frmSource.text $eval_window_arr(input_index); procAddNewEnterLine ; procSetHistoryToLastEvaluatedString}}
            bind $t <Control-C> {after idle {tk::TextSetCursor .eval.frmSource.text $eval_window_arr(input_index); procAddNewEnterLine ; procSetHistoryToLastEvaluatedString}}
	    bind $t <$CMD-v> {procPasteInEvalConsole .eval.frmSource.text; break }
	    bind $t <$CMD-V> {procPasteInEvalConsole .eval.frmSource.text; break}
            bind $t <Home> {procMoveCursorLeft "no"}
            # does not work:
            #bind $t <<RIGHTCLICK>> {procPerformEvalContextMenus $t %X %Y} 
            bind $t <Button-2> {selection clear; clipboard clear
                                after 1000 {catch {procDisableRightclickInEvalWindow $eval_window_arr(input_index)}}}
            wm protocol .eval WM_DELETE_WINDOW {set eval_window_arr(proCSPInterpreter) true; destroy .eval}
        }
    } else {
             procEval
    }
}

proc procPerformEvalContextMenus {t X Y} {
   destroy .eval_popup
   menu .eval_popup -tearoff 0
   .eval_popup add command -label "Clear" -command {procClearWindow}
   .eval_popup add command -label "Evaluate" -command {procEvalInputConsole $t; procUpdateHistoryListAndHistoryIndex}
   tk_popup .eval_popup $X $Y
}


proc procPasteInEvalConsole {w} {
   global eval_window_arr
   if {[$w tag ranges sel] != ""} {
        $w tag delete sel	
	tk::TextSetCursor $w $eval_window_arr(input_index)
   }   
   regexp {([0-9]+)\.[0-9]+} [$w index insert] match line
   regexp {([0-9]+)\.[0-9]+} $eval_window_arr(input_index) match curline
   if {$line != $curline} {
	tk::TextSetCursor $w $eval_window_arr(input_index)
   }
   tk_textPaste $w
}

proc tk_textPaste {w} {
   global tcl_platform
   array set range {}
   if { [catch {$w tag ranges sel} ranges] } { return }
   foreach {first last} $ranges {
     set range($first) $last
     puts "set range($first) \[$last\]"
   }

   if { [catch {::tk::GetSelection $w CLIPBOARD} sel] } { return }

   set oldSeparator [$w cget -autoseparators]
   if { $oldSeparator } {
     $w configure -autoseparators 0
     $w edit separator
   }
   if { ![string equal [tk windowingsystem] "x11"] } {
     foreach first [lsort -decreasing [array names range]] {
       $w delete $first $range($first)
     }
   }
   $w insert insert $sel
   if { $oldSeparator } {
     $w edit separator
     $w configure -autoseparators 1
   }
 }

proc tk_textCopy {w} {
   set list [list]
   if { [catch {$w tag ranges sel} ranges] } { return }
   foreach {first last} $ranges {
     lappend list [$w get $first $last]
   }
   clipboard clear -displayof $w
   clipboard append -displayof $w [join $list \n]
 }

proc procDisableRightclickInEvalWindow {index} {
     after idle {
     set ind [.eval.frmSource.text index current]
#        puts "ind: $ind"
     if [catch {selection get} sel] {
          if [catch {selection get -selection CLIPBOARD} sel] {
              # no text were pasted
          } else {
#                 puts "Selection: $sel"
              set len [string length $sel]
              .eval.frmSource.text delete $ind "$ind +$len chars"
          }
     } else {
#                 puts "Selection: $sel"
              set len [string length $sel]
              .eval.frmSource.text delete $ind "$ind +$len chars"
     } }
     tk::TextSetCursor .eval.frmSource.text $index
}

proc procRecallHistoryOfEvalConsole {num listHistory} {
    global eval_window_arr
    set ev .eval.frmSource.text
    if [prolog animation_mode(cspm)] {
        procRecallHistoryEval $num $listHistory true
    } else {
        procRecallHistoryEval $num $listHistory false
    }
    regexp {([0-9]+)\.([0-9]+)} [$ev index insert] match line col
    if {$col > 5} {
         $ev delete $line.5 $line.end
    }
    $ev insert $line.6 $eval_window_arr(input)
    $ev highlight $line.5 $line.end
    if {$eval_window_arr(input) != ""} {
        set chs [string length $eval_window_arr(input)]
        set col [expr {$chs + 6}]
        set eval_window_arr(input_index) $line.$col
    }
    after idle {tk::TextSetCursor .eval.frmSource.text $eval_window_arr(input_index)}
}

proc procCatchTabulatorEvent {} {
    after idle {
        regexp {([0-9]+)\.([0-9]+)} [.eval.frmSource.text index insert] match line col
        .eval.frmSource.text delete $line.5 $line.$col
        tk::TextSetCursor .eval.frmSource.text $line.6
    }
}

proc procMoveCursorLeft {is_backspace} {
    regexp {([0-9]+)\.([0-9]+)} [.eval.frmSource.text index insert] match line col
    if {$col < 6} {
        if {$is_backspace == "yes"} {
            after idle {}
            .eval.frmSource.text insert $line.5 " "
            tk::TextSetCursor .eval.frmSource.text $line.6
        } else {
            after idle {
                    regexp {([0-9]+)\.[0-9]+} [.eval.frmSource.text index insert] match line
                    tk::TextSetCursor .eval.frmSource.text $line.5
            }
        }
    }
}

proc procMoveCursorRight {} {
    after idle {
           regexp {([0-9]+)\.([0-9]+)} [.eval.frmSource.text index insert] match line col
           if {$col == 0} {
               # new line
               incr line -1
               tk::TextSetCursor .eval.frmSource.text $line.end
           }
    }
}

proc procClearWindow {twin} {
  global eval_window_arr
  # now get line and column number from input_index:
  regexp {([0-9]+)\.([0-9]+)} $eval_window_arr(input_index) match line col
  $twin delete 1.0 $line.0
  set eval_window_arr(input_index) "1.5"
}
proc procEvalInputConsole {twin} {
    global eval_window_arr
    regexp {([0-9]+)\.([0-9]+)} $eval_window_arr(input_index) match line col
    set eval_window_arr(input) [$twin get $line.5 $line.end]
    if {$eval_window_arr(input) == "exit"} {
        set eval_window_arr(input) ""
        set eval_window_arr(input_index) "2.5"
	set eval_window_arr(proCSPInterpreter) true
        wm withdraw .eval
    } elseif {$eval_window_arr(input) == "help"} {
        if [prolog animation_mode(cspm)] {
             procLaunchSyntaxInfo "CSP"
	     procAddNewEnterLine
        } else {
             procLaunchSyntaxInfo "B"
	     procAddNewEnterLine
        }
    } else {
	if [prolog animation_mode(cspm)] {
      	   procRunCspmEvaluator
	} else {
	   procEvalConsoleCurrentInput
	}
    }
}

proc procAddNewEnterLine {} {
    global eval_window_arr
    set twin .eval.frmSource.text
    regexp {([0-9]+)\.([0-9]+)} [$twin index insert] match line col
    append EnterInput "\n" ">>>> "
    $twin insert $line.$col $EnterInput
    incr line
    set col 5
    set eval_window_arr(input_index) $line.$col
    $twin delete $eval_window_arr(input_index) end
    after idle {tk::TextSetCursor .eval.frmSource.text $eval_window_arr(input_index)}
}

proc procEvalInput {} {
    if [prolog animation_mode(cspm)] {
        procRunCspmEvaluator
    } else {
        procEvalCurrentInput
    }
}

proc procSetHistoryToLastEvaluatedString {} {
     global eval_window_arr
     if [prolog animation_mode(cspm)] {
         set eval_window_arr(csp_hist_index) [llength $eval_window_arr(csp_history)]
     } else { 
         set eval_window_arr(b_hist_index) [llength $eval_window_arr(b_history)]
     }
}

proc procUpdateHistoryListAndHistoryIndex {} {
     global eval_window_arr
     if {[prolog animation_mode(cspm)] && [expr {$eval_window_arr(input) != ""}]} {
	lappend eval_window_arr(csp_history) $eval_window_arr(input)
	set eval_window_arr(csp_hist_index) [llength $eval_window_arr(csp_history)]
	set eval_window_arr(input) [string map {"\\" "\\\\" "'" "\\'"} $eval_window_arr(input)]
	if [procIsSymbolPaired $eval_window_arr(input) "\{" "\}"] { ;# saving the history of commands only with equal number of {'s and }'s
								     # there is a problem by getting strings with no paired braces of type { } 
								     # later from ProB_Preferences.pl file.  
		prolog preferences:add_element_to_history(eval_csp_history_elements,'$eval_window_arr(input)',50)
	}
     } else {
	if {$eval_window_arr(input) != ""} {
		lappend eval_window_arr(b_history) $eval_window_arr(input)
		set eval_window_arr(b_hist_index) [llength $eval_window_arr(b_history)]
		set eval_window_arr(input) [string map {"\\" "\\\\" "'" "\\'"} $eval_window_arr(input)]
		if [procIsSymbolPaired $eval_window_arr(input) "\{" "\}"] {
			prolog preferences:add_element_to_history(eval_history_elements,'$eval_window_arr(input)',50)
		}
         }
     }
}

proc procRecallHistoryEval {num listHistory is_csp} {
   global eval_window_arr
   set nextIndex 0
   set len [llength $listHistory]
   if {[llength $listHistory] == 0} {
       ##there is no history saved
   } elseif {[llength $listHistory] >0} {
       if {$num == 1} {
           if {$is_csp} {
              set nextIndex [expr {$eval_window_arr(csp_hist_index) +1}]
           } else {
              set nextIndex [expr {$eval_window_arr(b_hist_index) +1}]
           }
           if {$nextIndex < [llength $listHistory]} {
                set eval_window_arr(input) [lindex $listHistory $nextIndex]
                if {$is_csp} {
                    set eval_window_arr(csp_hist_index) $nextIndex
                } else {
                   set eval_window_arr(b_hist_index) $nextIndex
                }     
           } else {
                set eval_window_arr(input) ""
                if {$is_csp} {
                    set eval_window_arr(csp_hist_index) $len
                } else {
                   set eval_window_arr(b_hist_index) $len
                }
           }
       } elseif {$num == -1} {
           if {$is_csp} {
              set nextIndex [expr {$eval_window_arr(csp_hist_index) -1}]
           } else {
              set nextIndex [expr {$eval_window_arr(b_hist_index) -1}]
           }             
           if {$nextIndex >= 0} {
                set eval_window_arr(input) [lindex $listHistory $nextIndex]
                if {$is_csp} {
                    set eval_window_arr(csp_hist_index) $nextIndex
                } else {
                   set eval_window_arr(b_hist_index) $nextIndex
                }
           } elseif {[llength $listHistory]>0} {
                set eval_window_arr(input) [lindex $listHistory 0]
                if {$is_csp} {
                    set eval_window_arr(csp_hist_index) 0
                } else {
                   set eval_window_arr(b_hist_index) 0
                }
           } else {
                set eval_window_arr(input) ""
           }
       }
   }
}

proc Dialog_Dismiss {top} {
	global dialog
	# Save current size and position
	catch {
		# window may have been deleted
		set dialog(geo,$top) [wm geometry $top]
		wm withdraw $top
	}
}

proc procEvalCurrentInput {} {
    global eval_window_arr
    set widget .eval.frmSource.text
    $widget configure -state normal
    $widget insert end ">>>> $eval_window_arr(input)\n"
    set EevalInput [escapeChars $eval_window_arr(input)]
    prolog tcltk_eval('$EevalInput',Res,EnumWarning)
    $widget insert end "  $prolog_variables(Res)\n"
    if {$prolog_variables(EnumWarning) == "true"} {
        $widget insert end "#### Warning: infinite types were enumerated\n"
    }
    if [prolog get_all_errors(ERes)] {
        set PResult [split [string trimright $prolog_variables(ERes) {;}] \;]
        $widget insert end "ERRORS:\n$PResult\n"
        prolog reset_errors
    }
    procDoSyntaxColouring $widget
    $widget see end
    $widget configure -state disabled
}

proc procEvalConsoleCurrentInput {} {
    global eval_window_arr
    if {$eval_window_arr(input) != ""} {
       set widget .eval.frmSource.text
       $widget configure -state normal
       set EevalInput [escapeChars $eval_window_arr(input)]
       regexp {([0-9]+)\.([0-9]+)} [$widget index insert] match line col
       $widget delete $line.5 $line.end
       $widget insert $line.5 $eval_window_arr(input)
       set eval_window_arr(input_index) [$widget index end]
       regexp {([0-9]+)\.[0-9]+} $eval_window_arr(input_index) match line
       prolog "tcltk_eval(\'$EevalInput\',Res,EnumWarning,Solution)"
       procWrapEvalOutput $widget $prolog_variables(Res)
       if {$prolog_variables(EnumWarning) == "true"} {
           $widget insert [$widget index insert] "#### Warning: infinite types were enumerated\n"
       }
       if [prolog get_all_errors(ERes)] {
           # set PResult [split [string trimright $prolog_variables(ERes) {;}] \;]
           set PResult [string map {";" "\n"} $prolog_variables(ERes)]
           $widget insert end "\nERRORS:\n$PResult\n"
           prolog reset_errors
       }
       if {$prolog_variables(Solution) != ""} {
           procWrapEvalOutput $widget $prolog_variables(Solution)
       }
       $widget see end
       incr line -2
       procAddNewEnterLine
       $widget highlight $line.0 end
    } else {
       procAddNewEnterLine
    }
}

proc procGetCurrentTextWidgetWidth {widget} {
    return [expr {([winfo width $widget] -2*[$widget cget -borderwidth] -4)\
                                  /[font measure [$widget cget -font] 0]}]
}

proc procGetCurrentTextWidgetHeight {widget} {
    return [expr {(([winfo height $widget] -2*[$widget cget -borderwidth] -4)\
                                  /[font measure [$widget cget -font] 0] -2)/2}]
}

proc procChangeEvalWidnowsTitle {widget twidget} {
    set width [procGetCurrentTextWidgetWidth $twidget]
    set height [procGetCurrentTextWidgetHeight $twidget]
    set title [join [list "Eval - $width" "$height"] x]
    wm title $widget $title
}


proc procWrapEvalOutput {widget output} {
    set strlen [string length $output]
    set FirstInsertIndex [$widget index insert]
    regexp {([0-9]+)\.[0-9]+} [$widget index insert] index line
    set firstn [string first "\n" [string trim $output "\n"]]
    # prolog "tools:print_message('check firstn=$firstn, strlen=$strlen')"
    if {$firstn < 1 || $strlen > 1000 } {
	# we want to wrap only long outputs consisting of one line only 
		set width [expr {[procGetCurrentTextWidgetWidth $widget] -2}]
		set height [procGetCurrentTextWidgetHeight $widget]
		set lines [procReturnFloatBase [expr {$strlen/$width}]]
		set remstr [expr {$strlen % $width}]
		if {$remstr > 0} {incr lines}
		set i 0; set j 0
		set k [expr { $width -2 }]
		incr line 1
		while {$i < $lines} {
			  $widget insert $index "\n  "
			  $widget insert $line.2 [string range $output $j $k]
			  set j $k ; set k [expr {$k + $width -1}] ;# step interval
			  set index $line.end
			  incr i; incr j; incr line
		}
		$widget see $index
		set LastInsertIndex [$widget index insert]
		$widget insert $LastInsertIndex "\n  "
		$widget highlight $FirstInsertIndex $LastInsertIndex
    } else {
		$widget insert $index "\n\n$output\n"
		$widget highlight $FirstInsertIndex [$widget index insert]
    }
}

proc procReturnFloatBase {float} {
    return [lindex [split $float \.] 0]
}

proc procShowText {Result Msg1} {
    procShowText4 $Result $Msg1 none none
}

proc procShowText4 {Result Msg1 ExtraButtonName ExtraButtonCmd} {
    global ok
	destroy .invariant
	# destroy added for Mac TclTk
    set f .invariant
	if [Dialog_Create $f $Msg1 -borderwidth 10] {
		#message $f.msg -text $Msg2 -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.text xview" -orient h
        text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
         -setgrid 1 -height 18 -state disabled
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		button $b.save -text "Save..." -command {set ok 3}
		pack $b.save -side left
		if {$ExtraButtonName!="none"} {
		  button $b.extra -text "$ExtraButtonName" -command {set ok 4}
		  pack $b.extra -side left
		}
		button $b.ok -text Done -command {set ok 1}
		pack $b.ok -side right

		bind $f.frmSource <Return> {set ok 1 ; break}
		bind $f.frmSource <Control-c> {set ok 1 ; break}
	}


    procShowSourceCodeFromCodes $f.frmSource.text $Result
    $f.frmSource.text configure -state normal

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	
	if {$ok==3} {
	    set types {
	        {"Text File" {.txt} }
			{"All files"		*}
		}
	    set DEBUGFILE [tk_getSaveFile -filetypes $types -initialfile "ProB_Output.txt" -parent . -defaultextension "txt"]
		if {$DEBUGFILE != ""} { 
		    puts "Opening File: $DEBUGFILE"
		   set channel [open "$DEBUGFILE" "w+"]
			foreach i $Result {
			   puts -nonewline $channel [format %c $i]
			}
		   close $channel
       }
	} elseif {$ok==4} {
	   eval $ExtraButtonCmd
	   procShowErrors
	}
	
	Dialog_Dismiss $f
}

proc procShowLogFile {sFileName Msg1 Msg2} {
    global ok
	destroy .invariant
	# destroy added for Mac TclTk
    set f .invariant
	if [Dialog_Create $f $Msg1 -borderwidth 10] {
		message $f.msg -text $Msg2 -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.text xview" -orient h
        text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" -xscroll "$f.frmSource.scrollx set" \
         -setgrid 1 -height 18 -state disabled
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
		pack $f.msg $f.frmSource $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		button $b.ok -text Done -command {set ok 1}
		pack $b.ok -side right

		bind $f.frmSource <Return> {set ok 1 ; break}
		bind $f.frmSource <Control-c> {set ok 1 ; break}
	}


    $f.frmSource.text configure -state normal
    $f.frmSource.text delete 0.0 end

    set fid [open $sFileName r]
    $f.frmSource.text insert 0.0 [read $fid]
    close $fid
    # $f.frmSource.text configure -state disabled

    set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
}

proc procAbsInt {} {
   if [prolog animation_mode(b)] {
       prolog popup(X)
       set res $prolog_variables(X)
       procShowList $res "test1" "test2" 
   } else {
       tkErrorBoxNoParent "Can only be applied to B specifications."
   }
}
proc procShowAllSpecializedInvariants {} {
   if [prolog animation_mode(b)] {
	   prolog bmachine:tcltk_get_specialized_invariants_for_ops(X)
	   set res $prolog_variables(X)
	   procShowList2 $res "Specialized Invariants" "Specialized Invariants" 1 0 "SpecializedInvariants.mch"
   } else {
       tkErrorBoxNoParent "Can only be applied to B specifications."
   }
}
proc procShowSpecializedInvariants {} {
   if [prolog animation_mode(b)] {
	   global OpName
	   set OpName [procChooseOperation]
	   if {$OpName != ""} {
		   prolog bmachine:tcltk_get_specialized_invariant_for_op($OpName,X)
		   set res $prolog_variables(X)
		   procShowList2 $res "Specialized Invariant" "Specialized Invariant" 1 0 "SpecializedInvariant.mch"
       }
   } else {
       tkErrorBoxNoParent "Can only be applied to B specifications."
   }
}


proc procVisualizeSliceGraph {slicetype} {
  global app_dir
  set rootName "$app_dir/src/cia/$slicetype"
  # we should change the location of those files and generate them on demand, as for visited states
  append dotName $rootName ".dot"
  append psName $rootName ".ps"
  procVisualiseDotFile $dotName $psName
}

proc procSliceProgramPoint {} {
    global strFilename
    if [prolog animation_mode(cspm)] {
           procRemoveHighlightSlice
           procRemoveHighlightSliceCEB
	   set cursel [.main.frmSource.text tag ranges sel] 
	   puts "Selection: $cursel"
	   if {[llength $cursel]==2} {
		  set from [lindex $cursel 0]
		  set to [lindex $cursel end]
		  set fl [split [lindex $cursel 0] {.}]
		  set from_line [lindex $fl 0]
		  set from_col [lindex $fl end]
		  set tl [split [lindex $cursel end] {.}]
		  set to_line [lindex $tl 0]
		  set to_col [lindex $tl end]
		  if [prolog slicer_csp:slice_from_program_point($from_line,$from_col,$to_line,$to_col,'$strFilename',X,Y,XE,YE,XCEB,YCEB,XECEB,YECEB,Reachable)] {
                  set LineCEB $prolog_variables(XCEB)
                  set ColCEB $prolog_variables(YCEB)
                  set EndLineCEB $prolog_variables(XECEB)
                  set EndColCEB $prolog_variables(YECEB)
                  set iNbElemCEB [llength $LineCEB]
		  set Line $prolog_variables(X)
                  set Col $prolog_variables(Y)
                  set EndLine $prolog_variables(XE)
                  set EndCol $prolog_variables(YE)
                  set iNbElem [llength $Line]
                  set ReachableTCL $prolog_variables(Reachable)
                  if {$ReachableTCL == false} {tkMessageBox "Selected symbol is not reachable."} 
                  #else {
	                  for {set iCEB 0} {$iCEB < $iNbElemCEB} {incr iCEB} {
	               		procHighlightSliceCEB [lindex $LineCEB $iCEB] [lindex $ColCEB $iCEB] [lindex $EndLineCEB $iCEB] [lindex $EndColCEB $iCEB]
	            	  }
	                  for {set i 0} {$i < $iNbElem} {incr i} {
	               		procHighlightSlice [lindex $Line $i] [lindex $Col $i] [lindex $EndLine $i] [lindex $EndCol $i]
	            	  }
                  #}
                  # procHighlightSlice $Line $Col $EndLine $EndCol
          }
		  procShowErrors
	   } else {
		   tkMessageBox "Please first select an event inside a CSP Process inside the source text."
	   }
   } else {
       tkErrorBox "This command can only be used in CSPM mode."
   }
}

proc procSliceExecutableMEB {} {
    global strFilename
    if [prolog animation_mode(cspm)] {
	   set cursel [.main.frmSource.text tag ranges sel] 
	   puts "Selection: $cursel"
	   if {[llength $cursel]==2} {
		  set from [lindex $cursel 0]
		  set to [lindex $cursel end]
		  set fl [split [lindex $cursel 0] {.}]
		  set from_line [lindex $fl 0]
		  set from_col [lindex $fl end]
		  set tl [split [lindex $cursel end] {.}]
		  set to_line [lindex $tl 0]
		  set to_col [lindex $tl end]
		  if [prolog slicer_csp:slice_from_program_point_executableMEB($from_line,$from_col,$to_line,$to_col,'$strFilename',NewF)] {
			  procShowErrors
			  procExecutePathPrefOnFile path_to_text_editor emacs {External Text Editor} Advanced $prolog_variables(NewF)
          } else {
		      tkErrorBox "Internal error: Slicing failed"
              procShowErrors
          }
		  
	   } else {
		   tkMessageBox "Please first select an event inside a CSP Process inside the source text."
	   }
   } else {
       tkErrorBox "This command can only be used in CSPM mode."
   }
}

proc procSliceExecutableCEB {} {
    global strFilename
    if [prolog animation_mode(cspm)] {
	   set cursel [.main.frmSource.text tag ranges sel] 
	   puts "Selection: $cursel"
	   if {[llength $cursel]==2} {
		  set from [lindex $cursel 0]
		  set to [lindex $cursel end]
		  set fl [split [lindex $cursel 0] {.}]
		  set from_line [lindex $fl 0]
		  set from_col [lindex $fl end]
		  set tl [split [lindex $cursel end] {.}]
		  set to_line [lindex $tl 0]
		  set to_col [lindex $tl end]
		  if [prolog slicer_csp:slice_from_program_point_executableCEB($from_line,$from_col,$to_line,$to_col,'$strFilename',NewF)] {
			  procShowErrors
			  procExecutePathPrefOnFile path_to_text_editor emacs {External Text Editor} Advanced $prolog_variables(NewF)
		  } else {
		      tkErrorBox "Internal error: Slicing failed"
		      procShowErrors
		  }
	   } else {
		   tkMessageBox "Please first select an event inside a CSP Process inside the source text."
	   }
   } else {
       tkErrorBox "This command can only be used in CSPM mode."
   }
}





# -------
# procedure to search for invariant violations using open search
# -------
global last_queue_size last_ms
proc initInfos {f} {
   global last_queue_size last_ms
   set last_ms -1
   set last_queue_size -1
   updateInfos $f
}
proc updateInfos {f} {
    prolog get_state_space_stats(DistinctStates,T,Processed)
	set ds [expr $prolog_variables(DistinctStates)-1]
	set ps [expr $prolog_variables(Processed)-1]
	if {$ps > 0} {
	    set perc [expr (100*$ps)/$ds]
        $f.infos.f0.cstates configure -text "$prolog_variables(Processed) ($perc %)"
    } else {
        $f.infos.f0.cstates configure -text "$prolog_variables(Processed)"
    }
    $f.infos.f1.states configure -text "$prolog_variables(DistinctStates)"
    $f.infos.f2.transitions configure -text "$prolog_variables(T)"   
	global expert_user tcl_version
	if {$tcl_version >= 8.5} {
		$f.pb1 configure -maximum $ds
		$f.pb1 configure -value $ps 
        update idletasks
        
		global last_queue_size last_ms
		set clock_ms [clock milliseconds]
		set delta [expr $clock_ms - $last_ms]
		if {$delta > 5000} {
			set queue_size [expr $ds-$ps]
			if {$last_ms > 0 && $queue_size < $last_queue_size} {
			   set estimated_time [expr ($delta * $queue_size) / (1000*($last_queue_size - $queue_size))]
			   puts "Estimated time to completion: $estimated_time seconds (Queue Size: $queue_size)"
			} elseif {$last_ms > 0} {
			   puts "Queue size is increasing: $queue_size"
			}
			set last_queue_size $queue_size
			set last_ms $clock_ms
		}
    }
}

proc procModelCheck {} {
	global mc_prompt Depth count done
	destroy .search
	global expert_user
	# destroy re-added for Mac TclTk
	set f .search
    global mcPerformBreadthFirst mcFindDeadlocks mcFindInvViolations mcSearchForNewErrors
	global mcFindAssViolations mcFindGOAL mcStopWhenFullCoverage mcPartialOrderReduction
	if [Dialog_Create $f "Model Check:" -borderwidth 10] {
		# message $f.msg -text "Enter max. nr of nodes to check:" -aspect 1000
		# entry $f.entry -textvariable mc_prompt(result)
		label $f.msg2 -text "Waiting"
		set b [frame $f.buttons]
		set op [frame $f.options]
		set infos [frame $f.infos]
		# pack $f.msg $f.entry $f.buttons $f.options $f.msg2 $f.progress -side top -fill x
		pack $b $op $infos $f.msg2 -side top -fill x
        global expert_user
		# pack $f.entry -pady 5
		set infos0 [frame $infos.f0]
		set infos1 [frame $infos.f1]
		set infos2 [frame $infos.f2]
        label $infos0.l0 -text "Checked States: "
        label $infos0.cstates -text "-"
        label $infos1.l1 -text "Total Distinct States: "
        label $infos1.states -text "-"
        label $infos2.l2 -text "Total Transitions: "
        label $infos2.transitions -text "-"
        pack $infos0 $infos1 $infos2 -side top
        pack $infos0.l0 $infos0.cstates -side left
        pack $infos1.l1 $infos1.states -side left
        pack $infos2.l2 $infos2.transitions -side left
        global tcl_version
        if {$tcl_version >= 8.5} {
          ttk::progressbar $f.pb1 -orient horizontal -mode determinate -maximum 100 -length 200
          pack $f.pb1 -side top
        }
        initInfos $f
        
		button $b.ok -text "Model Check" -command {set mc_prompt(ok) 1}
		button $b.cancel -text Cancel -command {set mc_prompt(ok) 0}
		pack $b.ok -side left
		pack $b.cancel -side right
		bind $f <Return> {set mc_prompt(ok) 1 ; break}
		bind $f <Control-c> {set mc_prompt(ok) 0 ; break}
		
		# set bfop [frame $op.bf -borderwidth .3c -relief flat]
		# label $bfop.lbl -text "Search:"
		# radiobutton $bfop.bf0 -text "Mixed" -variable mcPerformBreadthFirst  -value 0
		# radiobutton $bfop.bf1 -text "Breadth" -variable mcPerformBreadthFirst  -value 1
		# radiobutton $bfop.bf2 -text "Depth" -variable mcPerformBreadthFirst  -value 2
		# pack $bfop -side top
		# pack $bfop.lbl $bfop.bf0 $bfop.bf1 $bfop.bf2 -side left
		
		menubutton $op.bfmenu -text "Search Strategy" -menu $op.bfmenu.m -relief raised -borderwidth .1c
		pack $op.bfmenu -side top
		menu $op.bfmenu.m -tearoff 0
		prolog tcltk_dbf_modes(DBFNAMES)
		for {set i 0} {$i < [llength $prolog_variables(DBFNAMES)]} {incr i 1} {
				set NM [lindex $prolog_variables(DBFNAMES) $i];
				$op.bfmenu.m add radiobutton -label $NM  -variable mcPerformBreadthFirst -value $i
				# puts "Mode $NM  -- value $i"
			}
	       
		#checkbutton $op.bf -text "Breadth First" -variable mcPerformBreadthFirst -offvalue 0 -onvalue 1
		checkbutton $op.deadlocks -text "Find Deadlocks" -variable mcFindDeadlocks
		checkbutton $op.invariants -text "Find Invariant Violations" -variable mcFindInvViolations
		if {$expert_user == 1} {
			checkbutton $op.reduction -text "Partial Order Reduction" -variable mcPartialOrderReduction
		}
		
        global curFileTypeOpened cspstrFilename
		if {[prolog bmachine:b_get_machine_goal(_)]} {
		   checkbutton $op.findGOAL -text "Find Defined GOAL" -variable mcFindGOAL
		} elseif {$curFileTypeOpened == "CSP" || $cspstrFilename != ""} {
		   checkbutton $op.findGOAL -text "Find Event on \"goal\" CSP Channel" -variable mcFindGOAL
		} else {
		   checkbutton $op.findGOAL -text "Find GOAL (from DEFINITIONS)" -variable mcFindGOAL -state disabled
		}
		set mcFindAssViolations 0
		set ASS [AssertionName]
	    if [prolog tcltk_machine_has_assertions] {
            set assertionState normal
        } else {
            set assertionState disabled
        }
        checkbutton $op.assertions -text "Find B $ASS Violations" -variable mcFindAssViolations -state $assertionState
		
	    if {[prolog operation_name_not_yet_covered(_)]} {
		     checkbutton $op.stopcoverage -text "Stop when All Operations Covered" -variable mcStopWhenFullCoverage
		} else {
		     set mcStopWhenFullCoverage 0
		     checkbutton $op.stopcoverage -text "Stop when All Operations Covered" -variable mcStopWhenFullCoverage -state disabled
		}
		if {![prolog tcltk_exists_an_open_node]} {
		   set mcSearchForNewErrors 0
		}
		checkbutton $op.already -text "Search for New Errors" -variable mcSearchForNewErrors
		if {$expert_user == 1} {
			pack $op.deadlocks $op.invariants $op.assertions $op.findGOAL $op.stopcoverage $op.already $op.reduction -side top -fill x
		} else {
			pack $op.deadlocks $op.invariants $op.assertions $op.findGOAL $op.stopcoverage $op.already -side top -fill x
		}
	} else {
	    wm title $f "Model Check:"
	    # $f.msg configure -text "Enter max. nr of nodes to check:" -aspect 1000
	    set b $f.buttons
	}
    $f.msg2 configure -text ""
    global batch_mode
    set done 0
    set mc_prompt(ok) 0
    $b.ok configure -text "Model Check"
    $b.ok configure -state normal

    Dialog_Wait_Prepare $f mc_prompt(ok) $f.buttons

    while {$done != 1} {
	  $b.ok configure -state normal
	  
      if {$batch_mode} {
        set mc_prompt(ok) 1
      } else {
        set mc_prompt(ok) 0
        tkwait variable mc_prompt(ok)
      }

	  # .search.progress start 50
	  global doInspectExistingNodes
	  if {!$mcSearchForNewErrors} {
	     set doInspectExistingNodes 1
	  } elseif [prolog tcltk_state_space_only_has_root_node] {
	     set doInspectExistingNodes 1
	     # in this case: force looking at the root node for state errors
	  } else {
	     set doInspectExistingNodes 0
	  }
	  if {$mc_prompt(ok) && $doInspectExistingNodes} {
		    # puts "Searching existing nodes"
		    if [prolog tcltk_search_among_existing_nodes(ErrRes,$mcFindDeadlocks,$mcFindInvViolations,$mcFindGOAL,$mcFindAssViolations)] {
				# puts "finished"
				set Result $prolog_variables(ErrRes)
				if {$Result == "all"} {
				  $f.msg2 configure -text "No error among existing nodes"
				  set done 0
				} else {
					if {$Result == "goal_found"} {
					   tkMessageBoxNoParent "Existing state satisfying GOAL predicate was found."
					} else {
					   tkErrorBoxNoParent "Error state was found for existing node:  $Result"
					}
					procInsertHistoryOptionsState
					set done 1
				}
	        } else {
			  $f.msg2 configure -text "Internal error occurred"
			  set done 0
	          tkErrorBox "error occurred !!"
	        }
	    }
	   # .search.progress stop 
	    if {$mc_prompt(ok) && ($done != 1)} {
		  # puts "Searching new nodes"
		  # set Depth $mc_prompt(result)
		  prolog tcltk_set_dbf_mode($mcPerformBreadthFirst)
		  $f.msg2 configure -text "Checking... "
		  set mc_prompt(ok) 1
		  set count 0
		  set done 0
		  $b.ok configure -state disabled
		  global stepval
		  prologmnf animation_mode(MODE)
		  set curMode $prolog_variables(MODE)
		  if {$curMode == "cspm" || $curMode == "csp" || $curMode == "xtl"} {
		      set stepval 1000
		  } else {
		      set stepval 100
		  }
		  search_loop

		  if {!($done)} {
		    tkwait variable done
		  }
	     } else {
	       set done 1
	     }
	}
	Dialog_Wait_Finish $f
	Dialog_Dismiss $f
	procShowErrors
}

proc search_loop {} {
	global mc_prompt
	global count done stepval found_or_all_visited
	global mcFindDeadlocks mcFindInvViolations mcSearchForNewErrors doInspectExistingNodes mcFindGOAL mcFindAssViolations
	global searchResult
    
    set sst "Total time for model checking step: [time {search_step} 1]"
    prolog "statistics(memory_used,MEM)"
    set MB [expr $prolog_variables(MEM)/1048576]
	prolog "tools:print_message('$sst (used memory: $MB MBytes)')"
    updateInfos .search
     if {$found_or_all_visited} {
        if {$searchResult == "all"} {
            if [prolog tcltk_find_max_reached_node(_)] {
              set msg "\nNote: not all transitions were computed (increase the max. number of enablings and initialisations shown)."
            } else {
              set msg ""
            }
			if [prolog state_space:operation_name_not_yet_covered(R)] {
				  set msg "\nNote: some operations are not covered (e.g., $prolog_variables(R)).$msg"
			}
			if [prolog model_checker:proof_info_model_checking_incomplete($mcFindInvViolations,$mcFindDeadlocks,$mcFindGOAL,$mcFindAssViolations,Msg)] {
				  set msg "\nNote: Using PROOF information is potentially incomplete when [AssertionName] violation checking is turned off.$msg"
			}
			if [prolog tcltk_hash_model_checking_imprecise] {
				  set msg "\nNote: Hash markers could be imprecise for this machine.$msg"
			} 
			append msg [getUnboundedWarnings]
            if {$doInspectExistingNodes} {
                  tkMessageBoxNoParent "No error state found, ALL nodes visited.$msg"
            } else {
                  if [prolog state_error_exists] {
                     set msg "\nNote: some existing nodes do contain errors.\nRe-run the model checker (with changed options) and inspect existing nodes.$msg"
                  } 
                  tkMessageBoxNoParent "No error state found, all NEW nodes visited.$msg"
              }
            } else {
				if {$searchResult == "goal_found"} {
				   tkMessageBoxNoParent "State satisfying GOAL predicate was found."
			   } elseif {$searchResult == "full_coverage"} {
				   tkMessageBoxNoParent "All operations are now covered by at least one transition.\nUse Compute Coverage to obtain more details."
				} else {
				   tkErrorBoxNoParent "Error state was found for new node:  $searchResult"
				}
				procInsertHistoryOptionsState
	        }
     } else {
      # puts "finished search_loop"
        if {!($done)} {
         set done 2
         if {$mc_prompt(ok)} {
         .search.msg2 configure -text "No error so far, $count nodes visited"
         } else {
        .search.msg2 configure -text "User stopped after $count"
         }
      }}
      return

}


proc search_step {} {
	global mc_prompt
	global count done stepval found_or_all_visited
	global mcFindDeadlocks mcFindInvViolations mcSearchForNewErrors mcFindGOAL
	global mcFindAssViolations mcStopWhenFullCoverage mcPartialOrderReduction
	global searchResult

	set found_or_all_visited 0
	.search.buttons.cancel configure -text "Stop"
    while {($mc_prompt(ok)) && (!$found_or_all_visited)} {
      #.search.msg2 configure -text "Checking... $count"
      updateInfos .search
      # .search.progress step $stepval
      update
      set count [expr $count+$stepval]
      # puts $count
      
      prolog tcltk_model_check($stepval,ErrRes,$mcFindDeadlocks,$mcFindInvViolations,$mcFindGOAL,$mcFindAssViolations,$mcStopWhenFullCoverage,$mcPartialOrderReduction,500,_)
      
       set searchResult $prolog_variables(ErrRes)
       set ll [llength $searchResult]
       
       if {$ll==2} {
          # timeout occured
          set count [expr $count-$stepval+[lindex $searchResult end]]
       } elseif {$searchResult != "no"} {
	        # force exit of loop
	        set found_or_all_visited 1
	        set done 1
            updateInfos .search
            .search.msg2 configure -text "Checking Finished"
	   }
    }
	.search.buttons.cancel configure -text "Cancel"
}



proc Dialog_Wait_Prepare {top varName {focus {}}} {
	upvar $varName var

	# Poke the variable if the user nukes the window
	bind $top <Destroy> [list set $varName $var]

	# Grab focus for the dialog
	if {[string length $focus] == 0} {
		set focus $top
	}
    global dw_old
	set dw_old [focus -displayof $top]
	focus $focus
	catch {tkwait visibility $top}
	catch {grab $top}
}

proc Dialog_Wait_Finish {top} {
    global dw_old
	catch {grab release $top}
	focus $dw_old
}

# -------

proc procCBCTestcases {} {
    global prompt
    global mc_prompt
    set finished 0
    prologmnf sap:tcl_get_events_preselected(Events,Presel)
    set prompt(sap_max_depth) 5
    set prompt(sap_eventsel) $prolog_variables(Presel)
    if { [catch {set $prompt(sap_filename)}] } {set prompt(sap_filename) "cbc_testcases.xml"}
    while {!$finished} {
        set chosen [SAPDialog $prolog_variables(Events) 0]
        if {[llength $chosen] > 0} {
            set clist [join $chosen ","]
            set target [escapeChars $prompt(sap_target_predicate)]
            set maxdepth $prompt(sap_max_depth)
            set filename [escapeChars $prompt(sap_filename)]
            if [string is integer -strict $maxdepth] {
                if [prolog sap:tcl_generate_cb_testcases(\[$clist\],'$target',$maxdepth,'$filename',Uncovered)] {
                    procShowErrors
                    set uncovered $prolog_variables(Uncovered)
                    if {[llength $uncovered] == 0} {
                        tkMessageBox "Generated test cases for all events."
                    } else {
                        tkMessageBox "Generated test cases, uncovered events: $uncovered"
                    }
                    set finished 1
                } else {
                    procShowErrors
                    tkMessageBox "Generating test cases failed."
                }
            } else {
                tkMessageBox "maximum depth is not a number"
            }
        } else {
            # tkMessageBox "No events selected."
            set finished 1
        }
    }
}

proc procSAPTestcases {} {
    global prompt
    global mc_prompt
    set finished 0
    prologmnf sap:tcl_get_events_preselected(Events,Presel)
    set prompt(sap_max_depth) 10
    set prompt(sap_eventsel) $prolog_variables(Presel)
    if { [catch {set $prompt(sap_filename)}] } {set prompt(sap_filename) "sap_testcases.xml"}
    while {!$finished} {
	set chosen [SAPDialog $prolog_variables(Events) 1]
	if {[llength $chosen] > 0} {
	    set clist [join $chosen ","]
	    set target [escapeChars $prompt(sap_target_predicate)]
	    set maxdepth $prompt(sap_max_depth)
	    set maxnodes $mc_prompt(result)
	    set filename [escapeChars $prompt(sap_filename)]
	    if [string is integer -strict $maxdepth] {
		if [string is integer -strict $maxnodes] {
		    if [prolog sap:tcl_generate_testcases(\[$clist\],'$target',$maxdepth,$maxnodes,'$filename',NumberOfTestcases)] {
			procShowErrors
			set numberTC $prolog_variables(NumberOfTestcases)
			tkMessageBox "Generated $numberTC test cases."
			set finished 1
		    } else {
			procShowErrors
			tkMessageBox "Generating test cases failed."
		    }
		} else {
		    tkMessageBox "maximum number of nodes is not a number"
		}
	    } else {
		tkMessageBox "maximum depth is not a number"
	    }
	} else {
	    set finished 1
	}
    }
}
proc SAPDialog {events prompt_for_new_states} {
    global prompt
    global mc_prompt
    set result [list]
    destroy .sap
    if [Dialog_Create .sap "SAP test case generation" -borderwidth 10] {
        message .sap.filemsg -aspect 1000 \
            -text "file for saving test cases:"
        frame .sap.file
        entry .sap.file.filename -textvariable prompt(sap_filename)
        button .sap.file.browse -text Browse -command {SAPFile}
        pack .sap.file.filename .sap.file.browse -side left

        message .sap.predmsg -aspect 1000 \
            -text "predicate to identify target states:"
        entry .sap.pred -textvariable prompt(sap_target_predicate)
        message .sap.eventmsg -aspect 1000 \
            -text "please select events that should be covered:"
        frame .sap.events -borderwidth .1c -relief groove
        scrollbar .sap.events.scrolly -command ".sap.events.list yview"
        listbox .sap.events.list -selectmode multiple -yscroll ".sap.events.scrolly set" -height 10 -setgrid 1
        pack .sap.events.scrolly -side right -fill y
        pack .sap.events.list -expand 1 -fill both
        foreach e $events {
            .sap.events.list insert end $e
        }
        .sap.events.list selection clear 0
        foreach i $prompt(sap_eventsel) {
            .sap.events.list selection set $i
        }
        message .sap.maxmsg -aspect 1000 \
            -text "maximum search depth:"
        entry .sap.max -textvariable prompt(sap_max_depth)
        if $prompt_for_new_states {
            message .sap.maxnodemsg -aspect 1000 \
                -text "maximum number of new states:"
            entry .sap.maxnodes -textvariable mc_prompt(result)
        }

        frame .sap.selbuttons
        button .sap.selbuttons.selall -text "Select all" -command {.sap.events.list selection set 0 end}
        button .sap.selbuttons.selnone -text "Deselect all" -command {.sap.events.list selection clear 0 end}
        pack .sap.selbuttons.selall .sap.selbuttons.selnone -side left
	
        frame .sap.buttons
        button .sap.buttons.ok -text OK -command {if {[llength [.sap.events.list curselection]] < 1} {tk_messageBox -message "No events selected." -parent .sap -icon warning} else {set prompt(ok) 1}}
        button .sap.buttons.cancel -text Cancel -command {set prompt(ok) 0}
        pack .sap.buttons.ok -side right
        pack .sap.buttons.cancel -side right

        if $prompt_for_new_states {
            pack .sap.file .sap.predmsg .sap.pred .sap.eventmsg .sap.events .sap.selbuttons .sap.maxmsg .sap.max \
                .sap.maxnodemsg .sap.maxnodes .sap.buttons -fill x -fill y
        } else {
            pack .sap.file .sap.predmsg .sap.pred .sap.eventmsg .sap.events .sap.selbuttons .sap.maxmsg .sap.max \
                .sap.buttons -fill x -fill y
        }
        set prompt(ok) 0
        Dialog_Wait .sap prompt(ok) .sap.events.list
        Dialog_Dismiss .sap

        if {$prompt(ok)} {
            set result [.sap.events.list curselection]
        }
    }
    return $result
}
proc SAPFile {} {
    global prompt
    set types {
	{"XML Files" {.xml} }
    }
    set prompt(sap_filename) [tk_getSaveFile -filetypes $types -initialfile $prompt(sap_filename) -parent . -defaultextension "xml"]
}

proc procSAPLocal {} {
    global prompt
    global mc_prompt
    set prompt(sap_global) ""
    set prompt(sap_local) ""
    if {[SAPlocalDialog]} {
	set lfile [escapeChars $prompt(sap_local)]
	set gfile [escapeChars $prompt(sap_global)]
	if [prolog sap:tcl_create_local_testsuite('$gfile','$lfile',$mc_prompt(result),Sat,Unsat)] {
	    procShowErrors
	    set numsat $prolog_variables(Sat)
	    set numunsat $prolog_variables(Unsat)
	    if {$numunsat > 0} {
		set msg "Generated local traces for $numsat test cases, no traces found for $numunsat test cases."
	    } else {
		set msg "Generated local traces for all $numsat test cases."
	    }
	    tkMessageBox $msg
	} else {
	    procShowErrors
	    tkMessageBox "Generating test cases failed."
	}
    }
    
}
proc SAPlocalDialog {} {
    global prompt
    global mc_prompt
    set result 0
    destroy .saplocal
    if [Dialog_Create .saplocal "SAP local test case generation" -borderwidth 10] {

	message .saplocal.filemsg -aspect 1000 \
	    -text "file with global test cases"

	frame .saplocal.gfile
	entry .saplocal.gfile.filename -textvariable prompt(sap_global)
	button .saplocal.gfile.browse -text Browse -command {SAPGlobalFile}
	pack .saplocal.gfile.filename .saplocal.gfile.browse -side left

	message .saplocal.filemsl -aspect 1000 \
	    -text "file for local test cases"

	frame .saplocal.lfile
	entry .saplocal.lfile.filename -textvariable prompt(sap_local)
	button .saplocal.lfile.browse -text Browse -command {SAPLocalFile}
	pack .saplocal.lfile.filename .saplocal.lfile.browse -side left

	message .saplocal.maxnodemsg -aspect 1000 \
	    -text "maximum number of new states:"
	entry .saplocal.maxnodes -textvariable mc_prompt(result)
	
	frame .saplocal.buttons
	button .saplocal.buttons.ok -text OK -command {set prompt(ok) 1}
	button .saplocal.buttons.cancel -text Cancel -command {set prompt(ok) 0}
	pack .saplocal.buttons.ok -side right
	pack .saplocal.buttons.cancel -side right

	pack .saplocal.filemsg .saplocal.gfile .saplocal.filemsl .saplocal.lfile \
	    .saplocal.maxnodemsg .saplocal.maxnodes .saplocal.buttons -fill x

	set prompt(ok) 0
	Dialog_Wait .saplocal prompt(ok) .saplocal.gfile.filename
	Dialog_Dismiss .saplocal

	set result $prompt(ok)
    }
    return $result
}
proc SAPGlobalFile {} {
    global prompt
    set types {
	{"XML Files" {.xml} }
    }
    set prompt(sap_global) [tk_getOpenFile -filetypes $types -initialfile $prompt(sap_global) -parent .]
}
proc SAPLocalFile {} {
    global prompt
    set types {
	{"XML Files" {.xml} }
    }
    set prompt(sap_local) [tk_getSaveFile -filetypes $types -initialfile $prompt(sap_local) -parent . -defaultextension "xml"]
}

# -------

proc procShowInternalRep {} {
   if [prolog specfile:get_internal_representation(Res)] {
        set Result $prolog_variables(Res)
        procShowText $Result "Internal Representation"
   } else {
       tkErrorBox "Internal Error: Could not display internal representation."
   }
}

proc procPrintAsEventB {} {
   if [prolog bmachine:b_show_eventb_as_classicalb(Res,true)] {
        set Result $prolog_variables(Res)
        procShowText $Result "Event-B as Classical B"
   } else {
       tkErrorBox "Internal Error: Could not display B representation."
   }
}
    

proc procShowPropertiesAnalysis {} {
   if [prolog predicate_analysis:print_analysed_properties(Res)] {
        set Result $prolog_variables(Res)
        procShowText $Result "Predicate Analysis of the Properties"
   } else {
       tkErrorBox "Internal Error: Could not apply predicate analysis."
   }
}

proc procStartTesting {type} {
    global testing_mode logFile version testing_startTime
    set ProBDir [procGetEnviron2 'PROB_SOURCE_DIR' "~/svn_root/NewProB/src/"] 
    
    prologmnf preferences:backup_preferences
    prologmnf preferences:reset_for_benchmarking
    prologmnf preferences:deactivate_recent_documents
	set failed_tests ""
	set detailed_errors ""
    set testing_mode true
    set CURDATE [clock format [clock seconds] -format "%Y%m%d_%H"]
    puts "opening logfile $ProBDir/benchmark_history/$type$CURDATE.pl"
    set logFile [open "$ProBDir/benchmark_history/$type$CURDATE.pl" w 0600]
    puts $logFile "% ProB $version"
    set testing_startTime [clock clicks -milliseconds]
	global batch_mode
	if {!$batch_mode} {
		destroy .testinfo
		set f .testinfo
		CreateTextDialog $f "Regression Testing" "Regression Testing Progress" 0 0
		$f.frmSource.text configure -state normal
		$f.frmSource.text delete 0.0 end
		$f.frmSource.text configure -state disabled
	    Dialog_WaitVisible $f $f.frmSource
	}
}

proc procAddTestingEntry {Msg} {
	global batch_mode
	if {!$batch_mode} {
		set f .testinfo
		$f.frmSource.text configure -state normal
		$f.frmSource.text insert end "$Msg\n"
		$f.frmSource.text see end
		$f.frmSource.text configure -state disabled
	}
}
proc procEndTesting {} {
    global testing_mode logFile version failed_tests detailed_errors testing_endTime
    set testing_endTime [clock clicks -milliseconds]
    close $logFile
    set testing_mode false
    procShowErrors
    procShowFailedTests
    prologmnf preferences:revert_preferences
    prologmnf preferences:activate_recent_documents
}

proc procShowFailedTests {} {
   global testing_mode strFilename
   global failed_tests detailed_errors testing_endTime testing_startTime
   global batch_mode
   set testing_Time [expr $testing_endTime - $testing_startTime]
 destroy .testinfo
   if {$failed_tests==""} {
	    tkMessageBox "All tests were successful.\nDuration: $testing_Time milliseconds"
   } else {
       append failed_tests ";; Duration: $testing_Time milliseconds;; DETAILS:; $detailed_errors"
       #puts "Details: $detailed_errors"
	   set Result [split [string trimright $failed_tests {;}] \;]
	   if {$batch_mode} {
	       puts "Failed Tests:\n$Result\n"
	       prolog assert_cli_error_occured(failed_tests)
	   } else {
	       procShowList $Result "Failed Tests" "The following tests failed:"
	   }
	   set failed_tests ""
	   set detailed_errors ""
   }
}

proc procParseGoal {Goal} {
       set EGoal [escapeChars $Goal]
       set success [prolog b_set_machine_goal('$EGoal')]
       procShowErrors2 $Goal "Parsing Error Messages" "The following errors occurred during parsing:"
       return $success
}

proc HighlightSyntaxErrors {w} {
	while {[prolog get_error_span_linecol(Line,Col,EL,EC)]} {
		  procHighlightErrorSpan $w $prolog_variables(Line) $prolog_variables(Col) $prolog_variables(EL) $prolog_variables(EC)
	}
	prolog reset_errors
}
proc procHighlightErrorSpan {w sline scol eline ecol} {
		  procHighlightLineIn $w $sline
		  procUnderlineColumnFromToIn $w $sline $scol $eline $ecol
		  $w see $eline.0
}
proc procShowErrors {} {
   procShowErrors2 "" "Error Messages" "The following errors occurred:"
}
proc procShowErrors2 {ParseContext ErrorTitleMessage ErrorBodyMessage} {
   global testing_mode strFilename failed_tests detailed_errors
   if [prolog real_error_occurred] {
      set ERRWARN "error(s)"
   } else {
      set ERRWARN "warning(s)"
   }
   if [prolog get_all_errors(Res)] {
   # replace \n by newline ?!
    # regsub {\\n} $prolog_variables(Res) "\n" PRes 
    
	set PResult [split [string trimright $prolog_variables(Res) {;}] \;]
    if {$ParseContext==""} {
        HighlightSyntaxErrors .main.frmSource.text
        set Result $PResult
    } else {
        # Syntax errors do not relate to main machine but to a subsidiary goal: ParseContext
        set Result [concat [list $ParseContext] $PResult]
    }
    if {$testing_mode==true} {
       set errs [llength $Result]
       append failed_tests $strFilename ";  " $errs " $ERRWARN ;;"
       append detailed_errors $strFilename ";  " $prolog_variables(Res) ";;" 
       # procShowList2 $detailed_errors "Error Messages" "The following errors occured:" 0 1
    } else {
        global batch_mode
        if {$batch_mode} {
           puts "The following errors occurred:\n$Result\n"
	       prolog assert_cli_error_occured(procShowErrors)
        } else {
             procShowList2 $Result "$ErrorTitleMessage" "$ErrorBodyMessage" 0 1 "Errors.txt"
        }
    }
	prolog reset_errors
   }
}

proc procExpectErrors {n} {
   prologmnf count_errors_occured(_,NrErrs)
   if {$n==0} {
       procShowErrors
   } elseif [prologmnf get_all_errors(Res)] {
	   set err_len $prolog_variables(NrErrs)
       if {$err_len != $n} {
	        set Result [split [string trimright $prolog_variables(Res) {;}] \;]
            procShowList $Result "Error Messages" "Expected $n errors but got $err_len :"
       }
   } else {
       tkErrorBox "Expecting $n errors: none happened!"
   }
}

proc procReExecuteTraceToCurNode {} {
    if [prolog tcltk_slowly_execute_trace_to_current_node] {
       procInsertHistoryOptionsState
    } else {
       tkErrorBox "Internal Error: could not execute history."
    }
}

proc procJumpToAnOpenNode {} {
    if [prolog tcltk_goto_an_open_node] {
       procInsertHistoryOptionsState
    } else {
       tkMessageBox "No open node, ALL nodes have been visited."
    }
}

proc procJumpToAMaxReachedNode {} {
    if [prolog tcltk_goto_max_reached_node] {
       procInsertHistoryOptionsState
    } else {
       tkMessageBox "ALL transitions have been computed for all nodes so far."
    }
}


proc procJumpToNonResetableNode {} {
    if [prolog tcltk_goto_a_non_resetable_node] {
       procInsertHistoryOptionsState
    } else {
       procAllNodesMsg "resetable (can reach an initial state)"
    }
}

proc procJumpToNonDetNode {} {
    if [prolog tcltk_goto_a_non_deterministic_node] {
       procInsertHistoryOptionsState
    } else {
       procAllNodesMsg "deterministic  (i.e., the same operation always leads to the same resulting state)"
    }
}

proc procAllNodesMsg {NodeFeature} {
      if [prolog tcltk_exists_an_open_node] {
         tkMessageBox "All states visited so far are $NodeFeature.\nUse the model checking command to explore more states."
      } else {
         tkMessageBox "All states are $NodeFeature."
      }
}

proc procJumpToBranchingNode {} {
    if [prolog tcltk_goto_a_branching_node] {
       procInsertHistoryOptionsState
    } else {
       procAllNodesMsg "non-branching (i.e., only one operation is enabled)"
    }
}

# -------
# procedure to search for custom predicate 
# -------

proc procAdvancedFind {} {
   if [EnterGOALFormula] {
	   prolog tcltk_search_among_existing_nodes(ErrRes,0,0,1,0)
	   procShowErrors
	   if {$prolog_variables(ErrRes) == "goal_found"} {
		   tkMessageBox "State satisfying your GOAL formula was found."
		   procInsertHistoryOptionsState
	   } else {
		   if [prolog tcltk_exists_an_open_node] {
		   tkMessageBox "No node visited so far satisfies your GOAL formula.
You can explore more (unvisited) nodes by using Temporal Model Check and ticking the 'Find defined GOAL' box."
		   } else {
		   tkMessageBox "No node satisfies your GOAL formula."
		   }
	   }
   }
}

proc EnterGOALFormula {} {
   EnterGOALFormulaWithCheckBtn ""
}
proc EnterGOALFormulaWithCheckBtn {CheckBtn1} {
   global Goal
   set Goal [Dialog_Promptww "Enter GOAL Formula (use B syntax):" 70 $CheckBtn1]
   if {$Goal != ""} {
       return [procParseGoal $Goal]
   } else {
      return 0
   }
}

proc procFindEnabledOp {} {
   global OpName FromCurrent
   set OpName [procChooseOperation2 "yes" "Search from Current State" "FromCurrent" "operation_name_covered"]
   if {$OpName != ""} {
      if [prolog tcltk_goto_state_enabling_operation('$OpName',$FromCurrent)] {
           procInsertHistoryOptionsState
      } else {
		  if [prolog tcltk_exists_an_open_node] {
		     if {$FromCurrent} {
			    tkMessageBox "No node visited so far and reachable from the current state enables '$OpName'.\nUse the 'Model Check' command to explore more nodes."
			 } else {
			    tkMessageBox "No node visited so far enables '$OpName'.\n Use the 'Model Check' command to explore more nodes."
			 }
		  } else {
		     if {$FromCurrent} {
			    tkMessageBox "No node reachable from the current state enables '$OpName'."
			 } else {
			     tkMessageBox "No node enables '$OpName'."
			 }
		  }
      }
   }
}

# -------
# procedure to enter and check an ltl formula
# -------

proc procLtl {} {
    global ltldata
    set ok [LtlDialog "LTL model checking"\
	"Enter an LTL formula
   use {...} for B predicates,
   G,F,X,U,W,R,true,false,not,&,or and => are part of the supported LTL syntax,
   use e(op) to check if an operation op is enabled,
   use sink to check if no operation is enabled that leads to another state,
   use brackets to check what is the next operation, e.g. \[reset\] => X{db={}},
   Past-LTL is supported: Y,H,O,S,T are the duals to X,G,F,U,R"]

   if {$ok} {
       if {[string is integer $ltldata(result)]} {
	   set formula [escapeChars $ltldata(formula)]
	       
	   if [prolog ltl_model_check('$formula',$ltldata(result),$ltldata(mode),Res)] {
	       procShowErrors
	       set res $prolog_variables(Res)
	       if {$res != "syntax_error"} {
		   if {$res == "no"} {
		       tkErrorBox "Formula FALSE.\nCounterexample found for $ltldata(formula)."
		       procInsertHistoryOptionsState
		   } elseif {$res == "ok"} {
		       tkMessageBox "Formula TRUE.\nNo counterexample found."
		   } elseif {$res == "incomplete"} {
		       tkMessageBox "No counterexample found so far.\nYou can explore more (unvisited) nodes by using Temporal Model Check or running LTL check again."
		   } elseif {$res == "nostart"} {
		       tkErrorBox "Error: No initialisation to start from found."
		   } else {
		       tkErrorBox "Internal error: unexpected result."
		   }
	       }
	   } else {
	       tkErrorBox "Internal error: LTL model checking failed."
	   }
	   procShowErrors
       } else {
	      tkErrorBox "Invalid input: $ltldata(result). Please enter a number."
       }
   }
}

proc procCtl {} {
    global ctldata
    set ok [CtlDialog "CTL model checking"\
                "Enter a CTL formula
   use {...} for B predicates,
   ExUy,EXx,AXx,EFx,AGx are supported CTL syntax,
   use e(op) to check if an operation op is enabled,
   use EX\[Op\]x to check what is the next operation, e.g. EX\[reset\]{db={}}"]

    if {$ok} {
        if {[string is integer $ctldata(result)]} {
            set formula [escapeChars $ctldata(formula)]
	       
            if [prolog ctl_model_check('$formula',$ctldata(result),$ctldata(mode),Res)] {
                procShowErrors
                set res $prolog_variables(Res)
                if {$res != "syntax_error"} {
                    procInsertHistoryOptionsState
                    if {$res == true} {
                        if [prolog state_space:max_nr_of_new_nodes_limit_not_reached] {
                            tkMessageBox "Formula TRUE.\nWitness found."
                        } else {
                            tkMessageBox "Potential witness found.\nNot all nodes explored!"
                        }
                    } else {
                        if [prolog state_space:max_nr_of_new_nodes_limit_not_reached] {
                            tkErrorBox "Formula FALSE.\nCounterexample found."
                        } else {
                            tkErrorBox "Potential counterexample found.\nNot all nodes explored!"
                        }
                    }
                } else {
                    tkErrorBox "Syntax error."
                }
            } else {
                tkErrorBox "Internal error: LTL model checking failed."
            }
        } else {
            tkErrorBox "Invalid input: $ctldata(result). Please enter a number."
        }
    }
    procShowErrors
}

# procedure to code forward slashes and quotes for transmission to Prolog
proc escapeChars {str} {return [string map {"\\" "\\\\" "'" "\\'" "\t" "  "} $str]}

proc AssertionName {} {
     global curFileTypeOpened
     if {$curFileTypeOpened == "EVENTB"} { return "THEOREM" } else { return "ASSERTION" }
}

proc procCBCFindSequence {} {
   global SeqToFind
    set SeqToFind [Dialog_Promptww "Enter Sequence of Operations, separated by ',':" 70 ""]
   if {$SeqToFind != ""} {
           prolog temporary_set_preference(use_smt_mode,true)
	       if [prolog tcltk_cbc_find_trace('$SeqToFind',ok)] {
			   procInsertHistoryOptionsState
			   procShowErrors
            } else {
			   procShowErrors
               tkErrorBox "No solution for trace from initial states found."
            }
            prolog reset_temporary_preference(use_smt_mode)
   }
}

proc procConstraintFindValidState {} {
  prolog tcltk_constraint_find_valid_state
  procInsertHistoryOptionsState
}

proc procCBCRefinementCheck {} {
    prolog temporary_set_preference(use_smt_mode,true)

    if [prologmnf tcltk_cbc_refinement_check(ErrRes,_)] {
        procShowErrors
        procShowList2 $prolog_variables(ErrRes) "Constraint Based Refinement Checking" "Constraint Based Refinement Check:" 1 0 "CBC_out.txt"
        procInsertHistoryOptionsState
    }

    prolog reset_temporary_preference(use_smt_mode)
}

proc procConstraintBasedCheck {} {
       prolog temporary_set_preference(use_smt_mode,true)
	   if [prologmnf tcltk_constraint_based_check(ErrRes)] {
			procShowList2 $prolog_variables(ErrRes) "Constraint Based Checking" "Constraint Based Check for the Operations:" 1 0 "CBC_out.txt"
			 procInsertHistoryOptionsState
       }
       prolog reset_temporary_preference(use_smt_mode)
}

proc procOpConstraintBasedCheck {} {
   global OpName
   set OpName [procChooseOperation]
   if {$OpName != ""} {
           prolog temporary_set_preference(use_smt_mode,true)
	       if [prolog tcltk_constraint_based_check_op('$OpName',ErrRes)] {
			   procInsertHistoryOptionsState
			   procShowErrors
			   set Result $prolog_variables(ErrRes)
			   if {$Result == "ok"} {
			       set msg [getUnboundedWarnings]
				   tkMessageBox "No error state found for $OpName.$msg"
			   } else {
				   tkErrorBox "Error state was found for $OpName:  $Result"
			   }
            } else {
               tkErrorBox "Internal error."
			   procShowErrors
            }
            prolog reset_temporary_preference(use_smt_mode)
	}
}
proc procFindDeadlockedState {} {
           prolog temporary_set_preference(use_smt_mode,true)
	       if [prolog tcltk_constraint_find_deadlock_state(Res)] {
				procInsertHistoryOptionsState
				procShowErrors
				if {$prolog_variables(Res)=="time_out"} {
                   tkMessageBox "Time-out occurred during Deadlock checking\n (using 10 times time-out specified in Animation Preferences)."
				} else {
                   tkMessageBox "Deadlocking State Satisfying Invariant Found!"
				}
            } else {
			   procShowErrors
			   set msg [getUnboundedWarnings]
               tkMessageBox "No Deadlock Counterexample Found.$msg"
            }
            prolog reset_temporary_preference(use_smt_mode)
}
proc procFindDeadlockedStateWithPred {} {
   global dialog_checkbutton1
   if [EnterGOALFormulaWithCheckBtn "Filter Unsatisfiable Guards"] {
           prolog temporary_set_preference(use_smt_mode,true)
	       if [prolog tcltk_constraint_find_deadlock_state_with_goal($dialog_checkbutton1,Res)] {
				procInsertHistoryOptionsState
				procShowErrors
				if {$prolog_variables(Res)=="time_out"} {
                   tkMessageBox "Time-out occurred during Deadlock checking\n (using 10 times the time-out specified in Animation Preferences)."
				} else {
                   tkMessageBox "Deadlocking State Satisfying Goal Predicate and Invariant Found!"
				}
            } else {
			   procShowErrors
			   set msg [getUnboundedWarnings]
               tkMessageBox "No Deadlock Counterexample (Satisfying Goal Predicate) Found.$msg"
            }
            prolog reset_temporary_preference(use_smt_mode)
   }
}

proc procFindStaticAssertionViolation {} {
           prolog temporary_set_preference(use_smt_mode,true)
	       if [prolog tcltk_constraint_find_static_assertion_violation(Res)] {
				procInsertHistoryOptionsState
				procShowErrors
				if {$prolog_variables(Res)=="time_out"} {
                   tkMessageBox "Time-out occured during static assertion checking\n (using 10 times time-out specified in Animation Preferences)."
				} else {
                   tkMessageBox "Counterexample for assertions found!"
				}
            } else {
			   procShowErrors
			   set msg [getUnboundedWarnings]
               tkMessageBox "No static assertion counterexample found.$msg"
            }
            prolog reset_temporary_preference(use_smt_mode)
}

proc getUnboundedWarnings {} {
	if {[prolog b_or_z_mode] && [prolog unfixed_deferred_set(DS)]} {
		  set msg "\nNote: Some SETS are potentially unbounded (e.g.,$prolog_variables(DS))."
	} else {
		  set msg ""
	}
	return $msg
}

# ------------------------------------------------------------
# ------------------------------------------------------------

# -------
# procedure to open a file, and put it on the source code
# -------
proc procShowSourceCode {sFileName} {
    global curFileDisplayed text_editor_arr
    set twin .main.frmSource.text
    $twin configure -state normal
    # open file
    set fid [open $sFileName r]
    set strInFile [read $fid]
    close $fid
    procDeleteErrorTagsInSourceFile
    .main.frmSource.statusframe.modelstatus configure -text "" -bg #EDECEB
    # On re-opening the File we don't have to delete and insert everytime the text in the text editor.
    # When there are no differences between the text in the file and the text in the ProB editor we 
    # just keep the old text in source code.
    if {$text_editor_arr(reopening_file) && $text_editor_arr(file_last_modified) != [file mtime $sFileName] \
                   && !$text_editor_arr(deactivate_asking_for_reloading)} {
        if {$text_editor_arr(ask_when_content_changed) || \
                  (!$text_editor_arr(ask_when_content_changed) && [$twin edit modified])} {
	        # save re-opening, for the case that file is opened with another editor and content in file is changed
	        set ans [tk_messageBox -default no -message "The file $sFileName changed on disk.\nDo you want\
        	         to reload the file content into the text editor?" -title "Warning" -type yesno -icon warning -parent .]
	        if {$ans == "yes"} {
	             procRefreshContentInTextEditor $twin $strInFile false
	             procresetundo
	             set text_editor_arr(file_last_modified) [file mtime $sFileName]
	             tk_messageBox -parent . -icon warning -message "File content in text editor changed!\
                          \nYou have to reload the current model to apply changes."
	        } else {
	             set text_editor_arr(deactivate_asking_for_reloading) true
	        }
	 } elseif {![$twin edit modified]} {
		procRefreshContentInTextEditor $twin $strInFile false
		procresetundo
		set text_editor_arr(file_last_modified) [file mtime $sFileName]
		#.main.frmSource.statusframe.modelstatus configure -text "File content was changed." -bg orange
         }
    }
    if {!$text_editor_arr(reopening_file)} {
        procRefreshContentInTextEditor $twin $strInFile true
        set text_editor_arr(deactivate_asking_for_reloading) false
    }
    set curFileDisplayed $sFileName
}

proc procRefreshContentInTextEditor {editor str disable} {
    global text_editor_arr
    ctext::getAr $editor config ar
    # on deleting and inserting the file content in the text editor
    # we don't have to highlight the text. That's why we have 
    # to set ar(highlightAfterId) to value different from ""
    set ar(highlightAfterId) "disable_highlighting"
    $editor delete 1.0 end
    $editor insert 1.0 $str
    set ar(highlightAfterId) ""
    if {$disable} {$editor configure -state disabled}
}

# maybe we have to delete this procedure
proc procBadPerfomanceMayOccurBecauseOfLongLines {str} {
    set countLongLines 0
    set lines [split $str "\n"]
    foreach line $lines {
	set strlen [string length $line]
	if {$strlen > 500 } {
	     set countLongLines [expr {($strlen / 500) + $countLongLines}] 
	}
	if {$countLongLines > 5} {
	     return true
 	}
    }
    return false
}

proc procShowSourceCodeFromString {sString} {
    .main.frmSource.text configure -state normal
    procRefreshContentInTextEditor .main.frmSource.text $sString true
}
proc procShowSourceCodeFromCodes {widget codes} {
    $widget configure -state normal
    $widget delete 0.0 end
    set src ""
    foreach i $codes {
        if {$i>255} {
            # inserting unicode on Mac makes the Text Widget incredibly slow
            if {$i==8469} {
                append src "NATURAL"
            } else {
                append src "???"
            }
        } else {
            append src [format %c $i]
        }
    }
    $widget insert end $src
    $widget configure -state disabled
}

proc procEnableSourceCodeEditing {} {
    if [prolog preferences:get_preference(allow_source_code_editing,true)] {
      .main.frmSource.text configure -state normal
      #.frmMenu.mnuFile entryconfigure 3 -state normal
    }
}

# -------
# procedure get new options from prolog and insert them to the listbox
# -------
proc procInsertHistoryOptionsState {} {
#      puts "procInsertHistoryOptionsState"
    procInsertHistory
#      puts "Inserting Options"
    procInsertOptions
#      puts "Inserting State"
    procInsertState
#      puts "Inserting State Errors"
    procInsertStateErrors
#      puts "Done procInsertHistoryOptionsState"
    updateEvaluationTree
#      puts "Done updateEvaluationTree"
}
proc procClearOptionsStateHistory {} {
        .main.frmInfo.frmPerform.list delete 0 end
        .main.frmInfo.frmState.list delete 0 end
        .main.frmInfo.frmState.list delete 0 end
}

proc procResetOptions {arg argcolor} {
       global StatusFrame OpStatusFrame
        .main.frmInfo.frmPerform.list delete 0 end
        .main.frmInfo.frmPerform.list insert 0 $arg
	    .main.frmInfo.frmPerform.list itemconfigure 0 -foreground $argcolor
           $StatusFrame.inv configure -state disabled
           $StatusFrame.inv configure -image InvUnknown
           $StatusFrame.timeout configure -image TimeoutEmpty
           $StatusFrame.timeout configure -state disabled
           $OpStatusFrame.maxreached configure -image MaxreachEmpty
           $OpStatusFrame.maxreached configure -state disabled
           update idletasks
}
proc procInsertOptions {} {
    # Insert Options into Enabled Operations pane
    procResetOptions "Computing..." DarkGray
    if [prolog {tcltk_get_options(Options)}] {
         procUpdateStatusFrame
         procShowErrors
         .main.frmInfo.frmPerform.list delete 0 end
         # obligatory to split into list because listbox fail to detect complex structure from prolog
         set listOptions $prolog_variables(Options)
         set iNbElem [llength $listOptions]
        
         # puts "inserting $iNbElem elements from $listOptions"
		 for {set i 0} {$i < $iNbElem} {incr i} {
			.main.frmInfo.frmPerform.list insert $i [lindex $listOptions $i]
		 }
	   
	   prologmnf tcltk_get_options_dest_info(DestInfoOptions)
       set listOptions $prolog_variables(DestInfoOptions)
       set iNbElem [llength $listOptions]
	   for {set i 0} {$i < $iNbElem} {incr i} {
	        set destinfo [lindex $listOptions $i]
	        if {$destinfo == "skip"} {
			  .main.frmInfo.frmPerform.list itemconfigure $i -foreground "midnight blue"
			} elseif {$destinfo == "open"} {
			  .main.frmInfo.frmPerform.list itemconfigure $i -foreground DarkOliveGreen4
			} elseif {$destinfo == "invariant_violated"} {
			  .main.frmInfo.frmPerform.list itemconfigure $i -foreground IndianRed4
			} elseif {$destinfo == "deadlock"} {
			  .main.frmInfo.frmPerform.list itemconfigure $i -foreground DarkOrange3
			}
		}
	if {$iNbElem == 0 && [prolog bmachine:bmachine_is_precompiled] && [prolog tcltk_no_constants_or_no_inititalisation_found]} {
          if {[prolog current_expression(root,_)]} {
			  if {[prolog b_machine_has_constants_or_properties]} {
			   .main.frmInfo.frmPerform.list insert 0 "NO-CONSTANTS-FOUND"
			  } else {
			   .main.frmInfo.frmPerform.list insert 0 "NO-INITIALISATION-FOUND"
			  } 
          } else {
            .main.frmInfo.frmPerform.list insert 0 "NO-INITIALISATION-FOUND"
          }
		 .main.frmInfo.frmPerform.list itemconfigure 0 -foreground IndianRed4
       }
       procCheckIfUnsatisfiableProperties 0
    } else {
         procResetOptions "InternalError" DarkOrange3
         procUpdateStatusFrame
         procShowErrors
         tkErrorBox "Internal error occured while computing enabled operations."
    }
}


proc procCheckIfUnsatisfiableProperties {force_feedback} {
	prologmnf tcltk_get_status(INVVIOLATED,MAXREACHED,TIMEOUT)
    global show_error_if_no_transition
    if {$force_feedback} { set show_error_if_no_transition 1}
	if {$show_error_if_no_transition && [prolog tcltk_current_node_has_no_real_transition]} {
		set show_error_if_no_transition 0
		if {[prolog bmachine:bmachine_is_precompiled] && [prolog b_machine_has_constants_or_properties] && [prolog current_expression(root,_)]} {
		   global testing_mode
		   if {[prolog tcltk_current_node_has_partial_transition]} {
			  if {[prolog preference(allow_incomplete_partial_setup_constants,true)]} {
				 set addtxt "some"
			  } else {
				 set addtxt "all"
			  }
			  set ptxt "\n(But I inferred a value for $addtxt CONSTANTS.)"
		   } else {
			  set ptxt ""
		   }
		   if  {$prolog_variables(TIMEOUT)==1} {
		      set cmsg "Timeout occurred while searching for CONSTANTS which satisfy the PROPERTIES!$ptxt"
		   } else {
		      set cmsg "Cannot find CONSTANTS which satisfy the PROPERTIES! The PROPERTIES could be inconsistent.$ptxt"
		   }
		   set ans "no"
		   if {[prolog b_interpreter:tcltk_unsatisfiable_components_exist]} {
		      procQuickDebugProperties $cmsg
		   } elseif {$testing_mode==false && $prolog_variables(TIMEOUT)==1} {
			 set ans [tkYesNoMessageWarningBox "$cmsg\nDo you want to debug the PROPERTIES?" \
					  "Timeout in PROPERTIES"]
		   } elseif {$testing_mode==false} {
			 set ans [tkYesNoMessageWarningBox "$cmsg\nDo you want to debug the PROPERTIES?" \
					  "Unsatisfiable PROPERTIES"]
		   } else {
			 puts "$cmsg"
		   }
		   assertBatchError "$cmsg"
		   #puts "ans: $ans"
		   if { $ans == "yes" } {
			  procDebugProperties
		   }
		} elseif {$force_feedback && ([prolog current_expression(_,root)] || [prolog current_expression(_,concrete_constants(_))])} {
		   if {$prolog_variables(TIMEOUT)==1} {
			  tkErrorBox "Timeout occurred while initialising machine!\nClick on the timeout button to recompute without a timeout."
		   } else {
			  if {[prolog b_or_z_mode]} {
				 set ans [tkYesNoMessageWarningBox "Cannot initialise machine!\nDo you want to debug the INITIALISATION?" \
					  "Failing INITIALISATION"]
			     if { $ans == "yes" } {
				    procDebugInitialisation
			     }
			  } elseif {[prolog animation_mode(xtl)]} {
				 tkErrorBox "Cannot start up XTL specification!\nExamine your start/1 predicate."
			  } else {
				 tkErrorBox "Cannot start up specification!"
			  }
		   }
		}
	} 
}

proc procQuickDebugProperties {Msg} {
	if {[prolog b_interpreter:tcltk_quick_describe_unsat_properties(Descr)]} {
		 set Cmd "procDebugProperties"
		 set ExtraBtn "Full Debug..."
		 set Result [split [string trimright $prolog_variables(Descr) {;}] \;]
		 procShowList3 $Result "PROPERTIES Info" $Msg 1 0 $ExtraBtn $Cmd "UNSAT_PROPERTIES.txt"
	}
}

proc procMaxreachedButtonAction {} {
    if [SymmetryOn] {
     prolog preferences:get_preference(symmetry_mode,SYMMODE)
       set Msg "Symmetry is turned on ($prolog_variables(SYMMODE)). This may permute the destination state of an operation."
    } else {
       set Msg "Note: Symmetry is off."
    }
    if [prolog {tcltk_get_status(INVVIOLATED,MAXREACHED,TIMEOUT)}] {
		if {$prolog_variables(MAXREACHED)==1} {
			set Msg "Possibly not all enabled operations were computed.\nIncrease Max Number of Initialisations/Operations in the Animation Preferences and re-load the machine."
	   } 
   }
   tkMessageBox "$Msg"
}

proc SymmetryOn {} {
    prolog preferences:get_preference(symmetry_mode,SYMMODE)
    if {$prolog_variables(SYMMODE)=="off"} {
      return 0
    } else {
      return 1
    }
}

proc procUpdateCheckCspAssertionsWindow {win is_new_file} {
    global tcl_version csp_assertions_dialog_arr
    set csp_assertions_dialog_arr(all_new_assertions) {}
    procUpdateListBoxIfExists $win false true
    prolog "get_csp_processes(Procs)"
    set ListProcs [lsort -dictionary -unique [split [string trimright $prolog_variables(Procs) {$}] \$]]
    set f $win.refMenu
    if {$tcl_version < 8.5} {
         foreach w [list $f.col1.fr.spec $f.col3.fr.impl $f.col2.fr.spec] {
	     if [winfo exists $w] {
        	$w delete 0 end
		foreach i [split $ListProcs] {
			$w insert end $i
		}
	     }
             foreach m [list $f.col1.entry $f.col3.entry $f.col2.entry] {
		if [winfo exists $m] {
             	    $m delete 0 end
	        }
             }
         }
    } else {
        foreach w [list $f.refinement.col1.spec1 $f.refinement.col3.spec2 $f.determinism.col1.spec \
                      $f.livelock.col2.spec $f.deadlock.col1.spec] {
             $w configure -values $ListProcs
             $w set ""
        }
        foreach m [list "determinism" "deadlock"] {
             $f.$m.col2.model set "Failure"
        }
        $f.refinement.col2.model set "Trace"
    }
}

proc procStatusFrameClick {} {
   if [prolog animation_mode(cspm)] {
        set win .checkCspAsser
        if [winfo exists .checkCspAsser] {
            procUpdateCheckCspAssertionsWindow .checkCspAsser true
            switch -- [wm state $win] {
               normal {
                   raise $win
               }
               withdraw -
               iconic {
                   wm deiconify $win
                   catch {wm geometry $win $dialog(geo,.checkCspAsser)}
               }
            }
            raise .checkCspAsser
            focus $win
        } else {
            CheckCspAssertions
        }
   } else {
        procAnalyseInvariant
   }
}
proc procUpdateStatusFrame {} {
    if [prolog {tcltk_get_status(INVVIOLATED,MAXREACHED,TIMEOUT)}] {
       global StatusFrame OpStatusFrame
       if {$prolog_variables(INVVIOLATED)==1} {
           # $StatusFrame.inv configure -text KO
           # $StatusFrame.inv configure -background red
           $StatusFrame.inv configure -image InvKO
           $StatusFrame.inv configure -state normal
           $StatusFrame.inv configure -cursor question_arrow
       } elseif {$prolog_variables(INVVIOLATED)==2} {
           # $StatusFrame.inv configure -text KO
           # $StatusFrame.inv configure -background red
           $StatusFrame.inv configure -image InvTimeout
           $StatusFrame.inv configure -state normal
           $StatusFrame.inv configure -cursor question_arrow
       } elseif [prolog current_state_corresponds_to_initialised_b_machine] {
           $StatusFrame.inv configure -image InvOK
           $StatusFrame.inv configure -state normal
           $StatusFrame.inv configure -cursor question_arrow
       } elseif [prolog animation_mode(cspm)] {
           $StatusFrame.inv configure -image InvRef
           $StatusFrame.inv configure -state normal
           $StatusFrame.inv configure -cursor question_arrow
       } else {
           $StatusFrame.inv configure -state disabled
           $StatusFrame.inv configure -image InvUnknown
           $StatusFrame.inv configure -cursor arrow
       }
       if {$prolog_variables(TIMEOUT)==1} {
           $StatusFrame.timeout configure -image Timeout
           $StatusFrame.timeout configure -state normal
       } else {
           $StatusFrame.timeout configure -image TimeoutEmpty
           $StatusFrame.timeout configure -state disabled
       }
       if {$prolog_variables(MAXREACHED)==1} {
           $OpStatusFrame.maxreached configure -image Maxreach
           $OpStatusFrame.maxreached configure -state normal
       } elseif [SymmetryOn] {
           $OpStatusFrame.maxreached configure -image MaxreachSym
           $OpStatusFrame.maxreached configure -state normal
       } else {
           $OpStatusFrame.maxreached configure -image MaxreachEmpty
           $OpStatusFrame.maxreached configure -state disabled
       }
       if [prolog tcltk_can_backtrack] {
           # $OpStatusFrame.backtrack configure -image BackEnabled
           $OpStatusFrame.backtrack configure -state normal
       } else {
           # $OpStatusFrame.backtrack configure -image BackDisabled
           $OpStatusFrame.backtrack configure -state disabled
       }
       if [prolog tcltk_can_forward] {
           # $OpStatusFrame.forward configure -image ForwardEnabled
           $OpStatusFrame.forward configure -state normal
       } else {
           # $OpStatusFrame.forward configure -image ForwardDisabled
           $OpStatusFrame.forward configure -state disabled
       }
       
    }
}


# -------
# procedure get new state from prolog and insert them to the listbox
# -------
proc procResetState {arg argcolor} {
    global StatusFrame OpStatusFrame
    $StatusFrame.inv configure -state disabled
    $StatusFrame.inv configure -image InvUnknown
    .main.frmInfo.frmState.list delete 0 end
    .main.frmInfo.frmState.list insert 0 $arg
	.main.frmInfo.frmState.list itemconfigure 0 -foreground $argcolor
    update idletasks
}
proc procInsertState {} {
    if [prolog {tcltk_get_state(State)}] {
       .main.frmInfo.frmState.list delete 0 end
        # puts "state: $prolog_variables(State)"
        # obligatory to split into list because listbox fail to detect complex structure from prolog
        set listState $prolog_variables(State)
        set iNbElem [llength $listState]
        # we have to also insert 1 by 1
        for {set i 0} {$i < $iNbElem} {incr i} {
            .main.frmInfo.frmState.list insert $i [lindex $listState $i]
        }
    }
    procShowErrors
    procUpdateStateViewer
}

# -------
# procedure to get the state's errors from prolog and insert them
# to the listbox
# This is not done in procInsertState, because the operations
# (a source for errors)may not yet have been computed
# -------
proc procInsertStateErrors {} {
    if [prolog {tcltk_get_state_errors(State)}] {
        # obligatory to split into list because listbox fail to detect complex structure from prolog
        set listState $prolog_variables(State)
        set iNbElem [llength $listState]
        # we have to also insert 1 by 1
        for {set i 0} {$i < $iNbElem} {incr i} {
            .main.frmInfo.frmState.list insert $i [lindex $listState $i]
	    .main.frmInfo.frmState.list itemconfigure $i -foreground red
        }
    }
}


# -------
# procedure get new history from prolog and insert them to the listbox
# -------
proc procResetHistory {} {
        .main.frmInfo.frmHisto.list delete 0 end
}
proc procInsertHistory {} {
    if [prolog {tcltk_get_history(History)}] {
        .main.frmInfo.frmHisto.list delete 0 end
        # obligatory to split into list because listbox fail to detect complex structure from prolog
        set listHistory $prolog_variables(History)
        set iNbElem [llength $listHistory]
        # we have to also insert 1 by 1
        for {set i 0} {$i < $iNbElem} {incr i} {
            .main.frmInfo.frmHisto.list insert $i [lindex $listHistory $i]
        }
    }
}

# -------
# procedure perform an option
# -------
global lastClicki lastSeeItem
set lastClicki -1
set lastSeeItem 1

proc procPerformOptionSingleClick {} {
    global lastClicki lastSeeItem
    procRemoveHighlightExecutedOperation
    set iOption [.main.frmInfo.frmPerform.list curselection]
    if {$iOption != ""} {
        incr iOption
        if [prolog tcltk_get_line_col($iOption,X,Y,XE,YE)] {
            set Line $prolog_variables(X)
            set Col $prolog_variables(Y)
            set EndLine $prolog_variables(XE)
            set EndCol $prolog_variables(YE)
            set iNbElem [llength $Line]
            # puts "source loc: option:$iOption line:$Line-$EndLine col:$Col-$EndCol Nb:$iNbElem last:$lastSeeItem\n"
            for {set i 0} {$i < $iNbElem} {incr i} {
               # puts "procHighlight $i"
               procHighlightExecutedOperation [lindex $Line $i] [lindex $Col $i] [lindex $EndLine $i] [lindex $EndCol $i]
            }
            if [prolog tcltk_is_sync_event($iOption)] {
               # Synchronisation happened
	           .main.frmSource.text tag configure executedTag -background gold2
	        }
	       # Make sure that by repeatedly clicking we cycle through the various positions
		   if {$lastClicki==$iOption} {
			   incr lastSeeItem
			   if {$lastSeeItem>=$iNbElem} {
				   set lastSeeItem 0
			   }
			   set SeeLine [lindex $Line $lastSeeItem]
			   # puts "SeeLine: $SeeLine,  lastSeeItem: $lastSeeItem"
			   .main.frmSource.text see "$SeeLine.0"
		   } else {
			   set lastSeeItem $iNbElem
			   incr lastSeeItem -1
		   }
        }
        set lastClicki $iOption
    }
}
proc procPerformOption {} {
   # React to double-click on Enabled Operations List
    set iOption [.main.frmInfo.frmPerform.list curselection]
    procPerformOptionByIOption $iOption
}

proc procPerformOptionByIOption {iOption} {
    if {$iOption != ""} {
        if {[prolog tcltk_no_constants_or_no_inititalisation_found]} {
            # we have a NO-CONSTANTS-FOUND or NO-INITIALISATION-FOUND transition
            procCheckIfUnsatisfiableProperties 1
        } else {
			incr iOption
			if [prolog tcltk_perform($iOption)] {
				procInsertHistoryOptionsState
			}
        }
    }
}

proc procPerformStateList {} {
    global eval_window_arr
    # React to double-click on State Properties List
    if [catch {set itemNrs [.main.frmInfo.frmState.list curselection]}] {
         set ii [lindex $itemNrs 0]
         if {![prolog animation_mode(cspm)]} {
               set eval_window_arr(input) [.main.frmInfo.frmState.list get $ii]
         } else {
               set eval_window_arr(input) ""
         }
    } else {set eval_window_arr(input) ""}
    procEvalConsole
}

proc procShowCSPProcessToAnimate {strProc} {
    global ProcessToAnimate strFilename
    
    set ProcessToAnimate [Dialog_Promptww "Please choose the arguments of $strProc: " 35 "" $strProc]
    if {$ProcessToAnimate != "" && $strFilename != ""} {
	    prolog "get_new_csp_process_id(\'$ProcessToAnimate\',\'$strFilename\',ID)"
	    procInsertOptions
    }
}

proc procPerformBacktrack {} {
        if [prolog tcltk_backtrack] {
            procInsertHistoryOptionsState
        }
}
proc procPerformForward {} {
        if [prolog tcltk_forward] {
            procInsertHistoryOptionsState
        }
}

# ---------------------------------------------

proc Dialog_Create {top title args} {
	global dialog tcl_version
	if [winfo exists $top] {
		switch -- [wm state $top] {
			normal {
				# Raise a buried window
				raise $top
			}
			withdrawn -
			iconified {
				# Open and restore geometry
				wm deiconify $top
				catch {wm geometry $top $dialog(geo,$top)}
			}
		}
		return 0
	} else {
		eval {toplevel $top} $args
		wm title $top $title
        if {$tcl_version>=8.5} {
            wm iconphoto $top WindowSubIcon
        }
		return 1
	}
}
proc Dialog_WaitVisible {top {focus {}}} {
	# Grab focus for the dialog
	if {[string length $focus] == 0} {
		set focus $top
	}
	set old [focus -displayof $top]
	focus $focus
	catch {tkwait visibility $top}
	catch {grab $top}
}
proc Dialog_Wait {top varName {focus {}}} {
	upvar $varName var

	# Poke the variable if the user nukes the window
	bind $top <Destroy> [list set $varName $var]

	# Grab focus for the dialog
	if {[string length $focus] == 0} {
		set focus $top
	}
	set old [focus -displayof $top]
	focus $focus
	catch {tkwait visibility $top}
	catch {grab $top}

	# Wait for the dialog to complete
	tkwait variable $varName
	catch {grab release $top}
	focus $old
}

proc Dialog_Dismiss {top} {
	global dialog
	# Save current size and position
	catch {
		# window may have been deleted
		set dialog(geo,$top) [wm geometry $top]
		wm withdraw $top
	}
}


#
# Example 33-2
# A simple dialog.
#

proc Dialog_Prompt { string } {
   Dialog_Promptww $string 0 ""
}

proc Dialog_Promptww { string wd CheckBox1 args} {
	global prompt dialog_checkbutton1
	destroy .prompt
	set f .prompt
	if [Dialog_Create $f "Prompt" -borderwidth 10] {
		message $f.msg -text $string -aspect 1000
		if {$wd > 0} {
		   entry $f.entry -textvariable prompt(result) -width $wd
		} else {
		   entry $f.entry -textvariable prompt(result)
		}
		set b [frame $f.buttons]
		pack $f.msg $f.entry $f.buttons -side top -fill x
		pack $f.entry -pady 5
		if {$CheckBox1 != ""} {
		    checkbutton $f.checkbutton1 -text "$CheckBox1" -variable dialog_checkbutton1 -onvalue 1 -offvalue 0
		    pack $f.checkbutton1 -pady 5 -side top
		}
		button $b.ok -text OK -command {set prompt(ok) 1}
		button $b.cancel -text Cancel \
			-command {set prompt(ok) 0}
		pack $b.ok -side left
		pack $b.cancel -side right
		bind $f.entry <Return> {set prompt(ok) 1 ; break}
		bind $f.entry <Control-c> {set prompt(ok) 0 ; break}
		if {[llength $args] == 1 && [lindex $args 0] != ""} {
			set strInEntry [$f.entry get]
			$f.entry delete 0 [string length $strInEntry]
			$f.entry insert 0 [lindex $args 0]
		}
	}
	set prompt(ok) 0
	Dialog_Wait $f prompt(ok) $f.entry
	Dialog_Dismiss $f
	if {$prompt(ok)} {
		return $prompt(result)
	} else {
		return {}
	}
}

## This procedure defines a new popup window for testing assertions in csp-files. 
proc CheckCspAssertions {} {
   global strFilename checkCspAsser strFilenameTemporary cspstrFilename UsedCspStrFilename curFileTypeOpened
   global tcl_dir tcl_version csp_assertions_dialog_arr
   destroy .checkCspAsser
   set csp_ext [file extension $strFilename]
   if { $csp_ext == ".csp" || $csp_ext == ".cspm" || ($curFileTypeOpened == "B" && $cspstrFilename != "")} {
       if {!($curFileTypeOpened == "B" && $cspstrFilename != "")} {
            set UsedCspStrFilename $strFilename
       } else {
            set UsedCspStrFilename $cspstrFilename
       }
       prolog "generate_temporary_cspm_file(\'$UsedCspStrFilename\', FileNameTemp)"
       set strFilenameTemporary $prolog_variables(FileNameTemp)
       procDeleteTmpFileContent $strFilenameTemporary
       procCopyFileContentToTemporaryFile $UsedCspStrFilename $strFilenameTemporary
       eval global csp
       set csp .checkCspAsser
       if [Dialog_Create $csp "Check CSP Assertions" -borderwidth 10] {
             #wm transient $csp .
             message $csp.msg -text "List of CSP Assertions" -aspect 1000
             menu $csp.menubar -tearoff 0 
             $csp config -menu $csp.menubar
             foreach m {File Font Assertions} {
                 set mb [string tolower $m]
                 set $m [menu $csp.menubar.$mb -tearoff 0]
                 $csp.menubar add cascade -label $m -menu $csp.menubar.$mb
             }
             set fimb $csp.menubar.file
             set Filename [file tail $UsedCspStrFilename]
             $fimb add command -label "ReOpen $Filename" -command {procLoadCSPMFile}
             $fimb add command -label "Copy new Assertions to Source File" -command "addAllNewCspAssertionsInFileGlobal"
             $fimb add command -label "Save Assertions to External File..." -command {saveAssertionsListToFile}
             $fimb add command -label "Exit" -command {destroy .checkCspAsser}
             set extTools [menu $csp.menubar.extTools -tearoff 0]
             $csp.menubar add cascade -label "External Tools" -menu $csp.menubar.extTools
             if {$tcl_version < 8.5} {
		 set view [menu $csp.menubar.view -tearoff 0]
		 $csp.menubar add cascade -label "View" -menu $csp.menubar.view
             }
             set fmb $csp.menubar.font
             foreach ms {Name Size Background} mi {name size bg} {
                  $fmb add cascade -label $ms -menu $fmb.$mi
             }
             set fnt [menu $fmb.name -tearoff 0]
             foreach name {Curier Times Arial Helvetica} {
                  set n [string tolower $name]
                  $fnt add radio -label $name -variable csp_assertions_dialog_arr(fontname) -command "procChangeFontName $csp.frmSource.text $name $csp_assertions_dialog_arr(fontsize)"
             }
             set fsz [menu $fmb.size -tearoff 0]
             foreach num {9 10 12 14 16 18 20 24} {
                  $fsz add radio -label $num -variable csp_assertions_dialog_arr(fontsize) -command "procChangeFontSize $csp.frmSource.text $csp_assertions_dialog_arr(fontname) $num"
             }
             set fcol [menu $fmb.bg -tearoff 0]
             foreach cl {Gray60 Gray70 Gray80 Gray90 Snow1 Snow2 Snow3 Snow4 White} {
                  set c [string tolower $cl]
                  $fcol add radio -label $cl -background $c -variable csp_assertions_dialog_arr(background) -command "procChangeBackground $csp.frmSource.text $c"
             }
             set scol [menu $fmb.color -tearoff 0]
             foreach sc {gray60 LightSkyBlue1 LightSkyBlue2} {
                   $scol add radio -label $sc -background $sc -variable csp_assertions_dialog_arr(selectcolor) -command "procChangeSelectColor $csp.frmSource.text $c"
             }
             set fassb $csp.menubar.assertions
             $fassb add command -label "Check All Assertions" -command {CheckAllAssertionsInTheListBox $csp.frmSource.text}
             $fassb add cascade -label "Check All Refinement..." -menu $fassb.refs
             set assRefs [menu $fassb.refs -tearoff 0]
             foreach csc {Traces Failures Failures-Divergences Refusals} i {"T=" "F=" "FD=" "R="} {
                   $assRefs add command -label $csc -command "procCheckAllAssertionsFromType $csp.frmSource.text $i"
             }
             $fassb add cascade -label "Check Processes for..." -menu $fassb.procs
             set assProc [menu $fassb.procs -tearoff 0]
             foreach csc {Determinism Deadlock Livelock} i {deterministic deadlock livelock} {
                   $assProc add command -label $csc -command "procCheckAllAssertionsFromType $csp.frmSource.text $i"
             }
             set fdrCheck $csp.menubar.extTools
             $fdrCheck add command -label "Open Specification with FDR" -command "procOpenFDROnSpec"
             $fdrCheck add command -label "Evaluate with CSPM-Interpreter" -command {set eval_window_arr(proCSPInterpreter) false; procEvalConsole}
             frame $csp.frmSource -borderwidth .1c -relief groove
             if {$tcl_version >= 8.5} {
                  ttk::notebook $csp.refMenu
                  # four pages for the refinement menu
                  foreach fr {refinement determinism deadlock livelock} {
                        ttk::frame $csp.refMenu.$fr
                  }
             } else {
                  set csp_assertions_dialog_arr(selected_notebook_type) Refinement
                  frame $csp.refMenu
                  set vview $csp.menubar.view
                  foreach m {Refinement Determinism Deadlock Livelock} {
                        $vview add radio -label $m -variable $csp_assertions_dialog_arr(selected_notebook_type) -command "procChangeViewInCheckCspAssertionsWindow $csp.refMenu $m"
                  }
             }
             if [prolog tools:host_platform(darwin)] {
                  set listboxheight 11
             } else {
                  set listboxheight 10
             }
             # the scrollbars for the text window 
             scrollbar $csp.frmSource.scrolly -command "$csp.frmSource.text yview"
             scrollbar $csp.frmSource.scrollx -orient horizontal -command "$csp.frmSource.text xview"
             listbox $csp.frmSource.text -yscroll "$csp.frmSource.scrolly set" \
                 -xscroll "$csp.frmSource.scrollx set" \
                 -setgrid 1 -height $listboxheight -width 70 -bg [string tolower $csp_assertions_dialog_arr(background)] -selectborderwidth 3 -selectbackground LightSkyBlue1 \
                 -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 11} \
                 -activestyle dotbox -selectmode extended
             pack $csp.frmSource.scrolly -side right -fill y
             pack $csp.frmSource.scrollx -side bottom -fill x
             pack $csp.frmSource.text -expand true -fill both
             bind $csp.frmSource.text <Double-ButtonPress-1> [list ActivateLineInListbox $csp.frmSource.text]
             bind $csp.frmSource.text <Return> [list ActivateLineInListbox $csp.frmSource.text]
             bind $csp.frmSource.text <<RIGHTCLICK>> {procPerformAssertionsContextMenus $csp.frmSource.text %X %Y}
             if [prolog tools:host_platform(darwin)] {
                   bind $csp.frmSource.text <Control-Button-1> {procPerformAssertionsContextMenus $csp.frmSource.text %X %Y}
             }
             pack $csp.msg $csp.frmSource -side top -fill x
             pack $csp.frmSource -expand true -fill both
             pack $csp.refMenu -pady 5 -fill both
             if {$tcl_version >= 8.5} {
                  foreach nl {Refinement Determinism Deadlock Livelock} {
                       set n [string tolower $nl]
                       $csp.refMenu add $csp.refMenu.$n -text $nl
                  }
                  set ref    $csp.refMenu.refinement
                  set determ $csp.refMenu.determinism
                  set ddlock $csp.refMenu.deadlock
                  set lvlock $csp.refMenu.livelock
                  ##Define widgets content in refinement subwindows
                  procCreateFrameOrLabelPlatformDepended frame "$ref.space"
                  pack  $ref.space -fill x
                  foreach col {col1 col2 col3} lbl {lspec lmod limp} t {"Specification:" "Model:" "Implementation:"} {
                      procCreateFrameOrLabelPlatformDepended frame "$ref.$col"
                      procCreateFrameOrLabelPlatformDepended label "$ref.$col.$lbl" "$t"
                  }
                  ## Get all CSP processes for the combobox widgets.
                  prolog "get_csp_processes(Procs)"
                  set ListProcs [lsort -dictionary -unique [split [string trimright $prolog_variables(Procs) {$}] \$]]
                  set ListModls {"Failure-Divergence" "Failure" "Trace" "Refusals"}
                  ttk::combobox $ref.col1.spec1 -textvariable csp_assertions_dialog_arr(spec) -state editable -value $ListProcs
                  ttk::combobox $ref.col2.model -textvariable csp_assertions_dialog_arr(ref_model) -state readonly -value $ListModls
                  ttk::combobox $ref.col3.spec2 -textvariable csp_assertions_dialog_arr(impl) -state editable -value $ListProcs
                  ## Arrange widgets content in refinement subwindow
                  button $ref.col1.add -text Add -command {updateListSpec $csp_assertions_dialog_arr(spec) $csp_assertions_dialog_arr(impl) \
                                      $csp_assertions_dialog_arr(ref_model) $csp.frmSource.text false} -state normal \
                                      -width 6
                  button $ref.col2.check -text Check -command \
                                     {updateListSpec $csp_assertions_dialog_arr(spec) $csp_assertions_dialog_arr(impl) $csp_assertions_dialog_arr(ref_model) $csp.frmSource.text true} \
                                     -state normal -width 6
                  button $ref.col2.change -image SwapProcs -relief raised -command {changeTextvariablesInComboboxes} -state normal
                  button $ref.col3.cancel -text Cancel -command \
                                     { if {!$csp_assertions_dialog_arr(assertion_check_running)} {askToSaveNewAssertionsFromCheckCspWin "yes" $csp.frmSource
                                       } else {procInterruptAssertionExecution .checkCspAsser}} -state normal \
                                     -width 6
                  foreach m1 {lspec spec1 add} m3 {limp spec2 cancel} num {5 5 20} {
                       pack "$ref.col1.$m1" -pady $num -side top
                       pack "$ref.col3.$m3" -pady $num -side top
                  }
                  foreach m {lmod model change check} num {5 5 5 5} {
                       pack "$ref.col2.$m" -pady $num -side top
                  }
                  pack $ref.col1 $ref.col2 $ref.col3 -side left -expand true
                  ##Define the three needed buttons for the Determinism submenu
                  foreach j "$determ $ddlock" {
                      procCreateFrameOrLabelPlatformDepended frame "$j.col1"
                      procCreateFrameOrLabelPlatformDepended frame "$j.col2"
                      procCreateFrameOrLabelPlatformDepended frame "$j.col3"
                  }
                  ttk::combobox $determ.col1.spec -textvariable csp_assertions_dialog_arr(deterministic_proc) -state editable -value $ListProcs
                  ttk::combobox $determ.col2.model -textvariable csp_assertions_dialog_arr(deterministic_model) -state readonly -value {"Failure" "Failure-Divergence"}
                  ttk::combobox $ddlock.col1.spec -textvariable csp_assertions_dialog_arr(deadlock_proc) -state editable -value $ListProcs
                  ttk::combobox $ddlock.col2.model -textvariable csp_assertions_dialog_arr(deadlock_model) -state readonly -value {"Failure" "Failure-Divergence"}
                  button $determ.col1.add -text Add -command \
                           {updateListDeterm $csp_assertions_dialog_arr(deterministic_proc) $csp_assertions_dialog_arr(deterministic_model) $csp.frmSource.text false} -state normal -width 6
                  button $determ.col2.check -text Check -command \
                           {updateListDeterm $csp_assertions_dialog_arr(deterministic_proc) $csp_assertions_dialog_arr(deterministic_model) $csp.frmSource.text true} -state normal -width 6
                  button $ddlock.col1.add -text Add -command \
                           {updateListDeadlock $csp_assertions_dialog_arr(deadlock_proc) $csp_assertions_dialog_arr(deadlock_model) $csp.frmSource.text false} -state normal \
                           -width 6
                  button $ddlock.col2.check -text Check -command \
                           {updateListDeadlock $csp_assertions_dialog_arr(deadlock_proc) $csp_assertions_dialog_arr(deadlock_model) $csp.frmSource.text true} -state normal \
                           -width 6
                  foreach i "$determ $ddlock" {
                      ##Define the determinism and deadlock widgets
                      procCreateFrameOrLabelPlatformDepended label "$i.col1.lspec" "Specification:"
                      procCreateFrameOrLabelPlatformDepended label "$i.col2.lmod" "Model:"
                      procCreateFrameOrLabelPlatformDepended label "$i.col3.empty"
                      button $i.col3.cancel -text Cancel -command \
                           { if {!$csp_assertions_dialog_arr(assertion_check_running)} { askToSaveNewAssertionsFromCheckCspWin "yes" $csp.frmSource
                             } else {procInterruptAssertionExecution .checkCspAsser}} -state normal
                      ##Arrange widgets content in determinism and deadlock subwindows
                      foreach m1 {lspec spec add} m2 {lmod model check} m3 {empty empty cancel} \
                                 n {5 5 20} n3 {15 18 20} {
                           pack "$i.col1.$m1" -pady "$n" -side top
                           pack "$i.col2.$m2" -pady "$n" -side top
                           pack "$i.col3.$m3" -pady "$n3" -side top
                      }
                      pack $i.col1 $i.col2 -side left -expand true
                      pack $i.col3 -side left -expand true -padx 40
                  }
                  ## Define widgets for the Livelock submenu
                  foreach col {col1 col2 col3} {
                      procCreateFrameOrLabelPlatformDepended frame "$lvlock.$col"
                  }
                  procCreateFrameOrLabelPlatformDepended label "$lvlock.col2.lspec" "Specification:"
                  procCreateFrameOrLabelPlatformDepended label "$lvlock.col1.empty"
                  procCreateFrameOrLabelPlatformDepended label "$lvlock.col3.empty"
                  ttk::combobox $lvlock.col2.spec -textvariable csp_assertions_dialog_arr(livelock_proc) -state editable -value $ListProcs
                  button $lvlock.col1.add -text Add -command \
                         {updateListLivelock $csp_assertions_dialog_arr(livelock_proc) $csp.frmSource.text false} -state normal -width 6
                  button $lvlock.col2.check -text Check -command \
                         {updateListLivelock $csp_assertions_dialog_arr(livelock_proc) $csp.frmSource.text true} -state normal -width 6
                  button $lvlock.col3.cancel -text Cancel -command \
                      { if {!$csp_assertions_dialog_arr(assertion_check_running)} {askToSaveNewAssertionsFromCheckCspWin "yes" $csp.frmSource
                        } else {procInterruptAssertionExecution .checkCspAsser}} -state normal -width 6
                  foreach m1 {empty empty add} m2 {lspec spec check} m3 {empty empty cancel} n {15 18 20} n2 {5 5 20} {
                      pack "$lvlock.col1.$m1" -pady "$n" -side top
                      pack "$lvlock.col2.$m2" -pady "$n2" -side top
                      pack "$lvlock.col3.$m3" -pady "$n" -side top
                  }
                  pack $lvlock.col1 -side left -expand true -padx 35
                  pack $lvlock.col2 -side left -expand true
                  pack $lvlock.col3 -side left -expand true -padx 40                  
                  if [prolog tools:host_platform(darwin)] {
                      foreach fr "$lvlock $ref $ddlock $determ" {
                           $fr.col1.add configure -highlightbackground systemSheetBackground
                           $fr.col2.check configure -highlightbackground systemSheetBackground
                           $fr.col3.cancel configure -highlightbackground systemSheetBackground
                      }
                      $ref.col2.change configure -highlightbackground systemSheetBackground
                  }
                  wm protocol .checkCspAsser WM_DELETE_WINDOW {askToSaveNewAssertionsFromCheckCspWin "yes" $csp.frmSource}
             } else {
                  procChangeViewInCheckCspAssertionsWindow $csp.refMenu "Refinement"
             }
      }
      if [prolog "get_csp_assertions_as_string(\'$UsedCspStrFilename\',Res)"] {
		set Result [split [string map {"CSP: " ""} [string trimright $prolog_variables(Res) {$}]] \$]
		set csp_assertions_dialog_arr(listbox_size) [llength $Result]
		foreach i $Result {
			$csp.frmSource.text insert end "?   $i"
		}
		if {"$Result"==""} {
        		$csp.frmSource.text insert end "No Assertions in this File found."
		}
      } else {
			procShowErrors
        		$csp.frmSource.text insert end "No Assertions in this File found."
      }
    } else {
       tkErrorBoxNoParent "Can only be applied to CSP specifications."
    }
}

proc procCreateFrameOrLabelPlatformDepended {command name args} {
    if [prolog tools:host_platform(darwin)] {
       if {[llength $args] == 1} {
           eval [list $command $name -text [lindex $args 0] -bg #[pickUpPlatformDependendColor]]
       } else {
           eval [list $command $name -bg #[pickUpPlatformDependendColor]]
       }
    } else {
       if {[llength $args] == 1} {
           eval [list $command $name -text [lindex $args 0]]
       } else {
           eval [list $command $name]
       }
    }
}

proc pickUpPlatformDependendColor {} {
    if [prolog tools:host_platform(darwin)] {
        return "EDEDED"
    } elseif [prolog tools:host_platform(windows)] {
        return "F1F1F1"
    } else {
        return "D9D9D9"
    }
}

proc procChangeViewInCheckCspAssertionsWindow {menu model} {
    global csp_assertions_dialog_arr
    if [winfo exists .checkCspAsser] {
        if [winfo exists $menu.col2.entry] {
            $menu.col2.entry delete 0 end
            if {$model != "Livelock" && [winfo exists $menu.col1.entry]} {
                $menu.col1.entry delete 0 end
                if {$model == "Refinement" && [winfo exists $menu.col3.entry]} {
                    $menu.col3.entry delete 0 end
                }
            }
        }
        destroy $menu
    }
    prolog "get_csp_processes(Procs)"
    set ListProcs [lsort -dictionary -unique [split [string trimright $prolog_variables(Procs) {$}] \$]]
    frame .checkCspAsser.refMenu
    pack .checkCspAsser.refMenu -pady 5 -expand true -fill both
    set menu .checkCspAsser.refMenu
    frame $menu.space
    pack $menu.space -fill x
    frame $menu.col1; frame $menu.col2; frame $menu.col3
    button $menu.col1.add -text Add -command "updateListBoxAfterModelView $model false" -state normal -height 1 -width 7 
    button $menu.col2.check -text Check -command "updateListBoxAfterModelView $model true" -state normal -height 1 -width 7
    button $menu.col3.cancel -text Cancel -command \
                  { if {!$csp_assertions_dialog_arr(assertion_check_running)} {askToSaveNewAssertionsFromCheckCspWin "yes" $csp.frmSource
                    } else {procInterruptAssertionExecution .checkCspAsser} } -state normal -height 1 -width 7
    if {$model != "Livelock"} {
        label $menu.col1.lspec -text Specification: -justify left
        label $menu.col2.lmod  -text Model:
        frame $menu.col1.fr
        scrollbar $menu.col1.fr.scrolly -orient vertical -command "$menu.col1.fr.spec yview"      
        listbox $menu.col1.fr.spec -yscrollcommand "$menu.col1.fr.scrolly set" \
          -setgrid 1 -height 5 -width 17 -bg white -selectbackground gray80 \
          -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
          -activestyle dotbox -selectmode single
        bind $menu.col1.fr.spec <MouseWheel-1> [list $menu.col1.fr.scrolly activate]
        listbox $menu.col2.model \
          -setgrid 1 -height 3 -width 17 -bg white -selectbackground gray80 \
          -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
          -activestyle dotbox -selectmode single
        foreach p $ListProcs {
           $menu.col1.fr.spec insert end $p
        }
        foreach m {"Failure-Divergence" "Failure" "Trace" "Refusals"} {
             if {$model != "Refinement" && $m == "Trace"} {break}
                 $menu.col2.model insert end $m
        }
        pack $menu.col1.fr.scrolly -side right -fill y
        pack $menu.col1.fr.spec -fill both
        if {$model == "Refinement"} {
            entry $menu.col1.entry -textvariable csp_assertions_dialog_arr(spec)
            entry $menu.col2.entry -textvariable csp_assertions_dialog_arr(ref_model) -state disabled
            bind $menu.col1.fr.spec <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col1.fr.spec $menu.col1.entry "Proc1"]
            bind $menu.col2.model   <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col2.model $menu.col2.entry "Modl"]
            button $menu.col2.change -image SwapProcs -relief raised \
	          -command {changeTextvariablesInComboboxes} -state normal
        } elseif {$model == "Determinism"} {
                           entry $menu.col1.entry -textvariable csp_assertions_dialog_arr(deterministic_proc)
            entry $menu.col2.entry -textvariable csp_assertions_dialog_arr(deterministic_model) -state disabled
            bind $menu.col1.fr.spec <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col1.fr.spec $menu.col1.entry "ProcDet"]
            bind $menu.col2.model   <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col2.model $menu.col2.entry "ProcModl"]
            bind $menu.col1.fr.spec <Return> \
                  [list setEntryVariable $menu.col1.fr.spec $menu.col1.entry "ProcDet"]
            bind $menu.col2.model   <Return> \
                  [list setEntryVariable $menu.col2.model $menu.col2.entry "ProcModl"]
         } elseif {$model == "Deadlock"} {
            entry $menu.col1.entry -textvariable csp_assertions_dialog_arr(deadlock_proc)
            entry $menu.col2.entry -textvariable csp_assertions_dialog_arr(deadlock_model) -state disabled
            bind $menu.col1.fr.spec <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col1.fr.spec $menu.col1.entry "ProcDeadlock"]
            bind $menu.col2.model   <Double-ButtonPress-1> \
                  [list setEntryVariable $menu.col2.model $menu.col2.entry "ProcModlDeadlock"]
         }
         foreach w {lspec fr entry} {
              pack "$menu.col1.$w" -pady 5 -side top
         }          
         if {$model == "Refinement"} {
              foreach w {lmod model entry change check} num {5 5 5 2 8} {
                  pack "$menu.col2.$w" -pady "$num" -side top
              }
         } else {
              foreach w {lmod model entry check} num {5 5 5 20} {
                  pack "$menu.col2.$w" -pady "$num" -side top
              }
         }			    
         pack $menu.col1.add   -pady 20 -side top
         pack $menu.col1 $menu.col2 -side left -expand true
         if {$model == "Refinement"} {
             label $menu.col3.limp  -text Implementation:
             frame $menu.col3.fr
             scrollbar $menu.col3.fr.scrolly -orient vertical -command "$menu.col3.fr.impl yview"
             listbox $menu.col3.fr.impl -yscroll "$menu.col3.fr.scrolly set" \
                 -setgrid 1 -height 5 -width 17 -bg white -selectbackground gray80 \
                 -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
                 -activestyle dotbox -selectmode single
             foreach p $ListProcs {$menu.col3.fr.impl insert end $p}
             entry $menu.col3.entry -textvariable csp_assertions_dialog_arr(impl)
             pack $menu.col3.fr.scrolly -side right -fill y
             pack $menu.col3.fr.impl -fill both
             bind $menu.col3.fr.impl <Double-ButtonPress-1> [list setEntryVariable $menu.col3.fr.impl $menu.col3.entry "Proc2"]
             bind $menu.col3.fr.impl <Return> [list setEntryVariable $menu.col3.fr.impl $menu.col3.entry "Proc2"]
             foreach w {limp fr entry cancel} n {5 5 5 20} {
                pack "$menu.col3.$w" -pady "$n" -side top
             }
             pack $menu.col3 -side left -expand true
        }                      
    } else {
           label $menu.col2.lspec -text Specification:
           frame $menu.col2.fr
           scrollbar $menu.col2.fr.scrolly -orient vertical -command "$menu.col2.fr.spec yview"
           listbox $menu.col2.fr.spec -yscroll "$menu.col2.fr.scrolly set" \
               -setgrid 1 -height 5 -width 17 -bg white -selectbackground gray80 \
               -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
               -activestyle dotbox -selectmode single
           foreach p $ListProcs {$menu.col2.fr.spec insert end $p}
           entry $menu.col2.entry -textvariable csp_assertions_dialog_arr(livelock_proc)
           pack $menu.col2.fr.scrolly -side right -fill y
           pack $menu.col2.fr.spec -fill both
           bind $menu.col2.fr.spec <Double-ButtonPress-1> [list setEntryVariable $menu.col2.fr.spec $menu.col2.entry "ProcLivelock"]
           bind $menu.col2.fr.spec <Return> [list setEntryVariable $menu.col2.fr.spec $menu.col2.entry "ProcLivelock"]
           frame $menu.col1.empty
           foreach w {empty empty add} n {55 61 20} {
               pack "$menu.col1.$w" -pady "$n" -side top
           }
           pack $menu.col1 -side left -expand true -padx 40
           foreach w {lspec fr entry check} n {5 5 5 20} {
               pack "$menu.col2.$w" -pady "$n" -side top
           }    
           pack $menu.col2 -side left -expand true     
    }
    if {$model != "Refinement"} {
        frame $menu.col3.empty
        foreach w {empty empty cancel} n {55 61 20} {
           pack "$menu.col3.$w" -pady "$n" -side top
        }
        pack $menu.col3 -side left -expand true -padx 40
    }
}

proc updateListBoxAfterModelView {model m} {
    global csp_assertions_dialog_arr
    set csp .checkCspAsser
    if {$model == "Refinement"} {
        updateListSpec $csp_assertions_dialog_arr(spec) $csp_assertions_dialog_arr(impl) $csp_assertions_dialog_arr(ref_model) $csp.frmSource.text $m
    } elseif {$model == "Determinism"} {
        updateListDeterm $csp_assertions_dialog_arr(deterministic_proc) $csp_assertions_dialog_arr(deterministic_model) $csp.frmSource.text $m
    } elseif {$model == "Deadlock"} {
        updateListDeadlock $csp_assertions_dialog_arr(deadlock_proc) $csp_assertions_dialog_arr(deadlock_model) $csp.frmSource.text $m
    } elseif {$model == "Livelock"} {
        updateListLivelock $csp_assertions_dialog_arr(livelock_proc) $csp.frmSource.text $m
    }
}

proc setEntryVariable {box entry pr} {
    global csp_assertions_dialog_arr
    foreach i [$box curselection] {
         $entry delete 0 end
         set choosen [$box get $i]
         switch $pr {
             "Proc1" {set csp_assertions_dialog_arr(spec) $choosen}
             "Modl"  {set csp_assertions_dialog_arr(ref_model)  $choosen}
             "Proc2" {set csp_assertions_dialog_arr(impl) $choosen}
             "ProcDet" {set csp_assertions_dialog_arr(deterministic_proc) $choosen}
             "ProcModl" {set csp_assertions_dialog_arr(deterministic_model) $choosen}
             "ProcDeadlock" {set csp_assertions_dialog_arr(deadlock_proc) $choosen}
             "ProcModlDeadlock" {set csp_assertions_dialog_arr(deadlock_model) $choosen}
             "ProcLivelock" {set csp_assertions_dialog_arr(livelock_proc) $choosen}
         }
    }
}

proc saveAssertionsListToFile {} {
    set types { {"Text File" {.txt} } }
    set machinesPath [getMachinesPath]
    set textFileName ""
    if {$machinesPath != "" && [file isdirectory $machinesPath]} {
         set textFileName [tk_getSaveFile -filetypes $types -initialdir $machinesPath -initialfile "Untitled.txt" -parent .checkCspAsser -defaultextension "txt"]
    } else {
         set textFileName [tk_getSaveFile -filetypes $types -initialfile "Untitled.txt" -parent .checkCspAsser -defaultextension "txt"]
    }
    set assList [.checkCspAsser.frmSource.text get 0 end]
    set pAssList [string map {"\} \{" "\n" "\{" "" "\}" ""} $assList]
    set fid [open $textFileName w]
    puts -nonewline $fid $pAssList
    close $fid
}

proc askToSaveNewAssertionsFromCheckCspWin {d par} {
   global strFilename UsedCspStrFilename\
          csp_assertions_dialog_arr checkCspAsser strFilenameTemporary
   if {[llength $csp_assertions_dialog_arr(all_new_assertions)] > 0 && false} {
        eval global f
        set f .checkCspAsser
        set ans [tk_messageBox -default yes -message "Do you want to save the generated new assertions in the current source file:\
                                    $UsedCspStrFilename.\nSave this assertions to disk?" \
                    	               -title "Warning" -type yesno -icon warning -parent $par]
        if { $ans == "yes" } {
            set csp_assertions_dialog_arr(listbox_size) 0
            addAllNewCspAssertionsInFileGlobal
            destroyCheckCspAsserWindowAndDeleteTmpFiles $d
        } else {
            set csp_assertions_dialog_arr(listbox_size) 0
            set csp_assertions_dialog_arr(all_new_assertions) {}
            destroyCheckCspAsserWindowAndDeleteTmpFiles $d
        }   
   } else {
       set csp_assertions_dialog_arr(listbox_size) 0
       destroyCheckCspAsserWindowAndDeleteTmpFiles $d
   }
}

proc destroyCheckCspAsserWindowAndDeleteTmpFiles {d} {
       global strFilenameTemporary strFilename UsedCspStrFilename
       if [file exists $strFilenameTemporary] {
                file delete $strFilenameTemporary
       }
       if {[expr {$d == "yes"}] && [winfo exists .checkCspAsser]} {
           destroy .checkCspAsser
           prolog parse_and_load_cspm_file('$UsedCspStrFilename')
       } elseif {[expr {$d == "yes"}] && ![winfo exists .checkCspAsser]} {
           prolog parse_and_load_cspm_file('$UsedCspStrFilename')
       } else {
           ## do not close .checkCspAsser
       }
}

proc addAllNewCspAssertionsInFileGlobal {} {
   global strFilename strFilenameTemporary UsedCspStrFilename csp_assertions_dialog_arr
   if { [llength $csp_assertions_dialog_arr(all_new_assertions)] > 0} {
       set twin .main.frmSource.text
       set lastEndIndex [$twin index end]
       $twin insert end "\n\n--These assertions are automatically added by the ProCSP tool on [clock format [clock seconds]].--\n"
       foreach i $csp_assertions_dialog_arr(all_new_assertions) {
           $twin insert end "\nassert $i"
       }
       $twin insert end "\n\n--End of the automatically added assertions.--\n"
       procHighlightTextSpecial $twin $lastEndIndex end
       $twin see end
       prolog "get_writable_compiled_filename(\'$UsedCspStrFilename\', \'.pl\', PrologFile)"
       set strPrologFilename $prolog_variables(PrologFile)
       prolog "parse_and_load_cspm_file_into_specific_pl_file(\'$UsedCspStrFilename\', \'$strPrologFilename\')"
       set csp_assertions_dialog_arr(all_new_assertions) {}
   }
}

proc procCopyFileContentToTemporaryFile {CspFile tmpCspFile} {
   if {[file exists $CspFile] && [file exists $tmpCspFile]} {
       set fileId [open $CspFile r]
       set fileTempId [open $tmpCspFile a]
       foreach line [split [read $fileId] \n] {
          puts $fileTempId $line
       }
       close $fileId
       close $fileTempId
   } elseif {![file exists $CspFile]} {
       tkErrorBoxNoParent "The source file does not exist."
   } elseif {![file exists $tmpCspFile]} {
       tkErrorBoxNoParent "The temporary file does not exist."
   } else {
       tkErrorBoxNoParent "The both files do not exist."
   }
}

proc procDeleteTmpFileContent {tmp} {
     prolog "generate_temporary_cspm_file(\'$tmp\', FileNameTemp)"
     set temp $prolog_variables(FileNameTemp)
     file rename -force $temp $tmp     
}

proc procRunCspmEvaluator {} {
   global eval_window_arr strFilename
   set widget .eval.frmSource.text
   $widget configure -state normal
   regexp {([0-9]+)\.([0-9]+)} [$widget index insert] match line col
   $widget delete $line.5 $line.end
   $widget insert $line.5 $eval_window_arr(input)
   set evalArg "--src="
   set EvalString [escapeChars $eval_window_arr(input)]
   if {$EvalString != ""} {
       set consoleCommand [lindex [split $EvalString] 0]
       if {$consoleCommand == "time"} {
		set EvalString [join [lreplace [split $EvalString] 0 0 ""]]
       }
       set eval_window_arr(input_index) [$widget index end]
       regexp {([0-9]+)\.[0-9]+} $eval_window_arr(input_index) match line
       if {$eval_window_arr(proCSPInterpreter)} {
		set csp_eval_command "evaluate_csp_expression(\'$EvalString\', \'$strFilename\',Result)"
	} else {
		set csp_eval_command "cspm_eval_expression_from_csp_file(\'$strFilename\', \'$evalArg\', \'$EvalString\', Result, ErrText)"
	}
        if {$consoleCommand == "time"} {
		set command "tcltk_time_call($csp_eval_command)"
		set now [clock clicks -milliseconds]
		procExecuteAndPrintOutCSPResult $widget $command
		set after [clock clicks -milliseconds]
		set RealTime [makePrettyTimeFormat [expr {$after-$now}]]
		prolog "eval_elapsed_time(Time)"
		set KernelTime [makePrettyTimeFormat $prolog_variables(Time)]
		$widget insert [$widget index insert] "\nreal time: $RealTime\nkernel time: $KernelTime\n"
        } else {
		procExecuteAndPrintOutCSPResult $widget $csp_eval_command
	}
        $widget see end
	incr line -1
	procAddNewEnterLine
	$widget highlight $line.0 end

   } else {
       procAddNewEnterLine
   }
}

proc procExecuteAndPrintOutCSPResult {widget command} {
       if {[prolog $command] && ![prolog get_all_errors(ERes)]} {
	       procWrapEvalOutput $widget $prolog_variables(Result)
	} else {
	       prolog get_all_errors(ERes)
	       set PResult [string map {";" "\n"} $prolog_variables(ERes)]
	       $widget insert [$widget index insert] "\n\nERRORS:\n $PResult"
	       prolog reset_errors
	}
}

proc makePrettyTimeFormat {ti} {
    set millisec [expr {round($ti)}]
    set min [expr {$millisec/60000}]
    set rem [expr {$millisec%60000}]
    set sec [format "%6.2d" [expr {$rem/1000}]]
    set rem1 [expr {$rem%1000}]
    set ms [format "%6.3d" $rem1]
    return [string map {" " ""} "$min m$sec .$ms s"]
}


proc changeTextvariablesInComboboxes {} {
   global csp_assertions_dialog_arr
   if {$csp_assertions_dialog_arr(spec) != "" && $csp_assertions_dialog_arr(impl) != ""} {
       set temp $csp_assertions_dialog_arr(spec)
       set csp_assertions_dialog_arr(spec) $csp_assertions_dialog_arr(impl) 
       set csp_assertions_dialog_arr(impl) $temp
   } else {
       tk_messageBox -parent .checkCspAsser -icon warning\
                         -message "One of the string values in the combboxes is empty."
  }
}

# procedure pops-up the context menu by performing a right click on a assertion declaration from the list box
proc procPerformAssertionsContextMenus {box X Y} {
     if {[$box get 0] != "No Assertions in this File found."} {
        set listy [winfo rooty $box]
        set ycoord [expr $Y -$listy]
        set index [$box nearest $ycoord]
        $box selection clear 0 end
        $box selection set $index
        $box activate $index
        set is_refinement disabled
        if [isRefinementAssertion [$box get $index]] {
            set is_refinement normal
        }
        CreatePopupMenuForTraces $box $is_refinement
        tk_popup .operationsCSPpopup $X $Y
     }
}

proc isRefinementAssertion {str} {
   set c [expr {[string first "\[F=" $str] + [string first "\[T=" $str] + \
              [string first "\[FD=" $str] >=0}]
   if {$c} {   
         return true
   }
   return false
}

proc SwapProcessesInListBox {box} {
  foreach i [$box curselection] {
         regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match sym str
         set last [$box index end]
         if [regexp {^(not) (.*)$} $str match n newstr] {
             set fileString [SwapProcessesInString $newstr]
             if {[isInTheListBox $box $last "$sym   not $fileString"] != -1} {
                  tk_messageBox -parent .checkCspAsser -icon error\
                           -message "Cannot swap processes at this assertion or assertion is already in the list."
             } else {
                  $box insert $last "?   not $fileString"
                  AppendStringToTheAssertionLists "not $fileString"
             }
         } else {
             set fileString [SwapProcessesInString $str]
             if {[isInTheListBox $box $last "$sym   $fileString"] != -1} {
                  tk_messageBox -parent .checkCspAsser -icon error\
                           -message "Cannot swap processes at this assertion or assertion is already in the list."
             } else {
                  $box insert $last "?   $fileString"
                  AppendStringToTheAssertionLists $fileString
             }
         }
         addAllNewCspAssertionsInFileIfNecessary $box "end"
  }
}

proc addAllNewCspAssertionsInFileIfNecessary {box ind} {
   global csp_assertions_dialog_arr
   if {[$box index $ind] >= $csp_assertions_dialog_arr(listbox_size)} {
       addAllNewCspAssertionsInFile
   }
}

proc SwapProcessesInString {str} {
   set l [split [string map {"\[T=" $ "\[F=" $ "\[FD=" $} $str] \$]
   set nextToLastL [expr {[string length [lindex $l 1]]-1}]
   set nextToLastR [expr {[string length [lindex $l 0]]-1}]
   set left_str [string map {" " ""} [string range [lindex $l 1] 0 $nextToLastL]]
   set right_str [string map {" " ""} [string range [lindex $l 0] 0 $nextToLastR]]
   set fileString ""
   if {[string first "\[T=" $str] > 0} {
       set fileString "$left_str \[T= $right_str"
   } elseif {[string first "\[F=" $str] >0 } {
       set fileString "$left_str \[F= $right_str"
   } else {
       set fileString "$left_str \[FD= $right_str"
   }
   return $fileString
}

proc CreatePopupMenuForTraces {box ref_state} {
  global llbox
  set llbox $box
  destroy .operationsCSPpopup
  menu .operationsCSPpopup -tearoff 0
  set debugState [procSeeIfAssertionExploredAndHolds $llbox]
  set checkState [procSeeIfTheSelectedAssertionIsChecked $llbox true]
  set uncheckState [procSeeIfTheSelectedAssertionIsChecked $llbox false]
  set runningModeState [procSeeIfAssertionCheckIsRunning $llbox]
  .operationsCSPpopup add command -label "Debug" -command {procShowCSPDebugTrace $llbox} -state $debugState
  .operationsCSPpopup add command -label "Check Assertion" -command {ActivateLineInListbox $llbox} \
                        -state $checkState
  .operationsCSPpopup add command -label "Interrupt Assertion Execution" -command {procInterruptAssertionExecution .checkCspAsser} \
                        -state $runningModeState 
  .operationsCSPpopup add command -label "Uncheck Assertion" -command {procUncheckACheckedAssertion $llbox} \
                        -state $uncheckState
  .operationsCSPpopup add command -label "Negate Assertion" -command {NegateLineInListBox $llbox} -state normal
  .operationsCSPpopup add command -label "Swap Processes" -command {SwapProcessesInListBox $llbox} -state $ref_state
  .operationsCSPpopup add sep
  .operationsCSPpopup add command -label "Check All Assertions" -command {CheckAllAssertionsInTheListBox $llbox} -state normal
  .operationsCSPpopup add sep
  .operationsCSPpopup add command -label "Open Specification with FDR" -command {procOpenFDROnSpec} -state normal
}

proc procUncheckACheckedAssertion {box} {
  foreach i [$box curselection] {
     regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match result str
     if {$result != "?"} {
         $box delete $i
         $box insert $i "?   $str"
         $box see $i
         $box activate $i
     } else {
         # do nothing
     }
  }
}

proc procSeeIfAssertionExploredAndHolds {box} {
  foreach i [$box curselection] {
     regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match result str
     if [regexp {^(not) .*} $str match not] {
         if {$result == "\u2718"} {
             return "disabled"
         }
     } else {
         if {$result == "\u2714"} {
               return "disabled"
         }
     }
  }
  return "normal"
}

proc procSeeIfTheSelectedAssertionIsChecked {box check} {
  foreach i [$box curselection] {
     regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match result str
     if {$result == "?" && $check == false && ($result != "\u231A" || $result != "checking...")} {
         return "disabled"
     } elseif {$result != "?" && $check == false && ($result != "\u231A" || $result != "checking...")} {
         return "normal"
     } elseif {$result == "?" && $check == true && ($result != "\u231A" || $result != "checking...")} {
         return "normal"
     } else {
         return "disabled"
     }
  }
}

proc procSeeIfAssertionCheckIsRunning {box} {
  foreach i [$box curselection] {
     regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match result str
     if {$result == "\u231A" || $result == "checking..."} {
         return "normal"
     } else {
         return "disabled"
     }
  }
}

proc procInterruptAssertionExecution {widget} {
     global lib_dir
     prolog "user: get_user_signal_ref(ID)"
     set ProcId $prolog_variables(ID)
     if [prolog tools:host_platform(windows)] {
         set cmd [list exec $lib_dir/send_user_interrupt.exe $ProcId]
     } else {
         set cmd [list exec $lib_dir/send_user_interrupt $ProcId]
     }
     if [catch {eval $cmd}] {
           puts "Error by interrupting process.\n Please check if the send_user_interrupt programm is in $lib_dir folder."
     } else {
        after idle {}
        update
        catch {focus $widget}
        
     }
}

proc procShowCSPDebugTrace {box} {
  global strFilename UsedCspStrFilename
  destroy .cspDebugWindow
  set w .cspDebugWindow
  foreach i [$box curselection] {
     set actualString ""
     set Negated ""
     regexp {([^a-zA-Z_]) \s* (.*)} [$box get $i] match sym str
     if [regexp {^(not)[\ ](.*)$} $str match n newstr] {
         set Negated "\'True\'"
         set actualString $newstr
     } else {
         set Negated "\'False\'"
         set actualString $str
     }
     set ModelString [procGetModelStringForTheTraceDebuggerTitle $actualString]
     if {$sym == "\ufffd"} {
              set outStr "Assertion check interrupted by user. No debugging info can be produced."
              tk_messageBox -parent .checkCspAsser -icon info -message $outStr
     } elseif {($sym == "\u2714" && $Negated == "\'False\'") || ($sym == "\u2718" && $Negated == "\'True\'") ||\
               ($sym == "TRUE" && $Negated == "\'False\'") || ($sym == "FALSE" && $Negated == "\'True\'") } {
              if {$ModelString == "Deadlock Free"} {
                     regexp (\[^:\]*): $actualString match Proc
                     set outStr "The Process $Proc has no deadlocks."
              } elseif {$ModelString == "Livelock Free"} {
                     regexp (\[^:\]*): $actualString match Proc
                     set outStr "The Process $Proc is divergence free."
              } elseif {$ModelString == "Deterministic"} {
                     regexp (\[^:\]*): $actualString match Proc
                     set outStr "The Process $Proc is deterministic."
              } else {
                     set l [split [string map {"\[T=" "$" "\[F=" "$" "\[FD=" "$" "\[R=" "$"} $actualString] \$]
                     set LeftProc [lindex $l 0]
                     set RightProc [lindex $l 1]
                     set outStr "$RightProc is a $ModelString of $LeftProc."
              }
              tk_messageBox -parent .checkCspAsser -icon info -message $outStr 
     } else {
        if {[catch { prolog "run_assertion_check_by_number(\'$UsedCspStrFilename\',$i,$Negated,Res)"
             set Result $prolog_variables(Res)}]} {
             puts "Unexpected interruption."
             ##procShowErrors
             ##break
        } else {
             if {$Result == "no_counter_example"} {
                 $box delete $i
                 if {$Negated == "\'True\'"} {
                     set res [procGetAssertionCheckResultSymbolPlatformDepended false]
                     $box insert $i "$res   not $actualString"
                 } else {
                     set res [procGetAssertionCheckResultSymbolPlatformDepended true]
                     $box insert $i "$res   $actualString"
                 }
             } elseif {$ModelString != "Unknown"} {
                 $box delete $i
                 if {$Negated == "\'True\'"} {
                     set res [procGetAssertionCheckResultSymbolPlatformDepended true]
                     $box insert $i "$res   not $actualString"
                 } else {
                     set res [procGetAssertionCheckResultSymbolPlatformDepended false]
                     $box insert $i "$res   $actualString"
                 }
                 if [Dialog_Create $w "Trace Debugger" -borderwidth 10] {
                     if {$ModelString == "Deadlock Free" || $ModelString == "Livelock Free"} {
                     ## matching just the process
                     regexp (\[^:\]*): $actualString match Proc
                     Create_Pane_Single_Trace $w $ModelString $Proc [procPrettyPrintCSPTrace [string map {"GO:" "go:"} $Result]]
                     } elseif {[string first "\[T=" $actualString] > 0 || [string first "\[F=" $actualString] > 0\
                           || [string first "\[FD=" $actualString] > 0 || [string first "\[R=" $actualString] > 0
                           || $ModelString == "Deterministic"} {
                           if {$ModelString == "Deterministic"} {
                               regexp (\[^:\]*): $actualString match Proc
                               set LeftProc $Proc; set RightProc $Proc
                               set isTraceRefinement 0; set isFailureRefinement 1
                            } else {
                               set l [split [string map {"\[T=" "$" "\[F=" "$" "\[FD=" "$" "\[R=" "$"} $actualString] \$]
                               set LeftProc [lindex $l 0]; set RightProc [lindex $l 1]
                               set isTraceRefinement [expr {[string first "\[T=" $actualString] > 0}]
                               set isFailureRefinement [expr {[string first "\[T=" $actualString] == -1}]
                            }
                            set outStr [split [string map {"Found counter example: " "" \
                                      "At_last_step_specification_can_do_one_of:" ";"\
                                      "Trace_of_the_left_specification:" ";"\
                                      "CANNOT_REFUSE_COMPL:" ";" "CANNOT_REFUSE:" ";"\
				      "REFUSED_SET:" "refuse:" \
				      "GO:" "go:"
				      } $Result] \;]
			    #puts "outStr: $outStr"
                            set len [llength $outStr]
                            if {$len == 3} {
                                set spec_trace [string trim [lindex $outStr 2]]
                                set impl_trace [string trim [lindex $outStr 0]]
                                set spec_accepts [string trim [lindex $outStr 1]]
                            } elseif {$len == 5} {
                                set spec_trace [string trim [lindex $outStr 4]]
                                set spec_accepts [string trim [lindex $outStr 3]]
                                set impl_trace [string trim [lindex $outStr 0]]
                                set impl_accepts [string trim [lindex $outStr 1]]
                                set impl_refuses [string trim [lindex $outStr 2]]
                                # need to be ample tested
                                set spec_accepts [procFindCommonElement $spec_accepts $impl_accepts $impl_refuses]
                                lappend spec_trace $spec_accepts
                            } else {
                                # Unknown handling of the list outStr
                            } 
                            if {($isTraceRefinement || $isFailureRefinement) && $len == 3} {
                                if {[lsearch $impl_trace DIVERGES] > -1 && $ModelString == "Deterministic" } {
                                    Create_Pane_Single_Trace $w $ModelString $Proc $impl_trace
                                } else {
                                    Create_Pane_TraceRefinement .cspDebugWindow $ModelString \
                                        $LeftProc $RightProc $spec_trace $spec_accepts $impl_trace horizontal
                                }
                            } elseif {$isFailureRefinement && $len == 5} {
                                Create_Pane_FailureRefinement .cspDebugWindow $ModelString \
                                        $LeftProc $RightProc $spec_trace $impl_trace $impl_accepts $impl_refuses horizontal
                            } else {
                            }
                           }
                         } 
                     } else {
                          tk_messageBox -parent .checkCspAsser -icon error\
                                 -message "Assertion declaration is not a valid refinement."
                     }
             }
       }
    }
}

proc procFindCommonElement {list1 list2 list3} {
     if {$list1 == {}} {
         return $list1
     } else {
         foreach i $list1 {
           set str1 [lindex [split $i \.] 0]
           if {$i != "tau" && [lsearch -exact $list2 $i] == -1 && [lsearch -regexp $list3 $str1] != -1} {
           return [list $i]
           }
         }
         # no common element found
         return [lsort -unique $list1]
     }
}

proc procGetModelStringForTheTraceDebuggerTitle {str} {
     set ModelString ""
     if {[string first "\[T=" $str] > 0} {
           set ModelString "Trace Refinement"
     } elseif {[string first "\[F=" $str] > 0} {
           set ModelString "Failure Refinement"
     } elseif {[string first "\[FD=" $str] > 0} {
           set ModelString "Failure-divergence Refinement"
     } elseif {[string first "\[R=" $str] > 0} {
           set ModelString "Refusal Testing Refinement"
     } elseif {[string first "deadlock" $str] > 0} {
           set ModelString "Deadlock Free"
     } elseif {[string first "livelock" $str] > 0} {
           set ModelString "Livelock Free"
     } elseif {[string first "deterministic" $str] > 0} {
           set ModelString "Deterministic"
     } else {
           set ModelString "Unknown"
     }
     return $ModelString
}

proc Create_Pane_Single_Trace {pane model Proc trace} {
     global csp_assertions_dialog_arr
     message $pane.model -justify center -text "Model: $model" -aspect 1000
     frame $pane.win
     frame $pane.win.w -borderwidth .1c -relief groove
     message $pane.win.w.spec -text "Specification:" -aspect 1000
     message $pane.win.w.msg  -text [procLimitStringLength $Proc 27] -aspect 1000
     scrollbar $pane.win.w.scrolly -command "$pane.win.w.text yview"
     scrollbar $pane.win.w.scrollx -orient horizontal -command "$pane.win.w.text xview"
     listbox $pane.win.w.text -yscroll "$pane.win.w.scrolly set" -xscroll "$pane.win.w.scrollx set"\
               -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
               -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
               -activestyle dotbox -selectmode browse
     foreach i [split $trace] {
           $pane.win.w.text insert end $i
     }
     pack $pane.model -fill x -expand false
     pack $pane.win -fill both -expand true
     if {[$pane.win.w.text get end] == "DEADLOCKS"} {
          message $pane.resultMsg -justify center -fg blue \
              -text "This process is not deadlock free." \
              -aspect 1000 -pady 10 -width 400
     } else {
          message $pane.resultMsg -justify center -fg blue \
              -text "This process diverges." \
              -aspect 1000 -pady 10 -width 400
     }
     pack $pane.win.w.spec $pane.win.w.msg -side top -fill x
     pack $pane.win.w.scrollx -side bottom -fill x
     pack $pane.win.w.scrolly -side right -fill y
     pack $pane.win.w.text -expand true -fill both
     pack $pane.win.w -side top -expand true -fill both
     pack $pane.resultMsg -expand false -fill x -side top
}

proc Create_Pane_TraceRefinement {pane model Proc Impl proc_trace proc_accepts impl_trace {orient horizontal}} {
    global csp_assertions_dialog_arr
    message $pane.model -justify center -text "Model: $model" -aspect 1000
    frame $pane.fr -width 450 -height 250

    foreach f {leftFrame rightFrame} name {"Specification:" "Implementation:"} bg {LightBlue LightGreen} pr [list $Proc $Impl] {
        frame $pane.fr.$f -borderwidth .1c -relief groove
        message $pane.fr.$f.spec -text $name -aspec 1000
        message $pane.fr.$f.proc  -text [procLimitStringLength $pr 27] -background $bg -aspect 1000
    }

    frame $pane.fr.leftFrame.fr
    foreach side {left right} titl {Accepts Trace} {
        frame $pane.fr.leftFrame.fr.$side -borderwidth .1c -relief groove
        message $pane.fr.leftFrame.fr.$side.title -text $titl -aspect 1000
        scrollbar $pane.fr.leftFrame.fr.$side.scrolly -orient vertical -command "$pane.fr.leftFrame.fr.$side.text yview"
        scrollbar $pane.fr.leftFrame.fr.$side.scrollx -orient horizontal -command "$pane.fr.leftFrame.fr.$side.text xview"
        listbox $pane.fr.leftFrame.fr.$side.text -yscroll "$pane.fr.leftFrame.fr.$side.scrolly set" \
          -xscroll "$pane.fr.leftFrame.fr.$side.scrollx set" \
          -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
          -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
          -activestyle dotbox -selectmode browse
        pack $pane.fr.leftFrame.fr.$side.title -side top
        pack $pane.fr.leftFrame.fr.$side.scrollx -side bottom -fill x
        pack $pane.fr.leftFrame.fr.$side.scrolly -side right -fill y
        pack $pane.fr.leftFrame.fr.$side.text -expand true -side top -fill both
    }
    pack $pane.fr.leftFrame.spec $pane.fr.leftFrame.proc -side top
    pack $pane.fr.leftFrame.fr -expand true -fill both
    pack propagate $pane.fr.leftFrame.fr off
    Pane_Create $pane.fr.leftFrame.fr.left $pane.fr.leftFrame.fr.right -in $pane.fr.leftFrame.fr\
                                                     -orient $orient -percent 0.5 -cursor sb_h_double_arrow

    frame $pane.fr.rightFrame.fr -borderwidth .1c -relief groove
    message $pane.fr.rightFrame.fr.title -text Trace -aspect 1000 
    scrollbar $pane.fr.rightFrame.fr.scrolly -orient vertical -command "$pane.fr.rightFrame.fr.text yview"
    scrollbar $pane.fr.rightFrame.fr.scrollx -orient horizontal -command "$pane.fr.rightFrame.fr.text xview"
    listbox $pane.fr.rightFrame.fr.text -yscroll "$pane.fr.rightFrame.fr.scrolly set" \
       -xscroll "$pane.fr.rightFrame.fr.scrollx set" \
       -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
       -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
       -activestyle dotbox -selectmode browse
    pack $pane.fr.rightFrame.spec $pane.fr.rightFrame.proc -side top
    pack $pane.fr.rightFrame.fr.title -side top
    pack $pane.fr.rightFrame.fr.scrollx -side bottom -fill x
    pack $pane.fr.rightFrame.fr.scrolly -side right -fill y
    pack $pane.fr.rightFrame.fr.text -expand true -side top -fill both
    pack $pane.fr.rightFrame.fr -expand true -fill both

    pack $pane.model -side top
    pack $pane.fr -expand true -fill both
    pack propagate $pane.fr off
    Pane_Create $pane.fr.leftFrame $pane.fr.rightFrame -in $pane.fr -orient $orient -percent 0.66 -cursor sb_h_double_arrow

    procFillTraceDebuggerListBox $pane.fr.leftFrame.fr.right.text $proc_trace
    procFillTraceDebuggerListBox $pane.fr.rightFrame.fr.text $impl_trace
    procInsertEventListIntoAppropriateListBox $pane.fr.leftFrame.fr.left.text $proc_accepts
}

proc procInsertEventListIntoAppropriateListBox {box list} {
    if {[llength $list] == 0} {
        $box insert end "\{ \}"
    } elseif {[llength $list] == 1} {
        $box insert end "\{ $list \}"
    } else {
        for {set i 0} {$i < [llength $list]} {incr i} {
            if {$i == 0} {
                $box insert end "\{ [lindex $list $i],"
            } elseif {$i == [expr {[llength $list] -1}] } {
                $box insert end "  [lindex $list $i] \}"
            } else {
                $box insert end "  [lindex $list $i],"
            }
        }
    }
}

proc Create_Pane_FailureRefinement {pane model Proc Impl proc_trace impl_trace accepts refuses {orient horizontal}} {
    global csp_assertions_dialog_arr
    message $pane.model -justify center -text "Model: $model" -aspect 1000
    frame $pane.fr -width 600 -height 250
    foreach f {leftFrame rightFrame} name {"Specification:" "Implementation:"} bg {LightBlue LightGreen} pr [list $Proc $Impl] {
        frame $pane.fr.$f -borderwidth .1c -relief groove
        message $pane.fr.$f.spec -text $name -aspec 1000
        message $pane.fr.$f.proc  -text [procLimitStringLength $pr 27] -background $bg -aspect 1000
    }
    frame $pane.fr.leftFrame.fr -borderwidth .1c -relief groove
    message $pane.fr.leftFrame.fr.title -text Trace -aspect 1000
    scrollbar $pane.fr.leftFrame.fr.scrolly -orient vertical -command "$pane.fr.leftFrame.fr.text yview"
    scrollbar $pane.fr.leftFrame.fr.scrollx -orient horizontal -command "$pane.fr.leftFrame.fr.text xview"
    listbox $pane.fr.leftFrame.fr.text -yscroll "$pane.fr.leftFrame.fr.scrolly set" \
       -xscroll "$pane.fr.leftFrame.fr.scrollx set" \
       -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
       -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
       -activestyle dotbox -selectmode browse
    pack $pane.fr.leftFrame.spec $pane.fr.leftFrame.proc -side top
    pack $pane.fr.leftFrame.fr.title -side top
    pack $pane.fr.leftFrame.fr.scrollx -side bottom -fill x
    pack $pane.fr.leftFrame.fr.scrolly -side right -fill y
    pack $pane.fr.leftFrame.fr.text -expand true -side top -fill both
    pack $pane.fr.leftFrame.fr -expand true -fill both

    frame $pane.fr.rightFrame.fr -borderwidth .1c -relief groove
    frame $pane.fr.rightFrame.fr.leftFr -relief flat

    pack $pane.fr.rightFrame.spec $pane.fr.rightFrame.proc -side top

    set leftFr $pane.fr.rightFrame.fr.leftFr
    foreach side {left right} titl {Trace Accepts} {
        frame $leftFr.$side -borderwidth .1c -relief groove
        message $leftFr.$side.title -text $titl -aspect 1000
        scrollbar $leftFr.$side.scrolly -orient vertical -command "$leftFr.$side.text yview"
        scrollbar $leftFr.$side.scrollx -orient horizontal -command "$leftFr.$side.text xview"
        listbox $leftFr.$side.text -yscroll "$leftFr.$side.scrolly set" \
          -xscroll "$leftFr.$side.scrollx set" \
          -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
          -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
          -activestyle dotbox -selectmode browse
        pack $leftFr.$side.title -side top
        pack $leftFr.$side.scrollx -side bottom -fill x
        pack $leftFr.$side.scrolly -side right -fill y
        pack $leftFr.$side.text -expand true -side top -fill both
    }
    pack $leftFr -expand true -fill both
    pack propagate $leftFr off
    Pane_Create $leftFr.left $leftFr.right -in $leftFr -orient $orient -percent 0.5 -cursor sb_h_double_arrow

    frame $pane.fr.rightFrame.fr.rightFr -borderwidth .1c -relief groove
    set rightFr $pane.fr.rightFrame.fr.rightFr
    message $rightFr.title -text Refuses -aspect 1000
    scrollbar $rightFr.scrolly -orient vertical -command "$rightFr.text yview"
    scrollbar $rightFr.scrollx -orient horizontal -command "$rightFr.text xview"
    listbox $rightFr.text -yscroll "$rightFr.scrolly set" \
       -xscroll "$rightFr.scrollx set" \
       -setgrid 1 -height 11 -width 30 -bg white -selectborderwidth 3 -selectbackground LightSkyBlue1 \
       -selectborderwidth 0 -selectforeground black -fg black -highlightcolor black -font {$csp_assertions_dialog_arr(fontname) 10} \
       -activestyle dotbox -selectmode browse
    pack $rightFr.title -side top
    pack $rightFr.scrollx -side bottom -fill x
    pack $rightFr.scrolly -side right -fill y
    pack $rightFr.text -expand true -side top -fill both
    pack $rightFr -expand true -fill both
    
    pack $pane.fr.rightFrame.fr -expand true -fill both
    pack propagate $pane.fr.rightFrame.fr off
    Pane_Create $leftFr $rightFr -in $pane.fr.rightFrame.fr -orient $orient -percent 0.66 -cursor sb_h_double_arrow

    pack $pane.model -side top
    pack $pane.fr -expand true -fill both
    pack propagate $pane.fr off
    Pane_Create $pane.fr.leftFrame $pane.fr.rightFrame -in $pane.fr -orient $orient -percent 0.25 -cursor sb_h_double_arrow

    procFillTraceDebuggerListBox $pane.fr.leftFrame.fr.text $proc_trace
    procFillTraceDebuggerListBox $pane.fr.rightFrame.fr.leftFr.left.text $impl_trace
    procInsertEventListIntoAppropriateListBox $leftFr.right.text $accepts
    procInsertEventListIntoAppropriateListBox $rightFr.text $refuses
}

proc procFillTraceDebuggerListBox {box list} {
    if {[llength $list] == 0} {
          $box insert end "Empty Trace"
    } else {
          foreach el [procPrettyPrintCSPTrace $list] {
              $box insert end [string map {"!" "\." "?" "\."} $el]
          }
    }
}

proc procGetSubString {list cutAtSymbol} {
    set result {}
    set len [llength $list]
    for {set i 0} {$i < $len} {incr i} {
        set el [lindex $list $i]
        if {$el != $cutAtSymbol} {
		lappend result $el
	} else {
		break
	}
    }
    return $result
}

proc procPrettyPrintCSPTrace {list} {
    set len [llength $list]
    set i 0
    set result {}
    while {$i < $len} {
	if {[lindex $list $i] == "go:"} {
		incr i
		lappend result [lindex $list $i]
		set step 1
	} elseif {[lindex $list $i] == "refuse:"} {
		incr i
		set refused_set [procGetSubString [lrange $list $i $len] "go:"]
                set step [llength $refused_set]
		set refused_set_string [string map {" " "," "Sigma" "\u03A3"} [join $refused_set]]
		if {[string first "\u03A3" $refused_set_string] >= 0} {
			lappend result $refused_set_string
		} else {
			lappend result "\{$refused_set_string\}"
		}
	} else {
		lappend result [lindex $list $i]
		set step 1
	}
	incr i $step
    }
    return $result
}


proc procLimitStringLength {str len} {
   if {[string length $str] > 30} {
       set str [string range $str 0 29] 
       append str "..."
   }
   return $str
}

proc returnASpecificNumberOfElements {list numb} {
   if {[llength $list] >= $numb} {
     set lres {}
     set tau_event false
     
     for {set i 0} {$i < $numb} {incr i} {
          set el [lindex $list $i]
          if {$el != ""} {
              lappend lres $el
          } 
     }
     lappend lres "..."
     return $lres
   } else {
     return $list
   }
}

proc NegateLineInListBox {box} {
  foreach i [$box curselection] {
     regexp {([^a-zA-Z_]) [\ ]* (.*)} [$box get $i] match sym str
     set last [$box index end]
     if [regexp {^(not) (.*)$} $str m n str1] {
            if {[isInTheListBox $box $last "$sym   $str1"] != -1} {
                  tk_messageBox -parent .checkCspAsser -icon error\
                           -message "The negated version of this assertion is already in the list."
            } else {
                  $box insert $last "?   $str1"
                  AppendStringToTheAssertionLists $str1
            }
     } else {
            if {[isInTheListBox $box $last "$sym   not $str"] != -1} {
                  tk_messageBox -parent .checkCspAsser -icon error\
                           -message "The negated version of this assertion is already in the list."
            } else {
                  $box insert $last "?   not $str"
                  AppendStringToTheAssertionLists "not $str"
            }
     }
         addAllNewCspAssertionsInFileIfNecessary $box "end"
  }
}

proc procCheckAllAssertionsFromType {box ty} {
    addAllNewCspAssertionsInFileIfNecessary $box "end"
    for {set i 0} {$i < [$box index end]} {incr i} {
         regexp {([^a-zA-Z0-9_])[\ ]*(.*)} [$box get $i] match mark str
         if {$mark != "\u2714" && $mark != "\u2718"} {
             set m [string first "\[$ty" $str]
             set d [string first "$ty" $str]
             if {$m != -1} {
                 HandleRefinementAssertion $box $str $i
             } elseif {$d !=-1 && $ty == "deterministic"} {
                 HandleRefinementAssertion $box $str $i
             } elseif {$d !=-1 && $ty == "livelock"} {
                 HandleRefinementAssertion $box $str $i
             } elseif {$d !=-1 && $ty == "deadlock"} {
                 HandleRefinementAssertion $box $str $i
             }
         }
    }
}

proc CheckAllAssertionsInTheListBox {box} {
    addAllNewCspAssertionsInFileIfNecessary $box "end"
    set i 0
    if {[$box get 0] != "No Assertions in this File found."} {
       foreach ln [$box get 0 end] {
            regexp {([^a-zA-Z_])[\ ]*(.*)} [$box get $i] match mark str
            if {$mark != "\u2714" && $mark != "\u2718"} {
                HandleRefinementAssertion $box $str $i
            }
            incr i
       }
    }
}

proc addAllNewCspAssertionsInFile {} {
   global strFilename strFilenameTemporary csp_assertions_dialog_arr
   global UsedCspStrFilename
   if {[llength $csp_assertions_dialog_arr(current_new_assertions)] > 0} {
       set fileId [open $strFilenameTemporary a]
       foreach i $csp_assertions_dialog_arr(current_new_assertions) {
           puts "Assertion to be added: $i."
           puts $fileId "assert $i"
       }
       close $fileId
       prolog "get_writable_compiled_filename(\'$UsedCspStrFilename\', \'.pl\', PrologFile)"
       set strPrologFilename $prolog_variables(PrologFile)
       puts "strFilenameTemporary: $strFilenameTemporary"
       puts "strPrologFilename: $strPrologFilename"
       prolog "parse_and_load_cspm_file_into_specific_pl_file(\'$strFilenameTemporary\', \'$strPrologFilename\')"
       if [prolog real_error_occurred] {
            ## An error occurred while loading file, which is not necessary parse error.
            ## Below we check what kind of error occurred and in case of parse error, then
            ## we return false.
            if [prolog get_all_errors(Res)] {
                puts "Real error occurred"
                set errors_occurred $prolog_variables(Res) 
                set error_lines [split $errors_occurred ";:"]
                if {[lsearch -exact $error_lines "Error while parsing CSP-M"] != -1} {
                    ## Parse error occured in the Temporary file!
                    ## We have to delete the last line of the file and tell the user
                    ## to correct the assertion.
	            procShowErrors
	            set fileIdNew [open $strFilenameTemporary r]
	            set FileContent [split [read $fileIdNew] \n]
	            close $fileIdNew
	            procDeleteTmpFileContent $strFilenameTemporary
	            set NewFileContent [ldelete $FileContent [lindex $FileContent end-1]]
	            set lastLine [lindex $FileContent end-1]
	            puts "The last line in the temporary file is: $lastLine."
	            set fileIdNew [open $strFilenameTemporary r+]
	            foreach i $NewFileContent {
	                  puts $fileIdNew $i
	            }
	            close $fileIdNew
	            ## parse the temporary file without the last added assertion
	            prolog "parse_and_load_cspm_file_into_specific_pl_file(\'$strFilenameTemporary\', \'$strPrologFilename\')"
	            ## delete the last element from the csp_assertions_dialog_arr(current_new_assertions) and csp_assertions_dialog_arr(all_new_assertions)
	            set csp_assertions_dialog_arr(current_new_assertions) \
                               [ldelete $csp_assertions_dialog_arr(current_new_assertions) [lindex $csp_assertions_dialog_arr(current_new_assertions) end]]
		    set csp_assertions_dialog_arr(all_new_assertions) \
                               [ldelete $csp_assertions_dialog_arr(all_new_assertions) [lindex $csp_assertions_dialog_arr(all_new_assertions) end]]
	            prolog "reset_errors"
	            return false
                } 
            }   
      }   
      # File is parsable
      set csp_assertions_dialog_arr(current_new_assertions) {}
      return true
 } else {
       # no assertion to be added
       return true
 }
}

proc ldelete { list value } {
   set ix [lsearch -exact $list $value]
   if {$ix >= 0} {
       return [lreplace $list $ix $ix]
   } else {
       return $list
   }
}

proc ActivateLineInListbox {box} {
    if {[$box get 0] != "No Assertions in this File found."} {
       foreach i [$box curselection] {
           regexp {([^a-zA-Z_])[\ ]*(.*)} [$box get $i] match result str
           #puts "The Result of this assertion is $result"
           if {$result == "?" || $result == "\ufffd" || $result == "checking..."} {
                addAllNewCspAssertionsInFileIfNecessary $box $i
                HandleRefinementAssertion $box $str $i
          } else {
                procShowCSPDebugTrace $box
          }
       }
    }
}

proc HandleRefinementAssertion {box str i} {
     ParseStringAssertions $box $str $i false
}

proc ParseStringAssertions {box str i is_new} {
## possible input arguments for this procedure:
## Refinement Assertions: "P [m= Q" or "not P [m= Q" where P and Q are Processes and m can be T, F, FD or R    
## Determinism Assertions: "P :[ deterministic [m]]" or "not P :[determinism [m]]" where m F or FD is and P is Process  
## Deadlock Assertions: "P :[ deadlock free [m]]" or "not P :[deadlock free [m]]" m and P are the same as above
## Livelock Assertions: "P :[ livelock free [m]]" or "not P :[ livelock free [m]]" m and P are the same as above
## We use here regexp command
   global strFilename UsedCspStrFilename
   if {![procIsAnyOfTheSubstringsInTheString $str "\u2718" "\u2714" "\u231A" "TRUE" "FALSE" "checking..."]} {
       if {!$is_new} {
           $box delete $i
       }
       if [procIsOSAnOlderVersionOfWindowsMS] {
           $box insert $i "checking...   $str"
       } else {
           $box insert $i "\u231A   $str"
       }
       update
       $box see $i
       $box activate $i
       set Result ""
       catch {focus .checkCspAsser.frmSource.text}
       catch {grab .checkCspAsser}
       set csp_assertions_dialog_arr(assertion_check_running) 1
       procChangeCancelButtonsTextInCheckCspAsser "Interrupt"
       procChangeStateStatusOfCheckButtonsInCheckCspAsser "disabled"
       update
       if {[catch { prolog "run_assertion_check_by_number(\'$UsedCspStrFilename\',$i,Negated,RR)"
                    set Result $prolog_variables(RR);update} result]} {
           catch {grab release .checkCspAsser}
           puts "An error occurred..."
           puts $result
	   procShowErrors
           # error occurred by Assertion Check
       } else {
           catch {grab release .checkCspAsser}
           $box delete $i
           if {$prolog_variables(Negated) == "True" } {
               if {$Result == "no_counter_example"} {
                   set res [procGetAssertionCheckResultSymbolPlatformDepended false]
                   $box insert $i "$res   $str"
               } elseif {$Result == "interrupted"} {
                   $box insert $i "\ufffd   $str"
               } else {
                   set res [procGetAssertionCheckResultSymbolPlatformDepended true]
                   $box insert $i "$res   $str"
              }
           } else {
              if {$Result == "no_counter_example"} {
                   set res [procGetAssertionCheckResultSymbolPlatformDepended true]
                   $box insert $i "$res   $str"
              } elseif {$Result == "interrupted"} {
                   $box insert $i "\ufffd   $str"
              } else {
                   set res [procGetAssertionCheckResultSymbolPlatformDepended false]
                   #puts "Found counter example: $Result."
                   $box insert $i "$res   $str"
              }
           }
           $box see $i
           procInsertHistoryOptionsState
           procShowErrors
       }
       set csp_assertions_dialog_arr(assertion_check_running) 0
       procChangeCancelButtonsTextInCheckCspAsser "Cancel"
       procChangeStateStatusOfCheckButtonsInCheckCspAsser "normal"
       update
  }
}

proc procIsAnyOfTheSubstringsInTheString {str args} {
  if {[llength $args] == 0} {
       return true
  } else {
       foreach i $args {
            if {[string first $i $str] > -1} {
                return true
            }
       }
       return false
  }
}

proc procGetAssertionCheckResultSymbolPlatformDepended {result} {
  if {$result} {
      if [procIsOSAnOlderVersionOfWindowsMS] {
          return "TRUE"
      } else {
          return "\u2714"
      }
  } else {
      if [procIsOSAnOlderVersionOfWindowsMS] {
          return "FALSE"
      } else {
          return "\u2718"
      }
  }
}

proc procIsOSAnOlderVersionOfWindowsMS {} {
  global tcl_platform
  if [prolog tools:host_platform(windows)] {
       if {$tcl_platform(osVersion) < 6.0 } {
           return true
       }
  }
  return false
}

proc procChangeCancelButtonsTextInCheckCspAsser {text} {
       global tcl_version
       set m .checkCspAsser.refMenu
       if {$tcl_version >= 8.5} {
           foreach b [list $m.refinement $m.determinism $m.deadlock $m.livelock] {
               $b.col3.cancel configure -text $text
           }
       } else {
           $m.col3.cancel configure -text $text
       }
}

proc procChangeStateStatusOfCheckButtonsInCheckCspAsser {status} {
       global tcl_version
       set m .checkCspAsser.refMenu
       if {$tcl_version >= 8.5} {
           foreach b [list $m.refinement $m.determinism $m.deadlock $m.livelock] {
                $b.col2.check configure -state $status
           }
       } else {
           $m.col2.check configure -state $status
       }
}

proc procChangeFontSize {box fname num} {
    $box configure -font "$fname $num"
}

proc procChangeFontName {box fname fsize} {
    $box configure -font "$fname $fsize"
}

proc procChangeBackground {box bgr} {
    $box configure -bg  $bgr
}

proc procChangeSelectColor {box col} {
    $box configure -selectbackground $col
}

proc procUpdateListBoxIfExists {box must_be_checked is_reopen_process} {
   global csp_assertions_dialog_arr strFilename strFilenameTemporary
   global UsedCspStrFilename
   if [winfo exists $box] {
        if {$is_reopen_process} {
             prolog "generate_temporary_cspm_file(\'$UsedCspStrFilename\', FileNameTemp)"
             procDeleteTmpFileContent $strFilenameTemporary
             procCopyFileContentToTemporaryFile $UsedCspStrFilename $strFilenameTemporary
        }
        set len [$box.frmSource.text index end]
        set listStr [$box.frmSource.text get 0 end]
        $box.frmSource.text delete 0 $len
        prolog "get_csp_assertions_as_string(\'$UsedCspStrFilename\',Res)"
        set Result [split [string map {"CSP: " ""} [string trimright $prolog_variables(Res) {$}]] \$]
        set csp_assertions_dialog_arr(listbox_size) [llength $Result]
        if {"$Result"==""} {
             $box.frmSource.text insert end "No Assertions in this File found."
             update
        } else {
             set currentIndex 0
             foreach i $Result {
                 if {$is_reopen_process} {
                     $box.frmSource.text insert end "?   $i"
                 } else {
                     foreach j $listStr {
                         if [regexp {(TRUE|FALSE) \s* (.*)} $j match symbol str] {
                             # do nothing
                         } else {
                            regexp {^([^a-zA-Z_]) \s* (.*)} $j match symbol str
                         }
                         if {$str == $i} {
                             $box.frmSource.text insert end "$symbol   $i"
                             break
                             # there could be more than one assertion from this type in the listStr list
                         }
                     }
                 }
             }
             if {[expr {[expr {$len +1}] == [llength $Result]}] && [expr {!$is_reopen_process}]} {
                  set newAssertion [lindex $Result end]
                  $box.frmSource.text insert end "?   $newAssertion"
             }
             if {$must_be_checked && [expr {!$is_reopen_process}]} {
                 if [procIsOSAnOlderVersionOfWindowsMS] {
                     regexp {^(TRUE|FALSE|\?) \s* (.*)$} [$box.frmSource.text get end] match sym new_str
                 } else {
                     regexp {^([^a-zA-Z0-9_]) \s* (.*)$} [$box.frmSource.text get end] match sym new_str
                 }
                 ParseStringAssertions $box.frmSource.text $new_str [expr {[$box.frmSource.text index end] -1}] false
             }
             update
        }
   }
}

proc updateListSpec {Proc1 Proc2 Model ListBox must_be_checked} {
# test if options and proc are selected
    if {$Proc1 != "" && $Proc2 != "" && $Model != ""} {
       deleteFirstRowIfThereAreNoAssertionsInTheListbox $ListBox
       set str ""
       set len [$ListBox index end]
       switch $Model {
          "Trace"   {set str "$Proc1 \[T= $Proc2"}
          "Failure" {set str "$Proc1 \[F= $Proc2"}
          "Failure-Divergence" {set str "$Proc1 \[FD= $Proc2"}
          "Refusals" {set str "$Proc1 \[R= $Proc2"}
          default {}
       }
       AddTheNewDefinedStringInListBox $ListBox $str $must_be_checked
    } else {
       tk_messageBox -parent .checkCspAsser -icon warning -message "No Process or Model has been selected."
    }
}

proc updateListDeterm {Proc Model ListBox must_be_checked} {
# test if proc and an option for the deterministic check are selected
   if {$Proc != "" && $Model != ""} {
      deleteFirstRowIfThereAreNoAssertionsInTheListbox $ListBox
      set str ""
      set len [$ListBox index end]
      switch $Model {
          "Failure" {set str "$Proc :\[ deterministic \[F\] \]"}
          "Failure-Divergence" {set str "$Proc :\[ deterministic \[FD\] \]"}
          default {}
      }
      AddTheNewDefinedStringInListBox $ListBox $str $must_be_checked
   } else {
       tk_messageBox -parent .checkCspAsser -icon warning -message "No Process or Model has been selected."
   }
}

proc updateListDeadlock {Proc Model ListBox must_be_checked} {
   if {$Proc != "" && $Model != ""} {
      deleteFirstRowIfThereAreNoAssertionsInTheListbox $ListBox
      set str ""
      set len [$ListBox index end]
      switch $Model {
          "Failure" {set str "$Proc :\[ deadlock free \[F\] \]"}
          "Failure-Divergence" {set str "$Proc :\[ deadlock free \[FD\] \]"}
          default {}
      }
      AddTheNewDefinedStringInListBox $ListBox $str $must_be_checked
   } else {
       tk_messageBox -parent .checkCspAsser -icon warning -message "No Process or Model has been selected."
   }
}

proc updateListLivelock {Proc ListBox must_be_checked} {
   if {$Proc != "" } {
      deleteFirstRowIfThereAreNoAssertionsInTheListbox $ListBox
      set len [$ListBox index end]
      set str "$Proc :\[ livelock free \]"
      AddTheNewDefinedStringInListBox $ListBox $str $must_be_checked
   } else {
       tk_messageBox -parent .checkCspAsser -icon warning -message "No Process or Model has been selected."
   }
}

proc procAddNewAssertionToTheFileText {str} {
   .main.frmSource.text insert end "\nassert $str"
   .main.frmSource.text see end
}

proc deleteFirstRowIfThereAreNoAssertionsInTheListbox {ListBox} {
   if {[$ListBox get 0] == "No Assertions in this File found."} {
        $ListBox delete 0
   }
}

proc AddTheNewDefinedStringInListBox {ListBox str must_be_checked} {
    set len [$ListBox index end]
    set ind [isInTheListBox $ListBox $len "?   $str"]
    if {$ind == -1} {
        AppendStringToTheAssertionLists $str
        if [addAllNewCspAssertionsInFile] {
             procUpdateListBoxIfExists .checkCspAsser $must_be_checked false
             #procAddNewAssertionToTheFileText $str
        } else {
             tk_messageBox -parent .checkCspAsser -icon error -message "The Assertion $str is not parsable."
        }
     } else {
        if [procIsOSAnOlderVersionOfWindowsMS] {
            regexp {^(TRUE|FALSE) \s* (.*)} [$ListBox get $ind] match symbol str
        } else {
            regexp {^([^a-zA-Z_]) \s* (.*)} [$ListBox get $ind] match symbol str
        }
        if {$symbol == "\u2714" || $symbol == "\u2718" || $symbol == "FALSE" || $symbol == "TRUE"} {
            tk_messageBox -parent .checkCspAsser -icon warning -message "Assertion has been already checked"
        } else {
            tk_messageBox -parent .checkCspAsser -icon warning -message "Assertion is already in the List."
            $ListBox selection clear 0 end
            $ListBox selection set $ind
            if {$must_be_checked} {
                ActivateLineInListbox $ListBox
            }
        }
     }
}

proc AppendStringToTheAssertionLists {str} {
   global csp_assertions_dialog_arr
   lappend csp_assertions_dialog_arr(current_new_assertions) $str
   lappend csp_assertions_dialog_arr(all_new_assertions) $str
}

proc InsertStringIntoListBox {lbox str len} {
     if {[isInTheListBox $lbox $len $str] > -1} {
           tk_messageBox -parent .checkCspAsser -icon warning \
              -message "This Assertion has been already selected."
     } else {
           $lbox insert end $str
     }
}

proc isInTheListBox {lbox len str} {
    for {set i 0} {$i < $len} {incr i 1} {
         if [procIsOSAnOlderVersionOfWindowsMS] {
             regexp {^(TRUE|FALSE|\?) \s* (.*)} $str match ignore new_str
             regexp {^(TRUE|FALSE|\?) \s* (.*)} [$lbox get $i] match ignore lstr
         } else {
             regexp {^([^a-zA-Z_]) \s* (.*)} $str match ignore new_str
             regexp {^([^a-zA-Z_]) \s* (.*)} [$lbox get $i] match ignore lstr
         }
         if {$lstr == $new_str} {
             return $i
         }
    }
    return -1
}

proc CheckLtlAssertions {} {
  if [prolog animation_mode(cspm)] {
	global strFilename
	set Cmd1 "haskell_csp:get_ltl_formulas_from_cspm_file(Res)"
  } else {
	set Cmd1 "b_get_definition_string_list_from_machine('ASSERT_LTL',Res)"
  }
  set Cmd2 "ltl_model_check('\$i',100000,init,Res)"
  CheckAssertions $Cmd1 $Cmd2 "LTL"
}

proc CheckAssertions {GetAssertionListCmd Eval_ith_AssertionCmd TypeOfAssertion} {
	global ok batch_mode
	global InvKO InvOK InvUnknown 
    destroy .checkltl
    set f .checkltl
	if [Dialog_Create $f "Check $TypeOfAssertion Assertions" -borderwidth 10] {
		message $f.msg -text "List of ASSERT_LTL Formulas" -aspect 1000
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        listbox $f.frmSource.text -yscroll "$f.frmSource.scrolly set" \
         -setgrid 1 -height 11 -width 70 -bg white -selectborderwidth 3 -selectbackground brown \
         -fg darkgreen -highlightcolor blue
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.text -expand 1 -fill both

		set b [frame $f.buttons]
	    set c [frame $f.checks]
		pack $f.msg $f.frmSource $f.checks $f.buttons -side top -fill x
		pack $f.frmSource -pady 5 -expand 1 -fill both
		global lastiOption boolPrefVal
		set lastiOption 0
		message $c.valmsg -text "" -aspect 1000
		button $c.inv -text "" -image InvUnknown -relief flat
		pack $c.inv $c.valmsg -side left
		# button $b.ok -text "Check All LTL Formulas" -command {set ok 1}
		button $b.cancel -text Cancel -command {set ok 2} -state disabled
		pack $b.cancel -side right 

		bind $f.frmSource <Control-c> {set ok 2 ; break}
	}
    prolog $GetAssertionListCmd
	set Result [split [string trimright $prolog_variables(Res) {;}] \;]
    foreach i $Result {
       $f.frmSource.text insert end "$i == ?"
    }
    if {$Result==""} {
      if [prolog animation_mode(b)] {
        $f.frmSource.text insert end  "No ASSERT_LTL in the DEFINITIONS."
        $f.frmSource.text insert end "Add DEFINITIONS of the form ASSERT_LTLnr == \"LTL FORMULA\" to your B model."
      } elseif [prolog animation_mode(cspm)] {
        $f.frmSource.text insert end  "No ASSERT_LTL_ inside of pragmas in the Csp model."
        $f.frmSource.text insert end "Add pragmas of the form {-# ASSERT_LTL_nr == \"LTL FORMULA\" #-} to your Csp model."
      } else {
        $f.frmSource.text insert end "LTL Assertions are only supported for B and Csp models at the moment.
      }
    
    }
    
	catch {tkwait visibility $f}
   set index 0
   set errors 0
   foreach i $Result {
		 $c.valmsg configure -text "Checking $i"
	     $f.frmSource.text delete $index
		 $f.frmSource.text insert $index "-->> $i == CHECKING" 
		 $f.frmSource.text see $index
		 $f.frmSource.text activate $index
		 $f.frmSource.text selection set $index $index
		 update
		 if [prolog [subst $Eval_ith_AssertionCmd]] {
			set res $prolog_variables(Res)
			$f.frmSource.text delete $index
		     if {$res == "ok"} {
			 $f.frmSource.text insert $index "$i == TRUE" 
		     } elseif {$res == "no"} {
			 $f.frmSource.text insert $index "$i == FALSE" 
			 # tkErrorBox "Formula FALSE.\nCounterexample found for $i."
			 # procInsertHistoryOptionsState
			 incr errors 1
			 $f.frmSource.text selection set $index $index
		     } elseif {$res == "syntax_error"} {
			 $f.frmSource.text insert $index "$i == SYNTAX_ERROR" 
			 incr errors 1
			 $f.frmSource.text selection set $index $index
		     } elseif {$res == "nostart"} {
			 $f.frmSource.text insert $index "$i == NO_INITIALISATION_FOUND" 
			 incr errors 1
			 $f.frmSource.text selection set $index $index
		     } else {
			 $f.frmSource.text insert $index "$i == UNKNOWN_ERROR" 
			 incr errors 1
			 $f.frmSource.text selection set $index $index			 
		     }
		 } else {
		     tkErrorBox "Internal error: LTL model checking failed."
		     incr errors 1
		}
		procShowErrors
		incr index 1
	}
	if {$errors>0} {
	   $c.valmsg configure -text "Errors occurred: $errors !"
	   procInsertHistoryOptionsState
	   $c.inv configure -image InvKO
	   if {$batch_mode} {
	       prolog assert_cli_error_occured(check_ltl_assertions)
	   }
	} else {
	   $c.valmsg configure -text "All formulas valid"
	   $c.inv configure -image InvOK
	}
	$b.cancel configure -text "Done" -state normal
	
    set ok 0
	# Dialog_Wait $f ok $f.frmSource
    if {!$batch_mode} {
	   tkwait variable ok
	}
	Dialog_Dismiss $f
	procInsertHistoryOptionsState
}

proc KodkodDialog {options errors} {
    global prompt
    set result [list]
    destroy .kodkod
    if [Dialog_Create .kodkod "Kodkod" -borderwidth 10] {
#	set oldresult $prompt(result)
	set prompt(result) $options
	set prompt(errors) $errors

	message .kodkod.msg -aspect 1000 \
	    -text "Please specify which parts of the B machine should be replaced"

	frame .kodkod.select
	listbox .kodkod.select.list -selectmode multiple -listvariable prompt(result)
	frame .kodkod.select.buttons
	button .kodkod.select.buttons.all -text "Select all" \
	    -command {.kodkod.select.list selection set 0 999999}
	button .kodkod.select.buttons.none -text "Deselect all" \
	    -command {.kodkod.select.list selection clear 0 999999}
	button .kodkod.select.buttons.errors -text "Show Errors" \
	    -command {KodkodErrors}
	pack .kodkod.select.buttons.all .kodkod.select.buttons.none -fill x -side top
	pack .kodkod.select.buttons.errors -fill x -side bottom
	pack .kodkod.select.list -side left -expand 1 -fill x
	pack .kodkod.select.buttons -side right -fill y
	
	frame .kodkod.buttons
	button .kodkod.buttons.ok -text OK -command {set prompt(ok) 1}
	button .kodkod.buttons.cancel -text Cancel -command {set prompt(ok) 0}
	pack .kodkod.buttons.ok -side left
	pack .kodkod.buttons.cancel -side right
	bind .kodkod <Return> {set prompt(ok) 1 ; break}
	bind .kodkod <Control-c> {set prompt(ok) 0 ; break}

	pack .kodkod.msg .kodkod.select .kodkod.buttons -fill x
	
	set prompt(ok) 0
	Dialog_Wait .kodkod prompt(ok) .kodkod.select.list
	Dialog_Dismiss .kodkod

	if {$prompt(ok) == 1} {
	    foreach i [.kodkod.select.list curselection] {
		lappend result [lindex $options $i]
	    }
	}
#	set prompt(result) $oldresult
    }
    return $result
}

proc KodkodErrors {} {
    global prompt
    destroy .kodkoderrors
    if [Dialog_Create .kodkoderrors "Kodkod: Errors" -borderwidth 10] {
	message .kodkoderrors.msg -aspect 1000 \
	    -text "The following parts of the specification were not applicable to Kodkod"
	listbox .kodkoderrors.list -listvariable prompt(errors)
	button .kodkoderrors.ok -text OK -command {set prompt(errorsbt) 1}
	pack .kodkoderrors.msg
	pack .kodkoderrors.list -expand 1 -fill both
	pack .kodkoderrors.ok -side left
	bind .kodkod <Return> {set prompt(errorsbt) 1 ; break}
	bind .kodkod <Key-Escape> {set prompt(errorsbt) 0 ; break}
	set prompt(errorsbt) 0
	Dialog_Wait .kodkoderrors prompt(errorsbt) .kodkoderrors.list
	Dialog_Dismiss .kodkoderrors
    }
}

proc procUpdateLtlFormulaHistory {} {
	global ltldata
	puts "updating ltl history $ltldata(formula)"
	if {$ltldata(formula) != ""} {
		prolog preferences:add_element_to_history(checked_ltl_formulas,'$ltldata(formula)',10)
		set tmpList [list $ltldata(formula)]
	} else {
		set tmpList {}
	}
	foreach i $ltldata(hist) {
		if {$ltldata(formula) != $i} {
			lappend tmpList $i
		}
	}
	set ltldata(hist) $tmpList
	.ltl.formula configure -values [lrange $tmpList 0 9]
}

proc LtlDialog {title msg} {
    global ltldata strFilename
    destroy .ltl
    prolog preferences:get_history_elements_list(checked_ltl_formulas,true,Formulas)
    set ltldata(hist) $prolog_variables(Formulas)
    if [Dialog_Create .ltl $title -borderwidth 10] {
	message .ltl.msg -text $msg -aspect 1000
	ttk::combobox .ltl.formula -textvariable ltldata(formula) -width 40 -state editable -value $ltldata(hist)
	set CMD [procGetAccKey]
	if {$ltldata(formula) == ""} {
	 	    if [prolog bmachine:b_get_definition_string_from_machine('ASSERT_LTL',Res)] {
	 	        set ltldata(formula) $prolog_variables(Res)
	 	    } elseif {[prolog animation_mode(cspm)] && [prolog haskell_csp:get_ltl_formula_from_cspm_file(Res)]} {
			#set ltldata(formula) $prolog_variables(Res)
		    }
  	}

	frame .ltl.states
	message .ltl.states.msg -text "Max no. of new states:" -aspect 1000 
	entry .ltl.states.max -textvariable ltldata(result) -width 9
	pack .ltl.states.msg .ltl.states.max -side left

	frame .ltl.modi
	radiobutton .ltl.modi.init -variable ltldata(mode) -value "init" \
	    -text "Start search in initialisation"
	radiobutton .ltl.modi.starthere -variable ltldata(mode) -value "starthere" \
	    -text "Start search in current state"
	radiobutton .ltl.modi.checkhere -variable ltldata(mode) -value "checkhere" \
	    -text "Start in initialisation, but check formula in current state"
	pack .ltl.modi.init .ltl.modi.starthere .ltl.modi.checkhere -anchor w
	
	frame .ltl.buttons
	button .ltl.buttons.ok -text OK -command {procUpdateLtlFormulaHistory; set ltldata(ok) 1}
	button .ltl.buttons.cancel -text Cancel -command {set ltldata(ok) 0}
	pack .ltl.buttons.cancel -side left
	pack .ltl.buttons.ok -side right
	bind .ltl <Return> {procUpdateLtlFormulaHistory; set ltldata(ok) 1 ; break}
	bind .ltl <Control-c> {set ltldata(ok) 0 ; break}
        bind .ltl <Escape> {set ltldata(ok) 0;break}
	pack .ltl.msg .ltl.formula .ltl.states .ltl.modi .ltl.buttons -fill x -side top -anchor w
    }
    set ltldata(ok) 0
    Dialog_Wait .ltl ltldata(ok) .ltl.formula
    Dialog_Dismiss .ltl
    if $ltldata(ok) {
	if {[string trim $ltldata(formula)] != ""} {
	    return 1
	} else {
	    return 0
	}
    } else {
	return 0
    }
}

proc CtlDialog {title msg} {
    global ctldata strFilename
    destroy .ctl
    if [Dialog_Create .ctl $title -borderwidth 10] {
        message .ctl.msg -text $msg -aspect 1000
        entry .ctl.formula -textvariable ctldata(formula) -width 40

        if {$ctldata(formula) == ""} {
            if [prolog bmachine:b_get_definition_string_from_machine('ASSERT_CTL',Res)] {
                set ltldata(formula) $prolog_variables(Res)
            } 
        }

        frame .ctl.states
        message .ctl.states.msg -text "Max no. of new states:" -aspect 1000 
        entry .ctl.states.max -textvariable ctldata(result) -width 9
        pack .ctl.states.msg .ctl.states.max -side left

        frame .ctl.modi
        radiobutton .ctl.modi.init -variable ctldata(mode) -value "init" \
            -text "Start search in initialisation"
        radiobutton .ctl.modi.starthere -variable ctldata(mode) -value "starthere" \
            -text "Start search in current state"
        pack .ctl.modi.init .ctl.modi.starthere -anchor w
	
        frame .ctl.buttons
        button .ctl.buttons.ok -text OK -command {set ctldata(ok) 1}
        button .ctl.buttons.cancel -text Cancel -command {set ctldata(ok) 0}
        pack .ctl.buttons.cancel -side left
        pack .ctl.buttons.ok -side right
        bind .ctl <Return> {set ctldata(ok) 1 ; break}
        bind .ctl <Control-c> {set ctldata(ok) 0 ; break}

        pack .ctl.msg .ctl.formula .ctl.states .ctl.modi .ctl.buttons -fill x -side top -anchor w
    }
    set ctldata(ok) 0
    Dialog_Wait .ctl ctldata(ok) .ctl.formula
    Dialog_Dismiss .ctl
    if $ctldata(ok) {
        if {[string trim $ctldata(formula)] != ""} {
            return 1
        } else {
            return 0
        }
    } else {
        return 0
    }
}

# ------------------------------------------------------------

proc installAtelierBPlugin {} {
	set SELTXT "Application"
	set types {
		{"All files"		*}
	}
        set BIN "StartProB.sh"
	if [prolog tools:host_platform(windows)] {
	     # puts "Windows"
	     set SELTXT "File inside the AtelierB Folder"
	     set apps_path "C:/PROGRA~1/Atelier B/"
             set BIN "ProBWin.exe"
	} elseif [prolog tools:host_platform(darwin)] {
	     puts "Darwin"
	     set apps_path "/Applications/"
	     # set apps_path "/Applications/AtelierB.app/AB/"
	     # if ![file isdirectory $apps_path] 
		set types {
			{"Applications"		{.app}	}
			{"All files"		*}
		}
	} else {
	     puts "Other"
	     set apps_path [file normalize "~"]
	     set SELTXT "file (inside the AB directory)"
             set types {
		 {"AtelierB"		{AtelierB}}
		 {"All files"		*}
	     }
	}
	# puts "apps_path: $apps_path"
	
	if {$apps_path != "" && [file isdirectory $apps_path]} {
		set pathres [tk_getOpenFile -filetypes $types -initialdir $apps_path -title "Select the AtelierB $SELTXT (version 4 final, not beta version)"]
    } else {
        set pathres [tk_getOpenFile -title "Select the AtelierB 4 $SELTXT (final, not beta version)"]
    }
	if {$pathres != ""} {
	  set extdir ""
	  if [file isdirectory "$pathres/AB/bbin"] {
	      # on Mac: go inside the AB directory
	      set apathres "$pathres/AB/"
	  } else {
	       set apathres [file dirname $pathres]
	  }
	  # puts "dirname $apathres"
	  if [file isdirectory "$apathres/bbin"] {
		  if [file isdirectory "$apathres/extensions"] {
			  set extdir "$apathres/extensions"
		  } elseif [file isdirectory "$apathres"] {
			  set extdir "$apathres/extensions"
			  file mkdir $extdir
		  }
	  }
	  if {$extdir != "" && [file isdirectory "$extdir"]} {
            global app_dir
            set menulbl "Animate with ProB (Tcl/Tk)"
            set etoolfile "probtclk.etool"
	        # puts "Writing to $extdir/$etoolfile"
	        # puts "Inserting reference to $app_dir/StartProB.sh"
			set fid [open "$extdir/$etoolfile" w]
			set str "<externalTool category=\"component\"   name=\"ProBTclTk\" label=\"&amp;$menulbl\">"
			puts  $fid $str
			set str "    <toolParameter name=\"editor\" type=\"tool\" configure=\"yes\""
            puts  $fid $str
			set str "   default=\"$app_dir/$BIN\" />"
        	puts  $fid $str
        	puts  $fid "    <command>\${editor}</command>"
			puts  $fid "    <param>\${componentPath}</param>"
			puts  $fid "    </externalTool>"
			close $fid
	        # puts "Closing $extdir/$etoolfile"
	        if {[file exists "$app_dir/StartProB.sh"] || [file exists "$app_dir/ProBWin.exe"]} {
			     tkMessageBox "Installation successful (generated '$extdir/$etoolfile'). Restart AtelierB, right-click on a component and select the command '$menulbl'. Note: in case you move ProB you need to re-install the plugin."
	        } else {
			     tkMessageBox "Installed external tool file '$extdir/$etoolfile'. However, the ProB directory $app_dir does not contain StartProB.sh or ProBWin.exe."
	        }
	  } else {
			 tkErrorBox "Invalid directory: $pathres. Does not contain 'bbin' or 'AB/bbin' subdirectory."
	  }
	}
}


proc procReportBug {} {
  procReportDBug "Please describe your problem."
}
proc procReportDBug {details} {
   global shortversion version prologversion strFilename normal_user expert_user
   prologmnf animation_mode(MODE)
   set curMode $prolog_variables(MODE)
   prologmnf host_platform(PF)
   set plat $prolog_variables(PF)
   set TKVERS "ProB (tcl/tk) $shortversion"
   set SUMM "ProB (tcl/tk) $version BUG"
   set KEYW "UserDiscoveredBug"
   prologmnf get_preferences_list(PLIST)
   # cannot attach info below; URI too large or Python exception in Trac Server
   # set PREFS $prolog_variables(PLIST)
   # set text [.main.frmSource.text get 1.0 "end - 1 chars"]
   set shortened_details [string range $details 0 5000]   
   set DESC "Bug report for ProB $version-$plat.\nUser=($normal_user/$expert_user).Mode=$curMode.\n\n$shortened_details\n\n<<PASTE YOUR SPECIFICATION HERE OR ATTACH BELOW>>"
   # proc_open_url "http://prob:prob@cobra.cs.uni-duesseldorf.de/trac/login/"
   set shorturl "cobra.cs.uni-duesseldorf.de/trac/newticket"
   if {[prolog tools:host_platform(windows)]} {
      set bug_report_url "http://$shorturl"
      # Windows seems to have a problem with long urls
       tkMessageBox "I will try and open $shorturl.\nPlease enter Bug details. Then press 'Create ticket'.\n\nThanks for providing feedback!"
   } else {
      set bug_report_url "http://$shorturl?version=$TKVERS&component=prolog_core&description=$DESC&summary=$SUMM&keywords=$KEYW"
       tkMessageBox "I will try and open $shorturl.\nPlease complete Bug details. Then press 'Create ticket'.\n\nThanks for providing feedback!"
   }
   proc_open_url $bug_report_url
}

proc procCheckForUpdates {} {
    global version
    set prob_update_url "http://www.stups.uni-duesseldorf.de/ProB_Releases/"
    package require http
    prolog "tools:print_message('Opening http connection')"
    set token [::http::geturl "$prob_update_url/current_version.txt"]
    set data [::http::data $token]
    # puts "data $data"
    ::http::cleanup $token
    set webversion [lindex [split $data] 0]
    prolog "tools:print_message('Webversion $webversion')"
    if {![string is digit [string index $webversion 0]]} {
           tkErrorBox "Error connecting to $prob_update_url. Message: $data."
    } elseif {$webversion != $version} {
           global tcl_platform
           set webdate [lindex [split $data] 1]
           if {$tcl_platform(platform) != "unix"} {
               tkMessageBox "Version $webversion of ProB is available as of $webdate (your version is $version).\nGo to $prob_update_url to obtain the update."
           } else {
             tkMessageBox "Version $webversion of ProB is available as of $webdate (your version is $version).\nI will try to open $prob_update_url in browser."
             proc_open_url $prob_update_url
           }
    } else {
           tkMessageBox "Your version of ProB ($version) is up-to-date."
   }
}

proc proc_open_url {url} {
	if {[prolog tools:host_platform(windows)]} {
                puts "Trying to open $url"
            exec rundll32 url.dll,FileProtocolHandler $url &
	    #[eval exec [auto_execok start] [list $url]]
	} elseif {[prolog tools:host_platform(darwin)]} {
		exec open $url
	} else {
	    invokeLinuxBrowser $url
	}
}
proc invokeLinuxBrowser {url} {
        foreach browser {gnome-open htmlview firefox mozilla konqueror netscape} {
            set binary [lindex [auto_execok $browser] 0]
            if {[string length $binary]} {
		puts "Trying $binary $url"
                catch {exec $binary $url &}
                break
            }
        }
 }

proc CreateTextDialog {f title msg is_image with_ok_button} {
	if [Dialog_Create $f $title -borderwidth 10] {
	    if {$is_image} {
           label $f.msg -image $msg
	    } else {
		    message $f.msg -text $msg -aspect 1000
        }
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.text yview"
        text $f.frmSource.text -yscroll "$f.frmSource.scrolly set" \
            -height 18 -width 80 -bg white
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.text -expand 1 -fill both
        
        frame $f.buttons
        if {$with_ok_button} {
			button $f.buttons.ok -text Finished -command {set ok 1}
			pack $f.buttons.ok -side right
        }
		pack $f.msg $f.frmSource $f.buttons -side top
		pack $f.frmSource -pady 5 -expand yes -fill both

		bind $f.frmSource <Return> {set ok 1 ; break}

	}
}


proc procAboutProB {} {
        global tcl_dir version
		destroy .binfo
		set f .binfo

	    if [file exists "$tcl_dir/icons/prob_logo.gif"] {
			image create photo prob_img -format gif -fil "$tcl_dir/icons/prob_logo.gif"
			CreateTextDialog $f "About ProB" prob_img 1 1
	    } elseif [file exists "./tcl/icons/prob_logo.gif"] {
			image create photo prob_img -format gif -fil "./tcl/icons/prob_logo.gif"
			CreateTextDialog $f "About ProB" prob_img 1 1
		} else {
			CreateTextDialog $f "About ProB" ProB 0 1
		}
        
		prologmnf prob_licence(Lic)
		$f.frmSource.text insert 0.0 $prolog_variables(Lic)
		global revision lastchangeddate prologversion tcl_version
        $f.frmSource.text insert 0.0 "ProB $version\n$revision\n$lastchangeddate\n Tcl\Tk $tcl_version\n $prologversion\n"

		set pattern {ProB|\((C|c)\)|Michael Leuschel|-+}
		procMarkRegExpression $f.frmSource.text $pattern about_highlight_tag
		$f.frmSource.text tag configure about_highlight_tag -foreground darkslateblue
		set pattern {http://[a-zA-Z/~_\-\.]*}
		procMarkRegExpression $f.frmSource.text $pattern about_highlight_tag2
		$f.frmSource.text tag configure about_highlight_tag2 -foreground tomato

		$f.frmSource.text configure -state disabled

		set ok 0
		Dialog_Wait $f ok $f.frmSource
		Dialog_Dismiss $f
}
proc procAboutProBInSourceFrame {} {
		procCheckIfSaved
        global version
		prologmnf prob_licence(Lic)
		global revision lastchangeddate prologversion tcl_version
		procShowSourceCodeFromString "ProB $version\n$revision\n$lastchangeddate\n Tcl\Tk $tcl_version\n $prologversion\n$prolog_variables(Lic)"

        global tcl_dir
	    if [file exists "$tcl_dir/icons/prob_logo.gif"] {
			image create photo prob_img -format gif -fil "$tcl_dir/icons/prob_logo.gif"
			#image create photo prob_img -format gif -fil "$tcl_dir/icons/ProBNewLogo.gif"
			.main.frmSource.text configure -state normal
			.main.frmSource.text insert 1.0 "\n"
			.main.frmSource.text image create 1.0 -image prob_img
			.main.frmSource.text configure -state disable
		}

		set pattern {ProB|\((C|c)\)|Michael Leuschel|-+}
		procMarkRegExpression .main.frmSource.text $pattern about_highlight_tag
		.main.frmSource.text tag configure about_highlight_tag -foreground darkslateblue
		set pattern {http://[a-zA-Z/~_\-\.]*}
		procMarkRegExpression .main.frmSource.text $pattern about_highlight_tag2
		.main.frmSource.text tag configure about_highlight_tag2 -foreground tomato
		procResetCodeModified false false
}

proc procSyntaxInfo {name title msg highlightProc state prolog_command} {
     destroy $name
     CreateTextDialog $name $title $msg 0 0
     
     set txt $name.frmSource.text 
     $txt configure -state normal
     $txt delete 1.0 end
      
     eval [list prologmnf $prolog_command]
     $txt insert 1.0 $prolog_variables(Summary)

     eval [list $highlightProc $txt]
     $txt configure -state $state
}

proc procLaunchSyntaxInfo {syntax} {
     if {$syntax == "B"} {
         procSyntaxInfo .bsinfo "B Syntax" "Summary of supported B notation" \
                                     "procDoSyntaxColouring" "normal" "prob_summary(Summary)"
     } elseif {$syntax == "CSP"} {
         procSyntaxInfo .cspinfo "CSP Syntax" "Summary of supported CSP notation" \
                                     "procDoCSPSyntaxColouring" "disabled" "procsp_summary(Summary)"
     } elseif {$syntax == "Z"} {
         procSyntaxInfo .zinfo "ProZ" "Summary of supported Z notation" \
                                     "procDoZedSyntaxColouring" "disabled" "proz_summary(Summary)"
     } elseif {$syntax == "TLA"} {
         procSyntaxInfo .zinfo "TLA+" "Summary of supported TLA+ notation" \
                                     "procDoTLASyntaxColouring" "normal" "protla_summary(Summary)"
     }
}

proc procCheckingInfo {} {
		destroy .binfo
		set f .binfo
		CreateTextDialog $f "Verification Information" "Summary of ProB Verification Tools" 0 1

		$f.frmSource.text configure -state normal
		$f.frmSource.text delete 0.0 end

		prologmnf mc_summary(Summary)
		$f.frmSource.text insert 0.0 $prolog_variables(Summary)

		$f.frmSource.text configure -state disabled

		set ok 0
		Dialog_Wait $f ok $f.frmSource
		Dialog_Dismiss $f
}

proc procSymmInfo {} {
		destroy .syminfo
		set f .syminfo
		CreateTextDialog $f "ProB Symmetry" "Summary of Symmetry Reduction Techniques" 0 0
		$f.frmSource.text configure -state normal
		$f.frmSource.text delete 0.0 end
		prologmnf symmetry_summary(Summary)
		$f.frmSource.text insert 0.0 $prolog_variables(Summary)
		$f.frmSource.text configure -state disabled
		set ok 0
}
# ------------------------------------------------------------


proc procOpenFileInEditor {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
        procExecutePathPrefOnFile path_to_text_editor emacs {External Text Editor} Advanced $strFilename
    } else {
       tkErrorBox "No File open. Cannot Open External Editor."
    }
}


proc procSaveState {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set saveName {}
		append saveName $rootName ".saved.P"
		# use P extension so that we can use XTL

		prolog "tcltk_save_state('$saveName')"
    } else {
       tkErrorBox "No File open. Cannot Save State."
    }
}
proc procLoadState {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set saveName {}
		append saveName $rootName ".saved.P"

		if [file exists $saveName] {
			if [prolog "tcltk_load_state('$saveName')"] {
			   procInsertHistoryOptionsState
			} else {
			   tkErrorBox "No state has been previously saved.\nUnable to open $saveName."
			}
		} else {
		   tkErrorBox "No state saved yet as $saveName"
		}
    } else {
       tkErrorBox "No File open. Cannot Load State."
    }
}

proc procSaveSpecStateForRefinement {} {
    global strFilename
    set rootName [file rootname $strFilename]
    set saveName {}
    append saveName $rootName "_refine_spec.P"
    # use P extension so that we can use XTL

    prolog "tcltk_save_specification_state_for_refinement('$saveName')"

    if [prolog "tcltk_exists_an_open_node"] {
		   tkMessageBox "Warning: not all nodes have been explored.\nLater refinement check may miss counterexamples.\nContinue model checking until all nodes have been explored to fix this."
    } elseif [prolog "tcltk_find_max_reached_node"] {
		   tkMessageBox "Warning: not all transitions have been computed.\nLater refinement check may miss counterexamples.\nIncrease the Max. Number of Enablings/Initialisations in Animation Preferences and Reopen machine."
    }
}



proc procSetDefaultRefSpecFile {} {
    global currentRefSpecFile strFilename
    if {$currentRefSpecFile == "" && [prolog {bmachine:b_get_machine_refinement_hierarchy([_Main,Machine|_Rest])}]} {
        global strFilename
		set dirName [file dirname $strFilename]
		set bmachine_Name $prolog_variables(Machine)

		set subxmlName {}
        append subxmlName $bmachine_Name "_refine_spec.P"
        set currentRefSpecFile [file join $dirName $subxmlName]
   } else {
        set currentRefSpecFile ""
   }
}

proc procRefinementShowCounterExample {Trace} {
  global currentRefSpecFile
  set curT [file tail $currentRefSpecFile]
  procShowList $Trace "Refinement Check Failed" "Trace of the implementation that cannot be matched by $curT:"
  procInsertHistoryOptionsState
}
proc profRefinementShowNoCounterExample {mcPerformSingleFailures} {
  global currentRefSpecFile 
  set curT [file tail $currentRefSpecFile]
  if [prolog "tcltk_exists_an_open_node"] {
   tkMessageBox "No counter example found.\nAll traces explored so far are matched by $curT.\nNote: Explore more nodes using model check to check all traces."
  } elseif [prolog "tcltk_find_max_reached_node"] {
   tkMessageBox "No counter example found.\nAll traces explored so far are matched by $curT.\nNote: not all transitions have been computed.
Increase the Max. Number of Enablings/Initialisations in Animation Preferences and Reopen machine."
  } elseif {$mcPerformSingleFailures} {
   tkMessageBox "No counter example exists.\nAll traces (and single failures) of the implementation are matched by $curT.\nNote: ProB does not check the particular gluing invariant you may have provided."
  } else {
   tkMessageBox "No counter example exists.\nAll traces of the implementation are matched by $curT.\nNote: ProB does not check the particular gluing invariant you may have provided."
  }
}

proc procChangeCurRefSpecFile {} {
  global currentRefSpecFile
	set types {
		{"XSB Files"		{.P}	}
		{"Prolog Files"		{.pl .pro}	}
		{"All files"		*}
	}
	# show the dialog box
        set machinesPath [getMachinesPath]
	if {$machinesPath != "" && [file isdirectory $machinesPath]} {
		 set newf [tk_getOpenFile -filetypes $types -initialdir $machinesPath -parent .refcheck -title "Select a _refine_spec.P File"]
	} else {
		 set newf [tk_getOpenFile -filetypes $types -parent .refcheck -title "Select a _refine_spec.P File"]
	}
	if {$newf != ""} {
	    set currentRefSpecFile $newf
	    .refcheck.file.filename configure -text [file tail $currentRefSpecFile]
	    .refcheck.buttons.ok configure -state normal
	}
}

proc procSetRefSpecFile {ancMachine} {
  # puts "setting $ancMachine"
  global currentRefSpecFile
  global strFilename
  set currentRefSpecFile {}
  append currentRefSpecFile [file dirname $strFilename] "/" $ancMachine "_refine_spec.P"
  .refcheck.file.filename configure -text [file tail $currentRefSpecFile]
  .refcheck.buttons.ok configure -state normal
  # puts "set $ancMachine"
}

global mcPerformSingleFailures
set mcPerformSingleFailures "trace"

proc procRefinementCheck {} {
  global strFilename
  if {$strFilename == ""} {
       tkErrorBox "No File open."
  } else {
	global mc_prompt Depth count done
	destroy .refcheck
	set f .refcheck
    global currentRefSpecFile
	procSetDefaultRefSpecFile

    global mcPerformSingleFailures
	if [Dialog_Create $f "Trace Refinement Check:" -borderwidth 10] {
		message $f.msg -text "Enter max. nr of new states to check:" -aspect 1000
		entry $f.entry -textvariable mc_prompt(result)
		label $f.msg2 -text "Waiting"
		set fn [frame $f.file]
		set b [frame $f.buttons]
		set op [frame $f.options]
		pack $f.msg $f.entry $f.file $f.buttons $f.options $f.msg2 -side top -fill x
		pack $f.entry -pady 5

		label $fn.filelabel -text "Specification:"
		message $fn.filename -text [file tail $currentRefSpecFile] -aspect 1000
		#button $fn.pick -text "Choose Specification..." -command {procChangeCurRefSpecFile} -relief raised -overRelief button
		menubutton $fn.pickmenu -text "Choose Specification..." -menu $fn.pickmenu.m -relief raised

		pack $fn.filelabel $fn.filename $fn.pickmenu -side top
		menu $fn.pickmenu.m -tearoff 0
	    if [prolog {b_get_machine_refinement_hierarchy([_Main|AncList])}] {
		    foreach ancMachine $prolog_variables(AncList) {
		        $fn.pickmenu.m add command -label $ancMachine -command "procSetRefSpecFile {$ancMachine}"
		    }
        $fn.pickmenu.m add sep
		}
        $fn.pickmenu.m add command -label "Other Specification..." -command procChangeCurRefSpecFile

		button $b.ok -text "Refinement Check" -command {set mc_prompt(ok) 1} -state disabled
		button $b.cancel -text Cancel -command {set mc_prompt(ok) 0}
		pack $b.ok -side left
		pack $b.cancel -side right
		bind $f.entry <Return> {set mc_prompt(ok) 1 ; break}
		bind $f.entry <Control-c> {set mc_prompt(ok) 0 ; break}

		checkbutton $op.failures -text "Check Failures" -variable mcPerformSingleFailures \
		    -offvalue "trace" -onvalue "failures"
		# checkbutton $op.check_explored -text "Only check explored nodes" -variable mcOnlyCheckExploredNodes
		pack $op.failures -side top -fill x
	} else {
	    wm title $f "Refinement Check:"
	    $f.msg configure -text "Enter max. nr of nodes to check:" -aspect 1000
	    set b $f.buttons
	}
    $f.msg2 configure -text ""

    set done 0
    set mc_prompt(ok) 0
    $b.ok configure -text "Refinement Check"
    if {$currentRefSpecFile != ""} {
        $b.ok configure -state normal
    } else {
        $b.ok configure -state disabled
    }
    Dialog_Wait_Prepare $f mc_prompt(ok) $f.entry

    while {$done != 1} {
	  set mc_prompt(ok) 0
	  tkwait variable mc_prompt(ok)
	  if {$mc_prompt(ok)} {
		  if {![string is integer $mc_prompt(result)]} {
			 tkErrorBox "Invalid input: $mc_prompt(result). Please enter a number."
		  } elseif {$currentRefSpecFile == ""} {
			 tkErrorBox "No Specification File chosen. Choose one first."
	      } elseif {! [file exists $currentRefSpecFile]} {
	         set tl [file tail $currentRefSpecFile]
			 tkErrorBox "The specification file '$tl' does not exist. You have to open the corresponding B machine and 'Save for later refinement check'."
		  } else {
			  set Depth $mc_prompt(result)
			  $f.msg2 configure -text "Checking... "
			  set mc_prompt(ok) 1
			  set done 0
			  $b.ok configure -state disabled
			  refinement_search $currentRefSpecFile $Depth $mcPerformSingleFailures
			  $b.ok configure -state normal

			  if {!($done)} {
				tkwait variable done
			  }
		  }
	  } else { set done 1}
	}
	Dialog_Wait_Finish $f
	Dialog_Dismiss $f
	procShowErrors
 }
}

proc default_trace_refinement_search {} {
    global currentRefSpecFile
	procSetDefaultRefSpecFile
	trace_refinement_search $currentRefSpecFile
}

proc trace_refinement_search {currentRefSpecFile} {
   refinement_search $currentRefSpecFile 10000 0
}

proc refinement_search {currentRefSpecFile Depth mcPerformSingleFailures} {
	global mc_prompt
	global  done
   global batch_mode
    
	prolog tcltk_load_refine_spec_file('$currentRefSpecFile')

    if [prolog tcltk_refinement_search(ErrRes,$mcPerformSingleFailures,$Depth)] {
		set Result $prolog_variables(ErrRes)
		set done 1
		if {$Result == "no_counter_example"} {
	        if {!$batch_mode} {
			   .refcheck.msg2 configure -text "No counter example found so far"
			}
			if [prolog "tcltk_exists_an_open_node"] { set done 2 } else { profRefinementShowNoCounterExample $mcPerformSingleFailures }
		  } else {			
			if {!$batch_mode} {
			 .refcheck.msg2 configure -text "Counter example found"
			 }
			procRefinementShowCounterExample $Result
		}
	} else {
	  tkErrorBox "Internal error. Refinement Search failed."
	}
    return
}


# ------------------------------------------------------------
# Trace Checking Section
# ------------------------------------------------------------
proc procSaveBTraceFile {} {
    global strFilename
    if {$strFilename != ""} {
		set types {
			{"Text Files"	{.txt}	}
			{"All files"		*}
		}
		set Name [file rootname [file tail $strFilename]]
		set TraceFile [proc_getSaveFilename $types "${Name}_history" "txt"]
		if {$TraceFile != ""} {
	        prolog "b_show_history:write_history_to_file('$TraceFile')"
		}
    } else {
       tkErrorBox "No File open. Cannot save current history to B file."
    }
}
proc procSaveTraceFile {saveDialog} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		if {$saveDialog==1} {
			set types {
				{"Text Files"	{.txt}	}
				{"All files"		*}
			}
		    set Name [file rootname [file tail $strFilename]]
		    set TraceFile [proc_getSaveFilename $types "${Name}_history" "trace"]
		    if {$TraceFile != ""} {
			    prolog "tcltk_save_history_as_trace_file('${TraceFile}')"
			}
		} else {
		    set rootName [file rootname $strFilename]
			prolog "tcltk_save_history_as_trace_file('${rootName}.trace')"
		}
    } else {
       tkErrorBox "No File open. Cannot save current history to trace file."
    }
}
proc procCheckTraceFile {} {
   procCheckTraceFile2 1 0
}
proc procCheckTraceFile2 {display_success_message silent} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set saveName {}
		append saveName $rootName ".trace"
		if [file exists $saveName] {
            procCheckTraceFileInternal $saveName $silent $display_success_message 
		} else {
           tkErrorBox "No trace has been saved for this machine.\nUnable to open $saveName."
		}
    } else {
       tkErrorBox "No file currently open. Cannot check trace."
    }
}

proc procCheckOtherTraceFile {} {
    set types {
    	{"Trace Files"		{.trace}	}
    	{"Prolog Files"		{.pl .pro}	}
	    {"All files"		*}
    }
    # show the dialog box
    set machinesPath [getMachinesPath]
    if {$machinesPath != "" && [file isdirectory $machinesPath]} {
         set strTrFilename [tk_getOpenFile -filetypes $types -initialdir $machinesPath -parent . ]
    } else {
         set strTrFilename [tk_getOpenFile -filetypes $types -parent . ]
    }
    if {$strTrFilename != ""} {
        procCheckTraceFileInternal $strTrFilename 0 1
    }
}

proc procCheckTraceFileInternal {tracefile silent display_success_message} {
    prolog "tcltk_check_sequence_from_file('$tracefile')"

    if [prolog test_error_occured(_)] {
        # errors will be displayed by procInsertHistoryOptionsState
        # tkMessageBox "Trace checking failed."
    } elseif {$display_success_message} {
        tkMessageBox "Trace checking successful."
    }
    if {$silent==0} { procInsertHistoryOptionsState }
}

# ------------------------------------------------------------
# Visualization Section
# ------------------------------------------------------------

proc procViewModuleHierarchy {} {
    global curFileTypeOpened strFilename
    puts "FileType: $curFileTypeOpened"
    if {$strFilename=="" || ($curFileTypeOpened != "B" && $curFileTypeOpened != "EVENTB")} {
       tkErrorBox "Please open a B Machine first."
    } else {
       set rootName [file rootname $strFilename]
       set dotName {}
       set psName {}
       append dotName $rootName ".dot"
       append psName $rootName ".ps"
       prolog "b_machine_hierarchy:print_hierarchy('$dotName')"
       procShowErrors
       procVisualiseDotFile $dotName $psName
    }
}

proc procDisplayVisitedStates {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
        prolog get_state_space_stats(S,T,PrNodes)
        if {$prolog_variables(S) < 250} {
		   prolog "tcltk_print_states_for_dot('$dotName')"
		   procVisualiseDotFile $dotName $psName
		} else {
		   set ans [tk_messageBox -default no -message "The state space is large\
		    ($prolog_variables(S) states and $prolog_variables(T) transitions)!\n\n\
		    Are you sure you want to view it?" -title "Warning" -type yesno -icon warning -parent .]
	        if {$ans == "yes"} {
		        prolog "tcltk_print_states_for_dot('$dotName')"
		   		procVisualiseDotFile $dotName $psName
		    }
		}
    } else {
       tkErrorBox "No File open. Cannot display statespace."
    }
}
proc procDisplayVisitedStatesUpTo {dist} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
        prolog "tcltk_print_neighbourhood_states_for_dot($dist,'$dotName')"
		procVisualiseDotFile $dotName $psName
	}
}

proc provVisualizeDEFGOAL {} {
  if [prolog b_reset_machine_goal_from_DEFINITIONS] {
     procVisualiseInvariantOrOpPRE "_goal_"
  } else {
       tkErrorBox "Could not obtain GOAL predicate from DEFINITIONS."
  }
}
proc procVisualiseCustomPredicate {} {
   global Goal
   set Goal [Dialog_Promptww "Enter Predicate to Visualize (use B syntax):" 70 ""]
   procVisualiseCustomPredicate_direct $Goal
}
proc procVisualiseCustomPredicate_direct { Predicate } {
   if {$Predicate != ""} {
       set success [procParseGoal $Predicate]
       if {$success} {
            procVisualiseInvariantOrOpPRE "_goal_"
       }
   }
}
proc procAnalyseCustomPredicate {} {
   global Goal
   set Goal [Dialog_Promptww "Enter Predicate to Analyse (use B syntax):" 70 ""]
   if {$Goal != ""} {
       set success [procParseGoal $Goal]
       if {$success} {
            procAnalyseGOAL
       }
   }
}

proc procVisualiseInvariant {} {
    procVisualiseInvariantOrOpPRE ""
}
proc procVisualiseAssertions {} {
	procVisualiseInvariantOrOpPRE "_assertions_"
}
proc procVisualiseProperties {} {
	procVisualiseInvariantOrOpPRE "@PROPERTIES"
}
proc procVisualiseSpanPredicate {} {
	procVisualiseInvariantOrOpPRE "_span_predicate_"
}
proc procVisualiseInvariantOrOpPRE {opName} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
        if { $opName == "@PROPERTIES" || $opName == "_assertions_" || $opName == "_goal_" || $opName == "@INITIALISATION" || [prolog current_state_corresponds_to_initialised_b_machine] } {
			set rootName [file rootname $strFilename]
			set dotName {}
			set psName {}
			append dotName $rootName ".dot"
			append psName $rootName ".ps"
			if {$opName == "@PROPERTIES"} {
			   prolog "generate_dot_from_properties('$dotName')"
			} elseif {$opName == "_assertions_"} {
			   prolog "generate_dot_from_assertions('$dotName')"
			} elseif {$opName == "_goal_"} {
			   prolog "generate_dot_from_goal('$dotName')"
			} elseif {$opName == "_deadlockpo_"} {
			   prolog "generate_dot_from_deadlock_po('$dotName')"
			} elseif {$opName == "_span_predicate_"} {
			   prolog "generate_dot_from_last_span_predicate('$dotName')"
			} elseif {$opName != ""} {
			   prolog generate_dot_from_operation('$opName','$dotName')
			} else {
			   prolog "generate_dot_from_invariant('$dotName')"
			}
			procShowErrors
			procVisualiseDotFile $dotName $psName
		 } else {
		   tkErrorBox "Please intialise Machine first."
		 }
    } else {
       tkErrorBox "No File open. Cannot visualise predicate."
    }
}


proc procVisualiseDotFile {dotName psName} {
  if [file exists $dotName] {
    if [prolog preferences:get_preference(dot_use_ps_viewer,true)] {
        if [prolog preferences:get_preference(path_to_dot,PDotCmd)] {
	        set DotCmd $prolog_variables(PDotCmd)
	    } else {set DotCmd dot}
	    # puts "exec $DotCmd -Tps $dotName -o $psName"
	    # use eval in case DotCmd contains arguments
	    if {[catch {exec $DotCmd -Tps $dotName -o $psName} errid]} {
           tkErrorBox "Could not execute dot.\n Be sure that dot is installed (e.g., from http://www.graphviz.org) and that path '$DotCmd' in the Viewer Preferences is correct.\nError: $errid"
         } else {
            procOpenPSFile $psName
        }
    } else {
       if [prolog preferences:get_preference(dot_use_alterate_dot_viewer,true)] {
        procExecutePathPrefOnFileForApp path_to_dotty2 dotty dotty Viewer $dotName "GraphViz (http://www.graphviz.org)"
       } else {
        procExecutePathPrefOnFileForApp path_to_dotty dotty dotty Viewer $dotName "GraphViz (http://www.graphviz.org)"
       }
    }
   } else {
       tkErrorBox "Dot file does not exists: '$dotName'."
   }
}


proc procExecutePathPrefOnFile {pathpreference DefaultCmd PathName PrefCategory FileName} {
        if [prolog preferences:get_preference($pathpreference,PDottyCmd)] {
	        set Cmd $prolog_variables(PDottyCmd)
	    } else {set Cmd $DefaultCmd}
        procExecuteCommandOnFile $Cmd $FileName \
           "Be sure that the path for $PathName in the $PrefCategory Preferences is correct."
}
proc procExecutePathPrefOnFileForApp {pathpreference DefaultCmd PathName PrefCategory FileName AppName} {
        if [prolog preferences:get_preference($pathpreference,PDottyCmd)] {
	        set Cmd $prolog_variables(PDottyCmd)
	    } else {set Cmd $DefaultCmd}
        procExecuteCommandOnFile $Cmd $FileName \
           "Be sure that $AppName is installed and that the path for $PathName in the $PrefCategory Preferences is correct."
}

proc procExecuteCommandOnFile {Cmd FileName ExtraErrMsg} {
  set dcmdtail [file extension $Cmd]
  set firstcmd [lindex $Cmd 0]
  if {[prolog tools:host_platform(darwin)] && ($firstcmd == "open" || $firstcmd == "wish") } {
      if {[catch {eval exec $Cmd $FileName &} errid]} {
         # use eval because Cmd is actually a list of commands with options
         tkErrorBox "Could not execute '$Cmd'.\n$ExtraErrMsg\nError: $errid"
      }
  } elseif {$dcmdtail == ".app" && [prolog tools:host_platform(darwin)]} {
	  if {[catch {exec open -a $Cmd $FileName &} errid]} {
		tkErrorBox "Could not open '$Cmd'.\n$ExtraErrMsg\nError: $errid"
	  }
  } else {
      if {[prolog tools:host_platform(windows)] } {
         set FN [file attributes $FileName -shortname]
      } else {
         set FN $FileName
      }
      # puts "trying $Cmd $FileName"
      if {[catch {exec $Cmd $FN &} errid]} {
         tkErrorBox "Could not execute '$Cmd'.\n$ExtraErrMsg\nError: $errid"
      }

  }
}

proc procOpenPSFile {psName} {
     procExecutePathPrefOnFileForApp path_to_ps_viewer gv {Postscript Viewer} Viewer $psName "a PostScript viewer"
}

proc procDisplayTransitionDiagram {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
        set ObsVar [Dialog_Prompt "Enter Variable or Expression to observe\n(ProB will show which operations can change the value of the expression):"]
        if {$ObsVar != ""} {
			set rootName [file rootname $strFilename]
			set dotName {}
			set psName {}
			append dotName $rootName ".dot"
			append psName $rootName ".ps"
			if [prolog "tcltk_print_transition_diagram_for_variable_or_expr('$ObsVar','$dotName')"] {
			   procVisualiseDotFile $dotName $psName
			}
			procShowErrors
		}
    } else {
       tkErrorBox "No File open."
    }
}

proc procDisplayCurrentState {asgraph} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
		if {$asgraph=="no"} {
		    if [prolog "tcltk_print_current_state_for_dot('$dotName')"] {
				procVisualiseDotFile $dotName $psName
		    }
		} elseif {$asgraph=="custom"} {
		    if [prolog "state_custom_dot_graph:tcltk_generate_state_custom_dot_graph('$dotName')"] {
				procVisualiseDotFile $dotName $psName
		    }
		} else {
		    # prolog "tcltk_print_current_state_as_graph_for_dot('$dotName')"
		    if [prolog "graph_canon:print_cstate_graph('$dotName')"] {
				procVisualiseDotFile $dotName $psName
		    }
		}
		procShowErrors
    } else {
       tkErrorBox "No File open. Cannot display current state."
    }
}
proc procDisplayTraceToCurrentState {shortest} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
		if {$shortest=="yes"} {
		  prolog "tcltk_print_shortest_trace_to_current_state_for_dot('$dotName')"
		} else {
		  prolog "tcltk_print_history_to_current_state_for_dot('$dotName')"
		}
		procVisualiseDotFile $dotName $psName
    } else {
       tkErrorBox "No File open. Cannot display trace to current state."
    }
}
proc procDisplayReducedSigMerge {} {
  procDisplayReducedState "no"
}
proc procDisplayReducedDFA {} {
  procDisplayReducedState "yes"
}
proc procDisplayReducedState {dfa} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
		if {$dfa=="yes"} {
		  prolog "reduce_graph_state_space:print_dot_for_dfa_from_nfa('$dotName')"
		} else {
		  prolog "reduce_graph_state_space:print_state_merge_for_dot('$dotName')"
		}
		procVisualiseDotFile $dotName $psName
    } else {
       tkErrorBox "No File open. Cannot display reduced state space."
    }
}

proc procSubgraph {type} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
		if {$type=="goal"} {
		    prolog "reduce_graph_state_space:	print_subgraph_of_goal_nodes('$dotName')"
		} else {
		    prolog "reduce_graph_state_space:print_subgraph_associated_with_invariant_violations('$dotName')"
		}
		procVisualiseDotFile $dotName $psName
    } else {
       tkErrorBox "No File open. Cannot display subgraph."
    }
}

proc procTestCaseGraph {} {
    global strFilename curFileTypeOpened
    if {$strFilename != ""} {
		set rootName [file rootname $strFilename]
		set dotName {}
		set psName {}
		append dotName $rootName ".dot"
		append psName $rootName ".ps"
		prolog "testcase_generator:generate_testcase_graph('$dotName')"
		procVisualiseDotFile $dotName $psName
    } else {
       tkErrorBox "No File open. Cannot display TestCaseGraph."
    }
}


###########   JENS 

proc procFlowEnableGraph {} {
    global strFilename curFileTypeOpened
    if { [prolog "specfile:animation_minor_mode(eventb)"] } {
       if {$strFilename != ""} {
		  set rootName [file rootname $strFilename]
		  set dotName {}
		  set psName {}
		  append dotName $rootName "_flow_eg.dot"
		  append psName $rootName ".ps"
		  prolog "flow:create_enable_graph('$dotName')"
		  procShowErrors
		  procVisualiseDotFile $dotName $psName
       } else {
          tkErrorBox "No File open. Cannot display FlowEnableGraph."
       }
    } else {
      tkErrorBox "Flow Graphs are only available for Event-B."
    }
}
proc procFlowEnableGraphs {} {
    global strFilename curFileTypeOpened
    if { [prolog "specfile:animation_minor_mode(eventb)"] } {
       if {$strFilename != ""} {
		  set rootName [file rootname $strFilename]
		  set dotName {}
		  set psName {}
		  append dotName $rootName "_flow_eg.dot"
		  append psName $rootName ".ps"
		  prolog "flow:create_enable_graphs('$dotName')"
	      procShowErrors
		  procVisualiseDotFile $dotName $psName
       } else {
          tkErrorBox "No File open. Cannot display FlowEnableGraph."
       }
    } else {
      tkErrorBox "Flow Graphs are only available for Event-B."
    }
}

proc procBaseGuide {} {
    global strFilename curFileTypeOpened
    if { [prolog "specfile:animation_minor_mode(eventb)"] } {
       if {$strFilename != ""} {
		  set rootName [file rootname $strFilename]
		  set dotName {}
		  set psName {}
		  append dotName $rootName "_flow_bgg.dot"
		  append psName $rootName ".ps"
		  prolog "flow:print_base_guide('$dotName')"
		  procShowErrors
		  procVisualiseDotFile $dotName $psName
       } else {
          tkErrorBox "No File open. Cannot display FlowEnableGraph."
       }
    } else {
      tkErrorBox "Flow Graphs are only available for Event-B."
    }
} 

proc procEventGuide {} {
global strFilename curFileTypeOpened
if { [prolog "specfile:animation_minor_mode(eventb)"] } {
   if {$strFilename != ""} {

   set Event [Dialog_Promptww "Enter Event Name:" 70 ""]
    # FIXME: Check existence 
   if {$Event != ""} {
	  set rootName [file rootname $strFilename]
	  set dotName {}
	  set psName {}
	  append dotName $rootName "_flow_" $Event "_bgg.dot"
	  append psName $rootName ".ps"
	  prolog "flow:print_event_guide('$dotName','$Event')"
	  procShowErrors
	  procVisualiseDotFile $dotName $psName
   } else {
      tkErrorBox "No Event given. Cannot display Graph."
   }
   } else {
      tkErrorBox "No File open. Cannot display FlowEnableGraph."
   }
} else {
  tkErrorBox "Flow Graphs are only available for Event-B."
}
}



proc procUpdateMenusFromPrologInfo {} {
  global debugMode typeCheckMode traceUponError
   if {[prolog "debug_mode(on)"]} {set debugMode 1} else {set debugMode 0}
   if {[prolog "run_time_type_check_mode(on)"]} {set typeCheckMode 1} else {set typeCheckMode 0}
   if {[prolog "trace_upon_error"]} {set traceUponError 1} else {set traceUponError 0}
   
    global chosensymmode
    prologmnf preferences:get_preference(symmetry_mode,SYMMODE)
    set chosensymmode $prolog_variables(SYMMODE)
    # puts "SymmMode $chosensymmode"
}

proc procUpdateDebuggingMode {} {
  global debugMode typeCheckMode traceUponError
  if {$debugMode==1} {
      prologmnf "tcltk_turn_debugging_on"
   } else {
      prologmnf "tcltk_turn_debugging_off"
   }
  if {$typeCheckMode==1} {
      prologmnf "turn_on_run_time_type_checks"
   } else {
      prologmnf "turn_off_run_time_type_checks"
   }
  if {$traceUponError==1} {
      prologmnf "turn_trace_upon_error_on"
      prologmnf "debug"
      # will only work when ProB run from source
   } else {
      prologmnf "turn_trace_upon_error_off"
      # prologmnf "nodebug"
   }
}

proc procSaveStateToFDR {} {
    global strFilename
    set rootName [file rootname $strFilename]
    set cspName {}
    append cspName $rootName "_statespace.csp"
    prolog "tcltk_print_states_for_fdr('$cspName')"
    if [prolog animation_mode(cspm)] {
       procExecutePathPrefOnFile path_to_probe cat {FDR/CSP Viewer} Advanced $cspName
    } else {
       procViewCSPFile $cspName
    }
}
proc procOpenFDROnSpec {} {
	global strFilename
    if [prolog animation_mode(cspm)] {
    	procExecutePathPrefOnFileForApp path_to_fdr fdr2 {FDR} Advanced $strFilename "FDR (http://www.cs.ox.ac.uk/projects/concurrency-tools/)"
    } else {
    	tkErrorBox "This command can only be used in CSPM mode."
    }
}
proc procCheckStatespaceWithFDR {} {
    if [prolog animation_mode(cspm)] {
        puts "Checking State Space Compliance with FDR"
		global strFilename
		set rootName [file rootname $strFilename]
		set cspName {}
		append cspName $rootName "_statespace.csp"
		prolog "tcltk_print_states_for_fdr('$cspName')"
		prologmnf preferences:get_preference(path_to_fdr,PCmd)
		set Cmd $prolog_variables(PCmd)
		puts "Calling $Cmd batch $cspName"
        catch {exec $Cmd batch $cspName} errfdrout
        # FDR always writes to stderr 
        if [string match {*false*} $errfdrout] {
            puts "FDR detected mismatch between FDR and ProB"
            # TO DO : check if we have Checking MAIN [FD= Nroot\nfalse or xfalse or otherway around
            # puts "FDR stderr:"
            # puts "$errfdrout"
            # tkErrorBox "Refinement checks failed!\nLog: $errfdrout"
		    set Result [split $errfdrout \n]
            procErrShowList $Result "FDR - ProB Refinement Check Failed" "FDR - ProB Refinement Check Failed"
            procExecutePathPrefOnFileForApp path_to_fdr fdr2 {FDR} Advanced $cspName "FDR (http://www.cs.ox.ac.uk/projects/concurrency-tools/)"
        } else {
           puts "\nFDR Compliance Check OK: No error occurred.\n"
        }
    } else {
       tkErrorBox "This command can only be used in CSPM mode."
    }
}

proc procTypeCheckFile {} {
    global strFilename
   if [prolog animation_mode(cspm)] {
       procTypeCheckCSP
   } elseif [prolog animation_mode(b)] {
       procTypeCheckB $strFilename 1
   } else {
       tkErrorBox "This command can only be used in B or CSPM mode."
   }
}
proc procTypeCheckCSP {} {
    global strFilename
	prologmnf preferences:get_preference(path_to_csp_typechecker,PCmd)
	set Cmd $prolog_variables(PCmd)
	puts "Calling $Cmd $strFilename"
	
	if {[catch {set tc_res [exec $Cmd $strFilename]} errid]} {
			 set Result [split $errid \n]
			 HighlightLineErr $errid " "
			 procShowList $Result "CSP Type Check of $strFilename" "CSP Type Check FAILED !!"
	} else {
		 set Result [split $tc_res  \n]
		 if [HighlightLineErr $tc_res " "] {
			 procShowList $Result "CSP Type Check of $strFilename" "CSP Type Check found ERROR"
		 } else {
			 procShowList $Result "CSP Type Check of $strFilename" "CSP Type Check SUCCESSFUL"
		 }
	}
}
proc procTypeCheckB {BFilename highlighterr} {
	prologmnf preferences:get_preference(path_to_bcomp,PCmd)
	set Cmd $prolog_variables(PCmd)
	set pwd [pwd]
	set newd [file dirname $BFilename]
	puts "cd $newd"
	cd $newd
	puts "Calling $Cmd -v -a -i $BFilename"
	
	if {[catch {set tc_res [exec $Cmd -v -a -i $BFilename]} errid]} {
			 set Result [split $errid \n]
			 if {$highlighterr==1} { HighlightBCompErr $errid }
			 append Result "\n{Ensure that the bcomp path advanced preference is correctly set.}"
			 procShowList "$Result" \
			              "B Type Check of $BFilename" "B Type Check FAILED !!"
	} else {
		 set Result [split $tc_res  \n]
		 if {$highlighterr==1 && [HighlightBCompErr $tc_res]} {
			 procShowList $Result "B Type Check of $BFilename" "B Type Check found WARNINGS"
		 } else {
			 procShowList $Result "B Type Check of $BFilename" "B Type Check SUCCESSFUL"
		 }
	}
	cd $pwd
}

proc procGetTempDir {} {
  package require fileutil
    return [::fileutil::tempdir]
}

proc procTypeCheck_PPF_BFile {} {
    global strFilename
    if [prolog animation_mode(b)] {
            set IRName "ProB_Typed_Internal_Representation"
	set TMP [procGetTempDir]
	    set tmp_PPF_File "$TMP$IRName.mch"
	    prolog b_write_machine_representation_to_file(all,'$tmp_PPF_File')
	    procTypeCheckB $tmp_PPF_File 0
    } else {
       tkErrorBox "This command can only be used in B mode."
    }
}

proc procViewCSPFile {psName} {
   procExecutePathPrefOnFile path_to_probe cat {FDR/CSP Viewer} Advanced $psName
}

proc procSaveStateToSPIN {} {
    global strFilename
    set rootName [file rootname $strFilename]
    set cspName {}
    append cspName $rootName "_statespace.prom"
    prolog "tcltk_print_states_for_spin('$cspName')"
    procOpenSPINFile $cspName
}

proc procSaveStateToNeverClaim {} {
    global strFilename
    set rootName [file rootname $strFilename]
    set neverName {}
    append neverName $rootName "_neverclaim.pml"
    prolog "promela_save_as_neverclaim('$strFilename', '$neverName')"
}

proc procOpenSPINFile {psName} {
   procExecutePathPrefOnFile path_to_spin xspin {Spin/Promela Viewer} Advanced $psName
}



# ------------------------------------------------------------

proc procCreateStateViewer {} {
	# destroy .stateviewer
	set f .stateviewer
	if [Dialog_Create $f "State Graphic Viewer" -borderwidth 10] {
		message $f.msg -text "Graphical Visualisation" -aspect 1000
		frame $f.sviewFrame -borderwidth .1c -relief groove
		#label $f.sviewFrame.label1 -text empty
		#pack $f.sviewFrame.label1 -side right
		pack $f.msg $f.sviewFrame -side top
		pack $f.sviewFrame -pady 5 -expand yes -fill both
	}
}
proc procUpdateStateViewer {} {
   global strFilename tcl_dir
   set f .stateviewer
   if [prolog preferences:get_preference(use_tk_custom_state_viewer,true)] {
	   if [prolog tcltk_get_image_list(Images,Contents)] {
		   if [winfo exists $f] {
			   foreach i [winfo children $f.sviewFrame] {
				  destroy $i
			   }
		   } else {
			   procCreateStateViewer
		   }
		  set imagelist [split $prolog_variables(Images)]
		  set path [file dirname $strFilename]
		  set notfound ""
		  #puts "app_dir: '$app_dir'"
		  foreach {label img} $imagelist {
		    if [file exists $path/$img] {
		        image create photo $label -format gif -fil $path/$img
		    } elseif [file exists $img] {
		        image create photo $label -format gif -fil $img
		    } elseif [file exists $tcl_dir/$img] {
		        image create photo $label -format gif -fil $tcl_dir/$img
		    } else {
		        append notfound " $img"
		    }
		  }
		  if {$notfound != ""} {
		        tkErrorBox "Cannot find gif image(s):$notfound.\nPaths: $path ; $tcl_dir"
		  } else {
			  set contents_list [split $prolog_variables(Contents)]
			  # puts "contents $contents_list"
			  foreach {type framename label} $contents_list {
			     # puts "Generating content $type $framename $label"
				 if {$type=="frame"} {
					 # frame $f.sviewFrame.$framename -borderwidth .1c -relief flat
					 frame $f.sviewFrame.$framename -relief flat
					 pack $f.sviewFrame.$framename -side $label
				 } elseif {[string range $type 0 3]=="text"} {
				     set FONT [getCurrentFont]
				     # TkFixedFont
					 label $f.sviewFrame.$framename.$type -text "$label" -font $FONT -relief groove -padx 10
					 pack $f.sviewFrame.$framename.$type -side left
				 } else {
					 label $f.sviewFrame.$framename.$type -image $label
					 pack $f.sviewFrame.$framename.$type -side left
				 }
	
			  }
		  }
		  procShowErrors
	   } else { destroy $f }
   } else { destroy $f }
}




############################## (ent03r) Op/Argument chooser creation and listeners ########
# populate a given listbox with each variable in a prolog query e.g. getHistory(X), :. for each x in X.
	proc procPopulateListBox {listbox query listname} {
		prolog $query
		catch {
			foreach i $prolog_variables($listname) {
				$listbox insert end $i;
			}
		}
	}

	# update the names and colours of operations in this listbox
	proc procUpdateOperationsListBox {{clear_old 0}} {
		global graph_type_rb argChooser_LastOperationClickedIndex;

		if {$clear_old != 0} {
			.argChooser.frame.list delete 0 end;
		}

		# populate the listbox
		procPopulateListBox .argChooser.frame.list "reduce_graph_state_space:get_alphabet_signatures(A)" "A";

		#### code here to initially set the items colour
		# colour the items red if theyre a dont care, black otherwise.
		for {set i 0} {$i < [.argChooser.frame.list size]} {incr i 1} {
			set itemname [.argChooser.frame.list get $i];
			# if its a desired transition for this particular graph
			if [prolog "reduce_graph_state_space:desired_user_transition($graph_type_rb,'$itemname')"] {
				.argChooser.frame.list itemconfigure $i -foreground "black" -selectforeground "black";
			} else {
				.argChooser.frame.list itemconfigure $i -foreground "red" -selectforeground "red";
			}
		}

		# select the last clicked on operation
		if {($argChooser_LastOperationClickedIndex >= 0) 		  && ($argChooser_LastOperationClickedIndex < [.argChooser.frame.list size])} {
			.argChooser.frame.list selection set $argChooser_LastOperationClickedIndex;
			.argChooser.frame.list itemconfigure $argChooser_LastOperationClickedIndex -selectforeground [.argChooser.frame.list itemcget $argChooser_LastOperationClickedIndex -foreground]
		}
	}

	# update the names and colours of arguments in this listbox
	proc procUpdateArgumentsListBox {operation {clear_old 0}} {
		global graph_type_rb argChooser_LastArgumentClickedIndex;

		if {$clear_old != 0} {
			.argChooser.frame.list2 delete 0 end;
		}

		procPopulateListBox .argChooser.frame.list2 "reduce_graph_state_space:assert_all_transition_arg_dont_cares,reduce_graph_state_space:get_transition_arguments_from_source('$operation', Arguments)" "Arguments";

		# colour the items red if theyre a dont care, black otherwise.
		if [prolog "reduce_graph_state_space:transition_arg_dont_cares($graph_type_rb,'$operation',DontCares)"] {
			for {set i 0} {$i < [llength $prolog_variables(DontCares)]} {incr i 1} {
				set element [lindex $prolog_variables(DontCares) $i];
				if {[string compare $element "_"] == 0} {
					.argChooser.frame.list2 itemconfigure $i -foreground "red" -selectforeground "red";
				} else {
					.argChooser.frame.list2 itemconfigure $i -foreground "black" -selectforeground "black";
				}
			}
		}

		# select the last clicked on argument
		if {($argChooser_LastArgumentClickedIndex >= 0) 		  && ($argChooser_LastArgumentClickedIndex < [.argChooser.frame.list2 size])} {
			.argChooser.frame.list2 selection set $argChooser_LastArgumentClickedIndex;
			.argChooser.frame.list2 itemconfigure $argChooser_LastArgumentClickedIndex -selectforeground [.argChooser.frame.list2 itemcget $argChooser_LastArgumentClickedIndex -foreground]
		}
	}

	# tell prolog which arguments we dont care about
	proc procSetDontCares {} {
		# get the last clicked operation
		global argChooser_LastOperationClicked graph_type_rb;

		# get the transition arg dont cares for this operation == Y
		prolog "reduce_graph_state_space:get_transition_arguments_from_source('$argChooser_LastOperationClicked', Arguments)";

		# the new list of dont cares
		set dontCares "\[";

		set elementsInLB [.argChooser.frame.list2 get 0 end];	# the elements in the listbox
		set sizeLB [llength $elementsInLB];

		# loop through the elements in this list box
		for {set i 0} {$i < $sizeLB} {incr i 1} {
			set elementCol [.argChooser.frame.list2 itemcget $i -foreground];
			if {[string compare $elementCol "red"] == 0} {
				append dontCares " '_'";
			} else {
				append dontCares [lindex $elementsInLB $i];
			}

			if {$i < [expr $sizeLB-1]} {
				append dontCares ",";
			} else {
				append dontCares "\]";
			}
		}

		# set the dont cares
		prolog "reduce_graph_state_space:assert_transition_dont_cares($graph_type_rb,'$argChooser_LastOperationClicked', $dontCares)";
	}

	proc procSettingsForDifferentGraph {graphtype} {
		global argChooser_LastOperationClicked;
		if {[string compare $graphtype "signature_merge"] == 0} {
			.argChooser.frame.oparglabel configure -state disabled
			.argChooser.frame.allarg_cb configure -state disabled
			.argChooser.frame.list2 delete 0 end;
		} else {
			.argChooser.frame.list2 delete 0 end;
			if {([string compare $argChooser_LastOperationClicked ""] != 0) 			     && [prolog "reduce_graph_state_space:desired_user_transition($graphtype, '$argChooser_LastOperationClicked')"]} {
				procUpdateArgumentsListBox $argChooser_LastOperationClicked
			}
			.argChooser.frame.oparglabel configure -state normal
			.argChooser.frame.allarg_cb configure -state normal
		}

		# set checkboxes selected or not according to sicstus db
		if [prolog reduce_graph_state_space:use_all_operations($graphtype,yes)] {
			.argChooser.frame.allop_cb select
		} else {
			.argChooser.frame.allop_cb deselect
		}
		if [prolog "reduce_graph_state_space:use_no_arguments($graphtype,yes)"] {
			.argChooser.frame.allarg_cb select
		} else {
			.argChooser.frame.allarg_cb deselect
		}
	}

	proc procUpdateAllOps {} {
		global graph_type_rb allop_cb;
		prologmnf "reduce_graph_state_space:set_use_all_operations($graph_type_rb,$allop_cb)";
		procUpdateOperationsListBox 1;
	}

	proc procUpdateAllArgs {} {
		global graph_type_rb argChooser_LastOperationClicked allarg_cb;
		prologmnf "reduce_graph_state_space:set_use_no_arguments($graph_type_rb,$allarg_cb)";
		procUpdateArgumentsListBox $argChooser_LastOperationClicked 1;
	}

	proc procShowArgChooser {} {
		global argChooser_LastOperationClicked graph_type_rb allop_cb allarg_cb argChooser_LastOperationClickedIndex argChooser_LastArgumentClicked argChooser_LastArgumentClickedIndex;
		set argChooser_LastOperationClicked ""
		set argChooser_LastArgumentClicked ""
		set argChooser_LastOperationClickedIndex -1
		set argChooser_LastArgumentClickedIndex -1
		set graph_type_rb "signature_merge"


		if [prolog "reduce_graph_state_space:use_all_operations($graph_type_rb,yes)"] {
			set allop_cb "yes"
		} else {
			set allop_cb "no"
		}

		if [prolog "reduce_graph_state_space:use_no_arguments($graph_type_rb,yes)"] {
			set allarg_cb "yes"
		} else {
			set allarg_cb "no"
		}


		destroy .argChooser;
		if [Dialog_Create .argChooser "Operation/Argument Chooser"] {
			wm geometry .argChooser +300+300;
			# top label
			label .argChooser.msg -padx 5 -pady 10 -wraplength 4i -justify left -text "Select which operations & arguments to use in Reduced Visted States / Reduced DFA graph. To select, click on an item in the list."
			pack .argChooser.msg -side top

			frame .argChooser.onoff -width 100 -height 50

			label .argChooser.onoff.on -padx 5 -pady 1 -foreground "red" -wraplength 4i -justify left -text "Red = Do not use"
			pack .argChooser.onoff.on -side left
			label .argChooser.onoff.off -padx 5 -pady 1 -foreground "black" -wraplength 4i -justify left -text ",  Black = Use"
			pack .argChooser.onoff.off -side left

			pack .argChooser.onoff -side top


			# bottom buttons
			frame .argChooser.buttons
			pack .argChooser.buttons -side bottom -fill x -pady 2m
			button .argChooser.buttons.finish -text Finish -command {destroy .argChooser}
			pack .argChooser.buttons.finish -side left -expand 1

			# make the main widget frame
			frame .argChooser.frame -borderwidth 10
			pack .argChooser.frame -side top -expand yes -fill y

			# make the scroll bars and listbox
			scrollbar .argChooser.frame.yscroll -command ".argChooser.frame.list yview"
			scrollbar .argChooser.frame.xscroll -orient horizontal 			    -command ".argChooser.frame.list xview"
			listbox .argChooser.frame.list -width 30 -height 10 -setgrid 1 			-yscroll ".argChooser.frame.yscroll set" -xscroll ".argChooser.frame.xscroll set" 			-foreground "black" -selectforeground "black"

			# bind for the operations list box
			bind .argChooser.frame.list <ButtonRelease-1> {
			if {[.argChooser.frame.list size] > 0} {
					global argChooser_LastOperationClicked argChooser_LastOperationClickedIndex graph_type_rb allop_cb;
					set selectedi [.argChooser.frame.list curselection];
					set selectedw [.argChooser.frame.list get $selectedi];
					set argChooser_LastOperationClicked $selectedw;

					# we click on an item in the list once to select it, and then
					# a second time to cause the change
					if {$argChooser_LastOperationClickedIndex != [.argChooser.frame.list curselection]} {
						set argChooser_LastOperationClickedIndex [.argChooser.frame.list curselection];

						set list1itemc [.argChooser.frame.list itemcget $selectedi -foreground];
						if {[string compare $list1itemc ""] == 0} {
							set list1itemc "black";
						}
						if {([string compare $list1itemc "black"] == 0) && ([string compare $graph_type_rb "dfa_abstraction"] == 0)} {
							procUpdateArgumentsListBox $argChooser_LastOperationClicked 1;
						} else {
							.argChooser.frame.list2 delete 0 end;
						}
					} else {
						prologmnf reduce_graph_state_space:user_made_op_selection;

						################## add list item listeners to change colour on click ##################
						set list1itemc [.argChooser.frame.list itemcget $selectedi -foreground];
						if {[string compare $list1itemc ""] == 0} {
							set list1itemc "black";
						}

						if {[string compare $list1itemc "red"] == 0} {
							.argChooser.frame.list itemconfigure $selectedi -foreground "black" -selectforeground "black";
							prolog "(reduce_graph_state_space:desired_user_transition($graph_type_rb,'$selectedw') -> true;assert(reduce_graph_state_space:desired_user_transition($graph_type_rb,'$selectedw')))";

							if {[string compare $graph_type_rb "dfa_abstraction"] == 0} {
								procUpdateArgumentsListBox $argChooser_LastOperationClicked 1;
							}
						} else {
							.argChooser.frame.list itemconfigure $selectedi -foreground "red" -selectforeground "red";
							prolog "retractall(reduce_graph_state_space:desired_user_transition($graph_type_rb,'$selectedw'))."
							set allop_cb "no";
							prologmnf reduce_graph_state_space:set_use_all_operations($graph_type_rb,$allop_cb);

							.argChooser.frame.list2 delete 0 end;
						}
					}
				}
			}

			# check if user has made any changes to selected operations
			# if not, then all operations are ON by default..
			if [prolog reduce_graph_state_space:user_has_made_op_selection(no)] {
				prologmnf reduce_graph_state_space:set_use_all_operations(signature_merge,yes);
				prologmnf reduce_graph_state_space:set_use_all_operations(dfa_abstraction,yes);
			}
			# set up the operations list box
			procUpdateOperationsListBox 1;

			# make some more scroll bars and listbox
			scrollbar .argChooser.frame.yscroll2 -command ".w.frame.list2 yview";
			scrollbar .argChooser.frame.xscroll2 -orient horizontal 			    -command ".argChooser.frame.list2 xview";
			listbox .argChooser.frame.list2 -width 30 -height 10 -setgrid 1 			    -yscroll ".argChooser.frame.yscroll2 set" -xscroll ".argChooser.frame.xscroll2 set";

			# bind for the arguments list box
			bind .argChooser.frame.list2 <ButtonRelease-1> {
				if {[.argChooser.frame.list2 size] > 0} {
					global argChooser_LastArgumentClicked argChooser_LastArgumentClickedIndex;

					if {$argChooser_LastArgumentClickedIndex != [.argChooser.frame.list2 curselection]} {
						set argChooser_LastArgumentClickedIndex [.argChooser.frame.list2 curselection];
					} else {

						set cursel [.argChooser.frame.list2 curselection];
						set currentcol [.argChooser.frame.list2 itemcget $cursel -foreground];
						prologmnf reduce_graph_state_space:user_made_arg_selection;

						if {[string compare $currentcol ""] == 0} {
							set currentcol "red";
						}
						set unhighlighted "black";
						set highlighted "red";
						if {[string compare $currentcol $unhighlighted] == 0} {
							.argChooser.frame.list2 itemconfigure $cursel -foreground $highlighted -selectforeground $highlighted;
						} else {
							.argChooser.frame.list2 itemconfigure $cursel -foreground $unhighlighted -selectforeground $unhighlighted;
							global allarg_cb graph_type_rb;
							set allarg_cb "no";
							prologmnf "reduce_graph_state_space:set_use_no_arguments($graph_type_rb,no)";
						}
						procSetDontCares;
					}
				}
			}

			# dummy label that provides an empty section
			label .argChooser.frame.label1 -relief flat -padx 5 -pady 5

			label .argChooser.frame.opnamelabel -text "Operation Name"
			label .argChooser.frame.oparglabel -text "Arguments/Return values (for reduced DFA only)"

			radiobutton .argChooser.frame.sig_m_rb -text "Signature Merge" -pady 2 -variable graph_type_rb -value "signature_merge" -command "procSettingsForDifferentGraph signature_merge;procUpdateAllOps"
			radiobutton .argChooser.frame.dfa_a_rb -text "DFA Abstraction" -pady 2 -variable graph_type_rb -value "dfa_abstraction" -command "procSettingsForDifferentGraph dfa_abstraction;procUpdateAllOps" -state disabled 
			# TO DO: remove state disabled

			checkbutton .argChooser.frame.allop_cb -text "All operations on" -pady 2 -variable allop_cb -onvalue "yes" -offvalue "no" -command "procUpdateAllOps"
			checkbutton .argChooser.frame.allarg_cb -text "All arguments/return values off" -pady 2  -variable allarg_cb -onvalue "yes" -offvalue "no" -command "procUpdateAllArgs"

			.argChooser.frame.sig_m_rb invoke;

			# I think this bit puts the first lot of scrollbars and listbox into the main frame
			grid .argChooser.frame.opnamelabel -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
			grid .argChooser.frame.oparglabel -row 0 -column 3 -rowspan 1 -columnspan 1 -sticky news

			grid .argChooser.frame.list -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
			grid .argChooser.frame.yscroll -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
			grid .argChooser.frame.xscroll -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news

			grid .argChooser.frame.label1 -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news

			grid .argChooser.frame.list2 -row 1 -column 3 -rowspan 1 -columnspan 1 -sticky news
			grid .argChooser.frame.yscroll2 -row 1 -column 4 -rowspan 1 -columnspan 1 -sticky news
			grid .argChooser.frame.xscroll2 -row 2 -column 3 -rowspan 1 -columnspan 1 -sticky news

			grid .argChooser.frame.sig_m_rb -row 3 -column 0 -columnspan 1 -sticky news
			grid .argChooser.frame.allop_cb -row 3 -column 3 -columnspan 1 -sticky news

			grid .argChooser.frame.dfa_a_rb -row 4 -column 0 -columnspan 1 -sticky news
			grid .argChooser.frame.allarg_cb -row 4 -column 3 -columnspan 1 -sticky news

			grid rowconfig    .argChooser.frame 0 -weight 1 -minsize 0
			grid columnconfig .argChooser.frame 0 -weight 1 -minsize 0
		}
	}
############################# ent03r End Op/Argument Chooser #########################





# ------------------------------------------------------------
# MAIN PROGRAM
# ------------------------------------------------------------

proc procComputeApplicationDirectory {} {
    global app_dir
    global lib_dir
    global tcl_dir
    # puts "procComputeApplicationDirectory"
    prolog tools:runtime_application_path(Dir)
    set app_dir $prolog_variables(Dir)
    prolog absolute_file_name(prob_lib('.'),LibDir)
    set lib_dir $prolog_variables(LibDir)
    prolog absolute_file_name(prob_tcl('.'),TclDir)
    set tcl_dir $prolog_variables(TclDir)
	prolog "tools:print_message('app_dir=$app_dir; lib_dir=$lib_dir; tcl_dir=$tcl_dir')"
}

proc getMachinesPath {} {
    prolog preferences:get_preference(machines_path,Dir)
    return $prolog_variables(Dir)
}
proc setMachinesPath {dir} {
    if {$dir != ""} {
	prolog preferences:set_preference(machines_path,'$dir')
    }
}

proc procEnablingAnalysisShort {} {
    procEnablingAnalysis 0
}
proc procEnablingAnalysisLong {} {
    procEnablingAnalysis 2000
}
proc procEnablingAnalysis {ExtraTimeout} {
    prolog tcltk_cbc_enabling_analysis($ExtraTimeout,Result)
    procShowErrors
    set LegendList {" * guaranteed: op2 (column) guaranteed to be executable after op1 (row)" " * impossible: op2 impossible to execute after op1"  " * independent: op1 and op2 syntactically independent; op2 stays enabled or disabled after op1" " * activation_indepdendent: op1 does not influence guard of op2, but (op1;op2) could have a different effect than (op2;op1)" " * keep: op2 always stays enabled resp. disabled after op1" " * possible_disable: op2 possible after op1, but can not be enabled only disabled by op1" " * possible_enable: op2 possible after op1, but op2 can not be disabled only enabled by op1"}
    procShowTable $prolog_variables(Result) "Enabling Analysis" "Enabling Information after Operation" "EnablingInfo" $LegendList
}
proc procDependenceAnalysis {} {
    prolog tcltk_cbc_dependence_analysis(Result)
    procShowErrors
    procShowTable $prolog_variables(Result) "Dependence Analysis" "Dependence Information for Operations" "DependenceInfo" ""
}

proc procDependenceAnalysis_Graph {} {
    procDependenceEnablingAnalysis_Graph "tcltk_create_dependence_graph"
}

proc procEnablingAnalysis_Graph {} {
    procDependenceEnablingAnalysis_Graph "tcltk_create_enable_graph"
}

proc procDependenceEnablingAnalysis_Graph {predicate_call} {
   global strFilename
   set rootName [file rootname $strFilename]
   set dotName {}; set psName {}
   append dotName $rootName ".dot"
   append psName $rootName ".ps"
   set CMD {}
   append CMD $predicate_call ('$dotName')
   prolog $CMD
   procVisualiseDotFile $dotName $psName
}
proc procShowLegend {} {
   global LegendTextList
   # puts "Legend: $LegendTextList"
   procShowList "$LegendTextList" "Legend" "Explanation of table entries:"
}
proc procShowTable {Result WindowTitleMsg1 Msg2 DefaultSaveName LegendList} {
   # Result is a list of lists;
    global ok cells
    global maximum_table_width
    set maximum_table_width 20
	destroy .table
    set f .table
    array set cells {}
	if [Dialog_Create $f $WindowTitleMsg1 -borderwidth 20] {
		message $f.msg -text $Msg2 -aspect 1500
		global tcl_dir
        
        # ------- code source frames
        frame $f.frmSource -borderwidth .1c -relief groove
	package require Tktable
	set listlen [llength $Result]
	set rows $listlen
	set cols [llength [lindex $Result 0]]
	
	array set cells [setTableCellsArray $Result]
        scrollbar $f.frmSource.scrolly -command "$f.frmSource.table yview" -orient v
        scrollbar $f.frmSource.scrollx -command "$f.frmSource.table xview" -orient h
	table $f.frmSource.table -rows $rows -cols $cols -variable cells -roworigin 0 -colorigin 0 -titlecols 1 -titlerows 1 -colwidth $maximum_table_width -colstretchmode all -rowstretchmode all -state disabled -xscroll "$f.frmSource.scrollx set" -yscroll "$f.frmSource.scrolly set"
        pack $f.frmSource.scrolly -side right -fill y
        pack $f.frmSource.scrollx -side bottom -fill x
	pack $f.frmSource.table -expand true -fill both
	set b [frame $f.buttons]
	pack $f.msg $f.frmSource $f.buttons -side top -fill x
	pack $f.frmSource -pady 5 -expand 1 -fill both
	button $b.save -text "Save..." -command {set ok 3}
	pack $b.save -side left
	if {$LegendList != ""} {
	   global LegendTextList
	   set LegendTextList "$LegendList"
	   button $b.legend -text "Legend..." -command {procShowLegend}
	   pack $b.legend -side left
	}
	button $b.ok -text Done -command {set ok 1}
	pack $b.ok -side right

	set t $f.frmSource.table 
      	$t tag celltag guaranteed
      	$t tag configure guaranteed -background lightgreen

      	$t tag celltag impossible
      	$t tag configure impossible -background pink

      	$t tag celltag independent
      	$t tag configure independent -background lightyellow

      	$t tag celltag neutral
      	$t tag configure neutral -background white

      	$t tag celltag timeout
      	$t tag configure timeout -background RosyBrown

      	$t tag celltag dependent
      	$t tag configure dependent -background lightgreen

      	$t tag celltag static_independent
      	$t tag configure static_independent -background lightyellow

      	$t tag celltag race_dependent
      	$t tag configure race_dependent -background lightgreen

	for {set i 0} {$i <$rows} {incr i} {
		for {set j 0} {$j < $cols} {incr j} {
			switch -regexp $cells($i,$j) {
				^timeout.* {
					$t tag celltag timeout "$i,$j"
				}
				guaranteed {
					$t tag celltag guaranteed "$i,$j"
				}
				impossible {
					$t tag celltag impossible "$i,$j"
				}
				independent {
					$t tag celltag independent "$i,$j"
				}
				keep {
					$t tag celltag independent "$i,$j"
				}
				activation_indepdendent {
					$t tag celltag independent "$i,$j"
				}
				possible.* {
					$t tag celltag neutral "$i,$j"
				}
				static_independent {
					$t tag celltag static_independent "$i,$j"
				}
				dependent {
					$t tag celltag dependent "$i,$j"
				}
				race_dependent {
					$t tag celltag race_dependent "$i,$j"
				}
			}
		}
	}
	bind $f.frmSource <Return> {set ok 1 ; break}
	bind $f.frmSource <Control-c> {set ok 1 ; break}
	bind $f.frmSource <Escape> {set ok 1 ; break}
	}

	set ok 0
	Dialog_Wait $f ok $f.frmSource
	Dialog_Dismiss $f
	if {$ok==3} {
	    set types {
	        {"Text File" {.txt} }
		    {"CSV File" {.csv}}
		    {"All files"		*}
		}
	    set DEBUGFILE [tk_getSaveFile -filetypes $types -initialfile $DefaultSaveName -parent . -defaultextension "txt"]
	    if {$DEBUGFILE != ""} { 
		#puts "Opening File: $DEBUGFILE"
		set csv false
		if {[file extension $DEBUGFILE] == ".csv"} {
			set csv true
		}
		set channel [open "$DEBUGFILE" "w+"]
		foreach i $Result {
		   if {$csv} {
			set line [string map {" " ";"} $i]
		        puts $channel $line
		   } else {
		   	puts $channel $i
		   }
		}
		close $channel
       	    }
	}
}

proc setTableCellsArray {content} {
    set list {}; set row 0
    global maximum_table_width
    foreach line $content {
        set col 0
	foreach el $line {
		set strlength [string length $el]
		if {$strlength > $maximum_table_width && $strlength < 50} {
			set maximum_table_width $strlength
		}
		if [regexp {timeout_(.*)} $el match arg] {
			set new_el "timeout($arg)"
		} else {
			set new_el $el
		}
		lappend list "$row,$col" $new_el
		incr col
	}
	incr row
    }
    return $list
}

# -------
# procedure initialise everythings
# -------
proc procMainInit {} {
    global lib_dir
    procComputeApplicationDirectory

    global curFileTypeOpened
    set curFileTypeOpened "None"

    global strFilename cspstrFilename
    set strFilename ""
    set cspstrFilename ""

    # set the first machine (a phonebook)
    prologmnf tcltk_set_initial_machine

    procInitPreferences
    procLoadPreferences

    # initialise GUI
    procInitGUI
    # initialise prolog
    prologmnf tcltk_initialise

    # get options by default
    #procInsertHistoryOptionsState

    procUpdateMenusFromPrologInfo
    global typeCheckMode traceUponError
    global expert_user
    set traceUponError 0
    if {$expert_user && \
     [prolog preferences:get_preference(default_to_runtime_type_checking_on_startup_for_expert,true)]} {
       set typeCheckMode 1
     } else {set typeCheckMode 0}
    procUpdateDebuggingMode

    if [file exists "$lib_dir/probcliparser.jar"] {
      # puts "Found Parser"
    } else {
      tkErrorBox "Your installation seems incomplete.\nCannot find probcliparser.jar file in $lib_dir.\nYou will only be able to open machines that have already been parsed."
    }
}

# puts "Starting"
procMainInit
# puts "Treating CommandLineArgs"
procTreatCommandLineArgs
